/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 32 "parser.y"

/** @endcond */

// local
#include "pjl_config.h"                 /* must go first */
#include "c_ast.h"
#include "c_ast_check.h"
#include "c_ast_util.h"
#include "c_keyword.h"
#include "c_lang.h"
#include "c_operator.h"
#include "c_sglob.h"
#include "c_sname.h"
#include "c_type.h"
#include "c_typedef.h"
#include "cdecl.h"
#include "cdecl_keyword.h"
#include "color.h"
#include "dump.h"
#include "did_you_mean.h"
#include "english.h"
#include "gibberish.h"
#include "help.h"
#include "lexer.h"
#include "literals.h"
#include "options.h"
#include "p_macro.h"
#include "p_token.h"
#include "print.h"
#include "set_options.h"
#include "show.h"
#include "slist.h"
#include "types.h"
#include "util.h"

/// @cond DOXYGEN_IGNORE

// standard
#include <assert.h>
#include <ctype.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stddef.h>                     /* for NULL, size_t */
#include <stdio.h>
#include <stdlib.h>

// Silence these warnings for Bison-generated code.
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wconversion"
#pragma GCC diagnostic ignored "-Wredundant-decls"
#pragma GCC diagnostic ignored "-Wunreachable-code"

// Developer aid for tracing when Bison %destructors are called.
#if 0
#define DTRACE                    EPRINTF( "%d: destructor\n", __LINE__ )
#else
#define DTRACE                    NO_OP
#endif

/// @endcond

///////////////////////////////////////////////////////////////////////////////

/**
 * Checks whether \a AST is a #K_NAME and therefore an error (if \ref
 * opt_permissive_types is `false`) or merely a warning (if \ref
 * opt_permissive_types is `true`).
 *
 * @param AST The AST to check.
 * @return Returns `true` only if \a ast is a #K_NAME and therefore an error.
 */
#define c_ast_is_name_error(AST)  l_c_ast_is_name_error( __LINE__, (AST) )

/**
 * Checks whether \a SNAME is a type.
 *
 * @param SNAME The scoped name to check.
 * @param LOC The location of \a SNAME.
 * @return Returns `true` only if \a SNAME is a type (and prints an error
 * message); otherwise `false` (and does nothing).
 */
#define c_sname_is_type(SNAME,LOC) \
  fl_c_sname_is_type( __FILE__, __LINE__, (SNAME), (LOC) )

/**
 * @defgroup parser-group Parser
 * Helper macros, data structures, variables, functions, and the grammar for
 * C/C++ declarations.
 * @{
 */

/**
 * Calls #elaborate_error_dym() with #DYM_NONE.
 *
 * @param ... Arguments passed to l_elaborate_error().
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  | Y_define error
 *    {
 *      elaborate_error( "name expected" );
 *    }
 * ```
 * @note A newline _is_ printed.
 *
 * @sa elaborate_error_dym()
 * @sa keyword_expected()
 * @sa punct_expected()
 */
#define elaborate_error(...) \
  elaborate_error_dym( DYM_NONE, __VA_ARGS__ )

/**
 * Calls l_elaborate_error() followed by #PARSE_ABORT().
 *
 * @param DYM_KINDS The bitwise-or of \ref dym_kind_t things possibly meant.
 * @param ... Arguments passed to l_elaborate_error().
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  | error
 *    {
 *      elaborate_error_dym( DYM_COMMANDS, "unexpected token" );
 *    }
 * ```
 * @note A newline _is_ printed.
 *
 * @sa elaborate_error()
 * @sa keyword_expected()
 * @sa punct_expected()
 */
#define elaborate_error_dym(DYM_KINDS,...) BLOCK( \
  l_elaborate_error( __LINE__, (DYM_KINDS), __VA_ARGS__ ); PARSE_ABORT(); )

/**
 * Executes the given statements only if \ref opt_cdecl_debug `!=`
 * #CDECL_DEBUG_NO.
 *
 * @param ... The statement(s) to execute.
 */
#define IF_CDECL_DEBUG(...) \
  BLOCK( if ( opt_cdecl_debug != CDECL_DEBUG_NO ) { __VA_ARGS__ } )

/**
 * Prints that a particular language feature is not supported by **cdecl** and
 * will be ignored.
 *
 * @param LOC The location of what's being ignored.
 * @param WHAT The string literal of what is being ignored.  It may contain a
 * `printf()` format string.
 * @param ... The `printf()` arguments, if any.
 *
 * @sa #UNSUPPORTED()
 */
#define IGNORING(LOC,WHAT,...)                      \
  print_warning( (LOC),                             \
    WHAT " not supported by " CDECL " (ignoring)\n" \
    VA_OPT( (,), __VA_ARGS__ ) __VA_ARGS__          \
  )

/**
 * Checks whether the type currently being declared (`enum`, `struct`,
 * `typedef`, or `union`) is nested within some other type (`struct` or
 * `union`) and whether the current language is C: if not, prints an error
 * message.
 *
 * @remarks In debug mode, also includes the file & line where the function was
 * called from in the error message.
 *
 * @param TYPE_LOC The location of the type declaration.
 * @return Returns `true` only if the type currently being declared is either
 * not nested or the current language is C++.
 *
 * @sa l_is_nested_type_ok()
 */
#define is_nested_type_ok(TYPE_LOC) \
  l_is_nested_type_ok( __LINE__, (TYPE_LOC) )

/**
 * Calls l_keyword_expected() followed by #PARSE_ABORT().
 *
 * @param KEYWORD A keyword literal.
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  : Y_virtual
 *  | error
 *    {
 *      keyword_expected( L_virtual );
 *    }
 * ```
 *
 * @sa elaborate_error()
 * @sa elaborate_error_dym()
 * @sa punct_expected()
 */
#define keyword_expected(KEYWORD) BLOCK ( \
  l_keyword_expected( __LINE__, (KEYWORD) ); PARSE_ABORT(); )

/**
 * Aborts the current parse after an error message has been printed.
 *
 * @sa #PARSE_ASSERT()
 */
#define PARSE_ABORT() \
  BLOCK( parse_cleanup( /*fatal_error=*/true ); YYABORT; )

/**
 * Evaluates \a EXPR: if `false`, calls #PARSE_ABORT().
 *
 * @param EXPR The expression to evalulate.
 */
#define PARSE_ASSERT(EXPR)        BLOCK( if ( !(EXPR) ) PARSE_ABORT(); )

/**
 * Calls l_punct_expected() followed by #PARSE_ABORT().
 *
 * @param PUNCT The punctuation character that was expected.
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  : ','
 *  | error
 *    {
 *      punct_expected( ',' );
 *    }
 * ```
 *
 * @sa elaborate_error()
 * @sa elaborate_error_dym()
 * @sa keyword_expected()
 */
#define punct_expected(PUNCT) BLOCK( \
  l_punct_expected( __LINE__, (PUNCT) ); PARSE_ABORT(); )

/**
 * Prints that a particular language feature is not supported by **cdecl** and
 * therefore an error followed by #PARSE_ABORT().
 *
 * @param LOC The location of what's not supported.
 * @param WHAT The string literal of what is being ignored.  It may contain a
 * `printf()` format string.
 * @param ... The `printf()` arguments, if any.
 *
 * @sa #IGNORING()
 */
#define UNSUPPORTED(LOC,WHAT,...) BLOCK(    \
  print_error( (LOC),                       \
    WHAT " not supported by " CDECL "\n"    \
    VA_OPT( (,), __VA_ARGS__ ) __VA_ARGS__  \
  );                                        \
  PARSE_ABORT(); )

/** @} */

///////////////////////////////////////////////////////////////////////////////

/**
 * @defgroup parser-dump-group Debugging Macros
 * Macros that are used to dump a trace during parsing when \ref
 * opt_cdecl_debug is set.
 * @ingroup parser-group
 * @{
 */

/**
 * Dumps \a ALIGN.
 *
 * @param KEY The key name to print.
 * @param ALIGN The \ref c_alignas to dump.
 */
#define DUMP_ALIGN(KEY,ALIGN) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_alignas_dump( &(ALIGN), stdout ); )

/**
 * Dumps an AST.
 *
 * @param KEY The key name to print.
 * @param AST The AST to dump.
 *
 * @sa #DUMP_AST_LIST()
 * @sa #DUMP_AST_PAIR()
 */
#define DUMP_AST(KEY,AST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_dump( (AST), stdout ); )

/**
 * Dumps an s_list of AST.
 *
 * @param KEY The key name to print.
 * @param AST_LIST The \ref slist of AST to dump.
 *
 * @sa #DUMP_AST()
 * @sa #DUMP_AST_PAIR()
 */
#define DUMP_AST_LIST(KEY,AST_LIST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_list_dump( &(AST_LIST), stdout ); )

/**
 * Dump a \ref c_ast_pair.
 *
 * @param KEY The key name to print.
 * @param ASTP The \ref c_ast_pair to dump.
 *
 * @sa #DUMP_AST()
 */
#define DUMP_AST_PAIR(KEY,ASTP) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_pair_dump( &(ASTP), stdout ); )

/**
 * Dumps a `bool`.
 *
 * @param KEY The key name to print.
 * @param BOOL The `bool` to dump.
 */
#define DUMP_BOOL(KEY,BOOL)  IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); bool_dump( (BOOL), stdout ); )

/**
 * Ends a dump block.
 *
 * @sa #DUMP_START()
 */
#define DUMP_END()                IF_CDECL_DEBUG( PUTS( "\n}\n\n" ); )

/**
 * Possibly dumps a comma and a newline followed by the `printf()` arguments
 * --- used for printing a key followed by a value.
 *
 * @param ... The `printf()` arguments.
 *
 * @warning This _must_ only be called inside #IF_CDECL_DEBUG().
 */
#define DUMP_KEY_IMPL(...) BLOCK(         \
  fput_sep( ",\n", &dump_comma, stdout ); \
  PRINTF( "  " __VA_ARGS__ ); )

/**
 * Dumps an integer.
 *
 * @param KEY The key name to print.
 * @param NUM The integer to dump.
 *
 * @sa #DUMP_STR()
 */
#define DUMP_INT(KEY,NUM) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": %d", STATIC_CAST( int, (NUM) ) ); )

/**
 * Dumps a \ref p_macro.
 *
 * @param KEY The key name to print.
 * @param MACRO The \ref p_macro to dump.
 */
#define DUMP_MACRO(KEY,MACRO) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); p_macro_dump( (MACRO), stdout ); )

/**
 * Dumps a list of macro arguments.
 *
 * @param KEY The key name to print.
 * @param ARG_LIST The list of arguments to dump.
 */
#define DUMP_MACRO_ARG_LIST(KEY,ARG_LIST) IF_CDECL_DEBUG( \
  if ( (ARG_LIST) != NULL ) {                             \
    DUMP_KEY_IMPL( KEY ": " );                            \
    p_arg_list_dump( (ARG_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Dumps a list of \ref p_param.
 *
 * @param KEY The key name to print.
 * @param PARAM_LIST The list of \ref p_param to dump.
 */
#define DUMP_MACRO_PARAM_LIST(KEY,PARAM_LIST) IF_CDECL_DEBUG( \
  if ( (PARAM_LIST) != NULL ) {                               \
    DUMP_KEY_IMPL( KEY ": " );                                \
    p_param_list_dump( (PARAM_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Dumps a list of \ref p_token.
 *
 * @param KEY The key name to print.
 * @param TOKEN_LIST The list of \ref p_token to dump.
 */
#define DUMP_MACRO_TOKEN_LIST(KEY,TOKEN_LIST) IF_CDECL_DEBUG( \
  if ( (TOKEN_LIST) != NULL ) {                               \
    DUMP_KEY_IMPL( KEY ": " );                                \
    p_token_list_dump( (TOKEN_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Starts a dump block.
 *
 * @remarks If a production has a result, it should be dumped as the final
 * thing before the #DUMP_END() with the KEY of `$$_` followed by a suffix
 * denoting the type, e.g., `ast`.  For example:
 * ```
 *  DUMP_START( "rule",
 *              "subrule_1 subrule_2 ..." );
 *  DUMP_AST( "subrule_1", $1 );
 *  DUMP_STR( "name", $2 );
 *  DUMP_AST( "subrule_2", $3 );
 *  // ...
 *  DUMP_AST( "$$_ast", $$ );
 *  DUMP_END();
 * ```
 *
 * @param NAME The grammar production name.
 * @param RULE The grammar production rule.
 *
 * @note The dump block _must_ end with #DUMP_END().
 *
 * @sa #DUMP_END()
 */
#define DUMP_START(NAME,RULE) \
  bool dump_comma = false;    \
  IF_CDECL_DEBUG( PUTS( "{\n  rule: {\n    lhs: \"" NAME "\",\n    rhs: \"" RULE "\"\n  },\n" ); )

/**
 * Dumps a scoped name.
 *
 * @param KEY The key name to print.
 * @param SNAME The scoped name to dump.
 *
 * @sa #DUMP_SNAME_LIST()
 * @sa #DUMP_STR()
 */
#define DUMP_SNAME(KEY,SNAME) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_sname_dump( &(SNAME), stdout ); )

/**
 * Dumps a list of scoped names.
 *
 * @param KEY The key name to print.
 * @param LIST The list of scoped names to dump.
 *
 * @sa #DUMP_SNAME()
 */
#define DUMP_SNAME_LIST(KEY,LIST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_sname_list_dump( &(LIST), stdout ); )

/**
 * Dumps a C string.
 *
 * @param KEY The key name to print.
 * @param STR The C string to dump.
 *
 * @sa #DUMP_INT()
 * @sa #DUMP_SNAME()
 */
#define DUMP_STR(KEY,STR) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); fputs_quoted( (STR), '"', stdout ); )

/**
 * Dumps a \ref c_tid_t.
 *
 * @param KEY The key name to print.
 * @param TID The \ref c_tid_t to dump.
 *
 * @sa #DUMP_TYPE()
 */
#define DUMP_TID(KEY,TID) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_tid_dump( (TID), stdout ); )

/**
 * Dumps a \ref c_type.
 *
 * @param KEY The key name to print.
 * @param TYPE The \ref c_type to dump.
 *
 * @sa #DUMP_TID()
 */
#define DUMP_TYPE(KEY,TYPE) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_type_dump( &(TYPE), stdout ); )

/** @} */

///////////////////////////////////////////////////////////////////////////////

/**
 * @addtogroup parser-group
 * @{
 */

/**
 * Inherited attributes.
 *
 * @remarks These are grouped into a `struct` (rather than having them as
 * separate global variables) so that they can all be reset (mostly) via a
 * single assignment from `{0}`.
 *
 * @sa ia_cleanup()
 */
struct in_attr {
  c_alignas_t     align;            ///< Alignment, if any.
  unsigned        ast_depth;        ///< Parentheses nesting depth.
  bool            is_typename;      ///< C++ only: is `typename` specified?
  c_sname_t       scope_sname;      ///< C++ only: current scope name, if any.

  /**
   * Type AST stack.
   *
   * @sa ia_type_ast_peek()
   * @sa ia_type_ast_pop()
   * @sa ia_type_ast_push()
   */
  c_ast_list_t    type_ast_stack;

  /**
   * Declaration type specifier AST.
   *
   * @remarks A C/C++ declaration is of the form:
   *
   *      type-specifier declarator+
   *
   * where one or more declarators all have the same base type, e.g.:
   *
   *      int i, *p, a[2], f(double);
   *
   * This is a pointer to the base type AST (above, `int`) that is duplicated
   * for each declarator.  It's set by the first call to ia_type_ast_push().
   *
   * @sa ia_type_spec_ast()
   */
  c_ast_t const  *type_spec_ast;

  /**
   * Red-black node for temporary `typedef`.
   *
   * @remarks This is used only in the `pc99_func_or_constructor_declaration_c`
   * grammar production. It's needed because a temporary `typedef` needs to be
   * created in a mid-rule action then removed in the end-rule action and
   * there's no way to pass local variables between Bison actions, so it's
   * passed via an inherited attribute.
   */
  rb_node_t      *tdef_rb;
};
typedef struct in_attr in_attr_t;

// local functions
PJL_PRINTF_LIKE_FUNC(3)
static void l_elaborate_error( int, dym_kind_t, char const*, ... );

PJL_DISCARD
static bool print_error_token( char const* );

// local variables
static c_ast_list_t   gc_ast_list;      ///< c_ast nodes freed after parse.
static in_attr_t      in_attr;          ///< Inherited attributes.
static c_ast_list_t   typedef_ast_list; ///< List of ASTs for `typedef`s.

////////// inline functions ///////////////////////////////////////////////////

/**
 * Duplicates \a ast and adds it to \ref gc_ast_list.
 *
 * @param ast The AST to duplicate.
 * @return Returns the duplicated AST.
 *
 * @sa c_ast_new_gc()
 */
static inline c_ast_t* c_ast_dup_gc( c_ast_t const *ast ) {
  return c_ast_dup( ast, &gc_ast_list );
}

/**
 * Garbage-collects the AST nodes on \a ast_list but does _not_ free \a
 * ast_list itself.
 *
 * @param ast_list The AST list to free the nodes of.
 *
 * @sa c_ast_list_cleanup()
 * @sa c_ast_dup_gc()
 * @sa c_ast_new_gc()
 * @sa c_ast_pair_new_gc()
 */
static inline void c_ast_list_cleanup_gc( c_ast_list_t *ast_list ) {
  slist_cleanup( ast_list, POINTER_CAST( slist_free_fn_t, &c_ast_free ) );
}

/**
 * Creates a new AST and adds it to \ref gc_ast_list.
 *
 * @param kind The kind of AST to create.
 * @param loc A pointer to the token location data.
 * @return Returns a pointer to a new AST.
 *
 * @sa c_ast_dup_gc()
 * @sa c_ast_pair_new_gc()
 */
NODISCARD
static inline c_ast_t* c_ast_new_gc( c_ast_kind_t kind, c_loc_t const *loc ) {
  return c_ast_new( kind, in_attr.ast_depth, loc, &gc_ast_list );
}

/**
 * Set our mode to deciphering gibberish into English.
 *
 * @sa is_english_to_gibberish()
 * @sa is_gibberish_to_english()
 */
static inline void gibberish_to_english( void ) {
  lexer_find &= ~LEXER_FIND_CDECL_KEYWORDS;
}

/**
 * Peeks at the type AST at the top of the
 * \ref in_attr.type_ast_stack "type AST inherited attribute stack".
 *
 * @return Returns said AST.
 *
 * @sa ia_type_ast_pop()
 * @sa ia_type_ast_push()
 */
NODISCARD
static inline c_ast_t* ia_type_ast_peek( void ) {
  return slist_front( &in_attr.type_ast_stack );
}

/**
 * Pops a type AST from the
 * \ref in_attr.type_ast_stack "type AST inherited attribute stack".
 *
 * @return Returns said AST.
 *
 * @sa ia_type_ast_peek()
 * @sa ia_type_ast_push()
 */
PJL_DISCARD
static inline c_ast_t* ia_type_ast_pop( void ) {
  c_ast_t *const ast = slist_pop_front( &in_attr.type_ast_stack );
  assert( ast != NULL );
  return ast;
}

/**
 * Given an AST for a type that is the "of type", return type, or "to type" of
 * a declaration, returns a duplicate of \a type_ast if necessary.
 *
 * @param type_ast The AST of a type.
 * @return If \a type_ast `==` \ref in_attr::type_spec_ast "type_spec_ast",
 * returns a duplicate of \a type_ast; otherwise returns \a type_ast.
 *
 * @sa \ref in_attr::type_spec_ast
 */
NODISCARD
static inline c_ast_t* ia_type_spec_ast( c_ast_t *type_ast ) {
  assert( type_ast != NULL );
  // Yes, == is correct here: we mean the same AST node.
  return type_ast == in_attr.type_spec_ast ?
    c_ast_dup_gc( type_ast ) : type_ast;
}

////////// local functions ////////////////////////////////////////////////////

/**
 * Prints a warning that the attribute \a keyword syntax is not supported (and
 * ignored).
 *
 * @param keyword The attribute syntax keyword, e.g., `__attribute__` or
 * `__declspec`.
 * @param keyword_loc The source location of \a keyword.
 */
static void attr_syntax_not_supported( char const *keyword,
                                       c_loc_t const *keyword_loc ) {
  assert( keyword != NULL );
  assert( keyword_loc != NULL );

  print_warning( keyword_loc,
    "\"%s\" not supported by " CDECL " (ignoring)", keyword
  );
  if ( OPT_LANG_IS( ATTRIBUTES ) )
    print_hint( "%s...%s", other_token_c( "[[" ), other_token_c( "]]" ) );
  else
    EPUTC( '\n' );
}

/**
 * A predicate function for slist_free_if() that checks whether \a ast is one
 * that can be garbage collected: if so, c_ast_free()s it.
 *
 * @param ast_node The \ref slist_node pointing to the AST to check.
 * @param data Contains the AST of the type being declared.
 * @return Returns `true` only if \a ast should be removed from the list.
 */
NODISCARD
static bool c_ast_free_if_garbage( slist_node_t *ast_node, void *data ) {
  assert( ast_node != NULL );
  c_ast_t *const ast = ast_node->data;
  assert( ast != NULL );
  c_ast_t const *const type_ast = data;
  assert( type_ast != NULL );

  if ( ast == type_ast || !c_ast_is_orphan( ast ) ) {
    assert( ast->kind != K_PLACEHOLDER );
    return false;
  }

  // We also need to ensure the AST isn't in the type_ast_stack.
  FOREACH_SLIST_NODE( type_node, &in_attr.type_ast_stack ) {
    if ( ast == type_node->data )
      return false;
  } // for

  c_ast_free( ast );
  return true;
}

/**
 * Checks whether `typename` is OK since the type's name is a qualified name.
 *
 * @param ast The AST to check.
 * @return Returns `true` only upon success.
 */
NODISCARD
bool c_ast_is_typename_ok( c_ast_t const *ast ) {
  c_ast_t const *const raw_ast = c_ast_untypedef( ast );
  if ( c_sname_count( &raw_ast->sname ) < 2 ) {
    print_error( &ast->loc, "qualified name expected after \"typename\"\n" );
    return false;
  }
  return true;
}

/**
 * If \a bit_width is &gt; 0 and \a ast is an integral type, sets \a ast's \ref
 * c_bit_field_ast::bit_width "bit_width" to \a bit_width.
 *
 * @remarks This check has to be done now in the parser rather than later in
 * the AST since we need to use the \ref c_ast::bit_field `union` member now.
 *
 * @param ast The AST whose \ref c_bit_field_ast::bit_width "bit_width" to
 * possibly set.
 * @param bit_width The bit-field width.
 * @return Returns `true` only if \a bit_width is &gt; 0 and \a ast if an
 * integral type.
 */
NODISCARD
static bool c_ast_set_bit_field_width( c_ast_t *ast, unsigned bit_width ) {
  assert( ast != NULL );

  if ( bit_width > 0 ) {
    if ( !c_ast_is_integral( ast ) ) {
      print_error( &ast->loc, "invalid bit-field type " );
      print_ast_type_aka( ast, stderr );
      EPRINTF( "; must be an integral %stype\n",
        OPT_LANG_IS( enum_BITFIELDS ) ? "or enumeration " : ""
      );
      return false;
    }
    ast->bit_field.bit_width = bit_width;
  }

  return true;
}

/**
 * Defines a type by adding it to the global set.
 *
 * @param type_ast The AST of the type to define.
 * @param decl_flags The declaration flags to use; must only be one of
 * #C_ENG_DECL, #C_GIB_TYPEDEF, or #C_GIB_USING.
 * @return Returns `true` either if the type was defined or it's equivalent to
 * an existing type; `false` if a different type already exists having the same
 * name.
 */
NODISCARD
static bool define_type( c_ast_t const *type_ast, decl_flags_t decl_flags ) {
  assert( type_ast != NULL );
  assert( is_1_bit_only_in_set( decl_flags, C_TYPE_DECL_ANY ) );

  if ( !c_type_ast_check( type_ast ) )
    return false;

  c_typedef_t *const tdef = (void*)c_typedef_add( type_ast, decl_flags )->data;

  if ( tdef->ast == type_ast ) {
    //
    // Type was added: we have to move the AST from the gc_ast_list so it won't
    // be garbage collected at the end of the parse to a separate
    // typedef_ast_list that's freed only at program termination.
    //
    // But first, garbage collect all orphaned AST nodes.  (For a non-type-
    // defining parse, this step isn't necessary since all nodes are freed at
    // the end of the parse anyway.)
    //
    slist_free_if(
      &gc_ast_list,
      &c_ast_free_if_garbage,
      CONST_CAST( void*, type_ast )
    );
    slist_push_list_back( &typedef_ast_list, &gc_ast_list );
    return true;
  }

  //
  // Type was NOT added because a previously declared type having the same name
  // was returned: check if the types are equal.
  //
  // In C, multiple typedef declarations having the same name are allowed only
  // if the types are equivalent:
  //
  //      typedef int T;
  //      typedef int T;                // OK
  //      typedef double T;             // error: types aren't equivalent
  //
  if ( c_ast_equal( type_ast, tdef->ast ) ) {
    // Update the language(s) the type is available in to include opt_lang_id.
    if ( opt_lang_id < c_lang_oldest( tdef->lang_ids ) )
      tdef->lang_ids = c_lang_and_newer( opt_lang_id );
    return true;
  }

  if ( tdef->is_predefined ) {
    print_error( &type_ast->loc,
      "\"%s\" is a predefined type starting in %s\n",
      c_sname_gibberish( &type_ast->sname ),
      c_lang_name( c_lang_oldest( tdef->lang_ids ) )
    );
  } else {
    print_error( &type_ast->loc, "type " );
    print_ast_type_aka( type_ast, stderr );
    EPUTS( " redefinition incompatible with original type \"" );
    print_type_ast( tdef, stderr );
    EPUTS( "\"\n" );
  }

  return false;
}

/**
 * Checks whether \a sname is a type.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param sname The scoped name to check.
 * @param loc The location of \a sname.
 * @return Returns `true` only if \a sname is a type (and prints an error
 * message); otherwise `false` (and does nothing).
 */
NODISCARD
static bool fl_c_sname_is_type( char const *file, int line,
                                c_sname_t const *sname, c_loc_t const *loc ) {
  assert( sname != NULL );
  assert( loc != NULL );

  c_typedef_t const *const tdef = c_typedef_find_sname( sname );
  if ( tdef == NULL )
    return false;

  if ( tdef->is_predefined ) {
    fl_print_error( file, line, loc,
      "\"%s\" is a predefined type starting in %s\n",
      c_sname_gibberish( sname ),
      c_lang_name( c_lang_oldest( tdef->lang_ids ) )
    );
  } else {
    fl_print_error( file, line, loc,
      "\"%s\": previously declared as type \"",
      c_sname_gibberish( sname )
    );
    print_type_ast( tdef, stderr );
    EPUTS( "\"\n" );
  }

  return true;
}

/**
 * Cleans-up all resources used by \ref in_attr "inherited attributes".
 */
static void ia_cleanup( void ) {
  c_sname_cleanup( &in_attr.scope_sname );
  // Do _not_ pass &c_ast_free for the 2nd argument! All AST nodes were already
  // free'd from the gc_ast_list in parse_cleanup(). Just free the slist nodes.
  slist_cleanup( &in_attr.type_ast_stack, /*free_fn=*/NULL );
  in_attr = (in_attr_t){ 0 };
}

/**
 * Pushes a type AST onto the
 * \ref in_attr.type_ast_stack "type AST inherited attribute  stack".
 *
 * @remarks Additionally, if \a ast is #K_ANY_TYPE_SPECIFIER and \ref
 * in_attr::type_spec_ast "type_spec_ast" is NULL, sets \ref
 * in_attr::type_spec_ast "type_spec_ast" to \a ast.
 *
 * @param ast The AST to push.
 *
 * @sa ia_type_ast_peek()
 * @sa ia_type_ast_pop()
 */
static void ia_type_ast_push( c_ast_t *ast ) {
  assert( ast != NULL );
  slist_push_front( &in_attr.type_ast_stack, ast );
  if ( in_attr.type_spec_ast != NULL )
    return;
  if ( (ast->kind & K_ANY_TYPE_SPECIFIER) != 0 )
    in_attr.type_spec_ast = ast;
}

/**
 * Joins \a type_ast and \a decl_ast into a single AST.
 *
 * @param type_ast The type AST.
 * @param decl_ast The declaration AST.
 * @return Returns the joined AST on success or NULL on error.
 */
NODISCARD
c_ast_t* join_type_decl( c_ast_t *type_ast, c_ast_t *decl_ast ) {
  assert( type_ast != NULL );
  assert( decl_ast != NULL );

  if ( in_attr.is_typename && !c_ast_is_typename_ok( type_ast ) )
    return NULL;

  type_ast = ia_type_spec_ast( type_ast );
  c_type_t type = c_ast_take_type_any( type_ast, &T_TS_typedef );

  //
  // This is for a case like:
  //
  //      explain typedef ...
  //
  bool const is_explain_typedef = c_tid_is_any( type.stids, TS_typedef );

  if ( !is_explain_typedef &&
       type_ast->kind == K_BUILTIN && decl_ast->kind == K_BUILTIN &&
       c_sname_is_type( &decl_ast->sname, &decl_ast->loc ) ) {
    //
    // This checks for a case like:
    //
    //      typedef int T
    //      explain unsigned T          // error
    //
    // This check has to be done now in the parser rather than later in the
    // AST because once type_ast and decl_ast are joined, the fact that
    // decl_ast was a typedef is lost.
    //
    return NULL;
  }

  if ( is_explain_typedef && decl_ast->kind == K_TYPEDEF ) {
    //
    // This is for a case like:
    //
    //      explain typedef int int32_t;
    //
    // that is: explaining an existing typedef.  In order to do that, we have
    // to un-typedef it so we explain the type that it's a typedef for.
    //
    c_ast_t const *const raw_decl_ast = c_ast_untypedef( decl_ast );

    //
    // However, we also have to check whether the typedef being explained is
    // not equivalent to the existing typedef.  This is for a case like:
    //
    //      explain typedef char int32_t;
    //
    if ( !c_ast_equal( type_ast, raw_decl_ast ) ) {
      print_error( &decl_ast->loc, "type " );
      print_ast_type_aka( type_ast, stderr );
      EPUTS( " redefinition incompatible with original type " );
      print_ast_type_aka( decl_ast, stderr );
      EPUTC( '\n' );
      return NULL;
    }

    //
    // Because the raw_decl_ast for the existing type is about to be combined
    // with type_ast, duplicate raw_decl_ast first.
    //
    c_loc_t const *const orig_loc = &decl_ast->loc;
    decl_ast = c_ast_dup_gc( raw_decl_ast );
    decl_ast->loc = *orig_loc;
  }

  c_ast_t *const ast = c_ast_patch_placeholder( type_ast, decl_ast );
  c_type_t const tdef_type = c_ast_take_type_any( ast, &T_TS_typedef );
  c_type_or_eq( &type, &tdef_type );
  c_type_or_eq( &ast->type, &type );

  if ( in_attr.align.kind != C_ALIGNAS_NONE ) {
    ast->align = in_attr.align;
    if ( c_tid_is_any( type.stids, TS_typedef ) ) {
      //
      // We check for illegal aligned typedef here rather than in c_ast_check.c
      // because the "typedef-ness" needed to be removed previously before the
      // eventual call to c_ast_check().
      //
      print_error( &ast->align.loc, "typedef can not be aligned\n" );
      return NULL;
    }
  }

  if ( ast->kind == K_UDEF_CONV &&
       c_sname_local_type( &ast->sname )->btids == TB_SCOPE ) {
    //
    // User-defined conversions don't have names, but they can still have a
    // scope.  Since only classes can have them, if the scope is still
    // TB_SCOPE, change it to TB_class.
    //
    c_sname_local_data( &ast->sname )->type = C_TYPE_LIT_B( TB_class );
  }

  return ast;
}

/**
 * Checks whether \a ast is of kind #K_NAME and an error if:
 *
 *  + \ref opt_permissive_types is `false`; and:
 *  + \ref c_ast::sname is a C or C++ keyword.
 *
 * @note This function isn't normally called directly; use the
 * #c_ast_is_name_error() macro instead.
 *
 * @param line The line number within this file where this function was called
 * from.
 * @param ast The AST to check.
 * @return Returns `true` only if \a ast is a #K_NAME, \ref
 * opt_permissive_types is `false`, and \ref c_ast::sname is a C or C++
 * keyword.
 */
NODISCARD
static bool l_c_ast_is_name_error( int line, c_ast_t const *ast ) {
  assert( ast != NULL );
  if ( ast->kind != K_NAME || opt_permissive_types )
    return false;

  c_keyword_t const *const ck = c_keyword_find(
    c_sname_gibberish( &ast->sname ), LANG_ANY, C_KW_CTX_DEFAULT
  );
  if ( ck == NULL )
    return false;

  assert( !c_sname_empty( &ast->sname ) );
  fl_print_error_unknown_name( __FILE__, line, &ast->loc, &ast->sname );
  return true;
}

/**
 * A special case of l_elaborate_error() that prevents oddly worded error
 * messages where a C/C++ keyword is expected, but that keyword isn't a keyword
 * either until a later version of the language or in a different language;
 * hence, the lexer will return the keyword as the `Y_NAME` token instead of
 * the keyword token.
 *
 * For example, if l_elaborate_error() were used for the following \b cdecl
 * command when the current language is C, you'd get the following:
 * ```
 * declare f as virtual function returning void
 *              ^
 * 14: syntax error: "virtual": "virtual" expected; not a keyword until C++98
 * ```
 * because it's really this:
 * ```
 * ... "virtual" [the name]": "virtual" [the token] expected ...
 * ```
 * and that looks odd.
 *
 * @note This function isn't normally called directly; use the
 * #keyword_expected() macro instead.
 *
 * @param line The line number within this file where this function was called
 * from.
 * @param keyword A keyword literal.
 *
 * @sa l_elaborate_error()
 * @sa l_punct_expected()
 * @sa yyerror()
 */
static void l_keyword_expected( int line, char const *keyword ) {
  assert( keyword != NULL );

  dym_kind_t dym_kinds = DYM_NONE;

  char const *const error_token = printable_yytext();
  if ( error_token != NULL ) {
    if ( strcmp( error_token, keyword ) == 0 ) {
      //
      // The error token is the expected keyword which means the lexer returned
      // it as a name and not the token which likely means it's not a C/C++
      // keyword until a later version of the current language.
      //
      c_keyword_t const *const ck =
        c_keyword_find( keyword, LANG_ANY, C_KW_CTX_DEFAULT );
      if ( ck != NULL ) {
        char const *const which_lang = c_lang_which( ck->lang_ids );
        if ( which_lang[0] != '\0' ) {
          EPUTS( ": " );
          print_debug_file_line( __FILE__, line );
          EPRINTF( "\"%s\" not supported%s\n", keyword, which_lang );
          return;
        }
      }
    }

    dym_kinds = is_english_to_gibberish() ? DYM_CDECL_KEYWORDS : DYM_C_KEYWORDS;
  }

  l_elaborate_error( line, dym_kinds, "\"%s\" expected", keyword );
}

/**
 * Checks whether the type currently being declared (`enum`, `struct`,
 * `typedef`, or `union`) is nested within some other type (`struct` or
 * `union`) and whether the current language is C: if not, prints an error
 * message.
 *
 * @note It is unnecessary to check either when a `class` is being declared or
 * when a type is being declared within a `namespace` since those are not legal
 * in C anyway.
 *
 * @note This function isn't normally called directly; use the
 * #is_nested_type_ok() macro instead.
 *
 * @param line The line number within this file where this function was called
 * from.
 * @param type_loc The location of the type declaration.
 * @return Returns `true` only if the type currently being declared is either
 * not nested or the current language is C++.
 */
NODISCARD
static bool l_is_nested_type_ok( int line, c_loc_t const *type_loc ) {
  assert( type_loc != NULL );
  if ( !c_sname_empty( &in_attr.scope_sname ) &&
       !OPT_LANG_IS( NESTED_TYPES ) ) {
    fl_print_error( __FILE__, line, type_loc,
      "nested types not supported%s\n",
      C_LANG_WHICH( NESTED_TYPES )
    );
    return false;
  }
  return true;
}

/**
 * A special case of l_elaborate_error() that prevents oddly worded error
 * messages when a punctuation character is expected by not doing keyword look-
 * ups of the error token.
 *
 * For example, if l_elaborate_error() were used for the following \b cdecl
 * command, you'd get the following:
 * ```
 * explain void f(int g const)
 *                      ^
 * 29: syntax error: "const": ',' expected ("const" is a keyword)
 * ```
 * and that looks odd since, if a punctuation character was expected, it seems
 * silly to point out that the encountered token is a keyword.
 *
 * @note This function isn't normally called directly; use the
 * #punct_expected() macro instead.
 *
 * @param line The line number within this file where this function was called
 * from.
 * @param punct The punctuation character that was expected.
 *
 * @sa l_elaborate_error()
 * @sa l_keyword_expected()
 * @sa yyerror()
 */
static void l_punct_expected( int line, char punct ) {
  EPUTS( ": " );
  print_debug_file_line( __FILE__, line );
  if ( print_error_token( printable_yytext() ) )
    EPUTS( ": " );
  EPRINTF( "'%c' expected\n", punct );
}

/**
 * Cleans up individial parse data after each parse.
 *
 * @param fatal_error Must be `true` only if a fatal semantic error has
 * occurred and `YYABORT` is about to be called to bail out of parsing by
 * returning from yyparse().
 */
static void parse_cleanup( bool fatal_error ) {
  //
  // We need to reset the lexer differently depending on whether we completed a
  // parse with a fatal error.  If so, do a "hard" reset that also resets the
  // EOF flag of the lexer.
  //
  lexer_reset( /*hard_reset=*/fatal_error );

  if ( fatal_error && yytext[0] != '\n' ) {
    //
    // Generally, PARSE_ABORT() was called before getting to the '\n' at the
    // end of the line, so Flex will not have incremented yylineno: manually
    // increment yylineno here to compensate.
    //
    ++yylineno;
  }

  c_ast_list_cleanup_gc( &gc_ast_list );
  ia_cleanup();
}

/**
 * Called by Bison to print a parsing error message to standard error.
 *
 * @remarks A custom error printing function via `%%define parse.error custom`
 * and
 * [`yyreport_syntax_error()`](https://www.gnu.org/software/bison/manual/html_node/Syntax-Error-Reporting-Function.html)
 * is not done because printing a (perhaps long) list of all the possible
 * expected tokens isn't helpful.
 * @par
 * It's also more flexible to be able to call one of #elaborate_error(),
 * #keyword_expected(), or #punct_expected() at the point of the error rather
 * than having a single function try to figure out the best type of error
 * message to print.
 *
 * @note A newline is _not_ printed since the error message will be appended to
 * by l_elaborate_error().  For example, the parts of an error message are
 * printed by the functions shown:
 *
 *      42: syntax error: "int": "into" expected
 *      |--||----------||----------------------|
 *      |   |           |
 *      |   yyerror()   l_elaborate_error()
 *      |
 *      print_loc()
 *
 * @param msg The error message to print.  Bison invariably passes `syntax
 * error`.
 *
 * @sa l_elaborate_error()
 * @sa l_keyword_expected()
 * @sa l_punct_expected()
 * @sa print_loc()
 */
static void yyerror( char const *msg ) {
  assert( msg != NULL );

  c_loc_t const loc = lexer_loc();
  print_loc( &loc );

  color_start( stderr, sgr_error );
  EPUTS( msg );                         // no newline
  color_end( stderr, sgr_error );

  //
  // A syntax error has occurred, but syntax errors aren't fatal since Bison
  // tries to recover.  We'll clean-up the current parse, but YYABORT won't be
  // called so we won't bail out of parsing by returning from yyparse(); hence,
  // parsing will continue.
  //
  parse_cleanup( /*fatal_error=*/false );
}

/** @} */

///////////////////////////////////////////////////////////////////////////////

/// @cond DOXYGEN_IGNORE


#line 1334 "parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include  "parser.h" 
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_Y_cast = 3,                     /* Y_cast  */
  YYSYMBOL_Y_constant = 4,                 /* Y_constant  */
  YYSYMBOL_Y_declare = 5,                  /* Y_declare  */
  YYSYMBOL_Y_define = 6,                   /* Y_define  */
  YYSYMBOL_Y_dynamic = 7,                  /* Y_dynamic  */
  YYSYMBOL_Y_explain = 8,                  /* Y_explain  */
  YYSYMBOL_Y_no = 9,                       /* Y_no  */
  YYSYMBOL_Y_quit = 10,                    /* Y_quit  */
  YYSYMBOL_Y_reinterpret = 11,             /* Y_reinterpret  */
  YYSYMBOL_Y_set = 12,                     /* Y_set  */
  YYSYMBOL_Y_show = 13,                    /* Y_show  */
  YYSYMBOL_Y_aligned = 14,                 /* Y_aligned  */
  YYSYMBOL_Y_all = 15,                     /* Y_all  */
  YYSYMBOL_Y_array = 16,                   /* Y_array  */
  YYSYMBOL_Y_as = 17,                      /* Y_as  */
  YYSYMBOL_Y_binding = 18,                 /* Y_binding  */
  YYSYMBOL_Y_bit = 19,                     /* Y_bit  */
  YYSYMBOL_Y_bit_precise = 20,             /* Y_bit_precise  */
  YYSYMBOL_Y_bits = 21,                    /* Y_bits  */
  YYSYMBOL_Y_by = 22,                      /* Y_by  */
  YYSYMBOL_Y_bytes = 23,                   /* Y_bytes  */
  YYSYMBOL_Y_capturing = 24,               /* Y_capturing  */
  YYSYMBOL_Y_commands = 25,                /* Y_commands  */
  YYSYMBOL_Y_constructor = 26,             /* Y_constructor  */
  YYSYMBOL_Y_conversion = 27,              /* Y_conversion  */
  YYSYMBOL_Y_copy = 28,                    /* Y_copy  */
  YYSYMBOL_Y_defined = 29,                 /* Y_defined  */
  YYSYMBOL_Y_destructor = 30,              /* Y_destructor  */
  YYSYMBOL_Y_english = 31,                 /* Y_english  */
  YYSYMBOL_Y_evaluation = 32,              /* Y_evaluation  */
  YYSYMBOL_Y_expand = 33,                  /* Y_expand  */
  YYSYMBOL_Y_expression = 34,              /* Y_expression  */
  YYSYMBOL_Y_floating = 35,                /* Y_floating  */
  YYSYMBOL_Y_function = 36,                /* Y_function  */
  YYSYMBOL_Y_initialization = 37,          /* Y_initialization  */
  YYSYMBOL_Y_into = 38,                    /* Y_into  */
  YYSYMBOL_Y_lambda = 39,                  /* Y_lambda  */
  YYSYMBOL_Y_length = 40,                  /* Y_length  */
  YYSYMBOL_Y_linkage = 41,                 /* Y_linkage  */
  YYSYMBOL_Y_literal = 42,                 /* Y_literal  */
  YYSYMBOL_Y_macros = 43,                  /* Y_macros  */
  YYSYMBOL_Y_member = 44,                  /* Y_member  */
  YYSYMBOL_Y_non_empty = 45,               /* Y_non_empty  */
  YYSYMBOL_Y_non_member = 46,              /* Y_non_member  */
  YYSYMBOL_Y_of = 47,                      /* Y_of  */
  YYSYMBOL_Y_options = 48,                 /* Y_options  */
  YYSYMBOL_Y_point = 49,                   /* Y_point  */
  YYSYMBOL_Y_pointer = 50,                 /* Y_pointer  */
  YYSYMBOL_Y_precise = 51,                 /* Y_precise  */
  YYSYMBOL_Y_precision = 52,               /* Y_precision  */
  YYSYMBOL_Y_predefined = 53,              /* Y_predefined  */
  YYSYMBOL_Y_pure = 54,                    /* Y_pure  */
  YYSYMBOL_Y_reference = 55,               /* Y_reference  */
  YYSYMBOL_Y_returning = 56,               /* Y_returning  */
  YYSYMBOL_Y_rvalue = 57,                  /* Y_rvalue  */
  YYSYMBOL_Y_scope = 58,                   /* Y_scope  */
  YYSYMBOL_Y_structured = 59,              /* Y_structured  */
  YYSYMBOL_Y_to = 60,                      /* Y_to  */
  YYSYMBOL_Y_user = 61,                    /* Y_user  */
  YYSYMBOL_Y_user_defined = 62,            /* Y_user_defined  */
  YYSYMBOL_Y_variable = 63,                /* Y_variable  */
  YYSYMBOL_Y_wide = 64,                    /* Y_wide  */
  YYSYMBOL_Y_width = 65,                   /* Y_width  */
  YYSYMBOL_Y_PREC_LESS_THAN_upc_layout_qualifier = 66, /* Y_PREC_LESS_THAN_upc_layout_qualifier  */
  YYSYMBOL_Y_COLON_COLON = 67,             /* Y_COLON_COLON  */
  YYSYMBOL_68_ = 68,                       /* "::"  */
  YYSYMBOL_Y_COLON_COLON_STAR = 69,        /* Y_COLON_COLON_STAR  */
  YYSYMBOL_Y_PLUS_PLUS = 70,               /* "++"  */
  YYSYMBOL_Y_MINUS_MINUS = 71,             /* "--"  */
  YYSYMBOL_72_ = 72,                       /* '('  */
  YYSYMBOL_73_ = 73,                       /* ')'  */
  YYSYMBOL_74_ = 74,                       /* '['  */
  YYSYMBOL_75_ = 75,                       /* ']'  */
  YYSYMBOL_76_ = 76,                       /* '.'  */
  YYSYMBOL_Y_MINUS_GREATER = 77,           /* Y_MINUS_GREATER  */
  YYSYMBOL_78_ = 78,                       /* "->"  */
  YYSYMBOL_79_ = 79,                       /* '&'  */
  YYSYMBOL_80_ = 80,                       /* '*'  */
  YYSYMBOL_81_ = 81,                       /* '!'  */
  YYSYMBOL_Y_sizeof = 82,                  /* Y_sizeof  */
  YYSYMBOL_83_ = 83,                       /* '~'  */
  YYSYMBOL_Y_DOT_STAR = 84,                /* Y_DOT_STAR  */
  YYSYMBOL_85_ = 85,                       /* ".*"  */
  YYSYMBOL_Y_MINUS_GREATER_STAR = 86,      /* Y_MINUS_GREATER_STAR  */
  YYSYMBOL_87_ = 87,                       /* "->*"  */
  YYSYMBOL_88_ = 88,                       /* '/'  */
  YYSYMBOL_89_ = 89,                       /* '%'  */
  YYSYMBOL_90_ = 90,                       /* '-'  */
  YYSYMBOL_91_ = 91,                       /* '+'  */
  YYSYMBOL_Y_LESS_LESS = 92,               /* Y_LESS_LESS  */
  YYSYMBOL_93_ = 93,                       /* "<<"  */
  YYSYMBOL_Y_GREATER_GREATER = 94,         /* Y_GREATER_GREATER  */
  YYSYMBOL_95_ = 95,                       /* ">>"  */
  YYSYMBOL_Y_LESS_EQUAL_GREATER = 96,      /* Y_LESS_EQUAL_GREATER  */
  YYSYMBOL_97_ = 97,                       /* "<=>"  */
  YYSYMBOL_98_ = 98,                       /* '<'  */
  YYSYMBOL_99_ = 99,                       /* '>'  */
  YYSYMBOL_Y_LESS_EQUAL = 100,             /* Y_LESS_EQUAL  */
  YYSYMBOL_101_ = 101,                     /* "<="  */
  YYSYMBOL_Y_GREATER_EQUAL = 102,          /* Y_GREATER_EQUAL  */
  YYSYMBOL_103_ = 103,                     /* ">="  */
  YYSYMBOL_Y_EQUAL_EQUAL = 104,            /* Y_EQUAL_EQUAL  */
  YYSYMBOL_105_ = 105,                     /* "=="  */
  YYSYMBOL_Y_EXCLAM_EQUAL = 106,           /* Y_EXCLAM_EQUAL  */
  YYSYMBOL_Y_bit_and = 107,                /* Y_bit_and  */
  YYSYMBOL_108_ = 108,                     /* '^'  */
  YYSYMBOL_109_ = 109,                     /* '|'  */
  YYSYMBOL_Y_AMPER_AMPER = 110,            /* Y_AMPER_AMPER  */
  YYSYMBOL_Y_PIPE_PIPE = 111,              /* Y_PIPE_PIPE  */
  YYSYMBOL_Y_QMARK_COLON = 112,            /* Y_QMARK_COLON  */
  YYSYMBOL_113_ = 113,                     /* "?:"  */
  YYSYMBOL_114_ = 114,                     /* '='  */
  YYSYMBOL_Y_PERCENT_EQUAL = 115,          /* Y_PERCENT_EQUAL  */
  YYSYMBOL_116_ = 116,                     /* "%="  */
  YYSYMBOL_Y_AMPER_EQUAL = 117,            /* Y_AMPER_EQUAL  */
  YYSYMBOL_Y_STAR_EQUAL = 118,             /* Y_STAR_EQUAL  */
  YYSYMBOL_119_ = 119,                     /* "*="  */
  YYSYMBOL_Y_PLUS_EQUAL = 120,             /* Y_PLUS_EQUAL  */
  YYSYMBOL_121_ = 121,                     /* "+="  */
  YYSYMBOL_Y_MINUS_EQUAL = 122,            /* Y_MINUS_EQUAL  */
  YYSYMBOL_123_ = 123,                     /* "-="  */
  YYSYMBOL_Y_SLASH_EQUAL = 124,            /* Y_SLASH_EQUAL  */
  YYSYMBOL_125_ = 125,                     /* "/="  */
  YYSYMBOL_Y_LESS_LESS_EQUAL = 126,        /* Y_LESS_LESS_EQUAL  */
  YYSYMBOL_127_ = 127,                     /* "<<="  */
  YYSYMBOL_Y_GREATER_GREATER_EQUAL = 128,  /* Y_GREATER_GREATER_EQUAL  */
  YYSYMBOL_129_ = 129,                     /* ">>="  */
  YYSYMBOL_Y_CARET_EQUAL = 130,            /* Y_CARET_EQUAL  */
  YYSYMBOL_Y_PIPE_EQUAL = 131,             /* Y_PIPE_EQUAL  */
  YYSYMBOL_132_ = 132,                     /* ','  */
  YYSYMBOL_Y_auto_STORAGE = 133,           /* Y_auto_STORAGE  */
  YYSYMBOL_Y_break = 134,                  /* Y_break  */
  YYSYMBOL_Y_case = 135,                   /* Y_case  */
  YYSYMBOL_Y_char = 136,                   /* Y_char  */
  YYSYMBOL_Y_continue = 137,               /* Y_continue  */
  YYSYMBOL_Y_default = 138,                /* Y_default  */
  YYSYMBOL_Y_do = 139,                     /* Y_do  */
  YYSYMBOL_Y_double = 140,                 /* Y_double  */
  YYSYMBOL_Y_else = 141,                   /* Y_else  */
  YYSYMBOL_Y_extern = 142,                 /* Y_extern  */
  YYSYMBOL_Y_float = 143,                  /* Y_float  */
  YYSYMBOL_Y_for = 144,                    /* Y_for  */
  YYSYMBOL_Y_goto = 145,                   /* Y_goto  */
  YYSYMBOL_Y_if = 146,                     /* Y_if  */
  YYSYMBOL_Y_int = 147,                    /* Y_int  */
  YYSYMBOL_Y_long = 148,                   /* Y_long  */
  YYSYMBOL_Y_register = 149,               /* Y_register  */
  YYSYMBOL_Y_return = 150,                 /* Y_return  */
  YYSYMBOL_Y_short = 151,                  /* Y_short  */
  YYSYMBOL_Y_static = 152,                 /* Y_static  */
  YYSYMBOL_Y_struct = 153,                 /* Y_struct  */
  YYSYMBOL_Y_switch = 154,                 /* Y_switch  */
  YYSYMBOL_Y_typedef = 155,                /* Y_typedef  */
  YYSYMBOL_Y_union = 156,                  /* Y_union  */
  YYSYMBOL_Y_unsigned = 157,               /* Y_unsigned  */
  YYSYMBOL_Y_while = 158,                  /* Y_while  */
  YYSYMBOL_159_ = 159,                     /* '#'  */
  YYSYMBOL_Y_PRE_CONCAT = 160,             /* "##"  */
  YYSYMBOL_Y_PRE_SPACE = 161,              /* Y_PRE_SPACE  */
  YYSYMBOL_Y_PRE_define = 162,             /* Y_PRE_define  */
  YYSYMBOL_Y_PRE_elif = 163,               /* Y_PRE_elif  */
  YYSYMBOL_Y_PRE_else = 164,               /* Y_PRE_else  */
  YYSYMBOL_Y_PRE_error = 165,              /* Y_PRE_error  */
  YYSYMBOL_Y_PRE_if = 166,                 /* Y_PRE_if  */
  YYSYMBOL_Y_PRE_ifdef = 167,              /* Y_PRE_ifdef  */
  YYSYMBOL_Y_PRE_ifndef = 168,             /* Y_PRE_ifndef  */
  YYSYMBOL_Y_PRE_line = 169,               /* Y_PRE_line  */
  YYSYMBOL_Y_PRE_undef = 170,              /* Y_PRE_undef  */
  YYSYMBOL_Y_PRE___VA_ARGS__ = 171,        /* Y_PRE___VA_ARGS__  */
  YYSYMBOL_Y_PRE___VA_OPT__ = 172,         /* Y_PRE___VA_OPT__  */
  YYSYMBOL_Y_PRE_pragma = 173,             /* Y_PRE_pragma  */
  YYSYMBOL_Y_PRE_elifdef = 174,            /* Y_PRE_elifdef  */
  YYSYMBOL_Y_PRE_elifndef = 175,           /* Y_PRE_elifndef  */
  YYSYMBOL_Y_PRE_embed = 176,              /* Y_PRE_embed  */
  YYSYMBOL_Y_PRE_warning = 177,            /* Y_PRE_warning  */
  YYSYMBOL_Y_asm = 178,                    /* Y_asm  */
  YYSYMBOL_Y_const = 179,                  /* Y_const  */
  YYSYMBOL_Y_ELLIPSIS = 180,               /* "..."  */
  YYSYMBOL_Y_enum = 181,                   /* Y_enum  */
  YYSYMBOL_Y_signed = 182,                 /* Y_signed  */
  YYSYMBOL_Y_void = 183,                   /* Y_void  */
  YYSYMBOL_Y_volatile = 184,               /* Y_volatile  */
  YYSYMBOL_Y_wchar_t = 185,                /* Y_wchar_t  */
  YYSYMBOL_Y__Bool = 186,                  /* Y__Bool  */
  YYSYMBOL_Y__Complex = 187,               /* Y__Complex  */
  YYSYMBOL_Y__Imaginary = 188,             /* Y__Imaginary  */
  YYSYMBOL_Y_inline = 189,                 /* Y_inline  */
  YYSYMBOL_Y_restrict = 190,               /* Y_restrict  */
  YYSYMBOL_Y__Alignas = 191,               /* Y__Alignas  */
  YYSYMBOL_Y__Alignof = 192,               /* Y__Alignof  */
  YYSYMBOL_Y__Atomic_QUAL = 193,           /* Y__Atomic_QUAL  */
  YYSYMBOL_Y__Atomic_SPEC = 194,           /* Y__Atomic_SPEC  */
  YYSYMBOL_Y__Generic = 195,               /* Y__Generic  */
  YYSYMBOL_Y__Noreturn = 196,              /* Y__Noreturn  */
  YYSYMBOL_Y__Static_assert = 197,         /* Y__Static_assert  */
  YYSYMBOL_Y__Thread_local = 198,          /* Y__Thread_local  */
  YYSYMBOL_Y_thread = 199,                 /* Y_thread  */
  YYSYMBOL_Y_local = 200,                  /* Y_local  */
  YYSYMBOL_Y_bool = 201,                   /* Y_bool  */
  YYSYMBOL_Y_catch = 202,                  /* Y_catch  */
  YYSYMBOL_Y_class = 203,                  /* Y_class  */
  YYSYMBOL_Y_const_cast = 204,             /* Y_const_cast  */
  YYSYMBOL_Y_CONSTRUCTOR_SNAME = 205,      /* Y_CONSTRUCTOR_SNAME  */
  YYSYMBOL_Y_delete = 206,                 /* Y_delete  */
  YYSYMBOL_Y_DESTRUCTOR_SNAME = 207,       /* Y_DESTRUCTOR_SNAME  */
  YYSYMBOL_Y_dynamic_cast = 208,           /* Y_dynamic_cast  */
  YYSYMBOL_Y_explicit = 209,               /* Y_explicit  */
  YYSYMBOL_Y_false = 210,                  /* Y_false  */
  YYSYMBOL_Y_friend = 211,                 /* Y_friend  */
  YYSYMBOL_Y_mutable = 212,                /* Y_mutable  */
  YYSYMBOL_Y_namespace = 213,              /* Y_namespace  */
  YYSYMBOL_Y_new = 214,                    /* Y_new  */
  YYSYMBOL_Y_operator = 215,               /* Y_operator  */
  YYSYMBOL_Y_OPERATOR_SNAME = 216,         /* Y_OPERATOR_SNAME  */
  YYSYMBOL_Y_private = 217,                /* Y_private  */
  YYSYMBOL_Y_protected = 218,              /* Y_protected  */
  YYSYMBOL_Y_public = 219,                 /* Y_public  */
  YYSYMBOL_Y_reinterpret_cast = 220,       /* Y_reinterpret_cast  */
  YYSYMBOL_Y_static_cast = 221,            /* Y_static_cast  */
  YYSYMBOL_Y_template = 222,               /* Y_template  */
  YYSYMBOL_Y_this = 223,                   /* Y_this  */
  YYSYMBOL_Y_throw = 224,                  /* Y_throw  */
  YYSYMBOL_Y_true = 225,                   /* Y_true  */
  YYSYMBOL_Y_try = 226,                    /* Y_try  */
  YYSYMBOL_Y_typeid = 227,                 /* Y_typeid  */
  YYSYMBOL_Y_typename = 228,               /* Y_typename  */
  YYSYMBOL_Y_using = 229,                  /* Y_using  */
  YYSYMBOL_Y_virtual = 230,                /* Y_virtual  */
  YYSYMBOL_Y_char16_t = 231,               /* Y_char16_t  */
  YYSYMBOL_Y_char32_t = 232,               /* Y_char32_t  */
  YYSYMBOL_Y__BitInt = 233,                /* Y__BitInt  */
  YYSYMBOL_Y_reproducible = 234,           /* Y_reproducible  */
  YYSYMBOL_Y_typeof = 235,                 /* Y_typeof  */
  YYSYMBOL_Y_typeof_unqual = 236,          /* Y_typeof_unqual  */
  YYSYMBOL_Y_unsequenced = 237,            /* Y_unsequenced  */
  YYSYMBOL_Y_ATTR_BEGIN = 238,             /* Y_ATTR_BEGIN  */
  YYSYMBOL_Y_auto_TYPE = 239,              /* Y_auto_TYPE  */
  YYSYMBOL_Y_alignas = 240,                /* Y_alignas  */
  YYSYMBOL_Y_alignof = 241,                /* Y_alignof  */
  YYSYMBOL_Y_carries = 242,                /* Y_carries  */
  YYSYMBOL_Y_dependency = 243,             /* Y_dependency  */
  YYSYMBOL_Y_carries_dependency = 244,     /* Y_carries_dependency  */
  YYSYMBOL_Y_constexpr = 245,              /* Y_constexpr  */
  YYSYMBOL_Y_decltype = 246,               /* Y_decltype  */
  YYSYMBOL_Y_except = 247,                 /* Y_except  */
  YYSYMBOL_Y_final = 248,                  /* Y_final  */
  YYSYMBOL_Y_noexcept = 249,               /* Y_noexcept  */
  YYSYMBOL_Y_nullptr = 250,                /* Y_nullptr  */
  YYSYMBOL_Y_override = 251,               /* Y_override  */
  YYSYMBOL_Y_static_assert = 252,          /* Y_static_assert  */
  YYSYMBOL_Y_thread_local = 253,           /* Y_thread_local  */
  YYSYMBOL_Y_deprecated = 254,             /* Y_deprecated  */
  YYSYMBOL_Y_auto_STRUCTURED_BINDING = 255, /* Y_auto_STRUCTURED_BINDING  */
  YYSYMBOL_Y_discard = 256,                /* Y_discard  */
  YYSYMBOL_Y_maybe_unused = 257,           /* Y_maybe_unused  */
  YYSYMBOL_Y_maybe = 258,                  /* Y_maybe  */
  YYSYMBOL_Y_unused = 259,                 /* Y_unused  */
  YYSYMBOL_Y_nodiscard = 260,              /* Y_nodiscard  */
  YYSYMBOL_Y_noreturn = 261,               /* Y_noreturn  */
  YYSYMBOL_Y_char8_t = 262,                /* Y_char8_t  */
  YYSYMBOL_Y_concept = 263,                /* Y_concept  */
  YYSYMBOL_Y_consteval = 264,              /* Y_consteval  */
  YYSYMBOL_Y_constinit = 265,              /* Y_constinit  */
  YYSYMBOL_Y_co_await = 266,               /* Y_co_await  */
  YYSYMBOL_Y_co_return = 267,              /* Y_co_return  */
  YYSYMBOL_Y_co_yield = 268,               /* Y_co_yield  */
  YYSYMBOL_Y_export = 269,                 /* Y_export  */
  YYSYMBOL_Y_no_unique_address = 270,      /* Y_no_unique_address  */
  YYSYMBOL_Y_parameter = 271,              /* Y_parameter  */
  YYSYMBOL_Y_pack = 272,                   /* Y_pack  */
  YYSYMBOL_Y_requires = 273,               /* Y_requires  */
  YYSYMBOL_Y_unique = 274,                 /* Y_unique  */
  YYSYMBOL_Y_address = 275,                /* Y_address  */
  YYSYMBOL_Y_indeterminate = 276,          /* Y_indeterminate  */
  YYSYMBOL_Y_EMC__Accum = 277,             /* Y_EMC__Accum  */
  YYSYMBOL_Y_EMC__Fract = 278,             /* Y_EMC__Fract  */
  YYSYMBOL_Y_EMC__Sat = 279,               /* Y_EMC__Sat  */
  YYSYMBOL_Y_UPC_relaxed = 280,            /* Y_UPC_relaxed  */
  YYSYMBOL_Y_UPC_shared = 281,             /* Y_UPC_shared  */
  YYSYMBOL_Y_UPC_strict = 282,             /* Y_UPC_strict  */
  YYSYMBOL_Y_GNU___attribute__ = 283,      /* Y_GNU___attribute__  */
  YYSYMBOL_Y_GNU___restrict = 284,         /* Y_GNU___restrict  */
  YYSYMBOL_Y_Apple___block = 285,          /* Y_Apple___block  */
  YYSYMBOL_Y_Apple_block = 286,            /* Y_Apple_block  */
  YYSYMBOL_Y_MSC___cdecl = 287,            /* Y_MSC___cdecl  */
  YYSYMBOL_Y_MSC___clrcall = 288,          /* Y_MSC___clrcall  */
  YYSYMBOL_Y_MSC___declspec = 289,         /* Y_MSC___declspec  */
  YYSYMBOL_Y_MSC___fastcall = 290,         /* Y_MSC___fastcall  */
  YYSYMBOL_Y_MSC___stdcall = 291,          /* Y_MSC___stdcall  */
  YYSYMBOL_Y_MSC___thiscall = 292,         /* Y_MSC___thiscall  */
  YYSYMBOL_Y_MSC___vectorcall = 293,       /* Y_MSC___vectorcall  */
  YYSYMBOL_294_ = 294,                     /* ':'  */
  YYSYMBOL_295_ = 295,                     /* ';'  */
  YYSYMBOL_296_ = 296,                     /* '{'  */
  YYSYMBOL_297_ = 297,                     /* '}'  */
  YYSYMBOL_Y_CHAR_LIT = 298,               /* Y_CHAR_LIT  */
  YYSYMBOL_Y_CONCEPT_SNAME = 299,          /* Y_CONCEPT_SNAME  */
  YYSYMBOL_Y_END = 300,                    /* Y_END  */
  YYSYMBOL_Y_ERROR = 301,                  /* Y_ERROR  */
  YYSYMBOL_Y_FLOAT_LIT = 302,              /* Y_FLOAT_LIT  */
  YYSYMBOL_Y_GLOB = 303,                   /* Y_GLOB  */
  YYSYMBOL_Y_INT_LIT = 304,                /* Y_INT_LIT  */
  YYSYMBOL_Y_NAME = 305,                   /* Y_NAME  */
  YYSYMBOL_Y_SET_OPTION = 306,             /* Y_SET_OPTION  */
  YYSYMBOL_Y_STR_LIT = 307,                /* Y_STR_LIT  */
  YYSYMBOL_Y_TYPEDEF_NAME_TDEF = 308,      /* Y_TYPEDEF_NAME_TDEF  */
  YYSYMBOL_Y_TYPEDEF_SNAME_TDEF = 309,     /* Y_TYPEDEF_SNAME_TDEF  */
  YYSYMBOL_Y_LEXER_ERROR = 310,            /* Y_LEXER_ERROR  */
  YYSYMBOL_311_ = 311,                     /* '$'  */
  YYSYMBOL_312_ = 312,                     /* '@'  */
  YYSYMBOL_313_ = 313,                     /* '`'  */
  YYSYMBOL_314_ = 314,                     /* '?'  */
  YYSYMBOL_YYACCEPT = 315,                 /* $accept  */
  YYSYMBOL_command_list = 316,             /* command_list  */
  YYSYMBOL_command = 317,                  /* command  */
  YYSYMBOL_cast_command = 318,             /* cast_command  */
  YYSYMBOL_new_style_cast_english = 319,   /* new_style_cast_english  */
  YYSYMBOL_declare_command = 320,          /* declare_command  */
  YYSYMBOL_321_1 = 321,                    /* $@1  */
  YYSYMBOL_alignas_or_width_decl_english_ast = 322, /* alignas_or_width_decl_english_ast  */
  YYSYMBOL_alignas_specifier_english = 323, /* alignas_specifier_english  */
  YYSYMBOL_aligned_english = 324,          /* aligned_english  */
  YYSYMBOL_capturing_paren_capture_decl_list_english_opt = 325, /* capturing_paren_capture_decl_list_english_opt  */
  YYSYMBOL_paren_capture_decl_list_english = 326, /* paren_capture_decl_list_english  */
  YYSYMBOL_capture_decl_list_english_opt = 327, /* capture_decl_list_english_opt  */
  YYSYMBOL_capture_decl_list_english = 328, /* capture_decl_list_english  */
  YYSYMBOL_capture_decl_english_ast = 329, /* capture_decl_english_ast  */
  YYSYMBOL_capture_default_opt = 330,      /* capture_default_opt  */
  YYSYMBOL_width_specifier_english_uint = 331, /* width_specifier_english_uint  */
  YYSYMBOL_storage_class_subset_english_type_opt = 332, /* storage_class_subset_english_type_opt  */
  YYSYMBOL_storage_class_subset_english_type = 333, /* storage_class_subset_english_type  */
  YYSYMBOL_storage_class_subset_english_stid = 334, /* storage_class_subset_english_stid  */
  YYSYMBOL_define_command = 335,           /* define_command  */
  YYSYMBOL_expand_command = 336,           /* expand_command  */
  YYSYMBOL_expand_command2 = 337,          /* expand_command2  */
  YYSYMBOL_p_extra_token_except_lparen = 338, /* p_extra_token_except_lparen  */
  YYSYMBOL_p_extra_tokens_opt = 339,       /* p_extra_tokens_opt  */
  YYSYMBOL_p_extra_tokens = 340,           /* p_extra_tokens  */
  YYSYMBOL_p_extra_token = 341,            /* p_extra_token  */
  YYSYMBOL_p_arg_list_opt = 342,           /* p_arg_list_opt  */
  YYSYMBOL_p_comma_arg_list = 343,         /* p_comma_arg_list  */
  YYSYMBOL_p_arg_list = 344,               /* p_arg_list  */
  YYSYMBOL_p_arg_tokens = 345,             /* p_arg_tokens  */
  YYSYMBOL_p_arg_token_as_list = 346,      /* p_arg_token_as_list  */
  YYSYMBOL_p_arg_token = 347,              /* p_arg_token  */
  YYSYMBOL_p_num_lit = 348,                /* p_num_lit  */
  YYSYMBOL_p_other = 349,                  /* p_other  */
  YYSYMBOL_p_punctuator = 350,             /* p_punctuator  */
  YYSYMBOL_p_arg_tokens_with_comma_opt = 351, /* p_arg_tokens_with_comma_opt  */
  YYSYMBOL_p_arg_tokens_with_comma = 352,  /* p_arg_tokens_with_comma  */
  YYSYMBOL_p_arg_token_with_comma_as_list = 353, /* p_arg_token_with_comma_as_list  */
  YYSYMBOL_p_arg_token_with_comma = 354,   /* p_arg_token_with_comma  */
  YYSYMBOL_explain_command = 355,          /* explain_command  */
  YYSYMBOL_356_2 = 356,                    /* $@2  */
  YYSYMBOL_explain = 357,                  /* explain  */
  YYSYMBOL_help_command = 358,             /* help_command  */
  YYSYMBOL_359_3 = 359,                    /* $@3  */
  YYSYMBOL_help_what_opt = 360,            /* help_what_opt  */
  YYSYMBOL_preprocessor_command = 361,     /* preprocessor_command  */
  YYSYMBOL_p_define = 362,                 /* p_define  */
  YYSYMBOL_p_paren_param_list_opt = 363,   /* p_paren_param_list_opt  */
  YYSYMBOL_p_param_list_opt = 364,         /* p_param_list_opt  */
  YYSYMBOL_p_param_list = 365,             /* p_param_list  */
  YYSYMBOL_p_param = 366,                  /* p_param  */
  YYSYMBOL_p_replace_list_opt = 367,       /* p_replace_list_opt  */
  YYSYMBOL_p_replace_list = 368,           /* p_replace_list  */
  YYSYMBOL_p_replace_token = 369,          /* p_replace_token  */
  YYSYMBOL_p_undef = 370,                  /* p_undef  */
  YYSYMBOL_quit_command = 371,             /* quit_command  */
  YYSYMBOL_scoped_command = 372,           /* scoped_command  */
  YYSYMBOL_set_command = 373,              /* set_command  */
  YYSYMBOL_set_option_list = 374,          /* set_option_list  */
  YYSYMBOL_set_option = 375,               /* set_option  */
  YYSYMBOL_set_option_value_opt = 376,     /* set_option_value_opt  */
  YYSYMBOL_show_command = 377,             /* show_command  */
  YYSYMBOL_show_format = 378,              /* show_format  */
  YYSYMBOL_show_format_exp = 379,          /* show_format_exp  */
  YYSYMBOL_show_format_opt = 380,          /* show_format_opt  */
  YYSYMBOL_show_types_opt = 381,           /* show_types_opt  */
  YYSYMBOL_predefined_or_user_types_opt = 382, /* predefined_or_user_types_opt  */
  YYSYMBOL_template_command = 383,         /* template_command  */
  YYSYMBOL_typedef_command = 384,          /* typedef_command  */
  YYSYMBOL_using_command = 385,            /* using_command  */
  YYSYMBOL_c_style_cast_expr_c = 386,      /* c_style_cast_expr_c  */
  YYSYMBOL_387_4 = 387,                    /* $@4  */
  YYSYMBOL_new_style_cast_expr_c = 388,    /* new_style_cast_expr_c  */
  YYSYMBOL_389_5 = 389,                    /* $@5  */
  YYSYMBOL_new_style_cast_c = 390,         /* new_style_cast_c  */
  YYSYMBOL_aligned_declaration_c = 391,    /* aligned_declaration_c  */
  YYSYMBOL_392_6 = 392,                    /* $@6  */
  YYSYMBOL_393_7 = 393,                    /* $@7  */
  YYSYMBOL_alignas_specifier_c = 394,      /* alignas_specifier_c  */
  YYSYMBOL_395_8 = 395,                    /* $@8  */
  YYSYMBOL_alignas = 396,                  /* alignas  */
  YYSYMBOL_asm_declaration_c = 397,        /* asm_declaration_c  */
  YYSYMBOL_scoped_declaration_c = 398,     /* scoped_declaration_c  */
  YYSYMBOL_class_struct_union_declaration_c = 399, /* class_struct_union_declaration_c  */
  YYSYMBOL_400_9 = 400,                    /* $@9  */
  YYSYMBOL_401_10 = 401,                   /* $@10  */
  YYSYMBOL_enum_declaration_c = 402,       /* enum_declaration_c  */
  YYSYMBOL_403_11 = 403,                   /* $@11  */
  YYSYMBOL_namespace_declaration_c = 404,  /* namespace_declaration_c  */
  YYSYMBOL_405_12 = 405,                   /* $@12  */
  YYSYMBOL_406_13 = 406,                   /* $@13  */
  YYSYMBOL_namespace_sname_c_exp = 407,    /* namespace_sname_c_exp  */
  YYSYMBOL_namespace_sname_c = 408,        /* namespace_sname_c  */
  YYSYMBOL_namespace_typedef_sname_c = 409, /* namespace_typedef_sname_c  */
  YYSYMBOL_brace_in_scope_declaration_c_exp = 410, /* brace_in_scope_declaration_c_exp  */
  YYSYMBOL_brace_in_scope_declaration_c_opt = 411, /* brace_in_scope_declaration_c_opt  */
  YYSYMBOL_brace_in_scope_declaration_c = 412, /* brace_in_scope_declaration_c  */
  YYSYMBOL_in_scope_declaration_c_exp = 413, /* in_scope_declaration_c_exp  */
  YYSYMBOL_lambda_declaration_c = 414,     /* lambda_declaration_c  */
  YYSYMBOL_capture_decl_list_c_opt = 415,  /* capture_decl_list_c_opt  */
  YYSYMBOL_capture_decl_list_c = 416,      /* capture_decl_list_c  */
  YYSYMBOL_capture_decl_c_ast = 417,       /* capture_decl_c_ast  */
  YYSYMBOL_lambda_return_type_c_ast_opt = 418, /* lambda_return_type_c_ast_opt  */
  YYSYMBOL_419_14 = 419,                   /* $@14  */
  YYSYMBOL_template_declaration_c = 420,   /* template_declaration_c  */
  YYSYMBOL_typed_declaration_c = 421,      /* typed_declaration_c  */
  YYSYMBOL_422_15 = 422,                   /* $@15  */
  YYSYMBOL_typedef_declaration_c = 423,    /* typedef_declaration_c  */
  YYSYMBOL_424_16 = 424,                   /* $@16  */
  YYSYMBOL_425_17 = 425,                   /* $@17  */
  YYSYMBOL_typedef_decl_list_c = 426,      /* typedef_decl_list_c  */
  YYSYMBOL_typedef_decl_c = 427,           /* typedef_decl_c  */
  YYSYMBOL_typedef_decl_c_exp = 428,       /* typedef_decl_c_exp  */
  YYSYMBOL_user_defined_conversion_declaration_c = 429, /* user_defined_conversion_declaration_c  */
  YYSYMBOL_using_declaration_c = 430,      /* using_declaration_c  */
  YYSYMBOL_using_decl_c_ast = 431,         /* using_decl_c_ast  */
  YYSYMBOL_432_18 = 432,                   /* $@18  */
  YYSYMBOL_433_19 = 433,                   /* $@19  */
  YYSYMBOL_decl_list_c_opt = 434,          /* decl_list_c_opt  */
  YYSYMBOL_decl_list_c = 435,              /* decl_list_c  */
  YYSYMBOL_decl_c = 436,                   /* decl_c  */
  YYSYMBOL_decl_c_exp = 437,               /* decl_c_exp  */
  YYSYMBOL_decl_c_astp = 438,              /* decl_c_astp  */
  YYSYMBOL_msc_calling_convention_c_astp = 439, /* msc_calling_convention_c_astp  */
  YYSYMBOL_decl2_c_astp = 440,             /* decl2_c_astp  */
  YYSYMBOL_param_pack_decl_c_ast = 441,    /* param_pack_decl_c_ast  */
  YYSYMBOL_array_decl_c_astp = 442,        /* array_decl_c_astp  */
  YYSYMBOL_array_size_c_ast = 443,         /* array_size_c_ast  */
  YYSYMBOL_block_decl_c_astp = 444,        /* block_decl_c_astp  */
  YYSYMBOL_445_20 = 445,                   /* $@20  */
  YYSYMBOL_destructor_declaration_c = 446, /* destructor_declaration_c  */
  YYSYMBOL_no_destructor_params = 447,     /* no_destructor_params  */
  YYSYMBOL_file_scope_constructor_declaration_c = 448, /* file_scope_constructor_declaration_c  */
  YYSYMBOL_file_scope_destructor_declaration_c = 449, /* file_scope_destructor_declaration_c  */
  YYSYMBOL_func_decl_c_astp = 450,         /* func_decl_c_astp  */
  YYSYMBOL_pc99_func_or_constructor_declaration_c = 451, /* pc99_func_or_constructor_declaration_c  */
  YYSYMBOL_452_21 = 452,                   /* $@21  */
  YYSYMBOL_param_list_rparen_func_qualifier_list_c_stid_opt = 453, /* param_list_rparen_func_qualifier_list_c_stid_opt  */
  YYSYMBOL_454_22 = 454,                   /* $@22  */
  YYSYMBOL_func_qualifier_list_c_stid_opt = 455, /* func_qualifier_list_c_stid_opt  */
  YYSYMBOL_func_qualifier_c_stid = 456,    /* func_qualifier_c_stid  */
  YYSYMBOL_noexcept_c_stid_opt = 457,      /* noexcept_c_stid_opt  */
  YYSYMBOL_noexcept_bool_stid_exp = 458,   /* noexcept_bool_stid_exp  */
  YYSYMBOL_trailing_return_type_c_ast_opt = 459, /* trailing_return_type_c_ast_opt  */
  YYSYMBOL_460_23 = 460,                   /* $@23  */
  YYSYMBOL_func_equals_c_stid_opt = 461,   /* func_equals_c_stid_opt  */
  YYSYMBOL_delete_reason_opt = 462,        /* delete_reason_opt  */
  YYSYMBOL_param_c_ast_list_exp = 463,     /* param_c_ast_list_exp  */
  YYSYMBOL_param_c_ast_list_opt = 464,     /* param_c_ast_list_opt  */
  YYSYMBOL_param_c_ast_list = 465,         /* param_c_ast_list  */
  YYSYMBOL_param_c_ast = 466,              /* param_c_ast  */
  YYSYMBOL_467_24 = 467,                   /* $@24  */
  YYSYMBOL_param_c_ast_exp = 468,          /* param_c_ast_exp  */
  YYSYMBOL_paren_param_c_ast_list_opt = 469, /* paren_param_c_ast_list_opt  */
  YYSYMBOL_param_list_c_lparen = 470,      /* param_list_c_lparen  */
  YYSYMBOL_param_list_rparen = 471,        /* param_list_rparen  */
  YYSYMBOL_nested_decl_c_astp = 472,       /* nested_decl_c_astp  */
  YYSYMBOL_473_25 = 473,                   /* $@25  */
  YYSYMBOL_oper_decl_c_astp = 474,         /* oper_decl_c_astp  */
  YYSYMBOL_pointer_decl_c_astp = 475,      /* pointer_decl_c_astp  */
  YYSYMBOL_476_26 = 476,                   /* $@26  */
  YYSYMBOL_pointer_type_c_ast = 477,       /* pointer_type_c_ast  */
  YYSYMBOL_pc99_pointer_decl_list_c = 478, /* pc99_pointer_decl_list_c  */
  YYSYMBOL_pc99_pointer_decl_c = 479,      /* pc99_pointer_decl_c  */
  YYSYMBOL_480_27 = 480,                   /* $@27  */
  YYSYMBOL_pc99_pointer_type_c_ast = 481,  /* pc99_pointer_type_c_ast  */
  YYSYMBOL_pointer_to_member_decl_c_astp = 482, /* pointer_to_member_decl_c_astp  */
  YYSYMBOL_483_28 = 483,                   /* $@28  */
  YYSYMBOL_pointer_to_member_type_c_ast = 484, /* pointer_to_member_type_c_ast  */
  YYSYMBOL_reference_decl_c_astp = 485,    /* reference_decl_c_astp  */
  YYSYMBOL_486_29 = 486,                   /* $@29  */
  YYSYMBOL_reference_type_c_ast = 487,     /* reference_type_c_ast  */
  YYSYMBOL_typedef_type_decl_c_ast = 488,  /* typedef_type_decl_c_ast  */
  YYSYMBOL_user_defined_conversion_decl_c_astp = 489, /* user_defined_conversion_decl_c_astp  */
  YYSYMBOL_490_30 = 490,                   /* $@30  */
  YYSYMBOL_user_defined_literal_decl_c_astp = 491, /* user_defined_literal_decl_c_astp  */
  YYSYMBOL_cast_c_astp_opt = 492,          /* cast_c_astp_opt  */
  YYSYMBOL_cast_c_astp = 493,              /* cast_c_astp  */
  YYSYMBOL_cast2_c_astp = 494,             /* cast2_c_astp  */
  YYSYMBOL_param_pack_cast_c_ast = 495,    /* param_pack_cast_c_ast  */
  YYSYMBOL_array_cast_c_astp = 496,        /* array_cast_c_astp  */
  YYSYMBOL_block_cast_c_astp = 497,        /* block_cast_c_astp  */
  YYSYMBOL_498_31 = 498,                   /* $@31  */
  YYSYMBOL_func_cast_c_astp = 499,         /* func_cast_c_astp  */
  YYSYMBOL_nested_cast_c_astp = 500,       /* nested_cast_c_astp  */
  YYSYMBOL_501_32 = 501,                   /* $@32  */
  YYSYMBOL_pointer_cast_c_astp = 502,      /* pointer_cast_c_astp  */
  YYSYMBOL_503_33 = 503,                   /* $@33  */
  YYSYMBOL_pointer_to_member_cast_c_astp = 504, /* pointer_to_member_cast_c_astp  */
  YYSYMBOL_505_34 = 505,                   /* $@34  */
  YYSYMBOL_reference_cast_c_astp = 506,    /* reference_cast_c_astp  */
  YYSYMBOL_507_35 = 507,                   /* $@35  */
  YYSYMBOL_udc_decl_c_ast_opt = 508,       /* udc_decl_c_ast_opt  */
  YYSYMBOL_udc_decl_c_ast = 509,           /* udc_decl_c_ast  */
  YYSYMBOL_pointer_udc_decl_c_ast = 510,   /* pointer_udc_decl_c_ast  */
  YYSYMBOL_511_36 = 511,                   /* $@36  */
  YYSYMBOL_pointer_to_member_udc_decl_c_ast = 512, /* pointer_to_member_udc_decl_c_ast  */
  YYSYMBOL_513_37 = 513,                   /* $@37  */
  YYSYMBOL_reference_udc_decl_c_ast = 514, /* reference_udc_decl_c_ast  */
  YYSYMBOL_515_38 = 515,                   /* $@38  */
  YYSYMBOL_type_c_ast = 516,               /* type_c_ast  */
  YYSYMBOL_type_modifier_list_c_type_opt = 517, /* type_modifier_list_c_type_opt  */
  YYSYMBOL_type_modifier_list_c_type = 518, /* type_modifier_list_c_type  */
  YYSYMBOL_type_modifier_c_type = 519,     /* type_modifier_c_type  */
  YYSYMBOL_type_modifier_base_type = 520,  /* type_modifier_base_type  */
  YYSYMBOL_east_modified_type_c_ast = 521, /* east_modified_type_c_ast  */
  YYSYMBOL_east_modifiable_type_c_ast = 522, /* east_modifiable_type_c_ast  */
  YYSYMBOL_atomic_specifier_type_c_ast = 523, /* atomic_specifier_type_c_ast  */
  YYSYMBOL_524_39 = 524,                   /* $@39  */
  YYSYMBOL_builtin_type_c_ast = 525,       /* builtin_type_c_ast  */
  YYSYMBOL_builtin_no_BitInt_c_btid = 526, /* builtin_no_BitInt_c_btid  */
  YYSYMBOL_concept_type_c_ast = 527,       /* concept_type_c_ast  */
  YYSYMBOL_structured_binding_type_c_ast = 528, /* structured_binding_type_c_ast  */
  YYSYMBOL_typedef_type_c_ast = 529,       /* typedef_type_c_ast  */
  YYSYMBOL_sub_scope_sname_c_opt = 530,    /* sub_scope_sname_c_opt  */
  YYSYMBOL_typeof_type_c_ast = 531,        /* typeof_type_c_ast  */
  YYSYMBOL_532_40 = 532,                   /* $@40  */
  YYSYMBOL_typeof = 533,                   /* typeof  */
  YYSYMBOL_enum_class_struct_union_c_ast = 534, /* enum_class_struct_union_c_ast  */
  YYSYMBOL_class_struct_union_c_ast = 535, /* class_struct_union_c_ast  */
  YYSYMBOL_enum_c_ast = 536,               /* enum_c_ast  */
  YYSYMBOL_enum_btids = 537,               /* enum_btids  */
  YYSYMBOL_enum_fixed_type_c_ast_opt = 538, /* enum_fixed_type_c_ast_opt  */
  YYSYMBOL_enum_fixed_type_c_ast = 539,    /* enum_fixed_type_c_ast  */
  YYSYMBOL_enum_fixed_type_modifier_list_btid_opt = 540, /* enum_fixed_type_modifier_list_btid_opt  */
  YYSYMBOL_enum_fixed_type_modifier_list_btid = 541, /* enum_fixed_type_modifier_list_btid  */
  YYSYMBOL_enum_fixed_type_modifier_btid = 542, /* enum_fixed_type_modifier_btid  */
  YYSYMBOL_enum_unmodified_fixed_type_c_ast = 543, /* enum_unmodified_fixed_type_c_ast  */
  YYSYMBOL_class_struct_btid_opt = 544,    /* class_struct_btid_opt  */
  YYSYMBOL_class_struct_btid = 545,        /* class_struct_btid  */
  YYSYMBOL_class_struct_union_btid = 546,  /* class_struct_union_btid  */
  YYSYMBOL_type_qualifier_list_c_stid_opt = 547, /* type_qualifier_list_c_stid_opt  */
  YYSYMBOL_type_qualifier_list_c_stid = 548, /* type_qualifier_list_c_stid  */
  YYSYMBOL_type_qualifier_c_stid = 549,    /* type_qualifier_c_stid  */
  YYSYMBOL_cv_qualifier_stid = 550,        /* cv_qualifier_stid  */
  YYSYMBOL_cv_qualifier_list_stid_opt = 551, /* cv_qualifier_list_stid_opt  */
  YYSYMBOL_restrict_qualifier_c_stid = 552, /* restrict_qualifier_c_stid  */
  YYSYMBOL_upc_layout_qualifier_c = 553,   /* upc_layout_qualifier_c  */
  YYSYMBOL_storage_class_c_type = 554,     /* storage_class_c_type  */
  YYSYMBOL__Noreturn_atid = 555,           /* _Noreturn_atid  */
  YYSYMBOL_attribute_specifier_list_c_atid_opt = 556, /* attribute_specifier_list_c_atid_opt  */
  YYSYMBOL_attribute_specifier_list_c_atid = 557, /* attribute_specifier_list_c_atid  */
  YYSYMBOL_558_41 = 558,                   /* $@41  */
  YYSYMBOL_using_opt = 559,                /* using_opt  */
  YYSYMBOL_attribute_list_c_atid_opt = 560, /* attribute_list_c_atid_opt  */
  YYSYMBOL_attribute_list_c_atid = 561,    /* attribute_list_c_atid  */
  YYSYMBOL_attribute_c_atid_exp = 562,     /* attribute_c_atid_exp  */
  YYSYMBOL_attribute_str_arg_c_opt = 563,  /* attribute_str_arg_c_opt  */
  YYSYMBOL_gnu_or_msc_attribute_specifier_list_c_opt = 564, /* gnu_or_msc_attribute_specifier_list_c_opt  */
  YYSYMBOL_gnu_or_msc_attribute_specifier_list_c = 565, /* gnu_or_msc_attribute_specifier_list_c  */
  YYSYMBOL_gnu_attribute_specifier_list_c_opt = 566, /* gnu_attribute_specifier_list_c_opt  */
  YYSYMBOL_gnu_attribute_specifier_list_c = 567, /* gnu_attribute_specifier_list_c  */
  YYSYMBOL_gnu_attribute_specifier_c = 568, /* gnu_attribute_specifier_c  */
  YYSYMBOL_569_42 = 569,                   /* $@42  */
  YYSYMBOL_gnu_attribute_list_c_opt = 570, /* gnu_attribute_list_c_opt  */
  YYSYMBOL_gnu_attribuet_list_c = 571,     /* gnu_attribuet_list_c  */
  YYSYMBOL_gnu_attribute_c_exp = 572,      /* gnu_attribute_c_exp  */
  YYSYMBOL_gnu_attribute_decl_arg_list_c_opt = 573, /* gnu_attribute_decl_arg_list_c_opt  */
  YYSYMBOL_gnu_attribute_arg_list_c_opt = 574, /* gnu_attribute_arg_list_c_opt  */
  YYSYMBOL_gnu_attribute_arg_list_c = 575, /* gnu_attribute_arg_list_c  */
  YYSYMBOL_gnu_attribute_arg_c = 576,      /* gnu_attribute_arg_c  */
  YYSYMBOL_msc_attribute_specifier_list_c = 577, /* msc_attribute_specifier_list_c  */
  YYSYMBOL_msc_attribute_specifier_c = 578, /* msc_attribute_specifier_c  */
  YYSYMBOL_579_43 = 579,                   /* $@43  */
  YYSYMBOL_msc_attribute_list_c_opt = 580, /* msc_attribute_list_c_opt  */
  YYSYMBOL_msc_attribuet_list_c = 581,     /* msc_attribuet_list_c  */
  YYSYMBOL_decl_english_ast = 582,         /* decl_english_ast  */
  YYSYMBOL_array_decl_english_ast = 583,   /* array_decl_english_ast  */
  YYSYMBOL_array_size_decl_ast = 584,      /* array_size_decl_ast  */
  YYSYMBOL_length_opt = 585,               /* length_opt  */
  YYSYMBOL_block_decl_english_ast = 586,   /* block_decl_english_ast  */
  YYSYMBOL_constructor_decl_english_ast = 587, /* constructor_decl_english_ast  */
  YYSYMBOL_destructor_decl_english_ast = 588, /* destructor_decl_english_ast  */
  YYSYMBOL_destructor_parens_opt = 589,    /* destructor_parens_opt  */
  YYSYMBOL_func_decl_english_ast = 590,    /* func_decl_english_ast  */
  YYSYMBOL_func_qualifier_english_type_opt = 591, /* func_qualifier_english_type_opt  */
  YYSYMBOL_msc_calling_convention_atid = 592, /* msc_calling_convention_atid  */
  YYSYMBOL_paren_param_decl_list_english_opt = 593, /* paren_param_decl_list_english_opt  */
  YYSYMBOL_paren_param_decl_list_english = 594, /* paren_param_decl_list_english  */
  YYSYMBOL_param_decl_list_english_opt = 595, /* param_decl_list_english_opt  */
  YYSYMBOL_param_decl_list_english = 596,  /* param_decl_list_english  */
  YYSYMBOL_decl_english_ast_exp = 597,     /* decl_english_ast_exp  */
  YYSYMBOL_ref_qualifier_english_stid_opt = 598, /* ref_qualifier_english_stid_opt  */
  YYSYMBOL_returning_english_ast_opt = 599, /* returning_english_ast_opt  */
  YYSYMBOL_returning_english_ast = 600,    /* returning_english_ast  */
  YYSYMBOL_qualified_decl_english_ast = 601, /* qualified_decl_english_ast  */
  YYSYMBOL_type_qualifier_list_english_type_opt = 602, /* type_qualifier_list_english_type_opt  */
  YYSYMBOL_type_qualifier_list_english_type = 603, /* type_qualifier_list_english_type  */
  YYSYMBOL_type_qualifier_english_type = 604, /* type_qualifier_english_type  */
  YYSYMBOL_attribute_english_atid = 605,   /* attribute_english_atid  */
  YYSYMBOL_storage_class_english_stid = 606, /* storage_class_english_stid  */
  YYSYMBOL_eval_expr_init_stid = 607,      /* eval_expr_init_stid  */
  YYSYMBOL_linkage_stid = 608,             /* linkage_stid  */
  YYSYMBOL_linkage_opt = 609,              /* linkage_opt  */
  YYSYMBOL_type_qualifier_english_stid = 610, /* type_qualifier_english_stid  */
  YYSYMBOL_upc_layout_qualifier_english = 611, /* upc_layout_qualifier_english  */
  YYSYMBOL_qualifiable_decl_english_ast = 612, /* qualifiable_decl_english_ast  */
  YYSYMBOL_pointer_decl_english_ast = 613, /* pointer_decl_english_ast  */
  YYSYMBOL_reference_decl_english_ast = 614, /* reference_decl_english_ast  */
  YYSYMBOL_reference_english_ast = 615,    /* reference_english_ast  */
  YYSYMBOL_structured_binding_decl_english_ast = 616, /* structured_binding_decl_english_ast  */
  YYSYMBOL_user_defined_literal_decl_english_ast = 617, /* user_defined_literal_decl_english_ast  */
  YYSYMBOL_var_decl_english_ast = 618,     /* var_decl_english_ast  */
  YYSYMBOL_type_english_ast = 619,         /* type_english_ast  */
  YYSYMBOL_type_modifier_list_english_type_opt = 620, /* type_modifier_list_english_type_opt  */
  YYSYMBOL_type_modifier_list_english_type = 621, /* type_modifier_list_english_type  */
  YYSYMBOL_type_modifier_english_type = 622, /* type_modifier_english_type  */
  YYSYMBOL_unmodified_type_english_ast = 623, /* unmodified_type_english_ast  */
  YYSYMBOL_builtin_type_english_ast = 624, /* builtin_type_english_ast  */
  YYSYMBOL_builtin_no_BitInt_english_btid = 625, /* builtin_no_BitInt_english_btid  */
  YYSYMBOL_BitInt_english_int = 626,       /* BitInt_english_int  */
  YYSYMBOL_BitInt_english = 627,           /* BitInt_english  */
  YYSYMBOL_concept_type_english_ast = 628, /* concept_type_english_ast  */
  YYSYMBOL_parameter_pack_english_ast = 629, /* parameter_pack_english_ast  */
  YYSYMBOL_pack_exp = 630,                 /* pack_exp  */
  YYSYMBOL_precise_opt = 631,              /* precise_opt  */
  YYSYMBOL_class_struct_union_english_ast = 632, /* class_struct_union_english_ast  */
  YYSYMBOL_enum_english_ast = 633,         /* enum_english_ast  */
  YYSYMBOL_of_type_enum_fixed_type_english_ast_opt = 634, /* of_type_enum_fixed_type_english_ast_opt  */
  YYSYMBOL_enum_fixed_type_english_ast = 635, /* enum_fixed_type_english_ast  */
  YYSYMBOL_enum_fixed_type_modifier_list_english_btid_opt = 636, /* enum_fixed_type_modifier_list_english_btid_opt  */
  YYSYMBOL_enum_fixed_type_modifier_list_english_btid = 637, /* enum_fixed_type_modifier_list_english_btid  */
  YYSYMBOL_enum_unmodified_fixed_type_english_ast = 638, /* enum_unmodified_fixed_type_english_ast  */
  YYSYMBOL_any_name = 639,                 /* any_name  */
  YYSYMBOL_any_name_exp = 640,             /* any_name_exp  */
  YYSYMBOL_any_sname_c = 641,              /* any_sname_c  */
  YYSYMBOL_any_sname_c_exp = 642,          /* any_sname_c_exp  */
  YYSYMBOL_any_sname_c_opt = 643,          /* any_sname_c_opt  */
  YYSYMBOL_any_typedef_tdef = 644,         /* any_typedef_tdef  */
  YYSYMBOL_name_ast = 645,                 /* name_ast  */
  YYSYMBOL_name_exp = 646,                 /* name_exp  */
  YYSYMBOL_name_cat = 647,                 /* name_cat  */
  YYSYMBOL_name_opt = 648,                 /* name_opt  */
  YYSYMBOL_oper_sname_c_opt = 649,         /* oper_sname_c_opt  */
  YYSYMBOL_sname_c = 650,                  /* sname_c  */
  YYSYMBOL_sname_c_ast = 651,              /* sname_c_ast  */
  YYSYMBOL_bit_field_c_uint_opt = 652,     /* bit_field_c_uint_opt  */
  YYSYMBOL_sname_c_exp = 653,              /* sname_c_exp  */
  YYSYMBOL_sname_c_opt = 654,              /* sname_c_opt  */
  YYSYMBOL_sname_english = 655,            /* sname_english  */
  YYSYMBOL_sname_english_ast = 656,        /* sname_english_ast  */
  YYSYMBOL_sname_english_exp = 657,        /* sname_english_exp  */
  YYSYMBOL_sname_english_opt = 658,        /* sname_english_opt  */
  YYSYMBOL_sname_list_c = 659,             /* sname_list_c  */
  YYSYMBOL_sname_list_english = 660,       /* sname_list_english  */
  YYSYMBOL_typedef_sname_c = 661,          /* typedef_sname_c  */
  YYSYMBOL_address_exp = 662,              /* address_exp  */
  YYSYMBOL_array_exp = 663,                /* array_exp  */
  YYSYMBOL_as_exp = 664,                   /* as_exp  */
  YYSYMBOL_as_into_to_exp = 665,           /* as_into_to_exp  */
  YYSYMBOL_as_or_to_opt = 666,             /* as_or_to_opt  */
  YYSYMBOL_auto_TYPE_exp = 667,            /* auto_TYPE_exp  */
  YYSYMBOL_binding_exp = 668,              /* binding_exp  */
  YYSYMBOL_bits_opt = 669,                 /* bits_opt  */
  YYSYMBOL_bytes_opt = 670,                /* bytes_opt  */
  YYSYMBOL_cast_exp = 671,                 /* cast_exp  */
  YYSYMBOL_char_exp = 672,                 /* char_exp  */
  YYSYMBOL_class_struct_union_btid_exp = 673, /* class_struct_union_btid_exp  */
  YYSYMBOL_colon_exp = 674,                /* colon_exp  */
  YYSYMBOL_comma_exp = 675,                /* comma_exp  */
  YYSYMBOL_conversion_exp = 676,           /* conversion_exp  */
  YYSYMBOL_c_operator = 677,               /* c_operator  */
  YYSYMBOL_default_exp = 678,              /* default_exp  */
  YYSYMBOL_defined_exp = 679,              /* defined_exp  */
  YYSYMBOL_dependency_exp = 680,           /* dependency_exp  */
  YYSYMBOL_destructor_sname = 681,         /* destructor_sname  */
  YYSYMBOL_empty_str_lit_exp = 682,        /* empty_str_lit_exp  */
  YYSYMBOL_equals_exp = 683,               /* equals_exp  */
  YYSYMBOL_extern_linkage_c_stid = 684,    /* extern_linkage_c_stid  */
  YYSYMBOL_extern_linkage_c_stid_opt = 685, /* extern_linkage_c_stid_opt  */
  YYSYMBOL_glob = 686,                     /* glob  */
  YYSYMBOL_glob_opt = 687,                 /* glob_opt  */
  YYSYMBOL_gt_exp = 688,                   /* gt_exp  */
  YYSYMBOL_inline_stid_opt = 689,          /* inline_stid_opt  */
  YYSYMBOL_int_exp = 690,                  /* int_exp  */
  YYSYMBOL_lbracket_exp = 691,             /* lbracket_exp  */
  YYSYMBOL_literal_exp = 692,              /* literal_exp  */
  YYSYMBOL_local_exp = 693,                /* local_exp  */
  YYSYMBOL_lparen_exp = 694,               /* lparen_exp  */
  YYSYMBOL_lt_exp = 695,                   /* lt_exp  */
  YYSYMBOL_member_or_non_member_opt = 696, /* member_or_non_member_opt  */
  YYSYMBOL_namespace_btid_exp = 697,       /* namespace_btid_exp  */
  YYSYMBOL_namespace_type = 698,           /* namespace_type  */
  YYSYMBOL_of_exp = 699,                   /* of_exp  */
  YYSYMBOL_of_scope_english = 700,         /* of_scope_english  */
  YYSYMBOL_of_scope_list_english = 701,    /* of_scope_list_english  */
  YYSYMBOL_of_scope_list_english_opt = 702, /* of_scope_list_english_opt  */
  YYSYMBOL_operator_exp = 703,             /* operator_exp  */
  YYSYMBOL_operator_opt = 704,             /* operator_opt  */
  YYSYMBOL_point_exp = 705,                /* point_exp  */
  YYSYMBOL_precision_opt = 706,            /* precision_opt  */
  YYSYMBOL_rbrace_exp = 707,               /* rbrace_exp  */
  YYSYMBOL_rbracket_exp = 708,             /* rbracket_exp  */
  YYSYMBOL_ref_qualifier_c_stid_opt = 709, /* ref_qualifier_c_stid_opt  */
  YYSYMBOL_reference_exp = 710,            /* reference_exp  */
  YYSYMBOL_returning = 711,                /* returning  */
  YYSYMBOL_returning_exp = 712,            /* returning_exp  */
  YYSYMBOL_rparen_exp = 713,               /* rparen_exp  */
  YYSYMBOL_scope_english_type = 714,       /* scope_english_type  */
  YYSYMBOL_scope_english_type_exp = 715,   /* scope_english_type_exp  */
  YYSYMBOL_semi_exp = 716,                 /* semi_exp  */
  YYSYMBOL_semi_opt = 717,                 /* semi_opt  */
  YYSYMBOL_semi_or_end = 718,              /* semi_or_end  */
  YYSYMBOL_static_stid_opt = 719,          /* static_stid_opt  */
  YYSYMBOL_str_lit = 720,                  /* str_lit  */
  YYSYMBOL_str_lit_exp = 721,              /* str_lit_exp  */
  YYSYMBOL_this_exp = 722,                 /* this_exp  */
  YYSYMBOL_this_stid_opt = 723,            /* this_stid_opt  */
  YYSYMBOL_to_exp = 724,                   /* to_exp  */
  YYSYMBOL_type_opt = 725,                 /* type_opt  */
  YYSYMBOL_typename_flag_opt = 726,        /* typename_flag_opt  */
  YYSYMBOL_uint_lit = 727,                 /* uint_lit  */
  YYSYMBOL_uint_lit_exp = 728,             /* uint_lit_exp  */
  YYSYMBOL_uint_lit_opt = 729,             /* uint_lit_opt  */
  YYSYMBOL_unused_exp = 730,               /* unused_exp  */
  YYSYMBOL_user_defined = 731,             /* user_defined  */
  YYSYMBOL_virtual_stid_exp = 732,         /* virtual_stid_exp  */
  YYSYMBOL_virtual_stid_opt = 733          /* virtual_stid_opt  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   6605

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  315
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  419
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1130
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1491

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   541


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    81,     2,   159,   311,    89,    79,     2,
      72,    73,    80,    91,   132,    90,    76,    88,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   294,   295,
      98,   114,    99,   314,   312,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    74,     2,    75,   108,     2,   313,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   296,   109,   297,    83,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    77,    78,    82,
      84,    85,    86,    87,    92,    93,    94,    95,    96,    97,
     100,   101,   102,   103,   104,   105,   106,   107,   110,   111,
     112,   113,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1974,  1974,  1975,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2018,  2040,  2064,  2065,  2066,  2067,  2068,  2077,  2187,  2186,
    2250,  2285,  2317,  2327,  2329,  2344,  2374,  2386,  2404,  2413,
    2414,  2415,  2419,  2420,  2424,  2431,  2435,  2439,  2447,  2448,
    2452,  2467,  2482,  2487,  2492,  2498,  2502,  2503,  2504,  2508,
    2522,  2523,  2541,  2542,  2563,  2564,  2565,  2569,  2570,  2571,
    2572,  2573,  2574,  2575,  2579,  2580,  2581,  2582,  2583,  2584,
    2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,
    2595,  2601,  2649,  2670,  2677,  2692,  2704,  2712,  2713,  2720,
    2721,  2725,  2730,  2739,  2740,  2748,  2753,  2765,  2785,  2804,
    2826,  2833,  2841,  2846,  2865,  2879,  2888,  2893,  2897,  2903,
    2912,  2916,  2920,  2924,  2928,  2932,  2936,  2943,  2944,  2948,
    2949,  2950,  2954,  2955,  2956,  2957,  2960,  2961,  2963,  2964,
    2965,  2966,  2967,  2968,  2969,  2970,  2971,  2972,  2973,  2974,
    2975,  2976,  2977,  2978,  2979,  2980,  2981,  2982,  2983,  2984,
    2985,  2986,  2987,  2988,  2989,  2990,  2991,  2992,  2993,  2994,
    2995,  2996,  2997,  2998,  2999,  3000,  3001,  3002,  3003,  3004,
    3009,  3013,  3027,  3033,  3037,  3043,  3052,  3053,  3065,  3070,
    3075,  3080,  3085,  3090,  3095,  3100,  3105,  3110,  3120,  3129,
    3139,  3139,  3154,  3159,  3182,  3189,  3196,  3214,  3213,  3232,
    3233,  3234,  3235,  3240,  3252,  3253,  3255,  3257,  3261,  3265,
    3269,  3273,  3277,  3281,  3285,  3289,  3293,  3297,  3301,  3305,
    3312,  3353,  3354,  3358,  3368,  3372,  3385,  3400,  3405,  3410,
    3421,  3422,  3426,  3432,  3441,  3452,  3456,  3460,  3464,  3468,
    3472,  3479,  3488,  3494,  3500,  3504,  3508,  3509,  3513,  3523,
    3524,  3525,  3535,  3545,  3555,  3567,  3579,  3584,  3612,  3621,
    3622,  3623,  3637,  3638,  3648,  3649,  3653,  3654,  3658,  3659,
    3664,  3667,  3668,  3674,  3680,  3686,  3697,  3696,  3733,  3744,
    3743,  3775,  3776,  3777,  3778,  3788,  3789,  3788,  3794,  3807,
    3820,  3820,  3838,  3845,  3846,  3852,  3862,  3863,  3864,  3872,
    3877,  3871,  3929,  3928,  3968,  3972,  3967,  4043,  4044,  4045,
    4058,  4072,  4088,  4103,  4122,  4136,  4153,  4170,  4174,  4175,
    4182,  4183,  4187,  4188,  4192,  4193,  4194,  4195,  4204,  4236,
    4237,  4241,  4257,  4272,  4277,  4283,  4288,  4293,  4298,  4306,
    4307,  4307,  4327,  4336,  4336,  4346,  4352,  4345,  4367,  4368,
    4373,  4437,  4438,  4447,  4463,  4474,  4495,  4473,  4565,  4623,
    4635,  4640,  4649,  4680,  4681,  4688,  4689,  4690,  4691,  4692,
    4701,  4702,  4706,  4707,  4708,  4709,  4710,  4711,  4712,  4716,
    4720,  4721,  4725,  4736,  4747,  4782,  4787,  4793,  4799,  4805,
    4813,  4821,  4827,  4836,  4845,  4856,  4855,  4908,  4958,  4959,
    4986,  5023,  5065,  5199,  5198,  5309,  5308,  5327,  5328,  5344,
    5345,  5346,  5354,  5358,  5359,  5360,  5364,  5368,  5384,  5385,
    5386,  5393,  5395,  5395,  5447,  5454,  5455,  5456,  5460,  5468,
    5478,  5479,  5499,  5500,  5508,  5509,  5513,  5526,  5544,  5543,
    5578,  5583,  5595,  5596,  5603,  5604,  5611,  5615,  5622,  5621,
    5646,  5702,  5702,  5722,  5742,  5747,  5755,  5755,  5775,  5815,
    5815,  5835,  5875,  5874,  5899,  5914,  5933,  6023,  6022,  6068,
    6113,  6114,  6118,  6119,  6120,  6121,  6125,  6126,  6127,  6128,
    6130,  6131,  6139,  6152,  6169,  6207,  6206,  6257,  6334,  6333,
    6376,  6376,  6398,  6398,  6421,  6421,  6450,  6451,  6455,  6456,
    6457,  6458,  6462,  6462,  6480,  6480,  6498,  6498,  6525,  6577,
    6592,  6596,  6597,  6601,  6615,  6619,  6643,  6644,  6645,  6652,
    6653,  6654,  6655,  6656,  6657,  6658,  6664,  6668,  6684,  6702,
    6703,  6704,  6705,  6706,  6707,  6714,  6713,  6761,  6772,  6787,
    6788,  6789,  6790,  6791,  6792,  6793,  6794,  6795,  6799,  6800,
    6801,  6802,  6803,  6804,  6810,  6828,  6850,  6912,  6913,  6923,
    6922,  6966,  6975,  6976,  6982,  6983,  6987,  7006,  7017,  7038,
    7051,  7055,  7056,  7057,  7073,  7091,  7117,  7136,  7137,  7141,
    7157,  7161,  7162,  7163,  7164,  7168,  7169,  7170,  7176,  7177,
    7181,  7182,  7186,  7187,  7193,  7194,  7198,  7213,  7218,  7225,
    7226,  7227,  7228,  7229,  7230,  7231,  7235,  7236,  7240,  7241,
    7257,  7271,  7275,  7276,  7277,  7278,  7287,  7288,  7289,  7290,
    7291,  7292,  7293,  7294,  7295,  7296,  7297,  7298,  7299,  7300,
    7329,  7331,  7332,  7333,  7334,  7335,  7339,  7340,  7346,  7347,
    7352,  7351,  7376,  7383,  7384,  7392,  7393,  7397,  7411,  7415,
    7416,  7417,  7418,  7419,  7420,  7421,  7422,  7423,  7424,  7455,
    7462,  7463,  7471,  7472,  7476,  7477,  7481,  7482,  7486,  7487,
    7492,  7491,  7507,  7508,  7512,  7513,  7517,  7521,  7528,  7529,
    7533,  7534,  7538,  7539,  7543,  7544,  7545,  7546,  7547,  7548,
    7555,  7556,  7561,  7560,  7573,  7574,  7585,  7586,  7594,  7595,
    7596,  7602,  7617,  7641,  7645,  7651,  7657,  7665,  7666,  7673,
    7695,  7713,  7725,  7726,  7733,  7760,  7764,  7771,  7772,  7773,
    7774,  7775,  7776,  7782,  7783,  7787,  7801,  7802,  7806,  7821,
    7838,  7839,  7848,  7849,  7850,  7857,  7868,  7872,  7883,  7892,
    7912,  7913,  7917,  7933,  7937,  7938,  7939,  7943,  7944,  7945,
    7946,  7947,  7948,  7949,  7950,  7951,  7952,  7953,  7954,  7955,
    7956,  7957,  7961,  7962,  7963,  7967,  7968,  7969,  7970,  7971,
    7972,  7973,  7974,  7975,  7979,  7980,  7981,  7982,  7983,  7984,
    7985,  7986,  7988,  7989,  7990,  7991,  7992,  7993,  7994,  7995,
    7996,  8000,  8001,  8002,  8013,  8033,  8034,  8038,  8039,  8040,
    8041,  8042,  8043,  8044,  8048,  8049,  8053,  8054,  8055,  8056,
    8057,  8058,  8059,  8060,  8061,  8071,  8090,  8116,  8129,  8149,
    8154,  8163,  8172,  8213,  8236,  8241,  8258,  8280,  8300,  8301,
    8305,  8321,  8325,  8329,  8330,  8331,  8332,  8333,  8334,  8338,
    8350,  8365,  8366,  8367,  8368,  8369,  8381,  8382,  8383,  8384,
    8388,  8389,  8390,  8391,  8392,  8393,  8394,  8395,  8399,  8403,
    8407,  8411,  8418,  8419,  8420,  8424,  8438,  8456,  8465,  8466,
    8473,  8474,  8478,  8495,  8516,  8517,  8524,  8542,  8557,  8558,
    8562,  8578,  8582,  8583,  8591,  8592,  8600,  8601,  8609,  8610,
    8614,  8615,  8623,  8624,  8628,  8629,  8633,  8647,  8648,  8656,
    8661,  8665,  8666,  8670,  8672,  8681,  8706,  8728,  8742,  8761,
    8762,  8776,  8777,  8785,  8786,  8790,  8809,  8845,  8846,  8854,
    8855,  8859,  8874,  8890,  8906,  8922,  8941,  8964,  8972,  8973,
    8980,  8981,  8988,  9008,  9015,  9016,  9017,  9018,  9025,  9026,
    9027,  9031,  9032,  9039,  9040,  9047,  9048,  9049,  9053,  9054,
    9058,  9059,  9066,  9067,  9074,  9075,  9082,  9083,  9090,  9091,
    9098,  9099,  9106,  9107,  9108,  9109,  9110,  9111,  9112,  9113,
    9114,  9115,  9116,  9117,  9118,  9119,  9120,  9121,  9122,  9123,
    9124,  9125,  9126,  9127,  9128,  9129,  9130,  9131,  9132,  9133,
    9134,  9135,  9136,  9137,  9138,  9139,  9140,  9141,  9142,  9143,
    9144,  9145,  9146,  9147,  9148,  9149,  9150,  9151,  9152,  9153,
    9157,  9158,  9165,  9166,  9173,  9174,  9181,  9182,  9190,  9205,
    9206,  9213,  9214,  9221,  9222,  9226,  9241,  9242,  9246,  9247,
    9254,  9255,  9259,  9260,  9267,  9268,  9275,  9276,  9283,  9284,
    9291,  9292,  9299,  9300,  9307,  9308,  9309,  9313,  9314,  9321,
    9322,  9326,  9327,  9334,  9357,  9368,  9372,  9373,  9377,  9378,
    9385,  9386,  9390,  9391,  9397,  9398,  9402,  9403,  9410,  9411,
    9418,  9419,  9420,  9424,  9425,  9432,  9433,  9437,  9438,  9445,
    9446,  9453,  9454,  9455,  9459,  9460,  9469,  9470,  9477,  9478,
    9482,  9483,  9487,  9488,  9492,  9493,  9501,  9502,  9510,  9511,
    9518,  9519,  9523,  9524,  9531,  9532,  9536,  9537,  9541,  9557,
    9558,  9565,  9566,  9570,  9571,  9578,  9579,  9583,  9584,  9591,
    9592
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "Y_cast", "Y_constant",
  "Y_declare", "Y_define", "Y_dynamic", "Y_explain", "Y_no", "Y_quit",
  "Y_reinterpret", "Y_set", "Y_show", "Y_aligned", "Y_all", "Y_array",
  "Y_as", "Y_binding", "Y_bit", "Y_bit_precise", "Y_bits", "Y_by",
  "Y_bytes", "Y_capturing", "Y_commands", "Y_constructor", "Y_conversion",
  "Y_copy", "Y_defined", "Y_destructor", "Y_english", "Y_evaluation",
  "Y_expand", "Y_expression", "Y_floating", "Y_function",
  "Y_initialization", "Y_into", "Y_lambda", "Y_length", "Y_linkage",
  "Y_literal", "Y_macros", "Y_member", "Y_non_empty", "Y_non_member",
  "Y_of", "Y_options", "Y_point", "Y_pointer", "Y_precise", "Y_precision",
  "Y_predefined", "Y_pure", "Y_reference", "Y_returning", "Y_rvalue",
  "Y_scope", "Y_structured", "Y_to", "Y_user", "Y_user_defined",
  "Y_variable", "Y_wide", "Y_width",
  "Y_PREC_LESS_THAN_upc_layout_qualifier", "Y_COLON_COLON", "\"::\"",
  "Y_COLON_COLON_STAR", "\"++\"", "\"--\"", "'('", "')'", "'['", "']'",
  "'.'", "Y_MINUS_GREATER", "\"->\"", "'&'", "'*'", "'!'", "Y_sizeof",
  "'~'", "Y_DOT_STAR", "\".*\"", "Y_MINUS_GREATER_STAR", "\"->*\"", "'/'",
  "'%'", "'-'", "'+'", "Y_LESS_LESS", "\"<<\"", "Y_GREATER_GREATER",
  "\">>\"", "Y_LESS_EQUAL_GREATER", "\"<=>\"", "'<'", "'>'",
  "Y_LESS_EQUAL", "\"<=\"", "Y_GREATER_EQUAL", "\">=\"", "Y_EQUAL_EQUAL",
  "\"==\"", "Y_EXCLAM_EQUAL", "Y_bit_and", "'^'", "'|'", "Y_AMPER_AMPER",
  "Y_PIPE_PIPE", "Y_QMARK_COLON", "\"?:\"", "'='", "Y_PERCENT_EQUAL",
  "\"%=\"", "Y_AMPER_EQUAL", "Y_STAR_EQUAL", "\"*=\"", "Y_PLUS_EQUAL",
  "\"+=\"", "Y_MINUS_EQUAL", "\"-=\"", "Y_SLASH_EQUAL", "\"/=\"",
  "Y_LESS_LESS_EQUAL", "\"<<=\"", "Y_GREATER_GREATER_EQUAL", "\">>=\"",
  "Y_CARET_EQUAL", "Y_PIPE_EQUAL", "','", "Y_auto_STORAGE", "Y_break",
  "Y_case", "Y_char", "Y_continue", "Y_default", "Y_do", "Y_double",
  "Y_else", "Y_extern", "Y_float", "Y_for", "Y_goto", "Y_if", "Y_int",
  "Y_long", "Y_register", "Y_return", "Y_short", "Y_static", "Y_struct",
  "Y_switch", "Y_typedef", "Y_union", "Y_unsigned", "Y_while", "'#'",
  "\"##\"", "Y_PRE_SPACE", "Y_PRE_define", "Y_PRE_elif", "Y_PRE_else",
  "Y_PRE_error", "Y_PRE_if", "Y_PRE_ifdef", "Y_PRE_ifndef", "Y_PRE_line",
  "Y_PRE_undef", "Y_PRE___VA_ARGS__", "Y_PRE___VA_OPT__", "Y_PRE_pragma",
  "Y_PRE_elifdef", "Y_PRE_elifndef", "Y_PRE_embed", "Y_PRE_warning",
  "Y_asm", "Y_const", "\"...\"", "Y_enum", "Y_signed", "Y_void",
  "Y_volatile", "Y_wchar_t", "Y__Bool", "Y__Complex", "Y__Imaginary",
  "Y_inline", "Y_restrict", "Y__Alignas", "Y__Alignof", "Y__Atomic_QUAL",
  "Y__Atomic_SPEC", "Y__Generic", "Y__Noreturn", "Y__Static_assert",
  "Y__Thread_local", "Y_thread", "Y_local", "Y_bool", "Y_catch", "Y_class",
  "Y_const_cast", "Y_CONSTRUCTOR_SNAME", "Y_delete", "Y_DESTRUCTOR_SNAME",
  "Y_dynamic_cast", "Y_explicit", "Y_false", "Y_friend", "Y_mutable",
  "Y_namespace", "Y_new", "Y_operator", "Y_OPERATOR_SNAME", "Y_private",
  "Y_protected", "Y_public", "Y_reinterpret_cast", "Y_static_cast",
  "Y_template", "Y_this", "Y_throw", "Y_true", "Y_try", "Y_typeid",
  "Y_typename", "Y_using", "Y_virtual", "Y_char16_t", "Y_char32_t",
  "Y__BitInt", "Y_reproducible", "Y_typeof", "Y_typeof_unqual",
  "Y_unsequenced", "Y_ATTR_BEGIN", "Y_auto_TYPE", "Y_alignas", "Y_alignof",
  "Y_carries", "Y_dependency", "Y_carries_dependency", "Y_constexpr",
  "Y_decltype", "Y_except", "Y_final", "Y_noexcept", "Y_nullptr",
  "Y_override", "Y_static_assert", "Y_thread_local", "Y_deprecated",
  "Y_auto_STRUCTURED_BINDING", "Y_discard", "Y_maybe_unused", "Y_maybe",
  "Y_unused", "Y_nodiscard", "Y_noreturn", "Y_char8_t", "Y_concept",
  "Y_consteval", "Y_constinit", "Y_co_await", "Y_co_return", "Y_co_yield",
  "Y_export", "Y_no_unique_address", "Y_parameter", "Y_pack", "Y_requires",
  "Y_unique", "Y_address", "Y_indeterminate", "Y_EMC__Accum",
  "Y_EMC__Fract", "Y_EMC__Sat", "Y_UPC_relaxed", "Y_UPC_shared",
  "Y_UPC_strict", "Y_GNU___attribute__", "Y_GNU___restrict",
  "Y_Apple___block", "Y_Apple_block", "Y_MSC___cdecl", "Y_MSC___clrcall",
  "Y_MSC___declspec", "Y_MSC___fastcall", "Y_MSC___stdcall",
  "Y_MSC___thiscall", "Y_MSC___vectorcall", "':'", "';'", "'{'", "'}'",
  "Y_CHAR_LIT", "Y_CONCEPT_SNAME", "Y_END", "Y_ERROR", "Y_FLOAT_LIT",
  "Y_GLOB", "Y_INT_LIT", "Y_NAME", "Y_SET_OPTION", "Y_STR_LIT",
  "Y_TYPEDEF_NAME_TDEF", "Y_TYPEDEF_SNAME_TDEF", "Y_LEXER_ERROR", "'$'",
  "'@'", "'`'", "'?'", "$accept", "command_list", "command",
  "cast_command", "new_style_cast_english", "declare_command", "$@1",
  "alignas_or_width_decl_english_ast", "alignas_specifier_english",
  "aligned_english", "capturing_paren_capture_decl_list_english_opt",
  "paren_capture_decl_list_english", "capture_decl_list_english_opt",
  "capture_decl_list_english", "capture_decl_english_ast",
  "capture_default_opt", "width_specifier_english_uint",
  "storage_class_subset_english_type_opt",
  "storage_class_subset_english_type", "storage_class_subset_english_stid",
  "define_command", "expand_command", "expand_command2",
  "p_extra_token_except_lparen", "p_extra_tokens_opt", "p_extra_tokens",
  "p_extra_token", "p_arg_list_opt", "p_comma_arg_list", "p_arg_list",
  "p_arg_tokens", "p_arg_token_as_list", "p_arg_token", "p_num_lit",
  "p_other", "p_punctuator", "p_arg_tokens_with_comma_opt",
  "p_arg_tokens_with_comma", "p_arg_token_with_comma_as_list",
  "p_arg_token_with_comma", "explain_command", "$@2", "explain",
  "help_command", "$@3", "help_what_opt", "preprocessor_command",
  "p_define", "p_paren_param_list_opt", "p_param_list_opt", "p_param_list",
  "p_param", "p_replace_list_opt", "p_replace_list", "p_replace_token",
  "p_undef", "quit_command", "scoped_command", "set_command",
  "set_option_list", "set_option", "set_option_value_opt", "show_command",
  "show_format", "show_format_exp", "show_format_opt", "show_types_opt",
  "predefined_or_user_types_opt", "template_command", "typedef_command",
  "using_command", "c_style_cast_expr_c", "$@4", "new_style_cast_expr_c",
  "$@5", "new_style_cast_c", "aligned_declaration_c", "$@6", "$@7",
  "alignas_specifier_c", "$@8", "alignas", "asm_declaration_c",
  "scoped_declaration_c", "class_struct_union_declaration_c", "$@9",
  "$@10", "enum_declaration_c", "$@11", "namespace_declaration_c", "$@12",
  "$@13", "namespace_sname_c_exp", "namespace_sname_c",
  "namespace_typedef_sname_c", "brace_in_scope_declaration_c_exp",
  "brace_in_scope_declaration_c_opt", "brace_in_scope_declaration_c",
  "in_scope_declaration_c_exp", "lambda_declaration_c",
  "capture_decl_list_c_opt", "capture_decl_list_c", "capture_decl_c_ast",
  "lambda_return_type_c_ast_opt", "$@14", "template_declaration_c",
  "typed_declaration_c", "$@15", "typedef_declaration_c", "$@16", "$@17",
  "typedef_decl_list_c", "typedef_decl_c", "typedef_decl_c_exp",
  "user_defined_conversion_declaration_c", "using_declaration_c",
  "using_decl_c_ast", "$@18", "$@19", "decl_list_c_opt", "decl_list_c",
  "decl_c", "decl_c_exp", "decl_c_astp", "msc_calling_convention_c_astp",
  "decl2_c_astp", "param_pack_decl_c_ast", "array_decl_c_astp",
  "array_size_c_ast", "block_decl_c_astp", "$@20",
  "destructor_declaration_c", "no_destructor_params",
  "file_scope_constructor_declaration_c",
  "file_scope_destructor_declaration_c", "func_decl_c_astp",
  "pc99_func_or_constructor_declaration_c", "$@21",
  "param_list_rparen_func_qualifier_list_c_stid_opt", "$@22",
  "func_qualifier_list_c_stid_opt", "func_qualifier_c_stid",
  "noexcept_c_stid_opt", "noexcept_bool_stid_exp",
  "trailing_return_type_c_ast_opt", "$@23", "func_equals_c_stid_opt",
  "delete_reason_opt", "param_c_ast_list_exp", "param_c_ast_list_opt",
  "param_c_ast_list", "param_c_ast", "$@24", "param_c_ast_exp",
  "paren_param_c_ast_list_opt", "param_list_c_lparen", "param_list_rparen",
  "nested_decl_c_astp", "$@25", "oper_decl_c_astp", "pointer_decl_c_astp",
  "$@26", "pointer_type_c_ast", "pc99_pointer_decl_list_c",
  "pc99_pointer_decl_c", "$@27", "pc99_pointer_type_c_ast",
  "pointer_to_member_decl_c_astp", "$@28", "pointer_to_member_type_c_ast",
  "reference_decl_c_astp", "$@29", "reference_type_c_ast",
  "typedef_type_decl_c_ast", "user_defined_conversion_decl_c_astp", "$@30",
  "user_defined_literal_decl_c_astp", "cast_c_astp_opt", "cast_c_astp",
  "cast2_c_astp", "param_pack_cast_c_ast", "array_cast_c_astp",
  "block_cast_c_astp", "$@31", "func_cast_c_astp", "nested_cast_c_astp",
  "$@32", "pointer_cast_c_astp", "$@33", "pointer_to_member_cast_c_astp",
  "$@34", "reference_cast_c_astp", "$@35", "udc_decl_c_ast_opt",
  "udc_decl_c_ast", "pointer_udc_decl_c_ast", "$@36",
  "pointer_to_member_udc_decl_c_ast", "$@37", "reference_udc_decl_c_ast",
  "$@38", "type_c_ast", "type_modifier_list_c_type_opt",
  "type_modifier_list_c_type", "type_modifier_c_type",
  "type_modifier_base_type", "east_modified_type_c_ast",
  "east_modifiable_type_c_ast", "atomic_specifier_type_c_ast", "$@39",
  "builtin_type_c_ast", "builtin_no_BitInt_c_btid", "concept_type_c_ast",
  "structured_binding_type_c_ast", "typedef_type_c_ast",
  "sub_scope_sname_c_opt", "typeof_type_c_ast", "$@40", "typeof",
  "enum_class_struct_union_c_ast", "class_struct_union_c_ast",
  "enum_c_ast", "enum_btids", "enum_fixed_type_c_ast_opt",
  "enum_fixed_type_c_ast", "enum_fixed_type_modifier_list_btid_opt",
  "enum_fixed_type_modifier_list_btid", "enum_fixed_type_modifier_btid",
  "enum_unmodified_fixed_type_c_ast", "class_struct_btid_opt",
  "class_struct_btid", "class_struct_union_btid",
  "type_qualifier_list_c_stid_opt", "type_qualifier_list_c_stid",
  "type_qualifier_c_stid", "cv_qualifier_stid",
  "cv_qualifier_list_stid_opt", "restrict_qualifier_c_stid",
  "upc_layout_qualifier_c", "storage_class_c_type", "_Noreturn_atid",
  "attribute_specifier_list_c_atid_opt", "attribute_specifier_list_c_atid",
  "$@41", "using_opt", "attribute_list_c_atid_opt",
  "attribute_list_c_atid", "attribute_c_atid_exp",
  "attribute_str_arg_c_opt", "gnu_or_msc_attribute_specifier_list_c_opt",
  "gnu_or_msc_attribute_specifier_list_c",
  "gnu_attribute_specifier_list_c_opt", "gnu_attribute_specifier_list_c",
  "gnu_attribute_specifier_c", "$@42", "gnu_attribute_list_c_opt",
  "gnu_attribuet_list_c", "gnu_attribute_c_exp",
  "gnu_attribute_decl_arg_list_c_opt", "gnu_attribute_arg_list_c_opt",
  "gnu_attribute_arg_list_c", "gnu_attribute_arg_c",
  "msc_attribute_specifier_list_c", "msc_attribute_specifier_c", "$@43",
  "msc_attribute_list_c_opt", "msc_attribuet_list_c", "decl_english_ast",
  "array_decl_english_ast", "array_size_decl_ast", "length_opt",
  "block_decl_english_ast", "constructor_decl_english_ast",
  "destructor_decl_english_ast", "destructor_parens_opt",
  "func_decl_english_ast", "func_qualifier_english_type_opt",
  "msc_calling_convention_atid", "paren_param_decl_list_english_opt",
  "paren_param_decl_list_english", "param_decl_list_english_opt",
  "param_decl_list_english", "decl_english_ast_exp",
  "ref_qualifier_english_stid_opt", "returning_english_ast_opt",
  "returning_english_ast", "qualified_decl_english_ast",
  "type_qualifier_list_english_type_opt",
  "type_qualifier_list_english_type", "type_qualifier_english_type",
  "attribute_english_atid", "storage_class_english_stid",
  "eval_expr_init_stid", "linkage_stid", "linkage_opt",
  "type_qualifier_english_stid", "upc_layout_qualifier_english",
  "qualifiable_decl_english_ast", "pointer_decl_english_ast",
  "reference_decl_english_ast", "reference_english_ast",
  "structured_binding_decl_english_ast",
  "user_defined_literal_decl_english_ast", "var_decl_english_ast",
  "type_english_ast", "type_modifier_list_english_type_opt",
  "type_modifier_list_english_type", "type_modifier_english_type",
  "unmodified_type_english_ast", "builtin_type_english_ast",
  "builtin_no_BitInt_english_btid", "BitInt_english_int", "BitInt_english",
  "concept_type_english_ast", "parameter_pack_english_ast", "pack_exp",
  "precise_opt", "class_struct_union_english_ast", "enum_english_ast",
  "of_type_enum_fixed_type_english_ast_opt", "enum_fixed_type_english_ast",
  "enum_fixed_type_modifier_list_english_btid_opt",
  "enum_fixed_type_modifier_list_english_btid",
  "enum_unmodified_fixed_type_english_ast", "any_name", "any_name_exp",
  "any_sname_c", "any_sname_c_exp", "any_sname_c_opt", "any_typedef_tdef",
  "name_ast", "name_exp", "name_cat", "name_opt", "oper_sname_c_opt",
  "sname_c", "sname_c_ast", "bit_field_c_uint_opt", "sname_c_exp",
  "sname_c_opt", "sname_english", "sname_english_ast", "sname_english_exp",
  "sname_english_opt", "sname_list_c", "sname_list_english",
  "typedef_sname_c", "address_exp", "array_exp", "as_exp",
  "as_into_to_exp", "as_or_to_opt", "auto_TYPE_exp", "binding_exp",
  "bits_opt", "bytes_opt", "cast_exp", "char_exp",
  "class_struct_union_btid_exp", "colon_exp", "comma_exp",
  "conversion_exp", "c_operator", "default_exp", "defined_exp",
  "dependency_exp", "destructor_sname", "empty_str_lit_exp", "equals_exp",
  "extern_linkage_c_stid", "extern_linkage_c_stid_opt", "glob", "glob_opt",
  "gt_exp", "inline_stid_opt", "int_exp", "lbracket_exp", "literal_exp",
  "local_exp", "lparen_exp", "lt_exp", "member_or_non_member_opt",
  "namespace_btid_exp", "namespace_type", "of_exp", "of_scope_english",
  "of_scope_list_english", "of_scope_list_english_opt", "operator_exp",
  "operator_opt", "point_exp", "precision_opt", "rbrace_exp",
  "rbracket_exp", "ref_qualifier_c_stid_opt", "reference_exp", "returning",
  "returning_exp", "rparen_exp", "scope_english_type",
  "scope_english_type_exp", "semi_exp", "semi_opt", "semi_or_end",
  "static_stid_opt", "str_lit", "str_lit_exp", "this_exp", "this_stid_opt",
  "to_exp", "type_opt", "typename_flag_opt", "uint_lit", "uint_lit_exp",
  "uint_lit_opt", "unused_exp", "user_defined", "virtual_stid_exp",
  "virtual_stid_opt", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1143)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1131)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1143,  1123, -1143, -1143,   434,  3187,    77,   704, -1143, -1143,
     704,  -142,  2079,    83,   704, -1143,   -54, -1143,  1080,   704,
      -7,   126, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143,   337,    77,   337,   337,   337,   337,
    1725,   337,   -96,   337, -1143,   337,   337,   337,   337,   337,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143,   164, -1143,   244,
   -1143,   633,   394, -1143, -1143, -1143, -1143,   477,   138, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143,   217,   449, -1143,
    4781, -1143,   132, -1143, -1143, -1143,   176, -1143, -1143, -1143,
   -1143,   440,  -142, -1143, -1143,   641, -1143, -1143, -1143,    45,
     275, -1143,  5272, -1143, -1143, -1143, -1143,    91, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143,    91, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,    71,
     112, -1143,   633, -1143, -1143, -1143, -1143, -1143,  5910,   224,
    1236, -1143, -1143, -1143,   377, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143,   140, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143,   -23, -1143, -1143, -1143,   140, -1143, -1143, -1143,
   -1143, -1143, -1143,   502, -1143,   524, -1143, -1143,   140, -1143,
   -1143,   509, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,   545,
   -1143, -1143, -1143, -1143, -1143,    93,   558, -1143, -1143,   136,
   -1143, -1143,   140, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143,   512, -1143, -1143, -1143,  6074, -1143, -1143,
   -1143,  6316, -1143, -1143, -1143, -1143, -1143, -1143, -1143,   140,
   -1143, -1143, -1143,   311,   311, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143,   365, -1143,   376, -1143,   603,   462,   244,   503,
     551,   -13,   607, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143,    84,    84,    89,   610, -1143,   164, -1143,   500, -1143,
   -1143, -1143, -1143,  4320,   434, -1143, -1143, -1143, -1143, -1143,
   -1143,   138,   138,   629,   395,   121, -1143,   114,   377, -1143,
   -1143, -1143, -1143, -1143,   250, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143,    85, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143,    76, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143,   495, -1143, -1143, -1143,    77,  4320,
     164,  4320,    43, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143,   463,   124, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143,  1375, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,  5412,
   -1143, -1143, -1143, -1143, -1143,  6074, -1143, -1143,   689, -1143,
   -1143, -1143, -1143, -1143,   311, -1143,    94, -1143, -1143,   483,
    4320, -1143, -1143,   477, -1143, -1143,   510,   119, -1143, -1143,
   -1143,   722,   162, -1143, -1143,   814,   218,   814, -1143, -1143,
     508, -1143, -1143, -1143,    57,  6074, -1143,  6074,   116, -1143,
      65,    55, -1143,   140,   140, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143,  6074,   -54,  3814,  2107,  2107,  1119, -1143, -1143,
   -1143,  6316,  3984,   532,    82, -1143,    82, -1143, -1143,   434,
   -1143,  6074, -1143,   140, -1143, -1143,   140,    71, -1143, -1143,
     490, -1143, -1143, -1143, -1143,   749,   750, -1143, -1143, -1143,
   -1143, -1143, -1143,    84, -1143, -1143, -1143,   629,   398, -1143,
     114,   511, -1143, -1143, -1143,   377, -1143, -1143, -1143, -1143,
   -1143, -1143,   250, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,    25,
   -1143, -1143,   589, -1143, -1143, -1143, -1143,  5038,  4661, -1143,
   -1143, -1143, -1143, -1143, -1143,   479, -1143,   184, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,    62,
     153,    42,   755, -1143, -1143, -1143,   787, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143,   197, -1143, -1143,
     438,   176, -1143, -1143, -1143,   124, -1143, -1143, -1143, -1143,
   -1143,  5523, -1143,   757,  5663,   699,  5774, -1143, -1143, -1143,
   -1143, -1143,  5412, -1143, -1143,    61,  5161,   166, -1143, -1143,
   -1143, -1143, -1143,   753, -1143, -1143, -1143, -1143,   558, -1143,
   -1143,   224,   218, -1143, -1143, -1143, -1143, -1143, -1143,   477,
   -1143, -1143, -1143, -1143, -1143,   477,   611, -1143, -1143,   156,
     768, -1143,   138,   138,   140,    63,    53, -1143, -1143,   771,
   -1143,   535,   477,   737, -1143,  1236, -1143,   101, -1143, -1143,
   -1143, -1143, -1143, -1143,   732, -1143, -1143,   650, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,  1236,
   -1143, -1143, -1143,   571,   412,   798,   660,   655,    47,   365,
   -1143, -1143,   732, -1143, -1143,   576,   490,   577, -1143,   579,
   -1143, -1143,    53,   499,   140,   961, -1143,   580,    60,   392,
     410, -1143, -1143, -1143, -1143, -1143, -1143, -1143,   787, -1143,
   -1143, -1143, -1143, -1143,   151,   755,   805,   158,   185,   497,
     642,   839,   755, -1143, -1143, -1143, -1143, -1143, -1143,   691,
   -1143, -1143, -1143, -1143, -1143,   158, -1143, -1143,  4492,  4465,
   -1143, -1143,  4320, -1143, -1143,   140, -1143, -1143, -1143, -1143,
      42,    42, -1143,   120,   128,   806,   167, -1143, -1143,  4179,
      97, -1143, -1143, -1143, -1143, -1143,   667,   149,   116, -1143,
   -1143, -1143,  2012, -1143,  4661, -1143,  5523,   812,  5523, -1143,
   -1143,  5412, -1143,   699,  5663, -1143, -1143,  2107, -1143, -1143,
   -1143,   813,   177, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143,  5161, -1143, -1143, -1143,  6074,   780,   584, -1143,
   -1143, -1143,   609, -1143,   558, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143,    53, -1143, -1143, -1143,   753,
   -1143,    91,   592, -1143, -1143,   584, -1143, -1143, -1143,    78,
   -1143,   820, -1143,   821,    79, -1143, -1143, -1143,   825,   180,
   -1143, -1143,  6074,   753,  6074, -1143,   753, -1143, -1143, -1143,
    2107, -1143, -1143,    29, -1143,  1079,  1035,   365,    53,  2107,
    2107, -1143,   116, -1143, -1143,   650,   717, -1143,   822,  1511,
   -1143, -1143,   365,   753, -1143, -1143, -1143,   542,   825, -1143,
     825,   499, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143,  6224, -1143,   709,   282, -1143, -1143, -1143, -1143, -1143,
      91, -1143, -1143,    91, -1143, -1143, -1143, -1143, -1143,   161,
   -1143, -1143,   499, -1143, -1143, -1143,  2306, -1143, -1143,   461,
   -1143, -1143, -1143, -1143,   486,    97, -1143, -1143,   865,  4320,
     852,   127,   504,   146,   600,   853, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,    77,    73,
   -1143, -1143, -1143,    84,    84, -1143, -1143, -1143, -1143,   111,
   -1143, -1143, -1143, -1143, -1143, -1143,  4179,   834,   835,   139,
   -1143, -1143,    91, -1143, -1143,    42, -1143,   841,   465, -1143,
   -1143, -1143, -1143,  2600, -1143,   164, -1143, -1143, -1143,   743,
   -1143,   894,   894,   739,   845, -1143, -1143, -1143,  5663,  5774,
     788, -1143, -1143, -1143,    90, -1143, -1143, -1143,   753, -1143,
     753,   753,   753, -1143,   584,    53,  4907,   825,   609,   122,
   -1143, -1143, -1143, -1143,   847, -1143,   847, -1143, -1143, -1143,
     846,   488, -1143,   244,   244,   492,   849,   514, -1143,   144,
   -1143, -1143, -1143, -1143,   341, -1143,  3486, -1143,   481, -1143,
     609,  1236,   477, -1143, -1143, -1143,   848,  1236,   138,   851,
     690, -1143,   138, -1143,   825, -1143, -1143,  2107, -1143, -1143,
     558,    91, -1143,   609, -1143, -1143, -1143,   140, -1143, -1143,
   -1143, -1143, -1143,   341,   341,   825, -1143,   709, -1143,   709,
   -1143, -1143, -1143,   632,   110,   110, -1143, -1143, -1143, -1143,
    4320,   855, -1143,   161, -1143, -1143, -1143,   624, -1143,   755,
   -1143, -1143,   127, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143,   663, -1143, -1143, -1143,
     888, -1143, -1143,   116,   116,   743,   863, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143,  2894, -1143, -1143,   131, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143,   497,   691, -1143,  1821,
   -1143,   753,  1236,   609,   864,   864,   864,   244, -1143,   825,
    6074, -1143, -1143, -1143, -1143, -1143, -1143,    57, -1143, -1143,
     138,  1053,   584, -1143,   477,   108,   144, -1143, -1143, -1143,
   -1143, -1143,   866,   525, -1143,   140,   872,   831, -1143, -1143,
   -1143, -1143,   753, -1143, -1143,   140, -1143,  2107, -1143, -1143,
      -3, -1143,   138, -1143, -1143,   464, -1143,    69, -1143,   532,
      53,   140, -1143,   542,   542,   542,   825,   365,   365,   341,
   -1143, -1143,    64, -1143, -1143, -1143, -1143, -1143, -1143,   459,
   -1143,   161,    97, -1143,    73,   791, -1143,   743,   477, -1143,
      97, -1143, -1143, -1143, -1143, -1143,  4320, -1143,   157, -1143,
   -1143, -1143,   864,   753, -1143,   341, -1143,   477, -1143, -1143,
     244, -1143, -1143,   574, -1143,   144,  3322,   214,   118, -1143,
     -41,   864,   109,   477,   138,   138, -1143,   138,   138,   341,
     825,  3650, -1143, -1143, -1143,   341, -1143, -1143,   365, -1143,
   -1143, -1143, -1143, -1143,    77,  4320, -1143, -1143, -1143,   709,
   -1143, -1143, -1143, -1143, -1143, -1143,   755,   609,   145,   753,
   -1143,   615, -1143, -1143,   616, -1143, -1143, -1143, -1143,   477,
   -1143, -1143,   875, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
     244,   477,   140, -1143, -1143, -1143, -1143,   145,    69, -1143,
     876,   622,   831,   831,  4320, -1143, -1143, -1143,  4547,  2659,
      97,   558,  6074, -1143,   365,   864, -1143, -1143,    57, -1143,
   -1143,    53,   831,   341,   341, -1143, -1143, -1143,   164, -1143,
   -1143, -1143, -1143, -1143,    53, -1143,   477,   877, -1143,   145,
     145,   825,   753, -1143,   365,   831, -1143, -1143, -1143, -1143,
   -1143
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,    19,   929,     0,     0,     0,   206,   252,
       0,   254,     0,     0,     0,   601,  1116,   603,     0,     0,
     598,     0,   600,   291,   292,  1059,   293,   294,   352,   365,
    1100,  1101,   207,     3,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,     0,     0,     0,     0,     0,
      26,   253,   306,   307,   308,   283,   284,   285,   364,   312,
     602,   309,   314,    18,   917,   904,   905,  1066,   937,   898,
     930,     0,   899,    32,  1000,   988,   992,     0,     0,   996,
     994,   981,   985,   977,  1019,   997,   995,   998,   979,   991,
     987,  1002,  1009,  1005,  1001,  1008,  1004,  1011,  1007,   978,
    1014,  1016,   982,  1017,  1012,  1006,   980,   983,   986,   989,
     993,   999,  1003,  1010,  1015,  1018,   990,   975,   973,   972,
     618,   934,     0,    28,   928,   927,     0,   961,   960,    23,
      24,   259,   255,   257,   268,   280,   278,   279,   267,  1036,
     274,    93,    94,    25,  1117,   355,   229,     0,   217,   220,
     222,   223,   224,   225,   226,     0,   227,   218,   219,   221,
     228,   215,   216,    22,   580,   599,  1058,  1057,  1060,     0,
       0,     4,     0,     5,     6,     7,     8,   205,     0,   339,
     604,   626,   553,   561,   633,   560,   559,   531,   536,   532,
     641,   642,   534,     0,   616,   533,   549,   617,   558,   551,
     529,   530,   637,   620,   303,   609,     0,   646,   643,   552,
     631,   636,   638,     0,   200,   645,   555,   556,     0,   572,
     573,     0,   550,   304,   629,   557,   635,   640,   644,   618,
     647,   554,   628,   630,   632,   562,   563,   535,   612,   613,
     615,   680,   621,   627,   702,     0,   917,   188,   189,     0,
     191,   295,     0,   192,   196,   199,   190,   202,   194,   193,
     195,   197,   198,   465,   466,   363,   353,   518,   524,   525,
     520,   521,   539,   540,   547,   541,   542,   543,   544,     0,
     618,   574,   575,   648,   648,   526,   610,   611,   527,   639,
     528,   652,   674,   679,   675,   701,   567,     0,   204,   634,
       0,     0,     0,     9,    10,    11,    13,    14,    15,    16,
      17,     0,     0,     0,     0,  1065,  1067,   925,     0,   947,
     944,   945,   946,   750,     0,  1090,  1089,   984,  1079,  1078,
    1013,     0,     0,     0,     0,    42,    80,     0,    72,    82,
      88,    76,   766,    85,     0,    70,    75,    77,    83,    87,
      89,   770,   771,    64,     0,   758,    68,    74,    79,    81,
      86,   759,   762,     0,   764,   767,    67,    69,    71,   769,
     760,    65,    61,    63,     0,    62,   943,   942,     0,   750,
    1066,   750,     0,   258,   256,   281,   282,   277,   266,  1035,
    1037,   274,     0,   269,   270,   271,   275,   262,   157,   177,
     172,     0,    98,   147,   148,   139,   170,   135,   136,   132,
     153,   158,   171,   140,   134,   138,   137,   167,   163,   166,
     143,   145,   165,   162,   160,   161,   149,   151,   154,   175,
     144,   173,   155,   179,   176,   169,   178,   168,   164,   156,
     174,   187,   133,   123,   159,   141,   142,   150,   152,   120,
     127,   128,   121,   124,   129,   130,   131,   146,    92,    99,
     186,   122,   125,   126,    97,     0,   908,   907,   231,   251,
     897,   894,   895,   896,   648,   213,     0,   910,   208,   210,
     750,   637,   645,     0,   286,   634,   343,     0,   345,   347,
     346,     0,     0,   342,   468,   605,   672,     0,  1104,  1105,
    1031,   804,  1051,  1050,     0,     0,   914,     0,     0,   650,
    1080,     0,   614,     0,     0,   952,   951,   564,   456,   413,
    1053,  1052,     0,  1116,     0,   913,   913,   368,   523,   519,
     537,   522,     0,   538,     0,   649,     0,   678,   700,     0,
     566,     0,   203,     0,  1026,  1027,     0,     0,   901,   900,
     581,   310,   319,   323,   315,   317,   318,   327,  1095,  1093,
    1091,  1092,  1094,     0,  1064,   915,   916,     0,     0,   790,
       0,     0,  1125,   772,   778,   782,   792,   798,   835,   786,
     807,   795,     0,   779,   780,   785,   787,   793,   797,   799,
     776,   784,   789,   791,   796,   775,   777,   781,   810,   811,
     813,   773,  1066,   808,   809,    20,   708,   838,   751,   753,
     754,   755,   756,   709,   710,     0,   834,     0,   936,   935,
     976,   974,   801,   802,   803,    66,   765,    78,   763,     0,
       0,    48,   733,  1128,  1127,    90,   805,  1049,  1048,    84,
    1025,  1024,   757,  1124,  1123,   761,   619,     0,   933,    27,
      33,     0,    91,   261,   260,     0,   264,   273,   272,   263,
     111,   180,   113,     0,   107,   106,   115,   117,   118,   104,
     103,    95,   100,   102,   356,     0,   240,     0,   212,   211,
     909,    21,   288,   480,   344,  1109,  1108,   348,   454,   969,
     968,     0,   672,   608,   673,   607,  1032,  1107,  1106,     0,
     545,   201,  1120,  1118,  1119,     0,   653,  1081,  1082,     0,
       0,   622,     0,     0,     0,     0,  1110,   289,   296,     0,
     300,     0,     0,   458,   474,   604,   475,     0,   727,   728,
     729,   730,   731,   732,   464,   371,   372,   375,   387,   382,
     383,   384,   385,   386,   376,   461,   377,   469,   378,   604,
     389,   390,   391,   919,   913,     0,   567,     0,   919,   676,
     467,   354,   369,   571,   569,   900,   581,     0,   576,     0,
     568,   477,  1110,     0,     0,     0,   313,   330,     0,     0,
       0,  1063,   774,   788,   800,  1023,  1022,  1126,   805,   794,
     815,   812,   814,   926,   713,   733,   722,     0,   743,     0,
       0,   717,   733,   842,   816,   817,   818,   819,   820,  1054,
     726,   725,   749,   821,   822,     0,   823,   824,     0,   839,
     841,   752,   750,  1047,  1046,     0,   939,   938,   768,    47,
      48,    48,    43,    56,    56,     0,     0,    51,    55,   750,
     745,   734,   806,    73,   971,   970,  1070,   948,     0,    40,
      41,    34,     0,    35,   750,   265,   180,     0,   181,   183,
     184,    99,   112,   108,   110,   116,   101,   913,   239,   238,
     237,     0,     0,   236,   245,   246,   247,   248,   249,   250,
     244,   230,   241,   243,  1030,  1029,     0,   498,   492,   500,
     502,   504,     0,   481,   482,   490,   486,   487,   488,   489,
     483,   484,   485,   491,    60,  1110,   341,   606,   305,   480,
     548,     0,     0,  1045,  1044,     0,   625,   624,   623,     0,
     687,   688,   707,     0,     0,   451,  1111,   906,     0,     0,
     447,   450,     0,   480,     0,   302,   480,   299,   298,   405,
     913,   463,   393,   919,   392,     0,     0,   676,  1110,   913,
     913,   472,     0,   476,   379,     0,   380,   381,     0,     0,
     918,   388,   677,   480,   578,   579,   577,   506,     0,   409,
       0,     0,   583,   591,   592,   594,   593,   595,   596,   597,
     582,   584,   590,   587,     0,   311,   331,   329,   316,   328,
       0,   320,   321,     0,   325,   324,   783,   716,   715,     0,
     714,   720,     0,   721,  1113,  1112,     0,  1084,  1083,   744,
     954,   953,   831,   718,     0,   745,  1055,  1056,     0,   750,
     880,     0,     0,     0,  1121,  1074,   863,   862,   851,   860,
     853,   854,   857,   858,   872,   852,   859,   856,     0,     0,
     866,   867,   848,     0,     0,   836,   843,   849,   850,     0,
     845,   847,   844,   846,   840,   833,   750,     0,     0,     0,
      58,    52,     0,    53,    44,     0,   739,     0,     0,  1085,
    1086,    30,   746,     0,  1071,  1066,   949,   950,    39,   955,
      38,   958,   958,   742,     0,   119,   182,    96,   109,   114,
     357,   359,   360,   232,     0,   242,   366,   495,   480,   493,
     480,   480,   480,   494,   923,  1110,   349,     0,     0,     0,
     669,   666,   667,   659,   670,   662,   670,   664,   665,   661,
       0,     0,   658,   668,   932,     0,     0,     0,   685,   690,
     686,   703,   706,   457,   423,   415,     0,   448,     0,   297,
       0,   604,     0,   374,   373,   370,  1079,   604,     0,     0,
       0,   395,     0,   394,     0,   462,   470,   913,   920,   618,
       0,     0,  1028,     0,   512,   514,   516,     0,   507,   508,
     509,   510,   511,   423,   423,     0,   589,   587,   586,   588,
     337,   332,   334,  1098,     0,     0,   322,   326,  1062,  1061,
     750,     0,   827,     0,   825,   941,   940,   911,   719,   733,
     828,   881,     0,  1043,  1042,   873,  1073,  1072,   864,   963,
     962,   861,  1122,   855,  1075,   865,   875,   879,   878,   877,
     884,   882,   871,     0,     0,   955,     0,    46,    45,  1021,
    1020,    57,    54,    50,   735,     0,   748,   747,     0,   956,
     957,    59,   959,    37,    36,   743,     0,  1054,   185,     0,
     235,   480,   604,     0,   501,   503,   505,   924,   287,     0,
       0,   338,   455,   546,   967,   966,   654,     0,   660,   663,
       0,     0,     0,   565,     0,     0,     0,   695,   696,   694,
     697,   699,     0,     0,   693,     0,   424,   435,   417,   453,
     452,   446,   480,  1039,  1038,     0,   301,   913,   459,   404,
       0,   397,     0,  1103,   398,     0,   396,  1080,   473,   471,
    1110,     0,   570,   506,   506,   506,     0,   676,   676,   423,
     585,  1099,     0,  1097,  1096,   335,   336,   711,   723,     0,
     912,     0,   745,   874,     0,  1114,   883,   955,     0,   868,
     745,   741,   740,   738,  1088,  1087,   750,   744,     0,   362,
     361,   358,   367,   480,   499,   423,   350,     0,   651,   657,
     931,   681,   684,     0,   689,     0,     0,     0,     0,   414,
     416,   449,     0,     0,     0,     0,   401,     0,     0,   423,
       0,     0,   513,   515,   517,   423,   410,   411,   676,  1077,
    1076,   333,   965,   964,     0,   750,   724,   876,  1115,   888,
     870,   869,   832,    31,  1069,  1068,   733,     0,   431,   480,
     671,   969,   698,   692,     0,   426,   430,   428,   429,     0,
     439,   436,   440,   438,   420,   421,   422,   418,   419,   922,
     921,     0,     0,   403,   402,   400,   399,   431,  1080,   443,
       0,     0,   435,   435,   750,   712,   891,   885,     0,   889,
     745,     0,     0,   497,   434,   351,   427,   425,     0,   437,
     290,  1110,   435,   423,   423,   478,   407,   826,  1066,   892,
     886,   893,   890,    29,  1110,   432,     0,     0,   412,   431,
     431,     0,   480,   441,   676,   435,   479,   496,   433,   406,
     460
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143,   -57, -1143,  -112,   129, -1143,    51, -1143, -1143,
   -1143, -1143, -1143,   816,    95, -1143,   293, -1143,  -405,   302,
    -733,  -620,  -376, -1143, -1143, -1143,   113, -1143,   123,  -388,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143,  -127, -1143, -1143,    86, -1143, -1143, -1143, -1143, -1143,
     858, -1143, -1143,  -232,   328,   593, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143,   947, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143,     8, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143,   219, -1143, -1143,
   -1143, -1143,  -140, -1143, -1143,   956,  -457, -1143,    17, -1143,
   -1143, -1143,  -246, -1143, -1143,    21,   710, -1143, -1143, -1143,
     484,    67, -1143,  -504, -1143,   259, -1143, -1143,  -638, -1143,
   -1143, -1143,  -802, -1143, -1143,   260, -1143, -1143,  -897, -1143,
   -1143, -1143,  -730, -1143,  -697, -1143,  -685, -1143, -1143,  -725,
    -856,  -120, -1143, -1143, -1143,  -235, -1054, -1143, -1143, -1143,
     263, -1143,  -336,   840, -1143, -1143, -1143, -1143, -1143,  -264,
   -1143, -1143,  -241, -1143,   979, -1143, -1143,  -881, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143,  -562, -1143, -1143, -1143, -1143, -1143, -1143,
   -1143,  -172, -1143,   751,  -191,  -393,   754, -1143, -1143, -1143,
    -547, -1143, -1143, -1143,  -354, -1143,  -540, -1143, -1143, -1143,
   -1143, -1143,    16,   257, -1143,  -153,   251,  -940,    44, -1143,
    1007,     4,  -674,    92,  -161,  -281,  -211,  -278, -1143, -1143,
   -1143,     5,  -176, -1143, -1143, -1143, -1143,  -240,   -86,   340,
    -165,  -914,  -678,  -282, -1143, -1143, -1143,  -865, -1143, -1143,
    -239,  -330, -1143,   748, -1143, -1143, -1143,  -275, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143,   436,  -768, -1143,
     -12, -1143, -1143,   -38,  -975, -1143, -1143,   194, -1143,   445,
    -107, -1143,   493,  -249,   267, -1143, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143, -1143, -1143,   238, -1143,  -389,
   -1143, -1143, -1143, -1143, -1143,  -259, -1143, -1143, -1143, -1143,
   -1143, -1143, -1143, -1143, -1143,   523,     3,  -288,   540,    -8,
   -1143,  -132, -1143, -1143,  1037,    -4,  -459,   325, -1143, -1143,
     807,  -369,   -32, -1143, -1143, -1143, -1143, -1143, -1143,   -89,
     910, -1143, -1143, -1143, -1101,     1,   187, -1143, -1143, -1143,
    -463, -1143,   125, -1143, -1143, -1143, -1143, -1143, -1143,  1045,
   -1143, -1143, -1143, -1143, -1143,  -116, -1143, -1143,   517,  -192,
   -1143,  -157, -1143,   778, -1064,   786, -1143,   -55, -1143, -1143,
   -1143, -1143, -1143,  -311, -1142,  -141,  -131, -1143,  -467, -1143,
   -1143,   -79, -1143,  1492, -1143,  -135,  -924, -1143, -1143,   296,
   -1143,   590,  -481,  -791, -1143, -1143,   742,   552, -1143
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,    33,    34,    35,    36,   380,   649,   851,   852,
     632,   832,   835,   836,   837,  1061,   853,   120,   372,   373,
      37,    38,   458,   670,   671,   672,   673,   663,   664,   665,
     666,   667,   460,   461,   462,   463,   857,   858,   859,   464,
      39,   507,    40,    41,   170,   478,    42,   161,   676,   871,
     872,   873,   881,   882,   883,   162,    43,    44,    45,   132,
     133,   383,    46,   396,   659,   397,   139,   387,    47,    48,
      49,   247,   683,   248,   933,    50,   250,   523,   934,   251,
     936,   252,   253,    51,    52,   312,   777,    53,   311,    54,
     313,   778,   554,   555,   556,   988,   985,   986,  1183,   254,
     491,   492,   838,  1261,  1409,    55,   256,   527,    56,   465,
     867,  1090,  1091,  1351,   257,    57,    58,   169,  1251,   761,
     734,   735,  1145,   736,   954,   737,   738,   739,  1103,   740,
    1141,   258,   970,   259,   260,   741,   261,   716,  1134,  1288,
    1370,  1427,  1287,  1419,  1453,  1482,  1369,  1459,  1440,   928,
     929,   930,  1292,  1291,   904,   948,  1135,   742,   940,   743,
     744,   949,   889,   262,   263,   526,   264,   746,   950,   890,
     748,  1157,   891,   750,   751,   967,   752,   892,   893,   894,
     895,   896,   897,  1252,   898,   899,  1098,   900,  1100,   901,
    1101,   902,  1102,  1167,  1168,  1169,  1313,  1170,  1314,  1171,
    1315,   266,   530,   267,   268,   269,   270,   271,   272,   909,
     273,   274,   275,   276,   277,   540,   278,   963,   279,   280,
     281,   282,   283,   776,   980,  1178,  1179,   982,   983,   164,
      60,   284,   494,   495,   285,   286,   374,   287,   512,   288,
     289,   534,   290,   706,   912,  1120,  1121,  1122,  1268,   693,
     291,   961,   292,   293,   513,  1126,  1127,   922,  1130,  1282,
    1283,  1284,   294,   295,   514,   923,   924,  1066,   804,   999,
    1014,   805,   806,   807,  1003,   808,   809,   754,   840,   841,
    1067,  1068,  1343,   811,  1071,  1072,   606,   607,   608,   609,
     610,   611,   625,   500,   843,   612,   791,   812,   813,   814,
     815,   816,   613,   614,   817,   818,   819,   820,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1219,  1202,  1052,  1053,  1336,
    1447,  1448,  1449,  1470,   473,   474,   755,   550,   767,    68,
     931,   468,   479,  1331,   757,   758,   903,   960,  1431,  1258,
     125,   616,   126,    71,  1125,   122,    72,   828,  1197,   379,
     323,  1078,   517,  1012,  1241,  1243,   129,  1211,  1394,  1266,
    1136,   846,   123,  1231,   787,   642,   546,  1161,   886,   485,
     300,   390,   391,  1295,   301,  1205,   915,   825,   639,   504,
     522,  1018,   168,    62,  1190,   315,   316,   793,  1406,  1075,
    1208,  1215,  1391,   330,   709,  1009,  1073,  1346,   327,   562,
     563,  1325,  1322,    63,  1305,   698,   699,   687,   932,  1006,
    1399,   145,   704,   705,  1213,   645,   617,   635,   302
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      69,    69,    69,   172,   140,    61,   484,    67,    67,    67,
     537,   519,   317,   375,   505,   497,   682,    59,   510,   496,
     620,   621,   760,   469,   551,   668,   508,  1001,  1108,   691,
     713,    69,   296,  1153,  1015,  1162,   298,   381,    67,   493,
    1198,  1176,   603,   722,   653,   604,   865,   968,   605,   501,
     701,   941,  1138,  1262,  1128,  1140,   710,  1079,   697,  1132,
     524,   987,   868,   826,   920,  1389,   759,   759,   759,   533,
     833,  1173,   470,  1174,  1217,   951,   528,   643,   124,   920,
     920,   962,  1163,   548,   141,   548,   640,   532,   388,   636,
     552,   868,   466,   646,   515,   678,   318,   834,   603,   947,
     603,   604,   942,   604,   650,   790,   652,   535,   535,   920,
    1429,  1323,  1222,   475,   318,   633,  -898,   702,   792,  1420,
     685,   486,   487,  1264,  1339,   657,  -444,   166,  1203,  1329,
     711,  1089,  1344,   376,  -233,   712,  -704,   520,   194,   328,
    1229,   502,  1059,   197,   707,   630,    15,  1209,   707,   377,
    1059,  -682,  -705,  1069,   829,   393,   488,   913,  1404,  1004,
     658,  1158,  1188,   689,   131,  1379,  1076,   884,   689,  1175,
     296,   753,   753,   753,   144,   708,  1223,   376,   689,   708,
    1107,   689, -1041,  1224, -1041,   823,  -829,  1069,  1062,   745,
     745,   745,   543,   377,   544,   631,    22,   130,   844,   603,
    1191,   143,   604,   501,   304,   681,   163,  1424,  1189,  1077,
    1425,   314,   503,   329,   803,  1416,  1276,  1253,  1005,  1254,
    1255,  1256,  1452,  1154,   845,   830,   824,   831,   977,   646,
     914,   997,   908,   925,   521,   979,  1400,  -340,   910,  1176,
     -49,   869,   -49,  1426,   194,  -829,   766,  1070,   768,   197,
    -234,   637,   646,  -445,   937,   938,  1421,  1307,  1060,   296,
     864,   747,   747,   747,   378,   489,  1060,  1395,   944,   962,
     869,   476,  1149,   860,  1204,   781,   926,  1230,  1319,   394,
     885,  1070,  1210,  1180,   749,   749,   749, -1041,   668,   536,
     668,   331,   392,   674,   690,   759,  1463,   545,   535,   690,
     880,   703,  1374,   486,   487,   557,   393,    69,    69,   690,
     566,   318,   690,  1000,   549,   549,   618,   947,   560,   615,
     619,   714,   715,   952,  1422,   651,   788,   603,   641,   703,
     604,   694,   516,   700,   692,   644,   695,   827,   488,   167,
     528,   952,   686,  1357,   634,  1218,   648,   490,   389,   654,
     717,   772,   720,   395,   773,  1089,   984,  1396,   927,   703,
     764,  1390,  1355,  1092,   498,  1402,   870,   499,   921,   771,
    1352,  1082,  1405,  1065,    69,   615,   471,   615,  -902,   472,
    1259,    67,    64,   921,   921,    65,    66,    64,   142,    64,
      65,    66,    65,    66,   553,   870,   467,    65,    66,   679,
     753,   917,   918,  1386,  1387,  1324,    64,  -209,   759,  1094,
    1362,  1371,  -209,   921,    64,   703,  1265,   477,   745,  1385,
     703,   978,   703,   658,  1417,  1104,   803,  1487,   241,  1099,
     394,  1332,  1337,  1338,   977,    15,  1142,    16,    17,  1418,
     501,   979,  1277,  1317,  1318,  1155,  1156,   489,  1278,  1279,
     638,  1280,   847,   905,  1281,   703,   998,   296,  1088,  1446,
    1392,   324,  -830,    20,  1042,  1152,   689,  1297,   860,   865,
     860,    21,  1407,  1300,  1443,  1473,   615,  1139,   325,   677,
     655,   759,  1293,  1438,   723,    22,   759,  1195,   668,   689,
     759,   759,   725,   328,   393,    25,   822,   296,  1007,   296,
     969,   241,  1196,   848,   395,  1206,   880,   244,  1172,  1472,
    1414,    29,   785,   753,   296,   689,   296,   756,   756,   756,
     721,  -830,   919,   332,   296,  1441,   689,   694,  1455,   490,
      69,   745,    69,   296,  1476,    69,   325,   765,  -737,   765,
     786,   603,   770,  1212,   604,   626,   318,  1055,   626,   221,
     326,   906,  1008,  1207,   382,   946,   571,   572,   603,    69,
     497,   604,   854,  -656,   496,  1285,   549,   329,  1225,   506,
    1489,   603,  -408,   603,   604,  1411,   604,  1081,  1353,  1181,
    1294,   990,   971,   509,   497,  1380,   753,  -683,   496,  1388,
    1286,   753,   727,  1110,   241,   753,   753,   690,  -691,   993,
     244,  1488,   318,   747,   745,  1235,  -917, -1130,   326,   745,
     325,   558,    15,   745,   745,    17, -1090,   689,   394,   511,
     690,   724,   725,   689,  1272,  1408,   749,   978,   213,   849,
     518,  1164,    30,  1056,   319,  1151,   314,    31,  1450,   962,
     962,  1263,   627,  1010,   525,   783,   690,   326,   241,  1437,
     320,   628,   726,  1308,   628,  1442,  -917,   690,  1271,  1105,
    1011,   622,    22,   623,  1275,   244,   624,  -655,   559,   629,
     539,   321,   629,  1296,   194,  1298,   747,   541,   850,   197,
     537,   747,   326,   946,   498,   747,   747,   499, -1090,  1456,
     547,   328,   395,   322,   385,  -442,  1312,   991,   759,   749,
      65,    66,   386,  1165,   749,   127,   690,   128,   749,   749,
     962,   194,   668,   668,  1096,    64,   197,    64,    65,    66,
      65,    66,   518,   943,   946,   603,  1166,   539,   604,  -937,
    1454,  1194, -1034,  1479,  1480,  1016,  1477,  1017,   603,    64,
    1462,   604,    65,    66,  1200,  1092,   296, -1090,   690,  1481,
     943,  1382,  1383,  1384,   690,  1220,  1221,  1465,  1466,  1454,
    1137,   675,  1239,    15,  1240,   329,    17,   296,   703,  1377,
    -605,   992,   994,  1057,  1058,   603,   995,  1478,   604,  1109,
      29,   497,  1485,  1486,   775,   496,  1354,   771,   680,  -384,
     759,  -384,   603,  1373,  1245,   604,  1246,   688,  1237,    21,
    1490,  1454,  1454,   753,   696,   565,   962,  1361,    65,    66,
     296,    70,   121,    22,  1273,   684,   779,   780,   615,  1375,
    1365,   745,  1044,    25,  1378,   887,  1111,   839,   842,  1112,
     861,   662,   724,   725,  1043,   615,  1113,  1301,   759,  1304,
     911,  1306,  1303,   916,   935,   939,  1114,    64,   615,  1115,
      65,    66,  1116,  1117,  1172,  1172,  1172,   973,  1186,   756,
     974,  1187,  1118,   726,   945,   952,   975,   958,  1119,   194,
     959,  1401,  -903,   965,   197,   966,   984,  1002,   296,  1013,
     203,  1064,  1074,   205,   943,  1085,  1093,  1423,  1097,    64,
    1410,   976,  1129,   747,  1131,   753,  1412,    64,  1133,  1415,
    1365,  1199,  1159,  1201,   703,  1214,  1432,  1227,  1123,   603,
    1228,  1124,   604,   745,  1234,  1327,   749,  1242,  1248,  1267,
    1249,  1270,  1274,  1299,   296,  1310,   296,  1321,  1328,  1330,
    1232,  1302,   756,   888,  1334,  1335,  1340,   756,   946,  1364,
    1451,   756,   756,   753,  1367,  1368,  1398,  1458,  1309,  1464,
    1484,   296,  1457,  1233,   603,  1106,  1087,   604,   459,  1358,
    1342,   745,   972,  1063,  1460,   866,   863,  1250,  1095,  1084,
     238,   239,   240,   296,   242,  1316,   497,  1164,  1164,  1164,
     496,  1086,   497,   855,   656,   747,   496,   249,    61,   692,
     384,  1376,  1182,   194, -1102, -1102,   255,   989,   197,   375,
      59,  1184,   615,  1350,   203,  1185,  1216,   205,   749,  1483,
     542,   762,  1144,   955,   956,   615,  1290,   957,   483,   265,
    1238,   529,   531,   964,  1320,  1177,   981,   165,   646,  1311,
    1269,  1359,   907,   747,    69,  1413,  1146,  1363,  1150,    69,
      69,    67,   538,   810,  1226,  1247,   549,   549,  1083,  1165,
    1165,  1165,   615,   821,  1110,   996,   749,  1054,    64,  1469,
     782,    65,    66,  1433,  1434,   603,  1435,  1436,   604,   615,
     774,  1403,  1166,  1166,  1166,  1397,   769,   297,   953,  1471,
    1143,   146,   480,  1244,  1160,   299,  1333,   497,  1356,  1428,
    1348,   496,   561,  1366,   238,   239,   240,   182,   242,   789,
    1257,   183,   564,  1372,   185,  1347,  1326,  1345,   186,   973,
     329,  1019,   974,   718,   603,  -604,   647,   604,   975,  1381,
    1445,     0,   784,     2,     3,     0,     4,     0,     5,     6,
       7,     8,     0,     9,    10,    11,    12,     0,     0,     0,
       0,     0,     0,   976,   196,     0,   198,   199,     0,   756,
       0,   723,     0,     0,     0,     0,    13,     0,   724,   725,
       0,     0,   209,   603,     0,     0,   604,     0,     0,  1467,
       0,     0,   537,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   615,  1147,     0,   726,
       0,   723,   216,   217,   218,     0,   219,   220,   724,   725,
     222,     0,     0,     0,     0,     0,     0,   225,     0,     0,
       0,     0,     0,     0,   194,     0,  1474,     0,     0,   197,
       0,     0,     0,   231,     0,   203,     0,     0,   205,   726,
       0,   615,     0,     0,     0,     0,     0,     0,   235,   236,
    1461,   756,   147,   148,   149,   150,   151,   152,   153,   154,
     155,     0,   296,   156,   157,   158,   159,   160,     0,   727,
       0,     0,     0,     0,     0,     0,     0,  1123,  1360,    65,
      66,     0,     0,     0,     0,    14,    15,     0,    16,    17,
    1475,     0,    18,     0,     0,     0,     0,  1111,     0,   756,
    1112,     0,     0,     0,  -913,   213,     0,  1113,     0,   727,
       0,     0,    19,     0,    20,     0,     0,  1114,     0,     0,
    1115,     0,    21,  1116,  1117,   238,   239,   240,   241,   242,
       0,     0,     0,  1118,   244,     0,    22,    23,     0,  1119,
       0,    24,     0,  1393,  -913,   213,    25,     0,     0,   703,
    1148,     0,   615,    26,    27,    28,     0,     0,     0,     0,
       0,     0,    29,     0,     0,     0,     0,     0,    64,     0,
       0,     0,  1444,     0,     0,     0,   728,   729,  1430,   730,
     731,   732,   733,     0,     0,     0,   660,     0,     0,     0,
    -214,     0,     0,     0,    64,     0,     0,    65,    66,     0,
      69,   615,     0,     0,     0,     0,     0,    67,     0,     0,
       0,     0,     0,     0,     0,     0,   728,   729,     0,   730,
     731,   732,   733,     0,     0,   194,     0,     0,    30,     0,
     197,     0,     0,    31,    64,     0,   203,    65,    66,   205,
       0,     0,     0,     0,     0,     0,     0,    32,     0,     0,
     615,     0,   398,     0,   296,   399,   400,   661,  -105,   403,
     404,   405,   406,     0,   407,   408,   409,     0,   410,   411,
       0,   412,     0,   413,   414,   415,   416,   417,     0,   418,
       0,   419,     0,   420,   421,   422,     0,   423,     0,   424,
       0,   425,     0,   426,   427,   428,   429,     0,     0,   430,
     431,     0,   432,   433,     0,   434,     0,   435,     0,   436,
       0,   437,     0,   438,     0,   439,   440,   662,     0,     0,
       0,     0,   697,     0,     0,     0,   238,   239,   240,   241,
     242,     0,     0,     0,     0,   244,   171,     0,   173,   174,
     175,   176,     0,   303,   442,   305,   443,   306,   307,   308,
     309,   310,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   444,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    74,     0,
       0,    75,    76,    77,     0,    78,     0,    79,    80,     0,
      81,    82,    83,     0,    84,    85,     0,    86,     0,    87,
      88,    89,    90,    91,     0,    92,     0,    93,     0,    94,
      95,    96,     0,    97,     0,    98,     0,    99,     0,   100,
     101,   102,   103,   104,     0,   105,   106,     0,   107,   108,
       0,   109,     0,   110,     0,   111,     0,   112,     0,   113,
       0,   114,   115,   116,   181,     0,     0,   182,     0,     0,
       0,   183,     0,   184,   185,     0,     0,     0,   186,   187,
     188,     0,   189,   190,    15,     0,   191,    17,   192,   445,
     446,   447,   448,   449,     0,     0,     0,   450,     0,   451,
     452,     0,   453,     0,     0,     0,   454,   455,   456,   457,
     194,     0,    20,   195,   196,   197,   198,   199,   200,   201,
     481,   203,     0,     0,   205,   206,     0,   207,     0,   208,
       0,     0,   209,     0,    22,     0,     0,   117,     0,     0,
     210,     0,   211,   212,     0,   118,   177,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   482,   216,   217,   218,     0,   219,   220,     0,   221,
     222,     0,     0,     0,     0,     0,   224,   225,     0,   226,
       0,     0,   227,     0,   228,     0,   229,     0,     0,     0,
       0,     0,   230,   231,     0,   232,   233,   119,     0,     0,
     234,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   178,     0,   179,
     244,     0,     0,     0,     0,   180,     0,     0, -1129,     0,
     245,     0,     0,     0,     0,     0,     0,     0,   498,    65,
      66,   499,  1349,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   181,     0,
       0,   182,     0,     0,     0,   183,     0,   184,   185,     0,
       0,     0,   186,   187,   188,     0,   189,   190,    15,     0,
     191,    17,   192,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   723,     0,     0,     0,     0,     0,     0,
     724,   725,     0,   193,   194,     0,    20,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,     0,   205,   206,
       0,   207,     0,   208,     0,     0,   209,     0,    22,    23,
   -1040,   726, -1040,    24,   210,     0,   211,   212,     0,     0,
    -913,   213,     0,     0,     0,    26,    27,    28,     0,     0,
       0,     0,     0,   214, -1033,   215,   216,   217,   218,     0,
     219,   220,     0,   221,   222,   223,     0,     0,     0,     0,
     224,   225,     0,   226,     0,     0,   227,     0,   228,     0,
     229,     0,     0,     0,     0,     0,   230,   231,     0,   232,
     233,     0,     0,     0,   234,     0,     0,     0,     0,     0,
       0,   727,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,     0,  1080,   244,     0,   567,     0,     0,     0,
       0,   568,     0,     0,   245,     0,     0,     0,  -750,     0,
     246,  -750,  -750,    65,    66, -1040,  -913,   213,  -750,     0,
       0,     0,  -750,     0,     0,     0,     0,  -750,  -750,     0,
       0,     0,     0,     0,     0,     0,  -750,   569,  -750,     0,
       0,     0,  -750,     0,     0,     0,   570,  -750,     0,  -750,
       0,  -750,     0,   571,   572,  -750,  -750,     0,     0,     0,
     134,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   135,     0,  -276,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   728,   729,
    -276,   730,   731,   732,   733,     0,     0,     0,     0,     0,
       0,     0,  -276,     0,     0,     0,    64,     0,     0,    65,
      66,     0,   136,     0,     0,     0,     0,     0,     0,     0,
     137,     0,     0,     0,     0,   573,     0,     0,  -750,     0,
     574,     0,  -750,     0,   575,  -750,     0,     0,     0,  -750,
    -750,  -750,     0,  -750,   576,  -750,     0,   577,  -750,  -750,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   723,
       0,     0,     0,     0,     0,     0,   724,   725,     0,     0,
       0,   194,   578,  -750,  -750,  -750,   197,  -750,  -750,  -750,
    -750,   579,   203,     0,     0,   580,     0,     0,   342,     0,
     581,   582,     0,  -750,     0,  -750,     0,   726,   583,     0,
       0,   584,     0,   585,   586,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -276,   587,   588,     0,     0,     0,
       0,     0,   589,  -750,  -750,  -750,   351,     0,     0,   352,
       0,  -750,     0,     0,   354,     0,   355,   590,  -750,     0,
     591,   592,     0,   593,     0,   594,   361,     0,     0,   362,
     363,     0,   364,   365,  -750,  -750,   595,   596,     0,     0,
       0,   597,   369,  -750,     0,     0,     0,   727,   370,  -750,
    -750,  -750,   598,   599,   600,     0,   242,   601,  -750,  -750,
    -750,     0,  -750,  -750,  -750,  -750,     0,  1192,  -276,     0,
     567,     0,     0,     0,     0,   568,   703,   602,     0,     0,
    -750,  -750,  -750,   213,     0,  -750,  -750,     0,     0,     0,
       0,     0,  -750,     0,     0,     0,  -750,     0,     0,     0,
       0,  -750,  -750,     0,     0,     0,     0,     0,     0,     0,
    1193,   569,  -750,     0,     0,     0,  -750,     0,     0,     0,
     570,  -750,     0,  -750,     0,  -750,     0,   571,   572,  -750,
    -750,     0,     0,     0,  -276,     0,     0,     0,     0,  -276,
       0,     0,  -276,     0,   138,     0,     0,    65,    66,     0,
       0,     0,     0,     0,   728,   729,     0,   730,   731,   732,
     733,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    64,     0,     0,    65,    66,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   573,
       0,     0,  -750,     0,   574,     0,  -750,     0,   575,  -750,
       0,     0,     0,  -750,  -750,  -750,     0,  -750,   576,  -750,
       0,   577,  -750,  -750,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   194,   578,  -750,  -750,  -750,
     197,  -750,  -750,  -750,  -750,   579,   203,     0,     0,   580,
       0,     0,   342,     0,   581,   582,     0,  -750,     0,  -750,
       0,     0,   583,     0,     0,   584,     0,   585,   586,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   587,
     588,     0,     0,     0,     0,     0,   589,  -750,  -750,  -750,
     351,     0,     0,   352,     0,  -750,     0,     0,   354,     0,
     355,   590,  -750,     0,   591,   592,     0,   593,     0,   594,
     361,     0,     0,   362,   363,     0,   364,   365,  -750,  -750,
     595,   596,     0,     0,     0,   597,   369,  -750,     0,     0,
       0,     0,   370,  -750,  -750,  -750,   598,   599,   600,     0,
     242,   601,  -750,  -750,  -750,     0,  -750,  -750,  -750,  -750,
       0,  1236,     0,     0,   567,     0,     0,     0,     0,   568,
       0,   602,     0,     0,  -750,  -750,  -750,     0,     0,  -750,
    -750,     0,     0,     0,     0,     0,  -750,     0,     0,     0,
    -750,     0,     0,     0,     0,  -750,  -750,     0,     0,     0,
       0,     0,     0,     0,  -750,   569,  -750,     0,     0,     0,
    -750,     0,     0,     0,   570,  -750,     0,  -750,     0,  -750,
    -887,   571,   572,  -750,  -750,     0,     0,     0,     0,     0,
       0,     0,     0,  -887,     0,     0,     0,     0,     0,     0,
       0,     0,  -887,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -887,     0,     0,     0,     0,     0,
       0,     0,  -887,   573,     0,     0,  -750,     0,   574,     0,
    -750,     0,   575,  -750,     0,     0,     0,  -750,  -750,  -750,
       0,  -750,   576,  -750,     0,   577,  -750,  -750,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   194,
     578,  -750,  -750,  -750,   197,  -750,  -750,  -750,  -750,   579,
     203,  -887,     0,   580,     0,     0,   342,     0,   581,   582,
       0,  -750,     0,  -750,     0,     0,   583,   973,     0,   584,
     974,   585,   586,     0,     0,     0,   975,     0,     0,     0,
       0,     0,     0,   587,   588,     0,     0,     0,     0,     0,
     589,  -750,  -750,  -750,   351,     0,     0,   352,     0,  -750,
       0,   976,   354,     0,   355,   590,  -750,     0,   591,   592,
    -887,   593,     0,   594,   361,     0,     0,   362,   363,     0,
     364,   365,  -750,  -750,   595,   596,     0,     0,     0,   597,
     369,  -750,     0,     0,     0,     0,   370,  -750,  -750,  -750,
     598,   599,   600,     0,   242,   601,  -750,  -750,  -750,     0,
    -750,  -750,  -750,  -750,     0,  1341,     0,     0,   567,  -887,
       0,     0,     0,   568,     0,   602,     0,     0,  -750,  -750,
    -750,     0,     0,  -750,  -750,     0,     0,     0,     0,     0,
    -750,     0,     0,     0,  -750,     0,     0,     0,     0,  -750,
    -750,     0,     0,     0,     0,     0,     0,     0,  -750,   569,
    -750,     0,     0,     0,  -750,     0,     0,     0,   570,  -750,
       0,  -750,     0,  -750,  -887,   571,   572,  -750,  -750,  -887,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   573,     0,     0,
    -750,     0,   574,     0,  -750,     0,   575,  -750,     0,     0,
       0,  -750,  -750,  -750,     0,  -750,   576,  -750,     0,   577,
    -750,  -750,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   194,   578,  -750,  -750,  -750,   197,  -750,
    -750,  -750,  -750,   579,   203,     0,     0,   580,     0,     0,
     342,     0,   581,   582,     0,  -750,     0,  -750,     0,     0,
     583,     0,     0,   584,     0,   585,   586,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   587,   588,     0,
       0,     0,     0,     0,   589,  -750,  -750,  -750,   351,     0,
       0,   352,     0,  -750,     0,     0,   354,     0,   355,   590,
    -750,     0,   591,   592,     0,   593,     0,   594,   361,     0,
       0,   362,   363,     0,   364,   365,  -750,  -750,   595,   596,
       0,     0,     0,   597,   369,  -750,     0,     0,     0,     0,
     370,  -750,  -750,  -750,   598,   599,   600,     0,   242,   601,
    -750,  -750,  -750,     0,  -750,  -750,  -750,  -750,    73,     0,
       0,   -60,     0,     0,     0,     0,   -60,     0,     0,   602,
       0,     0,  -750,  -750,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   -60,     0,     0,     0,
       0,     0,   -60,     0,     0,     0,     0,     0,     0,     0,
       0,   -60,     0,     0,     0,     0,     0,     0,   -60,   -60,
       0,     0,     0,     0,    74,     0,     0,    75,    76,    77,
       0,    78,     0,    79,    80,     0,    81,    82,    83,     0,
      84,    85,     0,    86,     0,    87,    88,    89,    90,    91,
       0,    92,     0,    93,     0,    94,    95,    96,     0,    97,
       0,    98,     0,    99,     0,   100,   101,   102,   103,   104,
       0,   105,   106,     0,   107,   108,     0,   109,     0,   110,
       0,   111,     0,   112,     0,   113,     0,   114,   115,   116,
       0,     0,     0,   325,     0,     0,     0,     0,     0,   -60,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   -60,
       0,     0,   -60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   -60,     0,     0,     0,
       0,   -60,     0,     0,     0,     0,   -60,     0,     0,     0,
       0,     0,     0,   -60,     0,   -60,   -60,     0,     0,     0,
       0,     0,     0,   117,     0,   326,   -60,     0,   -60,   -60,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
     -60,   -60,     0,     0,     0,     0,     0,   -60,     0,     0,
       0,   -60,     0,     0,   -60,     0,   -60,     0,     0,   -60,
       0,   -60,   -60,     0,     0,   -60,   -60,     0,   -60,     0,
     -60,   -60,     0,     0,   -60,   -60,     0,   -60,   -60,     0,
       0,   -60,   -60,   119,     0, -1110,   -60,   -60, -1110,     0,
       0,     0, -1110,   -60, -1110, -1110,     0,     0,     0, -1110,
   -1110, -1110,   -60, -1110, -1110, -1110,     0, -1110, -1110, -1110,
       0,     0,     0,     0,     0,     0,     0,  1289,     0,     0,
       0,     0,    64,     0,     0,    65,    66,     0,     0,     0,
       0, -1110,   925, -1110, -1110, -1110, -1110, -1110, -1110, -1110,
   -1110, -1110, -1110,     0,     0, -1110, -1110,     0, -1110,     0,
   -1110,     0,     0, -1110,     0, -1110,     0,     0,     0,     0,
       0, -1110,     0, -1110, -1110,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   926,     0,     0,     0,     0,
       0,     0, -1110, -1110, -1110, -1110,     0, -1110, -1110,     0,
   -1110, -1110,     0,     0,     0,     0,     0, -1110, -1110,     0,
   -1110,     0,     0, -1110,     0, -1110,     0, -1110,     0,     0,
       0,     0,     0, -1110, -1110,     0, -1110, -1110,     0,     0,
       0, -1110,     0,     0,     0,     0,     0,     0,     0, -1110,
   -1110, -1110, -1110, -1110, -1110, -1110, -1110, -1110,     0,     0,
       0, -1110,     0,     0,     0,     0,     0,     0,     0, -1110,
       0, -1110, -1110,     0,     0,     0, -1110,   927, -1110, -1110,
   -1110, -1110,     0, -1110, -1110, -1110,     0, -1110, -1110, -1110,
       0, -1110, -1110, -1110,     0,     0,     0,     0,     0,     0,
       0,  1439,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -1110,   925, -1110, -1110, -1110,
   -1110, -1110, -1110, -1110, -1110, -1110, -1110,     0,     0, -1110,
   -1110,     0, -1110,     0, -1110,     0,     0, -1110,     0, -1110,
       0,     0,     0,     0,     0, -1110,     0, -1110, -1110,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   926,
       0,     0,     0,     0,     0,     0, -1110, -1110, -1110, -1110,
       0, -1110, -1110,     0, -1110, -1110,     0,     0,     0,     0,
       0, -1110, -1110,     0, -1110,     0,     0, -1110,     0, -1110,
       0, -1110,     0,     0,     0,     0,     0, -1110, -1110,     0,
   -1110, -1110,     0,     0,     0, -1110,     0,     0,     0,     0,
       0,     0,     0, -1110, -1110, -1110, -1110, -1110, -1110, -1110,
   -1110, -1110,     0,     0,     0, -1110,     0,     0,     0,     0,
       0,     0,     0, -1110,     0, -1110, -1110,     0,     0,     0,
   -1110,   927, -1110, -1110, -1110, -1110,     0, -1110, -1110, -1110,
       0, -1110, -1110, -1110,     0, -1110, -1110, -1110,     0,     0,
       0,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1110,
     925, -1110, -1110, -1110, -1110, -1110, -1110, -1110, -1110, -1110,
   -1110,     0,     0, -1110, -1110,     0, -1110,     0, -1110,     0,
       0, -1110,     0, -1110,     0,     0,     0,     0,     0, -1110,
       0, -1110, -1110,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   926,     0,     0,     0,     0,     0,     0,
   -1110, -1110, -1110, -1110,     0, -1110, -1110,     0, -1110, -1110,
       0,     0,     0,     0,     0, -1110, -1110,     0, -1110,     0,
       0, -1110,     0, -1110,     0, -1110,     0,     0,     0,     0,
       0, -1110, -1110,     0, -1110, -1110,     0,     0,     0, -1110,
       0,     0,     0,     0,     0,     0,     0, -1110, -1110, -1110,
   -1110, -1110, -1110, -1110, -1110, -1110,     0,     0,     0, -1110,
       0,     0,     0,     0,     0,     0,     0,   181,     0, -1110,
     182,     0,     0,     0,   183,   927,   184,   185, -1110, -1110,
       0,   186,   187,   188,     0,   189,   190,    15,     0,   191,
      17,   192,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   763,     0,     0,     0,     0,
       0,     0,     0,   194,     0,    20,   195,   196,   197,   198,
     199,   200,   201,   481,   203,     0,     0,   205,   206,     0,
     207,     0,   208,     0,     0,   209,     0,    22,     0,     0,
       0,     0,     0,   210,     0,   211,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   482,   216,   217,   218,     0,   219,
     220,     0,   221,   222,     0,     0,     0,     0,     0,   224,
     225,     0,   226,     0,     0,   227,     0,   228,     0,   229,
       0,     0,     0,     0,     0,   230,   231,     0,   232,   233,
       0,     0,     0,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,     0,     0,   244,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   245,     0,     0,     0,   181,   703,    64,
     182,     0,    65,    66,   183,     0,   184,   185,     0,     0,
       0,   186,   187,   188,     0,   189,   190,    15,     0,   191,
      17,   192,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   194,     0,    20,   195,   196,   197,   198,
     199,   200,   201,   481,   203,     0,     0,   205,   206,     0,
     207,     0,   208,   567,     0,   209,     0,    22,   568,     0,
       0,     0,     0,   210,     0,   211,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   482,   216,   217,   218,     0,   219,
     220,     0,   221,   222,   569,     0,     0,     0,     0,   224,
     225,     0,   226,   570,     0,   227,     0,   228,     0,   229,
     571,   572,     0,     0,     0,   230,   231,     0,   232,   233,
       0,     0,  -736,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,     0,     0,   244,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   245,     0,     0,     0,     0,     0,     0,
       0,     0,    65,    66,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   573,     0,     0,     0,     0,   574,     0,     0,
       0,   575,     0,     0,   567,     0,     0,     0,     0,   568,
       0,   576,     0,     0,   577,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   194,   578,
       0,     0,     0,   197,     0,   569,     0,     0,   579,   203,
       0,     0,   580,     0,   570,   342,     0,   581,   582,     0,
       0,   571,   572,     0,     0,   583,     0,     0,   584,     0,
     585,   586,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   587,   588,     0,     0,     0,     0,     0,   589,
       0,     0,     0,   351,     0,     0,   352,     0,     0,     0,
       0,   354,     0,   355,   590,     0,     0,   591,   592,     0,
     593,     0,   594,   361,     0,     0,   362,   363,     0,   364,
     365,     0,     0,   595,   596,     0,     0,     0,   597,   369,
       0,     0,     0,   573,     0,   370,     0,     0,   574,   598,
     599,   600,   575,   242,   601,     0,  -837,     0,     0,     0,
       0,     0,   576,     0,     0,   577,     0,     0,     0,  -837,
       0,     0,     0,     0,   602,     0,     0,     0,  -837,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   194,
     578,     0,     0,     0,   197,     0,     0,     0,     0,   579,
     203,  1020,  1021,   580,     0,     0,   342,     0,   581,   582,
       0,     0,     0,     0,     0,     0,   583,  1022,     0,   584,
    -837,   585,   586,     0,     0,     0,     0,     0,  -837,     0,
       0,     0,     0,   587,   588,     0,     0,     0,     0,     0,
     589,     0,     0,     0,   351,     0,  1023,   352,     0,     0,
       0,     0,   354,     0,   355,   590,  1020,  1021,   591,   592,
       0,   593,     0,   594,   361,     0,     0,   362,   363,     0,
     364,   365,  1022,     0,   595,   596,     0,     0,     0,   597,
     369,     0,     0,     0,     0,     0,   370,  -837,     0,     0,
     598,   599,   600,     0,   242,   601,     0,     0,     0,     0,
       0,  1023,     0,   187,   188,     0,   189,     0,     0,     0,
       0,     0,   192,     0,     0,   602,     0,     0,  1024,     0,
       0,     0,  1025,     0,     0,  1026,     0,     0,     0,  1027,
       0,     0,     0,     0,     0,    15,     0,   195,    17,     0,
       0,     0,   200,   201,     0,     0,  -837,     0,     0,     0,
       0,     0,     0,     0,     0,   567,     0,     0,     0,     0,
     568,     0,     0,    20,     0,  1028,     0,  1029,  1030,     0,
       0,     0,     0,  1024,     0,     0,     0,  1025,     0,     0,
    1026,     0,     0,  1031,  1027,    22,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -837,   569,     0,     0,     0,
       0,     0,     0,     0,     0,   570,     0,     0,     0,     0,
       0,     0,     0,  1032,  1033,  1034,     0,     0,     0,     0,
    1028,  1035,  1029,  1030,     0,     0,     0,     0,  1036,     0,
       0,     0,     0,     0,   237,     0,     0,     0,  1031,     0,
       0,     0,     0,     0,  1037,  1038,     0,     0,     0,     0,
    -837,     0,     0,  1039,     0,  -837,     0,     0,     0,  1040,
    1041,     0,     0,     0,     0,     0,     0,     0,  1032,  1033,
    1034,     0,     0,     0,     0,   333,  1035,     0,     0,     0,
     334,     0,     0,  1036,   573,     0,     0,     0,     0,   574,
      65,    66,     0,   575,     0,     0,     0,     0,     0,  1037,
       0,     0,     0,   576,     0,     0,   577,     0,     0,     0,
     335,     0,     0,     0,  1040,  1041,   336,     0,     0,     0,
       0,     0,     0,     0,     0,   337,     0,     0,     0,     0,
     194,     0,     0,     0,     0,   197,     0,     0,     0,     0,
     579,   203,  1468,     0,   580,     0,     0,   342,     0,   581,
     582,     0,     0,     0,     0,     0,     0,   583,     0,     0,
     584,     0,   585,   586,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   587,   588,     0,     0,     0,     0,
       0,   589,     0,     0,     0,   351,     0,     0,   352,     0,
       0,     0,     0,   354,     0,   355,   590,     0,     0,   591,
     592,   333,   593,     0,   594,   361,   334,     0,   362,   363,
       0,   364,   365,   338,     0,   595,   596,     0,     0,     0,
     597,   369,     0,   339,     0,     0,   340,   370,     0,     0,
       0,   598,   599,   600,     0,   242,   601,     0,     0,     0,
       0,     0,   336,     0,     0,     0,     0,     0,     0,     0,
       0,   337,     0,     0,     0,     0,     0,     0,     0,     0,
     341,     0,     0,     0,     0,     0,     0,   342,     0,   343,
     344,     0,     0,     0,  1260,     0,     0,     0,     0,     0,
     345,     0,   346,   347,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   348,   349,     0,     0,     0,     0,
       0,   350,     0,     0,     0,   351,     0,     0,   352,     0,
     353,     0,     0,   354,     0,   355,   356,     0,     0,   357,
     358,     0,   359,     0,   360,   361,     0,     0,   362,   363,
       0,   364,   365,     0,     0,   366,   367,     0,     0,   338,
     368,   369,     0,     0,   794,     0,     0,   370,     0,   339,
       0,     0,   340,     0,   795,     0,   371,     0,   796,     0,
       0,     0,     0,     0,  -742,     0,     0,     0,     0,     0,
       0,     0,  -742,     0,  -742,     0,     0,     0,   797,     0,
       0,     0,     0,   798,     0,   799,   341,   800,     0,     0,
       0,   801,     0,   342,     0,   343,   344,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   345,     0,   346,   347,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     348,   349,     0,     0,     0,     0,     0,   350,     0,     0,
       0,   351,     0,     0,   352,     0,   353,     0,     0,   354,
       0,   355,   356,     0,     0,   357,   358,     0,   359,     0,
     360,   361,     0,     0,   362,   363,     0,   364,   365,     0,
       0,   366,   367,     0,     0,     0,   368,   369,     0,     0,
       0,     0,     0,   370,     0,     0,   187,   188,     0,   189,
       0,     0,   371,     0,     0,   192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     195,     0,     0,     0,     0,   200,   201,     0,   398,     0,
       0,   399,   400,   874,   875,   403,   404,   405,   406,     0,
     407,   408,   409,     0,   410,   411,     0,   412,     0,   413,
     414,   415,   416,   417,     0,   418,     0,   419,     0,   420,
     421,   422,     0,   423,     0,   424,     0,   425,     0,   426,
     427,   428,   429,     0,     0,   430,   431,     0,   432,   433,
       0,   434,     0,   435,     0,   436,     0,   437,     0,   438,
       0,   439,   440,   876,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   237,     0,     0,
     442,   877,   443,     0,   802,   728,   729,     0,   730,   731,
     732,   733,   878,   879,     0,     0,     0,     0,     0,   398,
       0,   444,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   409,     0,   410,   411,     0,   412,     0,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
     420,   421,   422,     0,   423,     0,   424,     0,   425,     0,
     426,   427,   428,   429,     0,     0,   430,   431,     0,   432,
     433,     0,   434,     0,   435,     0,   436,     0,   437,     0,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   442,     0,   443,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   444,     0,     0,   445,   446,   447,   448,   449,
       0,     0,     0,   450,     0,   451,   452,     0,   453,     0,
       0,     0,   454,   455,   456,   457,     0,     0,     0,   398,
       0,     0,   399,   400,   669,   402,   403,   404,   405,   406,
       0,   407,   408,   409,     0,   410,   411,     0,   412,     0,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
     420,   421,   422,     0,   423,     0,   424,     0,   425,     0,
     426,   427,   428,   429,     0,     0,   430,   431,     0,   432,
     433,     0,   434,     0,   435,     0,   436,     0,   437,     0,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   445,   446,   447,   448,
     449,   442,     0,   443,   450,     0,   451,   452,     0,   453,
       0,     0,     0,   454,   455,   456,   457,     0,     0,     0,
     398,     0,   444,   399,   400,   856,     0,   403,   404,   405,
     406,     0,   407,   408,   409,     0,   410,   411,     0,   412,
       0,   413,   414,   415,   416,   417,     0,   418,     0,   419,
       0,   420,   421,   422,     0,   423,     0,   424,     0,   425,
       0,   426,   427,   428,   429,     0,     0,   430,   431,     0,
     432,   433,     0,   434,     0,   435,     0,   436,     0,   437,
       0,   438,     0,   439,   440,   441,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   442,     0,   443,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   444,     0,     0,   445,   446,   447,   448,
     449,     0,     0,     0,   450,     0,   451,   452,     0,   453,
       0,     0,     0,   454,   455,   456,   457,     0,     0,     0,
     398,     0,     0,   399,   400,   661,     0,   403,   404,   405,
     406,     0,   407,   408,   409,     0,   410,   411,     0,   412,
       0,   413,   414,   415,   416,   417,     0,   418,     0,   419,
       0,   420,   421,   422,     0,   423,     0,   424,     0,   425,
       0,   426,   427,   428,   429,     0,     0,   430,   431,     0,
     432,   433,     0,   434,     0,   435,     0,   436,     0,   437,
       0,   438,     0,   439,   440,   862,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   445,   446,   447,
     448,   449,   442,     0,   443,   450,     0,   451,   452,     0,
     453,     0,     0,     0,   454,   455,   456,   457,     0,     0,
       0,   398,     0,   444,   399,   400,   661,     0,   403,   404,
     405,   406,     0,   407,   408,   409,     0,   410,   411,     0,
     412,     0,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,   420,   421,   422,     0,   423,     0,   424,     0,
     425,     0,   426,   427,   428,   429,     0,     0,   430,   431,
       0,   432,   433,     0,   434,     0,   435,     0,   436,     0,
     437,     0,   438,     0,   439,   440,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   442,     0,   443,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   444,     0,     0,   445,   446,   447,
     448,   449,     0,     0,     0,   450,     0,   451,   452,     0,
     453,     0,     0,     0,   454,   455,   456,   457,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     180,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   181,     0,     0,   182,     0,     0,     0,
     183,     0,   184,   185,     0,     0,     0,   186,   187,   188,
       0,   189,   190,    15,     0,   191,    17,   192,   445,   446,
     447,   448,   449,     0,     0,     0,   450,     0,   451,   452,
       0,   453,     0,     0,     0,   454,   455,   456,   457,   194,
       0,    20,   195,   196,   197,   198,   199,   200,   201,   481,
     203,     0,     0,   205,   206,     0,   207,     0,   208,     0,
       0,   209,     0,    22,     0,     0,     0,     0,     0,   210,
       0,   211,   212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     482,   216,   217,   218,     0,   219,   220,     0,   221,   222,
       0,     0,     0,     0,     0,   224,   225,     0,   226,     0,
       0,   227,     0,   228,     0,   229,     0,     0,     0,     0,
       0,   230,   231,     0,   232,   233,     0,     0,     0,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,     0,     0,   244,
       0,     0,     0,     0,     0,     0,     0,   181,     0,   245,
     182,     0,     0,     0,   183,     0,   184,   185,    65,    66,
       0,   186,   187,   188,     0,   189,   190,    15,     0,   191,
      17,   192,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   194,     0,    20,   195,   196,   197,   198,
     199,   200,   201,   481,   203,     0,     0,   205,   206,     0,
     207,     0,   208,     0,     0,   209,     0,    22,     0,     0,
       0,     0,     0,   210,     0,   211,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   482,   216,   217,   218,     0,   219,
     220,     0,   221,   222,     0,     0,     0,     0,     0,   224,
     225,     0,   226,     0,     0,   227,     0,   228,     0,   229,
       0,     0,     0,     0,     0,   230,   231,     0,   232,   233,
       0,     0,     0,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     182,     0,     0,   244,   183,     0,     0,   185,     0,     0,
       0,   186,   973,   245,     0,   974,     0,     0,     0,     0,
       0,   975,    65,    66,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   976,   196,     0,   198,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   181,
       0,     0,     0,     0,     0,   216,   217,   218,   184,   219,
     220,     0,     0,   222,   187,   188,     0,   189,   190,     0,
     225,   191,     0,   192,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   231,     0,     0,     0,
       0,     0,     0,     0,     0,   194,     0,     0,   195,     0,
     197,   235,   236,   200,   201,   481,   203,     0,     0,   205,
       0,     0,   207,     0,   208,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   210,     0,   211,   212,     0,
       0,     0,    65,    66,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   482,     0,     0,     0,
       0,     0,     0,     0,   221,     0,     0,     0,     0,     0,
       0,   224,     0,     0,   226,     0,     0,   227,     0,   228,
       0,     0,     0,     0,     0,     0,     0,   230,     0,     0,
     232,   233,     0,     0,     0,   234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   237,   238,   239,   240,   241,
     242,   243,     0,     0,     0,   244
};

static const yytype_int16 yycheck[] =
{
       4,     5,     6,    35,    12,     1,   178,     4,     5,     6,
     292,   246,    67,   120,   206,   180,   483,     1,   229,   180,
     331,   332,   526,   155,   312,   401,   218,   795,   909,   492,
     511,    35,    40,   947,   802,   959,    40,   126,    35,   179,
    1015,   981,   323,   524,     1,   323,   666,   772,   323,   184,
     507,   725,   933,  1107,   919,   936,     1,   848,     1,   924,
     252,     1,     1,     1,     1,     1,   525,   526,   527,   280,
      28,   968,     1,   970,     1,   749,   267,     1,     1,     1,
       1,   759,   963,     1,     1,     1,     1,   279,    43,   338,
       1,     1,     1,   374,     1,     1,    67,    55,   379,   737,
     381,   379,     1,   381,   379,    80,   381,   283,   284,     1,
       1,     1,     1,     1,    67,     1,    69,     1,   599,     1,
       1,    79,    80,     1,  1225,     1,    73,     1,     1,  1193,
      75,   864,     1,     1,    73,    80,    73,     1,   179,     1,
       1,     1,    22,   184,    79,    24,   153,     1,    79,    17,
      22,    73,    73,    56,     1,    31,   114,     1,     1,     1,
     392,   952,     1,     1,   306,  1307,    17,     1,     1,   971,
     178,   525,   526,   527,   228,   110,    65,     1,     1,   110,
     905,     1,   205,    72,   207,     1,     1,    56,    60,   525,
     526,   527,   205,    17,   207,    74,   203,    10,     1,   480,
    1002,    14,   480,   338,   300,   480,    19,   248,    47,    60,
     251,    47,    72,    75,   607,     1,    72,  1098,    60,  1100,
    1101,  1102,    77,   948,    27,    72,    42,    74,   775,   510,
      74,    80,   699,   180,    98,   775,  1337,    75,   705,  1179,
      73,   180,    75,   284,   179,    60,   534,   150,   536,   184,
      73,     1,   533,    73,   721,   722,   138,  1154,   138,   267,
     665,   525,   526,   527,   132,   223,   138,  1331,   727,   947,
     180,   159,   946,   661,   147,   563,   223,   138,  1175,   155,
     114,   150,   136,     1,   525,   526,   527,   310,   664,   284,
     666,    74,    17,   465,   132,   754,  1438,   310,   474,   132,
     676,   304,   305,    79,    80,   313,    31,   311,   312,   132,
     318,    67,   132,   794,   311,   312,   324,   955,   314,   323,
     324,   513,   514,   294,   206,   380,   575,   608,   243,   304,
     608,   496,   239,   505,   495,   259,   497,   275,   114,   213,
     531,   294,   223,  1267,   230,   272,   378,   305,   303,   306,
     522,   543,   524,   229,   546,  1088,   296,  1332,   305,   304,
     532,   297,  1259,   867,   307,  1340,   305,   310,   305,   541,
    1251,   852,   215,   836,   378,   379,   305,   381,   296,   308,
    1105,   378,   305,   305,   305,   308,   309,   305,   305,   305,
     308,   309,   308,   309,   305,   305,   305,   308,   309,   305,
     754,   712,   713,  1317,  1318,   295,   305,   295,   867,   872,
    1275,  1292,   300,   305,   305,   304,   294,   305,   754,  1316,
     304,   775,   304,   655,   210,   892,   819,  1481,   283,   888,
     155,  1199,  1223,  1224,   981,   153,   940,   155,   156,   225,
     575,   981,   298,  1173,  1174,   949,   950,   223,   304,   305,
     200,   307,    14,   688,   310,   304,   305,   465,   863,  1399,
       1,    67,     1,   181,   818,   946,     1,  1141,   856,  1089,
     858,   189,  1353,  1147,  1388,  1450,   480,   934,     1,   474,
      17,   940,     1,  1380,    72,   203,   945,     1,   864,     1,
     949,   950,    80,     1,    31,   213,    17,   505,     1,   507,
       1,   283,    16,    65,   229,     1,   882,   289,   967,  1449,
    1366,   229,     1,   867,   522,     1,   524,   525,   526,   527,
     524,    60,   714,    74,   532,  1381,     1,   692,  1409,   305,
     534,   867,   536,   541,  1458,   539,     1,   534,    73,   536,
      29,   822,   539,  1024,   822,   150,    67,   822,   150,   238,
      73,   691,    55,    49,   114,    74,    61,    62,   839,   563,
     725,   839,   651,    75,   725,   224,   563,    75,  1049,    67,
    1484,   852,    73,   854,   852,     1,   854,   852,  1252,   297,
      99,   189,   774,    74,   749,  1310,   940,    73,   749,  1319,
     249,   945,   180,     1,   283,   949,   950,   132,    73,   189,
     289,  1482,    67,   867,   940,  1068,    17,    83,    73,   945,
       1,     1,   153,   949,   950,   156,     1,     1,   155,    74,
     132,    79,    80,     1,   132,  1355,   867,   981,   216,   191,
      72,   967,   295,   825,     1,   946,    47,   300,  1406,  1317,
    1318,  1108,   247,     1,   132,   247,   132,    73,   283,  1379,
      17,   256,   110,  1157,   256,  1385,    67,   132,  1121,   894,
      18,    32,   203,    34,  1127,   289,    37,    75,    58,   274,
      67,    38,   274,  1140,   179,  1142,   940,   215,   240,   184,
     962,   945,    73,    74,   307,   949,   950,   310,    73,    73,
      83,     1,   229,    60,    53,    73,  1163,   305,  1157,   940,
     308,   309,    61,   967,   945,     1,   132,     3,   949,   950,
    1388,   179,  1088,  1089,   886,   305,   184,   305,   308,   309,
     308,   309,    72,   727,    74,  1006,   967,    67,  1006,    69,
    1408,  1006,   229,  1463,  1464,    44,  1461,    46,  1019,   305,
    1437,  1019,   308,   309,  1019,  1249,   754,   132,   132,  1474,
     754,  1313,  1314,  1315,   132,  1043,  1044,  1442,  1443,  1437,
     932,    72,    19,   153,    21,    75,   156,   775,   304,   305,
      80,   779,   780,   830,   831,  1056,   780,  1462,  1056,   911,
     229,   946,  1479,  1480,   294,   946,  1253,   959,   305,    72,
    1249,    74,  1073,  1297,    55,  1073,    57,    75,  1073,   189,
    1485,  1479,  1480,  1157,   296,   305,  1484,  1274,   308,   309,
     818,     4,     5,   203,  1125,   305,    67,    67,   822,  1300,
    1283,  1157,   818,   213,  1305,    72,   234,    72,    41,   237,
      73,   132,    79,    80,   818,   839,   244,  1148,  1297,  1150,
     229,  1152,   152,    75,    73,   108,   254,   305,   852,   257,
     308,   309,   260,   261,  1313,  1314,  1315,   148,   990,   867,
     151,   993,   270,   110,   132,   294,   157,    69,   276,   179,
     215,  1338,   296,   296,   184,   296,   296,    72,   886,    40,
     190,    75,   215,   193,   888,    73,    73,  1368,   108,   305,
    1357,   182,    72,  1157,    73,  1249,  1363,   305,    73,  1366,
    1363,    36,    80,    51,   304,    52,  1373,    73,   912,  1190,
      75,   915,  1190,  1249,    73,  1190,  1157,    23,    73,    72,
     132,    75,    73,    75,   932,  1160,   934,   295,    73,   305,
    1062,    80,   940,   180,   271,    47,    73,   945,    74,    73,
    1407,   949,   950,  1297,    72,   114,   155,    72,  1159,    73,
      73,   959,  1419,  1065,  1235,   904,   861,  1235,   142,  1270,
    1235,  1297,     1,   834,  1431,   672,   664,  1094,   882,   856,
     280,   281,   282,   981,   284,  1167,  1141,  1313,  1314,  1315,
    1141,   858,  1147,   655,   391,  1249,  1147,    40,   984,  1150,
     132,  1302,   984,   179,   304,   305,    40,   778,   184,  1106,
     984,   984,  1006,  1249,   190,   984,  1038,   193,  1249,  1476,
     300,   527,   945,   754,   754,  1019,  1136,   754,   178,    40,
    1075,   267,   271,   766,  1177,   981,   775,    20,  1309,  1161,
    1116,  1271,   692,  1297,  1038,  1365,     1,  1276,   946,  1043,
    1044,  1038,   294,   607,  1056,  1083,  1043,  1044,   854,  1313,
    1314,  1315,  1056,   608,     1,   788,  1297,   819,   305,  1448,
     567,   308,   309,  1374,  1375,  1346,  1377,  1378,  1346,  1073,
     547,  1346,  1313,  1314,  1315,  1334,   536,    40,   753,  1448,
       1,     1,   172,  1082,   959,    40,  1202,  1252,  1260,  1370,
    1247,  1252,   314,  1285,   280,   281,   282,   136,   284,   582,
    1104,   140,   316,  1295,   143,  1246,  1185,  1238,   147,   148,
      75,   815,   151,   523,  1395,    80,   374,  1395,   157,  1311,
    1395,    -1,   570,     0,     1,    -1,     3,    -1,     5,     6,
       7,     8,    -1,    10,    11,    12,    13,    -1,    -1,    -1,
      -1,    -1,    -1,   182,   183,    -1,   185,   186,    -1,  1157,
      -1,    72,    -1,    -1,    -1,    -1,    33,    -1,    79,    80,
      -1,    -1,   201,  1444,    -1,    -1,  1444,    -1,    -1,  1444,
      -1,    -1,  1454,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1190,   152,    -1,   110,
      -1,    72,   231,   232,   233,    -1,   235,   236,    79,    80,
     239,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,  1451,    -1,    -1,   184,
      -1,    -1,    -1,   262,    -1,   190,    -1,    -1,   193,   110,
      -1,  1235,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,
    1432,  1249,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,  1260,   173,   174,   175,   176,   177,    -1,   180,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1271,  1272,   308,
     309,    -1,    -1,    -1,    -1,   152,   153,    -1,   155,   156,
    1452,    -1,   159,    -1,    -1,    -1,    -1,   234,    -1,  1297,
     237,    -1,    -1,    -1,   215,   216,    -1,   244,    -1,   180,
      -1,    -1,   179,    -1,   181,    -1,    -1,   254,    -1,    -1,
     257,    -1,   189,   260,   261,   280,   281,   282,   283,   284,
      -1,    -1,    -1,   270,   289,    -1,   203,   204,    -1,   276,
      -1,   208,    -1,  1329,   215,   216,   213,    -1,    -1,   304,
     305,    -1,  1346,   220,   221,   222,    -1,    -1,    -1,    -1,
      -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,   305,    -1,
      -1,    -1,  1394,    -1,    -1,    -1,   287,   288,  1372,   290,
     291,   292,   293,    -1,    -1,    -1,     1,    -1,    -1,    -1,
     300,    -1,    -1,    -1,   305,    -1,    -1,   308,   309,    -1,
    1394,  1395,    -1,    -1,    -1,    -1,    -1,  1394,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   287,   288,    -1,   290,
     291,   292,   293,    -1,    -1,   179,    -1,    -1,   295,    -1,
     184,    -1,    -1,   300,   305,    -1,   190,   308,   309,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,    -1,
    1444,    -1,    67,    -1,  1452,    70,    71,    72,    73,    74,
      75,    76,    77,    -1,    79,    80,    81,    -1,    83,    84,
      -1,    86,    -1,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    -1,    98,    99,   100,    -1,   102,    -1,   104,
      -1,   106,    -1,   108,   109,   110,   111,    -1,    -1,   114,
     115,    -1,   117,   118,    -1,   120,    -1,   122,    -1,   124,
      -1,   126,    -1,   128,    -1,   130,   131,   132,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,   280,   281,   282,   283,
     284,    -1,    -1,    -1,    -1,   289,    34,    -1,    36,    37,
      38,    39,    -1,    41,   159,    43,   161,    45,    46,    47,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   180,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    70,    71,    72,    -1,    74,    -1,    76,    77,    -1,
      79,    80,    81,    -1,    83,    84,    -1,    86,    -1,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    -1,    98,
      99,   100,    -1,   102,    -1,   104,    -1,   106,    -1,   108,
     109,   110,   111,   112,    -1,   114,   115,    -1,   117,   118,
      -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,    -1,    -1,
      -1,   140,    -1,   142,   143,    -1,    -1,    -1,   147,   148,
     149,    -1,   151,   152,   153,    -1,   155,   156,   157,   294,
     295,   296,   297,   298,    -1,    -1,    -1,   302,    -1,   304,
     305,    -1,   307,    -1,    -1,    -1,   311,   312,   313,   314,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,    -1,    -1,   193,   194,    -1,   196,    -1,   198,
      -1,    -1,   201,    -1,   203,    -1,    -1,   206,    -1,    -1,
     209,    -1,   211,   212,    -1,   214,     1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,    -1,   235,   236,    -1,   238,
     239,    -1,    -1,    -1,    -1,    -1,   245,   246,    -1,   248,
      -1,    -1,   251,    -1,   253,    -1,   255,    -1,    -1,    -1,
      -1,    -1,   261,   262,    -1,   264,   265,   266,    -1,    -1,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    72,    -1,    74,
     289,    -1,    -1,    -1,    -1,    80,    -1,    -1,    83,    -1,
     299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,
      -1,   136,    -1,    -1,    -1,   140,    -1,   142,   143,    -1,
      -1,    -1,   147,   148,   149,    -1,   151,   152,   153,    -1,
     155,   156,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,    -1,   193,   194,
      -1,   196,    -1,   198,    -1,    -1,   201,    -1,   203,   204,
     205,   110,   207,   208,   209,    -1,   211,   212,    -1,    -1,
     215,   216,    -1,    -1,    -1,   220,   221,   222,    -1,    -1,
      -1,    -1,    -1,   228,   229,   230,   231,   232,   233,    -1,
     235,   236,    -1,   238,   239,   240,    -1,    -1,    -1,    -1,
     245,   246,    -1,   248,    -1,    -1,   251,    -1,   253,    -1,
     255,    -1,    -1,    -1,    -1,    -1,   261,   262,    -1,   264,
     265,    -1,    -1,    -1,   269,    -1,    -1,    -1,    -1,    -1,
      -1,   180,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,    -1,     1,   289,    -1,     4,    -1,    -1,    -1,
      -1,     9,    -1,    -1,   299,    -1,    -1,    -1,    16,    -1,
     305,    19,    20,   308,   309,   310,   215,   216,    26,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    -1,    35,    36,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,    45,    46,    -1,
      -1,    -1,    50,    -1,    -1,    -1,    54,    55,    -1,    57,
      -1,    59,    -1,    61,    62,    63,    64,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    15,    -1,    17,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,
      31,   290,   291,   292,   293,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    43,    -1,    -1,    -1,   305,    -1,    -1,   308,
     309,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      61,    -1,    -1,    -1,    -1,   133,    -1,    -1,   136,    -1,
     138,    -1,   140,    -1,   142,   143,    -1,    -1,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,    -1,   201,    -1,   203,    -1,   110,   206,    -1,
      -1,   209,    -1,   211,   212,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   155,   223,   224,    -1,    -1,    -1,
      -1,    -1,   230,   231,   232,   233,   234,    -1,    -1,   237,
      -1,   239,    -1,    -1,   242,    -1,   244,   245,   246,    -1,
     248,   249,    -1,   251,    -1,   253,   254,    -1,    -1,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,    -1,    -1,
      -1,   269,   270,   271,    -1,    -1,    -1,   180,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,    -1,     1,   229,    -1,
       4,    -1,    -1,    -1,    -1,     9,   304,   305,    -1,    -1,
     308,   309,    16,   216,    -1,    19,    20,    -1,    -1,    -1,
      -1,    -1,    26,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      -1,    35,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,    45,    46,    -1,    -1,    -1,    50,    -1,    -1,    -1,
      54,    55,    -1,    57,    -1,    59,    -1,    61,    62,    63,
      64,    -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,   300,
      -1,    -1,   303,    -1,   305,    -1,    -1,   308,   309,    -1,
      -1,    -1,    -1,    -1,   287,   288,    -1,   290,   291,   292,
     293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   305,    -1,    -1,   308,   309,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,
      -1,    -1,   136,    -1,   138,    -1,   140,    -1,   142,   143,
      -1,    -1,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,    -1,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,    -1,   201,    -1,   203,
      -1,    -1,   206,    -1,    -1,   209,    -1,   211,   212,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,
     224,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
     234,    -1,    -1,   237,    -1,   239,    -1,    -1,   242,    -1,
     244,   245,   246,    -1,   248,   249,    -1,   251,    -1,   253,
     254,    -1,    -1,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,    -1,    -1,    -1,   269,   270,   271,    -1,    -1,
      -1,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
      -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,     9,
      -1,   305,    -1,    -1,   308,   309,    16,    -1,    -1,    19,
      20,    -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    -1,    35,    36,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    45,    46,    -1,    -1,    -1,
      50,    -1,    -1,    -1,    54,    55,    -1,    57,    -1,    59,
       1,    61,    62,    63,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    73,   133,    -1,    -1,   136,    -1,   138,    -1,
     140,    -1,   142,   143,    -1,    -1,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   132,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
      -1,   201,    -1,   203,    -1,    -1,   206,   148,    -1,   209,
     151,   211,   212,    -1,    -1,    -1,   157,    -1,    -1,    -1,
      -1,    -1,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,   234,    -1,    -1,   237,    -1,   239,
      -1,   182,   242,    -1,   244,   245,   246,    -1,   248,   249,
     191,   251,    -1,   253,   254,    -1,    -1,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,    -1,    -1,    -1,   269,
     270,   271,    -1,    -1,    -1,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,    -1,     1,    -1,    -1,     4,   240,
      -1,    -1,    -1,     9,    -1,   305,    -1,    -1,   308,   309,
      16,    -1,    -1,    19,    20,    -1,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    35,
      36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    45,
      46,    -1,    -1,    -1,    50,    -1,    -1,    -1,    54,    55,
      -1,    57,    -1,    59,   295,    61,    62,    63,    64,   300,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,    -1,
     136,    -1,   138,    -1,   140,    -1,   142,   143,    -1,    -1,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,    -1,   201,    -1,   203,    -1,    -1,
     206,    -1,    -1,   209,    -1,   211,   212,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,   224,    -1,
      -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,   239,    -1,    -1,   242,    -1,   244,   245,
     246,    -1,   248,   249,    -1,   251,    -1,   253,   254,    -1,
      -1,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
      -1,    -1,    -1,   269,   270,   271,    -1,    -1,    -1,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,     1,    -1,
      -1,     4,    -1,    -1,    -1,    -1,     9,    -1,    -1,   305,
      -1,    -1,   308,   309,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    61,    62,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    70,    71,    72,
      -1,    74,    -1,    76,    77,    -1,    79,    80,    81,    -1,
      83,    84,    -1,    86,    -1,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    -1,    98,    99,   100,    -1,   102,
      -1,   104,    -1,   106,    -1,   108,   109,   110,   111,   112,
      -1,   114,   115,    -1,   117,   118,    -1,   120,    -1,   122,
      -1,   124,    -1,   126,    -1,   128,    -1,   130,   131,   132,
      -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,   142,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,
      -1,    -1,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,    -1,
      -1,   184,    -1,    -1,    -1,    -1,   189,    -1,    -1,    -1,
      -1,    -1,    -1,   196,    -1,   198,   199,    -1,    -1,    -1,
      -1,    -1,    -1,   206,    -1,    73,   209,    -1,   211,   212,
      -1,   214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     223,   224,    -1,    -1,    -1,    -1,    -1,   230,    -1,    -1,
      -1,   234,    -1,    -1,   237,    -1,   239,    -1,    -1,   242,
      -1,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
     253,   254,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,   264,   265,   266,    -1,   133,   269,   270,   136,    -1,
      -1,    -1,   140,   276,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   285,   151,   152,   153,    -1,   155,   156,   157,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      -1,    -1,   305,    -1,    -1,   308,   309,    -1,    -1,    -1,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,    -1,    -1,   193,   194,    -1,   196,    -1,
     198,    -1,    -1,   201,    -1,   203,    -1,    -1,    -1,    -1,
      -1,   209,    -1,   211,   212,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   223,    -1,    -1,    -1,    -1,
      -1,    -1,   230,   231,   232,   233,    -1,   235,   236,    -1,
     238,   239,    -1,    -1,    -1,    -1,    -1,   245,   246,    -1,
     248,    -1,    -1,   251,    -1,   253,    -1,   255,    -1,    -1,
      -1,    -1,    -1,   261,   262,    -1,   264,   265,    -1,    -1,
      -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,    -1,    -1,
      -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,
      -1,   299,   136,    -1,    -1,    -1,   140,   305,   142,   143,
     308,   309,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,    -1,    -1,   193,
     194,    -1,   196,    -1,   198,    -1,    -1,   201,    -1,   203,
      -1,    -1,    -1,    -1,    -1,   209,    -1,   211,   212,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,
      -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
      -1,   235,   236,    -1,   238,   239,    -1,    -1,    -1,    -1,
      -1,   245,   246,    -1,   248,    -1,    -1,   251,    -1,   253,
      -1,   255,    -1,    -1,    -1,    -1,    -1,   261,   262,    -1,
     264,   265,    -1,    -1,    -1,   269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,    -1,    -1,    -1,   289,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,    -1,   299,   136,    -1,    -1,    -1,
     140,   305,   142,   143,   308,   309,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,   193,   194,    -1,   196,    -1,   198,    -1,
      -1,   201,    -1,   203,    -1,    -1,    -1,    -1,    -1,   209,
      -1,   211,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   223,    -1,    -1,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,    -1,   235,   236,    -1,   238,   239,
      -1,    -1,    -1,    -1,    -1,   245,   246,    -1,   248,    -1,
      -1,   251,    -1,   253,    -1,   255,    -1,    -1,    -1,    -1,
      -1,   261,   262,    -1,   264,   265,    -1,    -1,    -1,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,    -1,    -1,    -1,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,   299,
     136,    -1,    -1,    -1,   140,   305,   142,   143,   308,   309,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,   193,   194,    -1,
     196,    -1,   198,    -1,    -1,   201,    -1,   203,    -1,    -1,
      -1,    -1,    -1,   209,    -1,   211,   212,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   230,   231,   232,   233,    -1,   235,
     236,    -1,   238,   239,    -1,    -1,    -1,    -1,    -1,   245,
     246,    -1,   248,    -1,    -1,   251,    -1,   253,    -1,   255,
      -1,    -1,    -1,    -1,    -1,   261,   262,    -1,   264,   265,
      -1,    -1,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,    -1,    -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   299,    -1,    -1,    -1,   133,   304,   305,
     136,    -1,   308,   309,   140,    -1,   142,   143,    -1,    -1,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,   193,   194,    -1,
     196,    -1,   198,     4,    -1,   201,    -1,   203,     9,    -1,
      -1,    -1,    -1,   209,    -1,   211,   212,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   230,   231,   232,   233,    -1,   235,
     236,    -1,   238,   239,    45,    -1,    -1,    -1,    -1,   245,
     246,    -1,   248,    54,    -1,   251,    -1,   253,    -1,   255,
      61,    62,    -1,    -1,    -1,   261,   262,    -1,   264,   265,
      -1,    -1,    73,   269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,    -1,    -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,   309,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   133,    -1,    -1,    -1,    -1,   138,    -1,    -1,
      -1,   142,    -1,    -1,     4,    -1,    -1,    -1,    -1,     9,
      -1,   152,    -1,    -1,   155,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,   180,
      -1,    -1,    -1,   184,    -1,    45,    -1,    -1,   189,   190,
      -1,    -1,   193,    -1,    54,   196,    -1,   198,   199,    -1,
      -1,    61,    62,    -1,    -1,   206,    -1,    -1,   209,    -1,
     211,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,   230,
      -1,    -1,    -1,   234,    -1,    -1,   237,    -1,    -1,    -1,
      -1,   242,    -1,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,   253,   254,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,   264,   265,    -1,    -1,    -1,   269,   270,
      -1,    -1,    -1,   133,    -1,   276,    -1,    -1,   138,   280,
     281,   282,   142,   284,   285,    -1,     1,    -1,    -1,    -1,
      -1,    -1,   152,    -1,    -1,   155,    -1,    -1,    -1,    14,
      -1,    -1,    -1,    -1,   305,    -1,    -1,    -1,    23,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
     180,    -1,    -1,    -1,   184,    -1,    -1,    -1,    -1,   189,
     190,    19,    20,   193,    -1,    -1,   196,    -1,   198,   199,
      -1,    -1,    -1,    -1,    -1,    -1,   206,    35,    -1,   209,
      65,   211,   212,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,
     230,    -1,    -1,    -1,   234,    -1,    64,   237,    -1,    -1,
      -1,    -1,   242,    -1,   244,   245,    19,    20,   248,   249,
      -1,   251,    -1,   253,   254,    -1,    -1,   257,   258,    -1,
     260,   261,    35,    -1,   264,   265,    -1,    -1,    -1,   269,
     270,    -1,    -1,    -1,    -1,    -1,   276,   132,    -1,    -1,
     280,   281,   282,    -1,   284,   285,    -1,    -1,    -1,    -1,
      -1,    64,    -1,   148,   149,    -1,   151,    -1,    -1,    -1,
      -1,    -1,   157,    -1,    -1,   305,    -1,    -1,   136,    -1,
      -1,    -1,   140,    -1,    -1,   143,    -1,    -1,    -1,   147,
      -1,    -1,    -1,    -1,    -1,   153,    -1,   182,   156,    -1,
      -1,    -1,   187,   188,    -1,    -1,   191,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
       9,    -1,    -1,   181,    -1,   183,    -1,   185,   186,    -1,
      -1,    -1,    -1,   136,    -1,    -1,    -1,   140,    -1,    -1,
     143,    -1,    -1,   201,   147,   203,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   240,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   231,   232,   233,    -1,    -1,    -1,    -1,
     183,   239,   185,   186,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,    -1,   279,    -1,    -1,    -1,   201,    -1,
      -1,    -1,    -1,    -1,   262,   263,    -1,    -1,    -1,    -1,
     295,    -1,    -1,   271,    -1,   300,    -1,    -1,    -1,   277,
     278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   231,   232,
     233,    -1,    -1,    -1,    -1,     4,   239,    -1,    -1,    -1,
       9,    -1,    -1,   246,   133,    -1,    -1,    -1,    -1,   138,
     308,   309,    -1,   142,    -1,    -1,    -1,    -1,    -1,   262,
      -1,    -1,    -1,   152,    -1,    -1,   155,    -1,    -1,    -1,
      39,    -1,    -1,    -1,   277,   278,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,
     179,    -1,    -1,    -1,    -1,   184,    -1,    -1,    -1,    -1,
     189,   190,   305,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,
     209,    -1,   211,   212,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   223,   224,    -1,    -1,    -1,    -1,
      -1,   230,    -1,    -1,    -1,   234,    -1,    -1,   237,    -1,
      -1,    -1,    -1,   242,    -1,   244,   245,    -1,    -1,   248,
     249,     4,   251,    -1,   253,   254,     9,    -1,   257,   258,
      -1,   260,   261,   142,    -1,   264,   265,    -1,    -1,    -1,
     269,   270,    -1,   152,    -1,    -1,   155,   276,    -1,    -1,
      -1,   280,   281,   282,    -1,   284,   285,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     189,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,   198,
     199,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,
     209,    -1,   211,   212,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   223,   224,    -1,    -1,    -1,    -1,
      -1,   230,    -1,    -1,    -1,   234,    -1,    -1,   237,    -1,
     239,    -1,    -1,   242,    -1,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,   253,   254,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,   264,   265,    -1,    -1,   142,
     269,   270,    -1,    -1,    16,    -1,    -1,   276,    -1,   152,
      -1,    -1,   155,    -1,    26,    -1,   285,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    44,    -1,    46,    -1,    -1,    -1,    50,    -1,
      -1,    -1,    -1,    55,    -1,    57,   189,    59,    -1,    -1,
      -1,    63,    -1,   196,    -1,   198,   199,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,   211,   212,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     223,   224,    -1,    -1,    -1,    -1,    -1,   230,    -1,    -1,
      -1,   234,    -1,    -1,   237,    -1,   239,    -1,    -1,   242,
      -1,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
     253,   254,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,   264,   265,    -1,    -1,    -1,   269,   270,    -1,    -1,
      -1,    -1,    -1,   276,    -1,    -1,   148,   149,    -1,   151,
      -1,    -1,   285,    -1,    -1,   157,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     182,    -1,    -1,    -1,    -1,   187,   188,    -1,    67,    -1,
      -1,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
      79,    80,    81,    -1,    83,    84,    -1,    86,    -1,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    -1,    98,
      99,   100,    -1,   102,    -1,   104,    -1,   106,    -1,   108,
     109,   110,   111,    -1,    -1,   114,   115,    -1,   117,   118,
      -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,
      -1,   130,   131,   132,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,    -1,    -1,
     159,   160,   161,    -1,   286,   287,   288,    -1,   290,   291,
     292,   293,   171,   172,    -1,    -1,    -1,    -1,    -1,    67,
      -1,   180,    70,    71,    72,    73,    74,    75,    76,    77,
      -1,    79,    80,    81,    -1,    83,    84,    -1,    86,    -1,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    -1,
      98,    99,   100,    -1,   102,    -1,   104,    -1,   106,    -1,
     108,   109,   110,   111,    -1,    -1,   114,   115,    -1,   117,
     118,    -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,
     128,    -1,   130,   131,   132,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   159,    -1,   161,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   180,    -1,    -1,   294,   295,   296,   297,   298,
      -1,    -1,    -1,   302,    -1,   304,   305,    -1,   307,    -1,
      -1,    -1,   311,   312,   313,   314,    -1,    -1,    -1,    67,
      -1,    -1,    70,    71,    72,    73,    74,    75,    76,    77,
      -1,    79,    80,    81,    -1,    83,    84,    -1,    86,    -1,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    -1,
      98,    99,   100,    -1,   102,    -1,   104,    -1,   106,    -1,
     108,   109,   110,   111,    -1,    -1,   114,   115,    -1,   117,
     118,    -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,
     128,    -1,   130,   131,   132,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   294,   295,   296,   297,
     298,   159,    -1,   161,   302,    -1,   304,   305,    -1,   307,
      -1,    -1,    -1,   311,   312,   313,   314,    -1,    -1,    -1,
      67,    -1,   180,    70,    71,    72,    -1,    74,    75,    76,
      77,    -1,    79,    80,    81,    -1,    83,    84,    -1,    86,
      -1,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      -1,    98,    99,   100,    -1,   102,    -1,   104,    -1,   106,
      -1,   108,   109,   110,   111,    -1,    -1,   114,   115,    -1,
     117,   118,    -1,   120,    -1,   122,    -1,   124,    -1,   126,
      -1,   128,    -1,   130,   131,   132,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   159,    -1,   161,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   180,    -1,    -1,   294,   295,   296,   297,
     298,    -1,    -1,    -1,   302,    -1,   304,   305,    -1,   307,
      -1,    -1,    -1,   311,   312,   313,   314,    -1,    -1,    -1,
      67,    -1,    -1,    70,    71,    72,    -1,    74,    75,    76,
      77,    -1,    79,    80,    81,    -1,    83,    84,    -1,    86,
      -1,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      -1,    98,    99,   100,    -1,   102,    -1,   104,    -1,   106,
      -1,   108,   109,   110,   111,    -1,    -1,   114,   115,    -1,
     117,   118,    -1,   120,    -1,   122,    -1,   124,    -1,   126,
      -1,   128,    -1,   130,   131,   132,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   294,   295,   296,
     297,   298,   159,    -1,   161,   302,    -1,   304,   305,    -1,
     307,    -1,    -1,    -1,   311,   312,   313,   314,    -1,    -1,
      -1,    67,    -1,   180,    70,    71,    72,    -1,    74,    75,
      76,    77,    -1,    79,    80,    81,    -1,    83,    84,    -1,
      86,    -1,    88,    89,    90,    91,    92,    -1,    94,    -1,
      96,    -1,    98,    99,   100,    -1,   102,    -1,   104,    -1,
     106,    -1,   108,   109,   110,   111,    -1,    -1,   114,   115,
      -1,   117,   118,    -1,   120,    -1,   122,    -1,   124,    -1,
     126,    -1,   128,    -1,   130,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   159,    -1,   161,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   180,    -1,    -1,   294,   295,   296,
     297,   298,    -1,    -1,    -1,   302,    -1,   304,   305,    -1,
     307,    -1,    -1,    -1,   311,   312,   313,   314,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,    -1,    -1,   136,    -1,    -1,    -1,
     140,    -1,   142,   143,    -1,    -1,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   294,   295,
     296,   297,   298,    -1,    -1,    -1,   302,    -1,   304,   305,
      -1,   307,    -1,    -1,    -1,   311,   312,   313,   314,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,   193,   194,    -1,   196,    -1,   198,    -1,
      -1,   201,    -1,   203,    -1,    -1,    -1,    -1,    -1,   209,
      -1,   211,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,    -1,   235,   236,    -1,   238,   239,
      -1,    -1,    -1,    -1,    -1,   245,   246,    -1,   248,    -1,
      -1,   251,    -1,   253,    -1,   255,    -1,    -1,    -1,    -1,
      -1,   261,   262,    -1,   264,   265,    -1,    -1,    -1,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,    -1,    -1,    -1,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,   299,
     136,    -1,    -1,    -1,   140,    -1,   142,   143,   308,   309,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,   193,   194,    -1,
     196,    -1,   198,    -1,    -1,   201,    -1,   203,    -1,    -1,
      -1,    -1,    -1,   209,    -1,   211,   212,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   230,   231,   232,   233,    -1,   235,
     236,    -1,   238,   239,    -1,    -1,    -1,    -1,    -1,   245,
     246,    -1,   248,    -1,    -1,   251,    -1,   253,    -1,   255,
      -1,    -1,    -1,    -1,    -1,   261,   262,    -1,   264,   265,
      -1,    -1,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     136,    -1,    -1,   289,   140,    -1,    -1,   143,    -1,    -1,
      -1,   147,   148,   299,    -1,   151,    -1,    -1,    -1,    -1,
      -1,   157,   308,   309,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   182,   183,    -1,   185,
     186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,
      -1,    -1,    -1,    -1,    -1,   231,   232,   233,   142,   235,
     236,    -1,    -1,   239,   148,   149,    -1,   151,   152,    -1,
     246,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,    -1,
     184,   277,   278,   187,   188,   189,   190,    -1,    -1,   193,
      -1,    -1,   196,    -1,   198,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,   211,   212,    -1,
      -1,    -1,   308,   309,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   230,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,   245,    -1,    -1,   248,    -1,    -1,   251,    -1,   253,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   261,    -1,    -1,
     264,   265,    -1,    -1,    -1,   269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   279,   280,   281,   282,   283,
     284,   285,    -1,    -1,    -1,   289
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   316,     0,     1,     3,     5,     6,     7,     8,    10,
      11,    12,    13,    33,   152,   153,   155,   156,   159,   179,
     181,   189,   203,   204,   208,   213,   220,   221,   222,   229,
     295,   300,   314,   317,   318,   319,   320,   335,   336,   355,
     357,   358,   361,   371,   372,   373,   377,   383,   384,   385,
     390,   398,   399,   402,   404,   420,   423,   430,   431,   537,
     545,   546,   698,   718,   305,   308,   309,   641,   644,   650,
     655,   658,   661,     1,    67,    70,    71,    72,    74,    76,
      77,    79,    80,    81,    83,    84,    86,    88,    89,    90,
      91,    92,    94,    96,    98,    99,   100,   102,   104,   106,
     108,   109,   110,   111,   112,   114,   115,   117,   118,   120,
     122,   124,   126,   128,   130,   131,   132,   206,   214,   266,
     332,   655,   660,   677,     1,   655,   657,     1,     3,   671,
     671,   306,   374,   375,     1,    15,    53,    61,   305,   381,
     644,     1,   305,   671,   228,   726,     1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   173,   174,   175,   176,
     177,   362,   370,   671,   544,   545,     1,   213,   697,   432,
     359,   718,   657,   718,   718,   718,   718,     1,    72,    74,
      80,   133,   136,   140,   142,   143,   147,   148,   149,   151,
     152,   155,   157,   178,   179,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   193,   194,   196,   198,   201,
     209,   211,   212,   216,   228,   230,   231,   232,   233,   235,
     236,   238,   239,   240,   245,   246,   248,   251,   253,   255,
     261,   262,   264,   265,   269,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   289,   299,   305,   386,   388,   390,
     391,   394,   396,   397,   414,   420,   421,   429,   446,   448,
     449,   451,   478,   479,   481,   489,   516,   518,   519,   520,
     521,   522,   523,   525,   526,   527,   528,   529,   531,   533,
     534,   535,   536,   537,   546,   549,   550,   552,   554,   555,
     557,   565,   567,   568,   577,   578,   644,   649,   650,   684,
     685,   689,   733,   718,   300,   718,   718,   718,   718,   718,
     718,   403,   400,   405,    47,   700,   701,   702,    67,     1,
      17,    38,    60,   665,    67,     1,    73,   713,     1,    75,
     708,    74,    74,     4,     9,    39,    45,    54,   142,   152,
     155,   189,   196,   198,   199,   209,   211,   212,   223,   224,
     230,   234,   237,   239,   242,   244,   245,   248,   249,   251,
     253,   254,   257,   258,   260,   261,   264,   265,   269,   270,
     276,   285,   333,   334,   551,   605,     1,    17,   132,   664,
     321,   664,   114,   376,   375,    53,    61,   382,    43,   303,
     686,   687,    17,    31,   155,   229,   378,   380,    67,    70,
      71,    72,    73,    74,    75,    76,    77,    79,    80,    81,
      83,    84,    86,    88,    89,    90,    91,    92,    94,    96,
      98,    99,   100,   102,   104,   106,   108,   109,   110,   111,
     114,   115,   117,   118,   120,   122,   124,   126,   128,   130,
     131,   132,   159,   161,   180,   294,   295,   296,   297,   298,
     302,   304,   305,   307,   311,   312,   313,   314,   337,   338,
     347,   348,   349,   350,   354,   424,     1,   305,   646,   646,
       1,   305,   308,   639,   640,     1,   159,   305,   360,   647,
     665,   189,   230,   478,   516,   684,    79,    80,   114,   223,
     305,   415,   416,   417,   547,   548,   549,   565,   307,   310,
     608,   720,     1,    72,   694,   694,    67,   356,   694,    74,
     551,    74,   553,   569,   579,     1,   239,   667,    72,   470,
       1,    98,   695,   392,   694,   132,   480,   422,   519,   521,
     517,   518,   694,   551,   556,   557,   556,   568,   578,    67,
     530,   215,   431,   205,   207,   310,   681,    83,     1,   641,
     642,   642,     1,   305,   407,   408,   409,   644,     1,    58,
     546,   698,   714,   715,   700,   305,   644,     4,     9,    45,
      54,    61,    62,   133,   138,   142,   152,   155,   180,   189,
     193,   198,   199,   206,   209,   211,   212,   223,   224,   230,
     245,   248,   249,   251,   253,   264,   265,   269,   280,   281,
     282,   285,   305,   550,   552,   582,   601,   602,   603,   604,
     605,   606,   610,   617,   618,   650,   656,   731,   644,   650,
     708,   708,    32,    34,    37,   607,   150,   247,   256,   274,
      24,    74,   325,     1,   230,   732,   608,     1,   200,   693,
       1,   243,   680,     1,   259,   730,   550,   731,   657,   322,
     582,   702,   582,     1,   306,    17,   380,     1,   378,   379,
       1,    72,   132,   342,   343,   344,   345,   346,   347,    72,
     338,   339,   340,   341,   516,    72,   363,   556,     1,   305,
     305,   582,   713,   387,   305,     1,   223,   722,    75,     1,
     132,   675,   549,   564,   565,   549,   296,     1,   720,   721,
     516,   421,     1,   304,   727,   728,   558,    79,   110,   709,
       1,    75,    80,   727,   694,   694,   452,   516,   726,     1,
     516,   650,   727,    72,    79,    80,   110,   180,   287,   288,
     290,   291,   292,   293,   435,   436,   438,   440,   441,   442,
     444,   450,   472,   474,   475,   477,   482,   484,   485,   487,
     488,   489,   491,   529,   592,   641,   644,   649,   650,   651,
     438,   434,   435,     1,   516,   641,   642,   643,   642,   643,
     641,   516,   694,   694,   640,   294,   538,   401,   406,    67,
      67,   642,   607,   247,   732,     1,    29,   679,   608,   693,
      80,   611,   727,   702,    16,    26,    30,    50,    55,    57,
      59,    63,   286,   520,   583,   586,   587,   588,   590,   591,
     592,   598,   612,   613,   614,   615,   616,   619,   620,   621,
     622,   604,    17,     1,    42,   692,     1,   275,   662,     1,
      72,    74,   326,    28,    55,   327,   328,   329,   417,    72,
     593,   594,    41,   609,     1,    27,   676,    14,    65,   191,
     240,   323,   324,   331,   664,   379,    72,   351,   352,   353,
     354,    73,   132,   344,   343,   346,   341,   425,     1,   180,
     305,   364,   365,   366,    72,    73,   132,   160,   171,   172,
     347,   367,   368,   369,     1,   114,   683,    72,   180,   477,
     484,   487,   492,   493,   494,   495,   496,   497,   499,   500,
     502,   504,   506,   651,   469,   470,   417,   564,   713,   524,
     713,   229,   559,     1,    74,   691,    75,   708,   708,   694,
       1,   305,   572,   580,   581,   180,   223,   305,   464,   465,
     466,   645,   723,   389,   393,    73,   395,   713,   713,   108,
     473,   547,     1,   650,   651,   132,    74,   443,   470,   476,
     483,   547,   294,   652,   439,   440,   450,   475,    69,   215,
     652,   566,   567,   532,   538,   296,   296,   490,   464,     1,
     447,   694,     1,   148,   151,   157,   182,   525,   529,   531,
     539,   541,   542,   543,   296,   411,   412,     1,   410,   412,
     189,   305,   644,   189,   644,   650,   609,    80,   305,   584,
     727,   593,    72,   589,     1,    60,   724,     1,    55,   710,
       1,    18,   668,    40,   585,   593,    44,    46,   696,   724,
      19,    20,    35,    64,   136,   140,   143,   147,   183,   185,
     186,   201,   231,   232,   233,   239,   246,   262,   263,   271,
     277,   278,   529,   537,   546,   623,   624,   625,   626,   627,
     628,   629,   632,   633,   622,   582,   694,   327,   327,    22,
     138,   330,    60,   330,    75,   675,   582,   595,   596,    56,
     150,   599,   600,   711,   215,   704,    17,    60,   666,   728,
       1,   582,   727,   602,   351,    73,   353,   339,   343,   345,
     426,   427,   438,    73,   675,   369,   516,   108,   501,   651,
     503,   505,   507,   443,   713,   470,   332,   464,   492,   646,
       1,   234,   237,   244,   254,   257,   260,   261,   270,   276,
     560,   561,   562,   650,   650,   659,   570,   571,   572,    72,
     573,    73,   572,    73,   453,   471,   675,   516,   492,   421,
     492,   445,   438,     1,   436,   437,     1,   152,   305,   547,
     548,   708,   727,   566,   464,   438,   438,   486,   728,    80,
     677,   682,   721,   492,   477,   484,   487,   508,   509,   510,
     512,   514,   651,   453,   453,   447,   542,   543,   540,   541,
       1,   297,   398,   413,   423,   430,   646,   646,     1,    47,
     699,   447,     1,    44,   582,     1,    16,   663,   599,    36,
     582,    51,   631,     1,   147,   690,     1,    49,   705,     1,
     136,   672,   727,   729,    52,   706,   657,     1,   272,   630,
     642,   642,     1,    65,    72,   727,   595,    73,    75,     1,
     138,   678,   646,   329,    73,   675,     1,   582,   702,    19,
      21,   669,    23,   670,   670,    55,    57,   598,    73,   132,
     366,   433,   498,   492,   492,   492,   492,   650,   654,   464,
      77,   418,   471,   713,     1,   294,   674,    72,   563,   563,
      75,   675,   132,   708,    73,   675,    72,   298,   304,   305,
     307,   310,   574,   575,   576,   224,   249,   457,   454,     1,
     466,   468,   467,     1,    99,   688,   713,   547,   713,    75,
     547,   708,    80,   152,   708,   719,   708,   453,   438,   551,
     470,   646,   713,   511,   513,   515,   694,   457,   457,   453,
     540,   295,   717,     1,   295,   716,   716,   582,    73,   699,
     305,   648,   593,   690,   271,    47,   634,   728,   728,   669,
      73,     1,   582,   597,     1,   711,   712,   710,   696,     1,
     427,   428,   492,   547,   713,   453,   516,   721,   708,   562,
     650,   713,   572,   575,    73,   675,   694,    72,   114,   461,
     455,   492,   694,   438,   305,   727,   708,   305,   727,   709,
     464,   694,   508,   508,   508,   453,   566,   566,   457,     1,
     297,   707,     1,   546,   673,   699,   599,   630,   155,   725,
     669,   713,   599,   582,     1,   215,   703,   492,   457,   419,
     713,     1,   713,   576,   465,   713,     1,   210,   225,   458,
       1,   138,   206,   727,   248,   251,   284,   456,   550,     1,
     650,   653,   713,   708,   708,   708,   708,   457,   453,     1,
     463,   465,   457,   566,   657,   582,   542,   635,   636,   637,
     593,   713,    77,   459,   567,   492,    73,   713,    72,   462,
     713,   694,   459,   709,    73,   461,   461,   582,   305,   624,
     638,   656,   542,   599,   470,   516,   721,   464,   461,   457,
     457,   464,   460,   713,    73,   459,   459,   471,   492,   566,
     461
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   315,   316,   316,   317,   317,   317,   317,   317,   317,
     317,   317,   317,   317,   317,   317,   317,   317,   317,   317,
     318,   318,   319,   319,   319,   319,   319,   320,   321,   320,
     320,   320,   320,   322,   322,   322,   323,   323,   323,   324,
     324,   324,   325,   325,   325,   326,   326,   326,   327,   327,
     328,   328,   329,   329,   329,   329,   330,   330,   330,   331,
     332,   332,   333,   333,   334,   334,   334,   334,   334,   334,
     334,   334,   334,   334,   334,   334,   334,   334,   334,   334,
     334,   334,   334,   334,   334,   334,   334,   334,   334,   334,
     334,   335,   336,   336,   337,   337,   337,   338,   338,   339,
     339,   340,   340,   341,   341,   342,   342,   342,   342,   342,
     342,   342,   343,   343,   344,   344,   345,   345,   346,   346,
     347,   347,   347,   347,   347,   347,   347,   348,   348,   349,
     349,   349,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     351,   351,   352,   352,   353,   353,   354,   354,   355,   355,
     355,   355,   355,   355,   355,   355,   355,   355,   355,   355,
     356,   355,   355,   355,   355,   355,   357,   359,   358,   360,
     360,   360,   360,   360,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     362,   363,   363,   364,   364,   365,   365,   366,   366,   366,
     367,   367,   368,   368,   369,   369,   369,   369,   369,   369,
     369,   370,   371,   372,   373,   373,   374,   374,   375,   376,
     376,   376,   377,   377,   377,   377,   377,   377,   377,   378,
     378,   378,   379,   379,   380,   380,   381,   381,   381,   381,
     382,   382,   382,   383,   384,   385,   387,   386,   386,   389,
     388,   390,   390,   390,   390,   392,   393,   391,   394,   394,
     395,   394,   394,   396,   396,   397,   398,   398,   398,   400,
     401,   399,   403,   402,   405,   406,   404,   407,   407,   407,
     408,   408,   408,   408,   409,   409,   409,   409,   410,   410,
     411,   411,   412,   412,   413,   413,   413,   413,   414,   415,
     415,   416,   416,   417,   417,   417,   417,   417,   417,   418,
     419,   418,   420,   422,   421,   424,   425,   423,   426,   426,
     427,   428,   428,   429,   430,   432,   433,   431,   434,   434,
     435,   435,   436,   437,   437,   438,   438,   438,   438,   438,
     439,   439,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   441,   441,   442,   443,   443,   443,   443,   443,
     443,   443,   443,   443,   443,   445,   444,   446,   447,   447,
     448,   449,   450,   452,   451,   454,   453,   455,   455,   456,
     456,   456,   456,   457,   457,   457,   457,   457,   458,   458,
     458,   459,   460,   459,   459,   461,   461,   461,   461,   461,
     462,   462,   463,   463,   464,   464,   465,   465,   467,   466,
     466,   466,   468,   468,   469,   469,   470,   471,   473,   472,
     474,   476,   475,   477,   478,   478,   480,   479,   481,   483,
     482,   484,   486,   485,   487,   487,   488,   490,   489,   491,
     492,   492,   493,   493,   493,   493,   494,   494,   494,   494,
     494,   494,   495,   495,   496,   498,   497,   499,   501,   500,
     503,   502,   505,   504,   507,   506,   508,   508,   509,   509,
     509,   509,   511,   510,   513,   512,   515,   514,   516,   516,
     516,   517,   517,   518,   518,   519,   519,   519,   519,   520,
     520,   520,   520,   520,   520,   520,   520,   521,   521,   522,
     522,   522,   522,   522,   522,   524,   523,   525,   525,   526,
     526,   526,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   526,   526,   526,   527,   528,   529,   530,   530,   532,
     531,   531,   533,   533,   534,   534,   535,   535,   536,   536,
     537,   538,   538,   538,   539,   539,   539,   540,   540,   541,
     541,   542,   542,   542,   542,   543,   543,   543,   544,   544,
     545,   545,   546,   546,   547,   547,   548,   548,   548,   549,
     549,   549,   549,   549,   549,   549,   550,   550,   551,   551,
     552,   552,   553,   553,   553,   553,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   555,   555,   556,   556,
     558,   557,   557,   559,   559,   560,   560,   561,   561,   562,
     562,   562,   562,   562,   562,   562,   562,   562,   562,   562,
     563,   563,   564,   564,   565,   565,   566,   566,   567,   567,
     569,   568,   570,   570,   571,   571,   572,   572,   573,   573,
     574,   574,   575,   575,   576,   576,   576,   576,   576,   576,
     577,   577,   579,   578,   580,   580,   581,   581,   582,   582,
     582,   583,   583,   584,   584,   584,   584,   585,   585,   586,
     587,   588,   589,   589,   590,   591,   591,   592,   592,   592,
     592,   592,   592,   593,   593,   594,   595,   595,   596,   596,
     597,   597,   598,   598,   598,   599,   599,   600,   600,   601,
     602,   602,   603,   603,   604,   604,   604,   605,   605,   605,
     605,   605,   605,   605,   605,   605,   605,   605,   605,   605,
     605,   605,   606,   606,   606,   606,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   606,   606,   606,
     606,   607,   607,   607,   608,   609,   609,   610,   610,   610,
     610,   610,   610,   610,   611,   611,   612,   612,   612,   612,
     612,   612,   612,   612,   612,   613,   613,   613,   614,   615,
     615,   616,   617,   618,   618,   618,   619,   619,   620,   620,
     621,   621,   622,   623,   623,   623,   623,   623,   623,   624,
     624,   625,   625,   625,   625,   625,   625,   625,   625,   625,
     625,   625,   625,   625,   625,   625,   625,   625,   626,   626,
     626,   626,   627,   627,   627,   628,   628,   629,   630,   630,
     631,   631,   632,   633,   634,   634,   635,   635,   636,   636,
     637,   637,   638,   638,   639,   639,   640,   640,   641,   641,
     642,   642,   643,   643,   644,   644,   645,   646,   646,   647,
     647,   648,   648,   649,   649,   650,   650,   650,   651,   652,
     652,   653,   653,   654,   654,   655,   656,   657,   657,   658,
     658,   659,   659,   660,   660,   661,   661,   661,   662,   662,
     663,   663,   664,   664,   665,   665,   665,   665,   666,   666,
     666,   667,   667,   668,   668,   669,   669,   669,   670,   670,
     671,   671,   672,   672,   673,   673,   674,   674,   675,   675,
     676,   676,   677,   677,   677,   677,   677,   677,   677,   677,
     677,   677,   677,   677,   677,   677,   677,   677,   677,   677,
     677,   677,   677,   677,   677,   677,   677,   677,   677,   677,
     677,   677,   677,   677,   677,   677,   677,   677,   677,   677,
     677,   677,   677,   677,   677,   677,   677,   677,   677,   677,
     678,   678,   679,   679,   680,   680,   681,   681,   682,   683,
     683,   684,   684,   685,   685,   686,   687,   687,   688,   688,
     689,   689,   690,   690,   691,   691,   692,   692,   693,   693,
     694,   694,   695,   695,   696,   696,   696,   697,   697,   698,
     698,   699,   699,   700,   701,   701,   702,   702,   703,   703,
     704,   704,   705,   705,   706,   706,   707,   707,   708,   708,
     709,   709,   709,   710,   710,   711,   711,   712,   712,   713,
     713,   714,   714,   714,   715,   715,   716,   716,   717,   717,
     718,   718,   719,   719,   720,   720,   721,   721,   722,   722,
     723,   723,   724,   724,   725,   725,   726,   726,   727,   728,
     728,   729,   729,   730,   730,   731,   731,   732,   732,   733,
     733
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     2,     2,     2,     2,     2,     1,     1,
       4,     4,     2,     2,     2,     2,     1,     4,     0,    11,
       6,     9,     2,     1,     2,     2,     3,     3,     2,     2,
       1,     1,     0,     2,     3,     3,     3,     1,     0,     1,
       3,     1,     2,     2,     3,     1,     0,     2,     1,     3,
       0,     2,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     4,     3,     2,     0,     2,     4,     1,     1,     0,
       1,     2,     1,     1,     1,     0,     1,     1,     2,     3,
       2,     1,     2,     1,     3,     1,     2,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     2,     1,     1,     3,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       0,     4,     2,     3,     2,     2,     1,     0,     3,     0,
       1,     2,     2,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     0,     3,     0,     1,     3,     1,     1,     1,     1,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     2,     2,     1,     2,     0,
       2,     2,     3,     4,     4,     5,     3,     2,     2,     1,
       1,     1,     1,     1,     0,     1,     0,     2,     1,     1,
       0,     1,     1,     1,     1,     1,     0,     6,     3,     0,
       9,     1,     1,     1,     1,     0,     0,     5,     4,     4,
       0,     6,     4,     1,     1,     4,     1,     1,     1,     0,
       0,     5,     0,     4,     0,     0,     5,     1,     1,     1,
       3,     3,     4,     1,     3,     3,     4,     1,     1,     1,
       0,     1,     2,     4,     1,     2,     2,     1,     6,     0,
       1,     3,     1,     1,     2,     1,     1,     1,     2,     0,
       0,     4,     1,     0,     3,     0,     0,     6,     3,     1,
       1,     1,     1,     1,     1,     0,     0,     8,     0,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     2,     2,     3,     2,     3,     3,     3,     5,
       5,     4,     5,     5,     3,     0,    10,     9,     0,     1,
       7,     7,     8,     0,     7,     0,     3,     0,     2,     1,
       1,     1,     1,     0,     1,     4,     3,     4,     1,     1,
       1,     0,     0,     4,     1,     0,     2,     3,     2,     2,
       0,     3,     1,     1,     0,     1,     3,     1,     0,     4,
       1,     1,     1,     1,     0,     3,     1,     1,     0,     4,
      10,     0,     3,     2,     3,     1,     0,     3,     2,     0,
       3,     4,     0,     4,     1,     1,     2,     0,     9,     9,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     9,     6,     0,     4,
       0,     3,     0,     3,     0,     3,     0,     1,     1,     1,
       1,     1,     0,     3,     0,     3,     0,     3,     1,     2,
       1,     0,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     0,     6,     1,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     6,     2,     0,     2,     0,
       6,     3,     1,     1,     1,     1,     3,     4,     4,     4,
       2,     0,     2,     2,     1,     3,     2,     0,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     0,     1,     3,     2,     2,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     0,     2,
       1,     1,     2,     3,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       0,     7,     1,     0,     3,     0,     1,     3,     1,     1,
       2,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       0,     3,     0,     1,     1,     1,     0,     1,     2,     1,
       0,     7,     0,     1,     3,     1,     2,     1,     0,     3,
       0,     1,     3,     1,     1,     1,     1,     1,     3,     1,
       2,     1,     0,     5,     0,     1,     2,     1,     1,     1,
       1,     4,     6,     0,     1,     1,     1,     0,     1,     3,
       2,     2,     0,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     0,     1,     3,     1,
       1,     1,     0,     1,     2,     0,     1,     2,     2,     2,
       0,     1,     2,     1,     1,     1,     1,     2,     1,     1,
       1,     2,     1,     2,     1,     2,     1,     1,     3,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     7,     3,     3,     1,
       2,     2,     6,     3,     1,     1,     2,     1,     0,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     1,     1,     2,     2,     1,     1,     3,     4,
       4,     2,     1,     2,     3,     2,     4,     2,     1,     1,
       0,     1,     2,     3,     0,     3,     2,     1,     0,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     2,
       1,     0,     1,     0,     2,     3,     3,     1,     2,     0,
       2,     1,     1,     0,     1,     2,     2,     1,     1,     0,
       1,     3,     1,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     0,     1,     1,     0,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       2,     1,     1,     3,     2,     1,     0,     1,     1,     1,
       0,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     0,     1,     0,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     2,     1,     1,     0,
       1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_Y_CONSTRUCTOR_SNAME: /* Y_CONSTRUCTOR_SNAME  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5295 "parser.c"
        break;

    case YYSYMBOL_Y_DESTRUCTOR_SNAME: /* Y_DESTRUCTOR_SNAME  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5301 "parser.c"
        break;

    case YYSYMBOL_Y_OPERATOR_SNAME: /* Y_OPERATOR_SNAME  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5307 "parser.c"
        break;

    case YYSYMBOL_Y_CHAR_LIT: /* Y_CHAR_LIT  */
#line 1968 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5313 "parser.c"
        break;

    case YYSYMBOL_Y_CONCEPT_SNAME: /* Y_CONCEPT_SNAME  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5319 "parser.c"
        break;

    case YYSYMBOL_Y_GLOB: /* Y_GLOB  */
#line 1960 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5325 "parser.c"
        break;

    case YYSYMBOL_Y_NAME: /* Y_NAME  */
#line 1960 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5331 "parser.c"
        break;

    case YYSYMBOL_Y_SET_OPTION: /* Y_SET_OPTION  */
#line 1960 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5337 "parser.c"
        break;

    case YYSYMBOL_Y_STR_LIT: /* Y_STR_LIT  */
#line 1968 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5343 "parser.c"
        break;

    case YYSYMBOL_capturing_paren_capture_decl_list_english_opt: /* capturing_paren_capture_decl_list_english_opt  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5349 "parser.c"
        break;

    case YYSYMBOL_paren_capture_decl_list_english: /* paren_capture_decl_list_english  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5355 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_english_opt: /* capture_decl_list_english_opt  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5361 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_english: /* capture_decl_list_english  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5367 "parser.c"
        break;

    case YYSYMBOL_p_extra_token_except_lparen: /* p_extra_token_except_lparen  */
#line 1964 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5373 "parser.c"
        break;

    case YYSYMBOL_p_extra_tokens_opt: /* p_extra_tokens_opt  */
#line 1965 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5379 "parser.c"
        break;

    case YYSYMBOL_p_extra_tokens: /* p_extra_tokens  */
#line 1965 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5385 "parser.c"
        break;

    case YYSYMBOL_p_extra_token: /* p_extra_token  */
#line 1964 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5391 "parser.c"
        break;

    case YYSYMBOL_p_arg_list_opt: /* p_arg_list_opt  */
#line 1961 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5397 "parser.c"
        break;

    case YYSYMBOL_p_comma_arg_list: /* p_comma_arg_list  */
#line 1961 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5403 "parser.c"
        break;

    case YYSYMBOL_p_arg_list: /* p_arg_list  */
#line 1961 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5409 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens: /* p_arg_tokens  */
#line 1965 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5415 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_as_list: /* p_arg_token_as_list  */
#line 1965 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5421 "parser.c"
        break;

    case YYSYMBOL_p_arg_token: /* p_arg_token  */
#line 1964 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5427 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens_with_comma_opt: /* p_arg_tokens_with_comma_opt  */
#line 1965 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5433 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens_with_comma: /* p_arg_tokens_with_comma  */
#line 1965 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5439 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_with_comma_as_list: /* p_arg_token_with_comma_as_list  */
#line 1965 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5445 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_with_comma: /* p_arg_token_with_comma  */
#line 1964 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5451 "parser.c"
        break;

    case YYSYMBOL_help_what_opt: /* help_what_opt  */
#line 1960 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5457 "parser.c"
        break;

    case YYSYMBOL_p_paren_param_list_opt: /* p_paren_param_list_opt  */
#line 1963 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5463 "parser.c"
        break;

    case YYSYMBOL_p_param_list_opt: /* p_param_list_opt  */
#line 1963 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5469 "parser.c"
        break;

    case YYSYMBOL_p_param_list: /* p_param_list  */
#line 1963 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5475 "parser.c"
        break;

    case YYSYMBOL_p_param: /* p_param  */
#line 1962 "parser.y"
            { DTRACE; p_param_free( ((*yyvaluep).p_param) );                     }
#line 5481 "parser.c"
        break;

    case YYSYMBOL_p_replace_list_opt: /* p_replace_list_opt  */
#line 1965 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5487 "parser.c"
        break;

    case YYSYMBOL_p_replace_list: /* p_replace_list  */
#line 1965 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5493 "parser.c"
        break;

    case YYSYMBOL_p_replace_token: /* p_replace_token  */
#line 1964 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5499 "parser.c"
        break;

    case YYSYMBOL_set_option_value_opt: /* set_option_value_opt  */
#line 1968 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5505 "parser.c"
        break;

    case YYSYMBOL_namespace_sname_c_exp: /* namespace_sname_c_exp  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5511 "parser.c"
        break;

    case YYSYMBOL_namespace_sname_c: /* namespace_sname_c  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5517 "parser.c"
        break;

    case YYSYMBOL_namespace_typedef_sname_c: /* namespace_typedef_sname_c  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5523 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_c_opt: /* capture_decl_list_c_opt  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5529 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_c: /* capture_decl_list_c  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5535 "parser.c"
        break;

    case YYSYMBOL_decl_list_c: /* decl_list_c  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5541 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list_exp: /* param_c_ast_list_exp  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5547 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list_opt: /* param_c_ast_list_opt  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5553 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list: /* param_c_ast_list  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5559 "parser.c"
        break;

    case YYSYMBOL_paren_param_c_ast_list_opt: /* paren_param_c_ast_list_opt  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5565 "parser.c"
        break;

    case YYSYMBOL_pc99_pointer_decl_list_c: /* pc99_pointer_decl_list_c  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5571 "parser.c"
        break;

    case YYSYMBOL_sub_scope_sname_c_opt: /* sub_scope_sname_c_opt  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5577 "parser.c"
        break;

    case YYSYMBOL_paren_param_decl_list_english_opt: /* paren_param_decl_list_english_opt  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5583 "parser.c"
        break;

    case YYSYMBOL_paren_param_decl_list_english: /* paren_param_decl_list_english  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5589 "parser.c"
        break;

    case YYSYMBOL_param_decl_list_english_opt: /* param_decl_list_english_opt  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5595 "parser.c"
        break;

    case YYSYMBOL_param_decl_list_english: /* param_decl_list_english  */
#line 1959 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5601 "parser.c"
        break;

    case YYSYMBOL_any_name: /* any_name  */
#line 1960 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5607 "parser.c"
        break;

    case YYSYMBOL_any_name_exp: /* any_name_exp  */
#line 1960 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5613 "parser.c"
        break;

    case YYSYMBOL_any_sname_c: /* any_sname_c  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5619 "parser.c"
        break;

    case YYSYMBOL_any_sname_c_exp: /* any_sname_c_exp  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5625 "parser.c"
        break;

    case YYSYMBOL_any_sname_c_opt: /* any_sname_c_opt  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5631 "parser.c"
        break;

    case YYSYMBOL_name_exp: /* name_exp  */
#line 1960 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5637 "parser.c"
        break;

    case YYSYMBOL_name_cat: /* name_cat  */
#line 1960 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5643 "parser.c"
        break;

    case YYSYMBOL_name_opt: /* name_opt  */
#line 1960 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5649 "parser.c"
        break;

    case YYSYMBOL_oper_sname_c_opt: /* oper_sname_c_opt  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5655 "parser.c"
        break;

    case YYSYMBOL_sname_c: /* sname_c  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5661 "parser.c"
        break;

    case YYSYMBOL_sname_c_exp: /* sname_c_exp  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5667 "parser.c"
        break;

    case YYSYMBOL_sname_c_opt: /* sname_c_opt  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5673 "parser.c"
        break;

    case YYSYMBOL_sname_english: /* sname_english  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5679 "parser.c"
        break;

    case YYSYMBOL_sname_english_exp: /* sname_english_exp  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5685 "parser.c"
        break;

    case YYSYMBOL_sname_english_opt: /* sname_english_opt  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5691 "parser.c"
        break;

    case YYSYMBOL_sname_list_c: /* sname_list_c  */
#line 1967 "parser.y"
            { DTRACE; c_sname_list_cleanup( &((*yyvaluep).sname_list) );            }
#line 5697 "parser.c"
        break;

    case YYSYMBOL_sname_list_english: /* sname_list_english  */
#line 1967 "parser.y"
            { DTRACE; c_sname_list_cleanup( &((*yyvaluep).sname_list) );            }
#line 5703 "parser.c"
        break;

    case YYSYMBOL_typedef_sname_c: /* typedef_sname_c  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5709 "parser.c"
        break;

    case YYSYMBOL_destructor_sname: /* destructor_sname  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5715 "parser.c"
        break;

    case YYSYMBOL_glob: /* glob  */
#line 1960 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5721 "parser.c"
        break;

    case YYSYMBOL_glob_opt: /* glob_opt  */
#line 1960 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5727 "parser.c"
        break;

    case YYSYMBOL_of_scope_english: /* of_scope_english  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5733 "parser.c"
        break;

    case YYSYMBOL_of_scope_list_english: /* of_scope_list_english  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5739 "parser.c"
        break;

    case YYSYMBOL_of_scope_list_english_opt: /* of_scope_list_english_opt  */
#line 1966 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5745 "parser.c"
        break;

    case YYSYMBOL_str_lit: /* str_lit  */
#line 1968 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5751 "parser.c"
        break;

    case YYSYMBOL_str_lit_exp: /* str_lit_exp  */
#line 1968 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5757 "parser.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* command_list: command_list command  */
#line 1976 "parser.y"
    { //
      // We get here only after a successful parse.
      //
      parse_cleanup( /*fatal_error=*/false );
    }
#line 6056 "parser.c"
    break;

  case 19: /* command: error  */
#line 2000 "parser.y"
    {
      if ( printable_yytext() != NULL )
        elaborate_error_dym( DYM_COMMANDS, "unexpected token" );
      else
        elaborate_error( "unexpected end of command" );
    }
#line 6067 "parser.c"
    break;

  case 20: /* cast_command: Y_cast sname_english_opt as_into_to_exp decl_english_ast  */
#line 2019 "parser.y"
    {
      DUMP_START( "cast_command",
                  "CAST sname_english_opt {AS|[IN]TO} decl_english_ast" );
      DUMP_SNAME( "sname_english_opt", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yylsp[-2]) );
      cast_ast->sname = c_sname_move( &(yyvsp[-2].sname) );
      cast_ast->cast.kind = C_CAST_C;
      cast_ast->cast.to_ast = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_gibberish( cast_ast, C_GIB_PRINT_CAST, stdout );
    }
#line 6089 "parser.c"
    break;

  case 21: /* cast_command: new_style_cast_english sname_english_exp as_into_to_exp decl_english_ast  */
#line 2042 "parser.y"
    {
      DUMP_START( "cast_command",
                  "new_style_cast_english sname_english_exp {AS|[IN]TO} "
                  "decl_english_ast" );
      DUMP_STR( "new_style_cast_english", c_cast_gibberish( (yyvsp[-3].cast_kind) ) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-2].sname) );
      cast_ast->cast.kind = (yyvsp[-3].cast_kind);
      cast_ast->cast.to_ast = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_gibberish( cast_ast, C_GIB_PRINT_CAST, stdout );
    }
#line 6113 "parser.c"
    break;

  case 22: /* new_style_cast_english: Y_const cast_exp  */
#line 2064 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_CONST;        }
#line 6119 "parser.c"
    break;

  case 23: /* new_style_cast_english: Y_dynamic cast_exp  */
#line 2065 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_DYNAMIC;      }
#line 6125 "parser.c"
    break;

  case 24: /* new_style_cast_english: Y_reinterpret cast_exp  */
#line 2066 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_REINTERPRET;  }
#line 6131 "parser.c"
    break;

  case 25: /* new_style_cast_english: Y_static cast_exp  */
#line 2067 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_STATIC;       }
#line 6137 "parser.c"
    break;

  case 27: /* declare_command: Y_declare sname_list_english as_exp alignas_or_width_decl_english_ast  */
#line 2079 "parser.y"
    {
      if ( c_ast_is_name_error( (yyvsp[0].ast) ) ) {
        //
        // This checks for a case like:
        //
        //      declare x as y
        //
        // i.e., declaring a variable name as another name (unknown type).
        // This can get this far due to the nature of the C/C++ grammar.
        //
        // This check has to be done now in the parser rather than later in the
        // AST because the name of the AST node needs to be set to the variable
        // name, but the AST node is itself a name and overwriting it would
        // lose information.
        //
        c_sname_list_cleanup( &(yyvsp[-2].sname_list) );
        PARSE_ABORT();
      }

      DUMP_START( "declare_command",
                  "DECLARE sname_list_english AS "
                  "alignas_or_width_decl_english_ast" );
      DUMP_SNAME_LIST( "sname_list_english", (yyvsp[-2].sname_list) );
      DUMP_AST( "alignas_or_width_decl_english_ast", (yyvsp[0].ast) );

      slist_t *sname_list = &(yyvsp[-2].sname_list);
      c_ast_t *const struct_bind_ast = c_ast_unreference_any( (yyvsp[0].ast) );

      if ( struct_bind_ast->kind == K_STRUCTURED_BINDING ) {
        //
        // For ref-qualified structured bindings, it's much simpler to
        // retroactively change $decl_ast to the structured binding AST
        // directly eliding the reference AST and fold in the reference type.
        //
        struct_bind_ast->type.stids |= (yyvsp[0].ast)->type.stids;
        switch ( (yyvsp[0].ast)->kind ) {
          case K_REFERENCE:
            struct_bind_ast->type.stids |= TS_REFERENCE;
            break;
          case K_RVALUE_REFERENCE:
            struct_bind_ast->type.stids |= TS_RVALUE_REFERENCE;
            break;
          default:
            /* suppress warning */;
        } // switch
        (yyvsp[0].ast) = struct_bind_ast;
        c_ast_set_parent( (yyvsp[0].ast), /*parent_ast=*/NULL );

        //
        // A structured binding is inverted: instead of having one structured
        // binding AST for each name, we have just one structured binding AST
        // with a list of name(s).
        //
        (yyvsp[0].ast)->struct_bind.sname_list = slist_move( sname_list );
        sname_list = &(yyvsp[0].ast)->struct_bind.sname_list;
      }

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      (yyvsp[0].ast)->loc = (yylsp[-2]);

      bool ok = true;
      //
      // Ensure that none of the names aren't of a previously declared type:
      //
      //      cdecl> struct S
      //      cdecl> declare S as int // error: "S": previously declared
      //
      // This check is done now in the parser rather than later in the AST
      // since similar checks are also done here in the parser.
      //
      FOREACH_SLIST_NODE( sname_node, sname_list ) {
        c_sname_t const *const sname = sname_node->data;
        if ( c_sname_is_type( sname, &(yyvsp[0].ast)->loc ) ) {
          ok = false;
          break;
        }
      } // for

      if ( ok ) {
        // To check the declaration, it needs a name: just dup the first one.
        c_sname_t temp_sname = c_sname_dup( slist_front( sname_list ) );
        c_sname_set( &(yyvsp[0].ast)->sname, &temp_sname );
        ok = c_ast_check( (yyvsp[0].ast) );
      }

      if ( ok ) {
        if ( (yyvsp[0].ast)->kind == K_STRUCTURED_BINDING ) {
          decl_flags_t decl_flags = C_GIB_PRINT_DECL;
          if ( opt_semicolon )
            decl_flags |= C_GIB_OPT_SEMICOLON;
          c_ast_gibberish( (yyvsp[0].ast), decl_flags, stdout );
        }
        else {
          c_ast_sname_list_gibberish( (yyvsp[0].ast), &(yyvsp[-2].sname_list), stdout );
        }
      }

      c_sname_list_cleanup( &(yyvsp[-2].sname_list) );
      PARSE_ASSERT( ok );
      PUTC( '\n' );
    }
#line 6245 "parser.c"
    break;

  case 28: /* $@1: %empty  */
#line 2187 "parser.y"
    { //
      // This check is done now in the parser right here mid-rule rather than
      // later in the end-rule action or in the AST since it yields a better
      // error message since otherwise it would warn that "operator" is a
      // keyword in C++98 which skims right past the bigger error that operator
      // overloading isn't supported in C.
      //
      if ( !OPT_LANG_IS( operator ) ) {
        print_error( &(yylsp[0]),
          "operator overloading not supported%s\n",
          C_LANG_WHICH( operator )
        );
        PARSE_ABORT();
      }
    }
#line 6265 "parser.c"
    break;

  case 29: /* declare_command: Y_declare c_operator $@1 of_scope_list_english_opt as_exp type_qualifier_list_english_type_opt ref_qualifier_english_stid_opt member_or_non_member_opt operator_exp paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 2208 "parser.y"
    {
      c_operator_t const *const operator = c_op_get( (yyvsp[-9].op_id) );

      DUMP_START( "declare_command",
                  "DECLARE c_operator of_scope_list_english_opt AS "
                  "type_qualifier_list_english_type_opt "
                  "ref_qualifier_english_stid_opt "
                  "member_or_non_member_opt "
                  "OPERATOR paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_STR( "c_operator", operator->literal );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[-7].sname) );
      DUMP_TYPE( "type_qualifier_list_english_type_opt", (yyvsp[-5].type) );
      DUMP_TID( "ref_qualifier_english_stid_opt", (yyvsp[-4].tid) );
      DUMP_INT( "member_or_non_member_opt", (yyvsp[-3].member) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );
      DUMP_END();

      c_ast_t *const oper_ast = c_ast_new_gc( K_OPERATOR, &(yylsp[-9]) );
      c_sname_set( &oper_ast->sname, &(yyvsp[-7].sname) );
      PARSE_ASSERT( c_type_add( &oper_ast->type, &(yyvsp[-5].type), &(yylsp[-5]) ) );
      PARSE_ASSERT(
        c_type_add_tid( &oper_ast->type, (yyvsp[-4].tid), &(yylsp[-4]) )
      );
      oper_ast->oper.operator = operator;
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), oper_ast );
      oper_ast->oper.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      oper_ast->oper.member = (yyvsp[-3].member);
      c_ast_set_parent( (yyvsp[0].ast), oper_ast );

      PARSE_ASSERT( c_ast_check( oper_ast ) );
      decl_flags_t decl_flags = C_GIB_PRINT_DECL;
      if ( opt_semicolon )
        decl_flags |= C_GIB_OPT_SEMICOLON;
      c_ast_gibberish( oper_ast, decl_flags, stdout );
      PUTC( '\n' );
    }
#line 6308 "parser.c"
    break;

  case 30: /* declare_command: Y_declare storage_class_subset_english_type_opt Y_lambda capturing_paren_capture_decl_list_english_opt paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 2254 "parser.y"
    {
      DUMP_START( "declare_command",
                  "DECLARE storage_class_subset_english_type_opt "
                  "LAMBDA capturing_paren_capture_decl_list_english_opt "
                  "paren_param_decl_list_english_opt"
                  "returning_english_ast_opt" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-4].type) );
      DUMP_AST_LIST( "capturing_paren_capture_decl_list_english_opt",
                     (yyvsp[-2].ast_list) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      c_ast_t *const lambda_ast = c_ast_new_gc( K_LAMBDA, &(yylsp[-3]) );
      lambda_ast->type = (yyvsp[-4].type);
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), lambda_ast );
      lambda_ast->lambda.capture_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), lambda_ast );
      lambda_ast->lambda.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), lambda_ast );

      DUMP_AST( "$$_ast", lambda_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( lambda_ast ) );
      c_ast_gibberish( lambda_ast, C_GIB_PRINT_DECL, stdout );
      PUTC( '\n' );
    }
#line 6340 "parser.c"
    break;

  case 31: /* declare_command: Y_declare storage_class_subset_english_type_opt cv_qualifier_list_stid_opt user_defined conversion_exp operator_opt of_scope_list_english_opt returning_exp decl_english_ast  */
#line 2289 "parser.y"
    {
      DUMP_START( "declare_command",
                  "DECLARE storage_class_subset_english_type_opt "
                  "cv_qualifier_list_stid_opt "
                  "USER-DEFINED CONVERSION [OPERATOR] "
                  "of_scope_list_english_opt "
                  "RETURNING decl_english_ast" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-7].type) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const udc_ast = c_ast_new_gc( K_UDEF_CONV, &(yyloc) );
      c_sname_set( &udc_ast->sname, &(yyvsp[-2].sname) );
      udc_ast->type = c_type_or( &(yyvsp[-7].type), &C_TYPE_LIT_S( (yyvsp[-6].tid) ) );
      c_ast_set_parent( (yyvsp[0].ast), udc_ast );

      DUMP_AST( "$$_ast", udc_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( udc_ast ) );
      decl_flags_t decl_flags = C_GIB_PRINT_DECL;
      if ( opt_semicolon )
        decl_flags |= C_GIB_OPT_SEMICOLON;
      c_ast_gibberish( udc_ast, decl_flags, stdout );
      PUTC( '\n' );
    }
#line 6372 "parser.c"
    break;

  case 32: /* declare_command: Y_declare error  */
#line 2318 "parser.y"
    {
      if ( OPT_LANG_IS( operator ) )
        elaborate_error( "name or operator expected" );
      else
        elaborate_error( "name expected" );
    }
#line 6383 "parser.c"
    break;

  case 34: /* alignas_or_width_decl_english_ast: decl_english_ast alignas_specifier_english  */
#line 2330 "parser.y"
    {
      DUMP_START( "alignas_or_width_decl_english_ast",
                  "decl_english_ast alignas_specifier_english" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );
      DUMP_ALIGN( "alignas_specifier_english", (yyvsp[0].align) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->align = (yyvsp[0].align);
      (yyval.ast)->loc = (yyloc);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 6401 "parser.c"
    break;

  case 35: /* alignas_or_width_decl_english_ast: decl_english_ast width_specifier_english_uint  */
#line 2345 "parser.y"
    {
      DUMP_START( "alignas_or_width_decl_english_ast",
                  "decl_english_ast width_specifier_english_uint" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );
      DUMP_INT( "width_specifier_english_uint", (yyvsp[0].uint_val) );

      //
      // This check has to be done now in the parser rather than later in the
      // AST since we need to use the builtin union member now.
      //
      if ( !c_ast_is_integral( (yyvsp[-1].ast) ) ) {
        print_error( &(yylsp[0]), "invalid bit-field type " );
        print_ast_type_aka( (yyvsp[-1].ast), stderr );
        EPRINTF( "; must be an integral %stype\n",
          OPT_LANG_IS( enum_BITFIELDS ) ? "or enumeration " : ""
        );
        PARSE_ABORT();
      }

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      (yyval.ast)->bit_field.bit_width = (yyvsp[0].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 6432 "parser.c"
    break;

  case 36: /* alignas_specifier_english: aligned_english uint_lit bytes_opt  */
#line 2375 "parser.y"
    {
      DUMP_START( "alignas_specifier_english", "ALIGNAS uint_lit [BYTES]" );
      DUMP_INT( "uint_lit", (yyvsp[-1].uint_val) );

      (yyval.align).kind = C_ALIGNAS_BYTES;
      (yyval.align).loc = (yyloc);
      (yyval.align).bytes = (yyvsp[-1].uint_val);

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 6448 "parser.c"
    break;

  case 37: /* alignas_specifier_english: aligned_english decl_english_ast bytes_opt  */
#line 2387 "parser.y"
    {
      DUMP_START( "alignas_specifier_english",
                  "ALIGNAS decl_english_ast [BYTES]" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );

      if ( (yyvsp[-1].ast)->kind == K_NAME ) {
        (yyval.align).kind = C_ALIGNAS_SNAME;
        (yyval.align).sname = c_sname_move( &(yyvsp[-1].ast)->sname );
      } else {
        (yyval.align).kind = C_ALIGNAS_TYPE;
        (yyval.align).type_ast = (yyvsp[-1].ast);
      }
      (yyval.align).loc = (yyloc);

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 6470 "parser.c"
    break;

  case 38: /* alignas_specifier_english: aligned_english error  */
#line 2405 "parser.y"
    {
      (yyval.align) = (c_alignas_t){ 0 };
      (yyval.align).loc = (yyloc);
      elaborate_error( "integer or type expected" );
    }
#line 6480 "parser.c"
    break;

  case 42: /* capturing_paren_capture_decl_list_english_opt: %empty  */
#line 2419 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 6486 "parser.c"
    break;

  case 43: /* capturing_paren_capture_decl_list_english_opt: Y_capturing paren_capture_decl_list_english  */
#line 2421 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[0].ast_list);
    }
#line 6494 "parser.c"
    break;

  case 44: /* capturing_paren_capture_decl_list_english_opt: '[' capture_decl_list_english_opt ']'  */
#line 2425 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6502 "parser.c"
    break;

  case 45: /* paren_capture_decl_list_english: '[' capture_decl_list_english_opt ']'  */
#line 2432 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6510 "parser.c"
    break;

  case 46: /* paren_capture_decl_list_english: '(' capture_decl_list_english_opt ')'  */
#line 2436 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6518 "parser.c"
    break;

  case 47: /* paren_capture_decl_list_english: error  */
#line 2440 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      elaborate_error( "'[' or '(' expected\n" );
    }
#line 6527 "parser.c"
    break;

  case 48: /* capture_decl_list_english_opt: %empty  */
#line 2447 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 6533 "parser.c"
    break;

  case 50: /* capture_decl_list_english: capture_decl_list_english comma_exp capture_decl_english_ast  */
#line 2454 "parser.y"
    {
      DUMP_START( "capture_decl_list_english",
                  "capture_decl_list_english ',' capture_decl_english_ast" );
      DUMP_AST_LIST( "capture_decl_list_english", (yyvsp[-2].ast_list) );
      DUMP_AST( "capture_decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 6550 "parser.c"
    break;

  case 51: /* capture_decl_list_english: capture_decl_english_ast  */
#line 2468 "parser.y"
    {
      DUMP_START( "capture_decl_list_english",
                  "capture_decl_english_ast" );
      DUMP_AST( "capture_decl_english_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 6566 "parser.c"
    break;

  case 52: /* capture_decl_english_ast: Y_copy capture_default_opt  */
#line 2483 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_COPY;
    }
#line 6575 "parser.c"
    break;

  case 53: /* capture_decl_english_ast: Y_reference capture_default_opt  */
#line 2488 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 6584 "parser.c"
    break;

  case 54: /* capture_decl_english_ast: Y_reference Y_to name_exp  */
#line 2493 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_init_name( &(yyval.ast)->sname, (yyvsp[0].name) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 6594 "parser.c"
    break;

  case 59: /* width_specifier_english_uint: Y_width uint_lit_exp bits_opt  */
#line 2509 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since we use 0 to mean "no bit-field."
      //
      if ( (yyvsp[-1].uint_val) == 0 ) {
        print_error( &(yylsp[-1]), "bit-field width must be > 0\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 6609 "parser.c"
    break;

  case 60: /* storage_class_subset_english_type_opt: %empty  */
#line 2522 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 6615 "parser.c"
    break;

  case 61: /* storage_class_subset_english_type_opt: storage_class_subset_english_type_opt storage_class_subset_english_type  */
#line 2525 "parser.y"
    {
      DUMP_START( "storage_class_subset_english_type_opt",
                  "storage_class_subset_english_type_opt "
                  "storage_class_subset_english_type" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-1].type) );
      DUMP_TYPE( "storage_class_subset_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 6633 "parser.c"
    break;

  case 62: /* storage_class_subset_english_type: attribute_english_atid  */
#line 2541 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) ); }
#line 6639 "parser.c"
    break;

  case 63: /* storage_class_subset_english_type: storage_class_subset_english_stid  */
#line 2543 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) );
    }
#line 6647 "parser.c"
    break;

  case 64: /* storage_class_subset_english_stid: Y_auto_TYPE  */
#line 2563 "parser.y"
                                  { (yyval.tid) = TS_auto; }
#line 6653 "parser.c"
    break;

  case 66: /* storage_class_subset_english_stid: Y_constant eval_expr_init_stid  */
#line 2566 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 6661 "parser.c"
    break;

  case 73: /* storage_class_subset_english_stid: Y_extern linkage_stid linkage_opt  */
#line 2576 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 6669 "parser.c"
    break;

  case 78: /* storage_class_subset_english_stid: Y_no Y_except  */
#line 2583 "parser.y"
                                  { (yyval.tid) = TS_noexcept; }
#line 6675 "parser.c"
    break;

  case 80: /* storage_class_subset_english_stid: Y_non_empty  */
#line 2585 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 6681 "parser.c"
    break;

  case 84: /* storage_class_subset_english_stid: Y_thread local_exp  */
#line 2589 "parser.y"
                                  { (yyval.tid) = TS_thread_local; }
#line 6687 "parser.c"
    break;

  case 90: /* storage_class_subset_english_stid: Y_pure virtual_stid_exp  */
#line 2595 "parser.y"
                                  { (yyval.tid) = TS_PURE_virtual | (yyvsp[0].tid); }
#line 6693 "parser.c"
    break;

  case 91: /* define_command: Y_define sname_english_exp as_exp decl_english_ast  */
#line 2602 "parser.y"
    {
      DUMP_START( "define_command",
                  "DEFINE sname_english AS decl_english_ast" );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      // see the comment in "declare_command"
      if ( c_ast_is_name_error( (yyvsp[0].ast) ) ) {
        c_sname_cleanup( &(yyvsp[-2].sname) );
        PARSE_ABORT();
      }

      if ( !c_tid_is_any( (yyvsp[0].ast)->type.stids, TS_typedef ) ) {
        //
        // Explicitly add TS_typedef (if it doesn't have it already) to
        // prohibit cases like:
        //
        //      define eint as extern int
        //      define rint as register int
        //      define sint as static int
        //      ...
        //
        // i.e., a defined type with a storage class.  Once the semantic checks
        // pass, remove the TS_typedef.
        //
        PARSE_ASSERT(
          c_type_add( &(yyvsp[0].ast)->type, &T_TS_typedef, &(yylsp[0]) )
        );
      }
      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast) ) );
      PJL_DISCARD_RV( c_ast_take_type_any( (yyvsp[0].ast), &T_TS_typedef ) );

      c_sname_set( &(yyvsp[0].ast)->sname, &(yyvsp[-2].sname) );
      if ( c_tid_is_any( (yyvsp[0].ast)->type.btids, TB_ANY_SCOPE ) )
        c_sname_local_data( &(yyvsp[0].ast)->sname )->type = (yyvsp[0].ast)->type;
      c_sname_set_all_types( &(yyvsp[0].ast)->sname );

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      PARSE_ASSERT( define_type( (yyvsp[0].ast), C_ENG_DECL ) );
    }
#line 6740 "parser.c"
    break;

  case 92: /* expand_command: Y_expand Y_NAME expand_command2  */
#line 2650 "parser.y"
    {
      p_arg_list_t   *const arg_list   = (yyvsp[0].ptrs)[0];
      p_token_list_t *const extra_list = (yyvsp[0].ptrs)[1];

      DUMP_START( "expand_command", "EXPAND NAME arg_list_opt extra_list_opt" );
      DUMP_STR( "name", (yyvsp[-1].name) );
      DUMP_MACRO_ARG_LIST( "arg_list", arg_list );
      DUMP_MACRO_TOKEN_LIST( "extra_list", extra_list );
      DUMP_END();

      bool const ok =
        p_macro_expand( (yyvsp[-1].name), &(yylsp[-1]), arg_list, extra_list, stdout );
      p_arg_list_cleanup( arg_list );
      free( arg_list );
      p_token_list_cleanup( extra_list );
      free( extra_list );
      free( (yyvsp[-1].name) );
      PARSE_ASSERT( ok );
    }
#line 6764 "parser.c"
    break;

  case 93: /* expand_command: Y_expand error  */
#line 2671 "parser.y"
    {
      elaborate_error( "macro name expected" );
    }
#line 6772 "parser.c"
    break;

  case 94: /* expand_command2: %empty  */
#line 2677 "parser.y"
                                  { (yyval.ptrs)[0] = (yyval.ptrs)[1] = NULL; }
#line 6778 "parser.c"
    break;

  case 95: /* expand_command2: p_extra_token_except_lparen p_extra_tokens_opt  */
#line 2693 "parser.y"
    {
      if ( (yyvsp[0].p_token_list) == NULL ) {
        (yyvsp[0].p_token_list) = MALLOC( p_token_list_t, 1 );
        slist_init( (yyvsp[0].p_token_list) );
      }
      slist_push_front( (yyvsp[0].p_token_list), (yyvsp[-1].p_token) );

      (yyval.ptrs)[0] = NULL;
      (yyval.ptrs)[1] = (yyvsp[0].p_token_list);
    }
#line 6793 "parser.c"
    break;

  case 96: /* expand_command2: '(' p_arg_list_opt ')' p_extra_tokens_opt  */
#line 2705 "parser.y"
    {
      (yyval.ptrs)[0] = (yyvsp[-2].p_arg_list);
      (yyval.ptrs)[1] = (yyvsp[0].p_token_list);
    }
#line 6802 "parser.c"
    break;

  case 98: /* p_extra_token_except_lparen: ')'  */
#line 2714 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" );
    }
#line 6810 "parser.c"
    break;

  case 99: /* p_extra_tokens_opt: %empty  */
#line 2720 "parser.y"
                                  { (yyval.p_token_list) = NULL; }
#line 6816 "parser.c"
    break;

  case 101: /* p_extra_tokens: p_extra_tokens p_extra_token  */
#line 2726 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6825 "parser.c"
    break;

  case 102: /* p_extra_tokens: p_extra_token  */
#line 2731 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6835 "parser.c"
    break;

  case 104: /* p_extra_token: '('  */
#line 2741 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "(" );
    }
#line 6843 "parser.c"
    break;

  case 105: /* p_arg_list_opt: %empty  */
#line 2748 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
    }
#line 6852 "parser.c"
    break;

  case 107: /* p_arg_list_opt: p_comma_arg_list  */
#line 2766 "parser.y"
    {
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
      slist_push_list_back( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6865 "parser.c"
    break;

  case 108: /* p_arg_list_opt: p_comma_arg_list p_arg_list  */
#line 2786 "parser.y"
    {
      slist_push_back( (yyvsp[-1].p_arg_list), p_token_list_new_placemarker() );
      (yyval.p_arg_list) = (yyvsp[0].p_arg_list);
      slist_push_list_front( (yyval.p_arg_list), (yyvsp[-1].p_arg_list) );
    }
#line 6875 "parser.c"
    break;

  case 109: /* p_arg_list_opt: p_comma_arg_list p_arg_list p_comma_arg_list  */
#line 2807 "parser.y"
    {
      slist_push_back( (yyvsp[-2].p_arg_list), p_token_list_new_placemarker() );
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_list_front( (yyval.p_arg_list), (yyvsp[-2].p_arg_list) );
      slist_push_list_back ( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6888 "parser.c"
    break;

  case 110: /* p_arg_list_opt: p_arg_list p_comma_arg_list  */
#line 2827 "parser.y"
    {
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );
      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_list_back( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6898 "parser.c"
    break;

  case 111: /* p_arg_list_opt: error  */
#line 2834 "parser.y"
    {
      (yyval.p_arg_list) = NULL;
      elaborate_error( "macro argument expected" );
    }
#line 6907 "parser.c"
    break;

  case 112: /* p_comma_arg_list: p_comma_arg_list ','  */
#line 2842 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_back( (yyval.p_arg_list), p_token_list_new_placemarker() );
    }
#line 6916 "parser.c"
    break;

  case 113: /* p_comma_arg_list: ','  */
#line 2847 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
    }
#line 6925 "parser.c"
    break;

  case 114: /* p_arg_list: p_arg_list p_comma_arg_list p_arg_tokens  */
#line 2868 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-2].p_arg_list);

      if ( slist_empty( (yyvsp[-1].p_arg_list) ) )
        free( (yyvsp[-1].p_arg_list) );
      else
        slist_push_list_back( (yyval.p_arg_list), (yyvsp[-1].p_arg_list) );

      slist_push_back( (yyval.p_arg_list), (yyvsp[0].p_token_list) );
    }
#line 6940 "parser.c"
    break;

  case 115: /* p_arg_list: p_arg_tokens  */
#line 2880 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
      slist_push_back( (yyval.p_arg_list), (yyvsp[0].p_token_list) );
    }
#line 6950 "parser.c"
    break;

  case 116: /* p_arg_tokens: p_arg_tokens p_arg_token_as_list  */
#line 2889 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_list_back( (yyval.p_token_list), (yyvsp[0].p_token_list) );
    }
#line 6959 "parser.c"
    break;

  case 118: /* p_arg_token_as_list: p_arg_token  */
#line 2898 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6969 "parser.c"
    break;

  case 119: /* p_arg_token_as_list: '(' p_arg_tokens_with_comma_opt ')'  */
#line 2904 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_front( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[-2]), "(" ) );
      slist_push_back ( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" ) );
    }
#line 6979 "parser.c"
    break;

  case 120: /* p_arg_token: Y_CHAR_LIT  */
#line 2913 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_CHAR_LIT, &(yylsp[0]), (yyvsp[0].str_val) );
    }
#line 6987 "parser.c"
    break;

  case 121: /* p_arg_token: Y_NAME  */
#line 2917 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_IDENTIFIER, &(yylsp[0]), (yyvsp[0].name) );
    }
#line 6995 "parser.c"
    break;

  case 122: /* p_arg_token: p_num_lit  */
#line 2921 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_NUM_LIT, &(yylsp[0]), check_strdup( yytext ) );
    }
#line 7003 "parser.c"
    break;

  case 123: /* p_arg_token: Y_PRE_SPACE  */
#line 2925 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_SPACE, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7011 "parser.c"
    break;

  case 124: /* p_arg_token: Y_STR_LIT  */
#line 2929 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_STR_LIT, &(yylsp[0]), (yyvsp[0].str_val) );
    }
#line 7019 "parser.c"
    break;

  case 125: /* p_arg_token: p_other  */
#line 2933 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_OTHER, &(yylsp[0]), yytext );
    }
#line 7027 "parser.c"
    break;

  case 126: /* p_arg_token: p_punctuator  */
#line 2937 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), yytext );
    }
#line 7035 "parser.c"
    break;

  case 180: /* p_arg_tokens_with_comma_opt: %empty  */
#line 3009 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
    }
#line 7044 "parser.c"
    break;

  case 182: /* p_arg_tokens_with_comma: p_arg_tokens_with_comma p_arg_token_with_comma_as_list  */
#line 3029 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_list_back( (yyval.p_token_list), (yyvsp[0].p_token_list) );
    }
#line 7053 "parser.c"
    break;

  case 184: /* p_arg_token_with_comma_as_list: p_arg_token_with_comma  */
#line 3038 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7063 "parser.c"
    break;

  case 185: /* p_arg_token_with_comma_as_list: '(' p_arg_tokens_with_comma_opt ')'  */
#line 3044 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_front( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[-2]), "(" ) );
      slist_push_back ( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" ) );
    }
#line 7073 "parser.c"
    break;

  case 187: /* p_arg_token_with_comma: ','  */
#line 3054 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "," );
    }
#line 7081 "parser.c"
    break;

  case 198: /* explain_command: explain pc99_pointer_decl_list_c  */
#line 3121 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[0].ast_list) ) );
      c_ast_list_english( &(yyvsp[0].ast_list), stdout );
    }
#line 7090 "parser.c"
    break;

  case 200: /* $@2: %empty  */
#line 3139 "parser.y"
                       { in_attr.is_typename = true; }
#line 7096 "parser.c"
    break;

  case 203: /* explain_command: explain extern_linkage_c_stid_opt using_decl_c_ast  */
#line 3160 "parser.y"
    {
      DUMP_START( "explain_command",
                  "EXPLAIN extern_linkage_c_stid_opt using_decl_c_ast" );
      DUMP_TID( "extern_linkage_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_AST( "using_decl_c_ast", (yyvsp[0].ast) );

      PARSE_ASSERT(
        c_type_add_tid( &(yyvsp[0].ast)->type, (yyvsp[-1].tid), &(yylsp[-1]) )
      );

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast) ) );
      c_ast_english( (yyvsp[0].ast), C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7118 "parser.c"
    break;

  case 204: /* explain_command: explain sname_c  */
#line 3183 "parser.y"
    {
      print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].sname) );
      c_sname_cleanup( &(yyvsp[0].sname) );
      PARSE_ABORT();
    }
#line 7128 "parser.c"
    break;

  case 205: /* explain_command: explain error  */
#line 3190 "parser.y"
    {
      elaborate_error( "cast or declaration expected" );
    }
#line 7136 "parser.c"
    break;

  case 206: /* explain: Y_explain  */
#line 3197 "parser.y"
    { //
      // Set our mode to deciphering gibberish into English and specifically
      // tell the lexer to return cdecl keywords (e.g., "func") as ordinary
      // names, otherwise gibberish like:
      //
      //      int func(void);
      //
      // would result in a parser error.
      //
      gibberish_to_english();
    }
#line 7152 "parser.c"
    break;

  case 207: /* $@3: %empty  */
#line 3214 "parser.y"
    { //
      // We want cdecl commands (like "declare", etc.), other cdecl keywords
      // (like "cast", "commands", "english", "options", etc.), and C/C++
      // keywords (like "const", "static", "typedef", etc.) all to be returned
      // as just strings so we don't have to enumerate all the possible tokens
      // in the grammar.
      //
      lexer_find &= ~(LEXER_FIND_C_KEYWORDS | LEXER_FIND_CDECL_KEYWORDS);
    }
#line 7166 "parser.c"
    break;

  case 208: /* help_command: '?' $@3 help_what_opt  */
#line 3224 "parser.y"
    {
      bool const ok = print_help( (yyvsp[0].name), &(yylsp[0]) );
      free( (yyvsp[0].name) );
      PARSE_ASSERT( ok );
    }
#line 7176 "parser.c"
    break;

  case 209: /* help_what_opt: %empty  */
#line 3232 "parser.y"
                                  { (yyval.name) = NULL; }
#line 7182 "parser.c"
    break;

  case 211: /* help_what_opt: '#' Y_NAME  */
#line 3234 "parser.y"
                                  { (yyval.name) = str_realloc_pcat( "#", "", (yyvsp[0].name) ); }
#line 7188 "parser.c"
    break;

  case 212: /* help_what_opt: '#' error  */
#line 3236 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "\"#define\", \"#include\", or \"#undef\" expected" );
    }
#line 7197 "parser.c"
    break;

  case 213: /* help_what_opt: error  */
#line 3241 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error(
        "<command>, \"commands\", \"english\", or \"options\" expected"
      );
    }
#line 7208 "parser.c"
    break;

  case 217: /* preprocessor_command: '#' Y_PRE_elif  */
#line 3258 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elif\"" );
    }
#line 7216 "parser.c"
    break;

  case 218: /* preprocessor_command: '#' Y_PRE_elifdef  */
#line 3262 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elifdef\"" );
    }
#line 7224 "parser.c"
    break;

  case 219: /* preprocessor_command: '#' Y_PRE_elifndef  */
#line 3266 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elifdef\"" );
    }
#line 7232 "parser.c"
    break;

  case 220: /* preprocessor_command: '#' Y_PRE_else  */
#line 3270 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#else\"" );
    }
#line 7240 "parser.c"
    break;

  case 221: /* preprocessor_command: '#' Y_PRE_embed  */
#line 3274 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#embed\"" );
    }
#line 7248 "parser.c"
    break;

  case 222: /* preprocessor_command: '#' Y_PRE_error  */
#line 3278 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#error\"" );
    }
#line 7256 "parser.c"
    break;

  case 223: /* preprocessor_command: '#' Y_PRE_if  */
#line 3282 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#if\"" );
    }
#line 7264 "parser.c"
    break;

  case 224: /* preprocessor_command: '#' Y_PRE_ifdef  */
#line 3286 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#ifdef\"" );
    }
#line 7272 "parser.c"
    break;

  case 225: /* preprocessor_command: '#' Y_PRE_ifndef  */
#line 3290 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#ifndef\"" );
    }
#line 7280 "parser.c"
    break;

  case 226: /* preprocessor_command: '#' Y_PRE_line  */
#line 3294 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#line\"" );
    }
#line 7288 "parser.c"
    break;

  case 227: /* preprocessor_command: '#' Y_PRE_pragma  */
#line 3298 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#pragma\"" );
    }
#line 7296 "parser.c"
    break;

  case 228: /* preprocessor_command: '#' Y_PRE_warning  */
#line 3302 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#warning\"" );
    }
#line 7304 "parser.c"
    break;

  case 229: /* preprocessor_command: '#' error  */
#line 3306 "parser.y"
    {
      elaborate_error( "\"#define\", \"#include\", or \"#undef\" expected" );
    }
#line 7312 "parser.c"
    break;

  case 230: /* p_define: Y_PRE_define name_exp p_paren_param_list_opt p_replace_list_opt  */
#line 3314 "parser.y"
    {
      DUMP_START( "p_define",
                  "#define NAME p_paren_param_list_opt p_replace_list_opt" );
      DUMP_STR( "name", (yyvsp[-2].name) );
      DUMP_MACRO_PARAM_LIST( "p_paren_param_list_opt", (yyvsp[-1].p_param_list) );
      DUMP_MACRO_TOKEN_LIST( "p_replace_list_opt", (yyvsp[0].p_token_list) );

      c_typedef_t const *const tdef = c_typedef_find_name( (yyvsp[-2].name) );
      if ( tdef != NULL ) {
        if ( tdef->is_predefined ) {
          print_warning( &(yylsp[-2]),
            "\"%s\" is a predefined type since %s\n",
            (yyvsp[-2].name),
            c_lang_name( c_lang_oldest( tdef->lang_ids ) )
          );
        }
        else {
          print_warning( &(yylsp[-2]),
            "\"%s\" previously defined as type (\"",
            (yyvsp[-2].name)
          );
          print_type_decl( tdef, tdef->decl_flags, stderr );
          EPUTS( "\")\n" );
        }
      }

      p_macro_t *const macro =
        p_macro_define( (yyvsp[-2].name), &(yylsp[-2]), (yyvsp[-1].p_param_list), (yyvsp[0].p_token_list) );
      p_param_list_cleanup( (yyvsp[-1].p_param_list) );
      free( (yyvsp[-1].p_param_list) );
      p_token_list_cleanup( (yyvsp[0].p_token_list) );
      free( (yyvsp[0].p_token_list) );
      PARSE_ASSERT( macro != NULL );

      DUMP_MACRO( "macro", macro );
      DUMP_END();
    }
#line 7354 "parser.c"
    break;

  case 231: /* p_paren_param_list_opt: %empty  */
#line 3353 "parser.y"
                                  { (yyval.p_param_list) = NULL; }
#line 7360 "parser.c"
    break;

  case 232: /* p_paren_param_list_opt: '(' p_param_list_opt ')'  */
#line 3354 "parser.y"
                                  { (yyval.p_param_list) = (yyvsp[-1].p_param_list); }
#line 7366 "parser.c"
    break;

  case 233: /* p_param_list_opt: %empty  */
#line 3358 "parser.y"
    { //
      // Use an empty list to distinguish a macro with an empty parameter list
      // from one with no parameter list.
      //
      //      #define M   X       // no parameter list: use NULL
      //      #define F() #X      // empty parameter list: use empty list
      //
      (yyval.p_param_list) = MALLOC( p_param_list_t, 1 );
      slist_init( (yyval.p_param_list) );
    }
#line 7381 "parser.c"
    break;

  case 235: /* p_param_list: p_param_list comma_exp p_param  */
#line 3373 "parser.y"
    {
      DUMP_START( "p_param_list", "p_param" );
      DUMP_MACRO_PARAM_LIST( "p_param_list", (yyvsp[-2].p_param_list) );
      DUMP_STR( "p_param", (yyvsp[0].p_param)->name );

      (yyval.p_param_list) = (yyvsp[-2].p_param_list);
      slist_push_back( (yyval.p_param_list), (yyvsp[0].p_param) );

      DUMP_MACRO_PARAM_LIST( "$$_list", (yyval.p_param_list) );
      DUMP_END();
    }
#line 7397 "parser.c"
    break;

  case 236: /* p_param_list: p_param  */
#line 3386 "parser.y"
    {
      DUMP_START( "p_param_list", "p_param" );
      DUMP_STR( "p_param", (yyvsp[0].p_param)->name );

      (yyval.p_param_list) = MALLOC( p_param_list_t, 1 );
      slist_init( (yyval.p_param_list) );
      slist_push_back( (yyval.p_param_list), (yyvsp[0].p_param) );

      DUMP_MACRO_PARAM_LIST( "$$_list", (yyval.p_param_list) );
      DUMP_END();
    }
#line 7413 "parser.c"
    break;

  case 237: /* p_param: Y_NAME  */
#line 3401 "parser.y"
    {
      (yyval.p_param) = MALLOC( p_param_t, 1 );
      *(yyval.p_param) = (p_param_t){ .name = (yyvsp[0].name), .loc = (yylsp[0]) };
    }
#line 7422 "parser.c"
    break;

  case 238: /* p_param: "..."  */
#line 3406 "parser.y"
    {
      (yyval.p_param) = MALLOC( p_param_t, 1 );
      *(yyval.p_param) = (p_param_t){ .name = check_strdup( L_ELLIPSIS ), .loc = (yylsp[0]) };
    }
#line 7431 "parser.c"
    break;

  case 239: /* p_param: error  */
#line 3411 "parser.y"
    {
      (yyval.p_param) = NULL;
      if ( OPT_LANG_IS( VARIADIC_MACROS ) )
        elaborate_error( "parameter name or \"...\" expected" );
      else
        elaborate_error( "parameter name expected" );
    }
#line 7443 "parser.c"
    break;

  case 240: /* p_replace_list_opt: %empty  */
#line 3421 "parser.y"
                                  { (yyval.p_token_list) = NULL; }
#line 7449 "parser.c"
    break;

  case 242: /* p_replace_list: p_replace_list p_replace_token  */
#line 3427 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7458 "parser.c"
    break;

  case 243: /* p_replace_list: p_replace_token  */
#line 3433 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7468 "parser.c"
    break;

  case 244: /* p_replace_token: p_arg_token  */
#line 3442 "parser.y"
    {
      if ( p_token_is_punct( (yyvsp[0].p_token), '#' ) ) {
        //
        // A '#' macro argument token is an ordinary '#', but as a replacement
        // token, retroactively make it P_STRINGIFY.
        //
        (yyvsp[0].p_token)->kind = P_STRINGIFY;
      }
      (yyval.p_token) = (yyvsp[0].p_token);
    }
#line 7483 "parser.c"
    break;

  case 245: /* p_replace_token: '('  */
#line 3453 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "(" );
    }
#line 7491 "parser.c"
    break;

  case 246: /* p_replace_token: ')'  */
#line 3457 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" );
    }
#line 7499 "parser.c"
    break;

  case 247: /* p_replace_token: ','  */
#line 3461 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "," );
    }
#line 7507 "parser.c"
    break;

  case 248: /* p_replace_token: "##"  */
#line 3465 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_CONCAT, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7515 "parser.c"
    break;

  case 249: /* p_replace_token: Y_PRE___VA_ARGS__  */
#line 3469 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P___VA_ARGS__, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7523 "parser.c"
    break;

  case 250: /* p_replace_token: Y_PRE___VA_OPT__  */
#line 3473 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P___VA_OPT__, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7531 "parser.c"
    break;

  case 251: /* p_undef: Y_PRE_undef name_exp  */
#line 3480 "parser.y"
    {
      PARSE_ASSERT( p_macro_undef( (yyvsp[0].name), &(yylsp[0]) ) );
    }
#line 7539 "parser.c"
    break;

  case 252: /* quit_command: Y_quit  */
#line 3488 "parser.y"
                                  { cdecl_quit(); }
#line 7545 "parser.c"
    break;

  case 254: /* set_command: Y_set  */
#line 3501 "parser.y"
    {
      PARSE_ASSERT( set_option( NULL, NULL, NULL, NULL ) );
    }
#line 7553 "parser.c"
    break;

  case 258: /* set_option: Y_SET_OPTION set_option_value_opt  */
#line 3514 "parser.y"
    {
      bool const ok = set_option( (yyvsp[-1].name), &(yylsp[-1]), (yyvsp[0].str_val), &(yylsp[0]) );
      free( (yyvsp[-1].name) );
      free( (yyvsp[0].str_val) );
      PARSE_ASSERT( ok );
    }
#line 7564 "parser.c"
    break;

  case 259: /* set_option_value_opt: %empty  */
#line 3523 "parser.y"
                                  { (yyval.str_val) = NULL; }
#line 7570 "parser.c"
    break;

  case 260: /* set_option_value_opt: '=' Y_SET_OPTION  */
#line 3524 "parser.y"
                                  { (yyval.str_val) = (yyvsp[0].name); (yyloc) = (yylsp[0]); }
#line 7576 "parser.c"
    break;

  case 261: /* set_option_value_opt: '=' error  */
#line 3526 "parser.y"
    {
      (yyval.str_val) = NULL;
      elaborate_error( "option value expected" );
    }
#line 7585 "parser.c"
    break;

  case 262: /* show_command: Y_show any_typedef_tdef show_format_opt  */
#line 3536 "parser.y"
    {
      DUMP_START( "show_command", "SHOW any_typedef_tdef show_format_opt" );
      DUMP_AST( "any_typedef__ast", (yyvsp[-1].tdef)->ast );
      DUMP_INT( "show_format_opt", (yyvsp[0].flags) );
      DUMP_END();

      show_type( (yyvsp[-1].tdef), (yyvsp[0].flags), stdout );
    }
#line 7598 "parser.c"
    break;

  case 263: /* show_command: Y_show any_typedef_tdef Y_as show_format_exp  */
#line 3546 "parser.y"
    {
      DUMP_START( "show_command", "SHOW any_typedef_tdef AS show_format_exp" );
      DUMP_AST( "any_typedef__ast", (yyvsp[-2].tdef)->ast );
      DUMP_INT( "show_format_exp", (yyvsp[0].flags) );
      DUMP_END();

      show_type( (yyvsp[-2].tdef), (yyvsp[0].flags), stdout );
    }
#line 7611 "parser.c"
    break;

  case 264: /* show_command: Y_show show_types_opt glob_opt show_format_opt  */
#line 3556 "parser.y"
    {
      bool const showed_any = show_types( (yyvsp[-2].show), (yyvsp[-1].name), (yyvsp[0].flags), stdout );
      if ( (yyvsp[-1].name) != NULL && !showed_any ) {
        print_error( &(yylsp[-1]), "\"%s\": no such type or macro defined", (yyvsp[-1].name) );
        print_suggestions( DYM_C_MACROS | DYM_C_TYPES, (yyvsp[-1].name) );
        EPUTC( '\n' );
      }
      free( (yyvsp[-1].name) );
      PARSE_ASSERT( showed_any );
    }
#line 7626 "parser.c"
    break;

  case 265: /* show_command: Y_show show_types_opt glob_opt Y_as show_format_exp  */
#line 3568 "parser.y"
    {
      bool const showed_any = show_types( (yyvsp[-3].show), (yyvsp[-2].name), (yyvsp[0].flags), stdout );
      if ( !showed_any ) {
        print_error( &(yylsp[-2]), "\"%s\": no such type or macro defined", (yyvsp[-2].name) );
        print_suggestions( DYM_C_MACROS | DYM_C_TYPES, (yyvsp[-2].name) );
        EPUTC( '\n' );
      }
      free( (yyvsp[-2].name) );
      PARSE_ASSERT( showed_any );
    }
#line 7641 "parser.c"
    break;

  case 266: /* show_command: Y_show show_types_opt Y_macros  */
#line 3580 "parser.y"
    {
      show_macros( (yyvsp[-1].show), stdout );
    }
#line 7649 "parser.c"
    break;

  case 267: /* show_command: Y_show Y_NAME  */
#line 3585 "parser.y"
    {
      bool ok = false;

      //
      // Check to see if $name is a macro here rather than in the lexer since
      // this is the only place in the cdecl grammar where a name can be a
      // macro since cdecl doesn't support using macros everywhere.
      //
      p_macro_t const *const macro = p_macro_find( (yyvsp[0].name) );
      if ( macro == NULL ) {
        print_error( &(yylsp[0]), "\"%s\": no such type or macro defined", (yyvsp[0].name) );
        print_suggestions( DYM_C_MACROS | DYM_C_TYPES, (yyvsp[0].name) );
        EPUTC( '\n' );
      }
      else if ( !(ok = show_macro( macro, stdout )) ) {
        c_lang_id_t const lang_ids = (*macro->dyn_fn)( /*ptoken=*/NULL );
        print_error( &(yylsp[0]),
          "\"%s\" not supported%s\n",
          (yyvsp[0].name), c_lang_which( lang_ids )
        );
      }

      free( (yyvsp[0].name) );
      if ( !ok )
        PARSE_ABORT();
    }
#line 7680 "parser.c"
    break;

  case 268: /* show_command: Y_show error  */
#line 3613 "parser.y"
    {
      elaborate_error(
        "type or macro name, or \"all\", \"predefined\", or \"user\" expected"
      );
    }
#line 7690 "parser.c"
    break;

  case 269: /* show_format: Y_english  */
#line 3621 "parser.y"
                                  { (yyval.flags) = C_ENG_DECL; }
#line 7696 "parser.c"
    break;

  case 270: /* show_format: Y_typedef  */
#line 3622 "parser.y"
                                  { (yyval.flags) = C_GIB_TYPEDEF; }
#line 7702 "parser.c"
    break;

  case 271: /* show_format: Y_using  */
#line 3624 "parser.y"
    {
      if ( !OPT_LANG_IS( using_DECLS ) ) {
        print_error( &(yylsp[0]),
          "\"using\" not supported%s\n",
          C_LANG_WHICH( using_DECLS )
        );
        PARSE_ABORT();
      }
      (yyval.flags) = C_GIB_USING;
    }
#line 7717 "parser.c"
    break;

  case 273: /* show_format_exp: error  */
#line 3639 "parser.y"
    {
      if ( OPT_LANG_IS( using_DECLS ) )
        elaborate_error( "\"english\", \"typedef\", or \"using\" expected" );
      else
        elaborate_error( "\"english\" or \"typedef\" expected" );
    }
#line 7728 "parser.c"
    break;

  case 274: /* show_format_opt: %empty  */
#line 3648 "parser.y"
                                  { (yyval.flags) = 0/*as declared*/; }
#line 7734 "parser.c"
    break;

  case 276: /* show_types_opt: %empty  */
#line 3653 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7740 "parser.c"
    break;

  case 277: /* show_types_opt: Y_all predefined_or_user_types_opt  */
#line 3655 "parser.y"
    {
      (yyval.show) = (yyvsp[0].show) | CDECL_SHOW_OPT_IGNORE_LANG;
    }
#line 7748 "parser.c"
    break;

  case 278: /* show_types_opt: Y_predefined  */
#line 3658 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_PREDEFINED; }
#line 7754 "parser.c"
    break;

  case 279: /* show_types_opt: Y_user  */
#line 3659 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7760 "parser.c"
    break;

  case 280: /* predefined_or_user_types_opt: %empty  */
#line 3664 "parser.y"
    {
      (yyval.show) = CDECL_SHOW_PREDEFINED | CDECL_SHOW_USER_DEFINED;
    }
#line 7768 "parser.c"
    break;

  case 281: /* predefined_or_user_types_opt: Y_predefined  */
#line 3667 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_PREDEFINED; }
#line 7774 "parser.c"
    break;

  case 282: /* predefined_or_user_types_opt: Y_user  */
#line 3668 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7780 "parser.c"
    break;

  case 286: /* $@4: %empty  */
#line 3697 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 7788 "parser.c"
    break;

  case 287: /* c_style_cast_expr_c: '(' type_c_ast $@4 cast_c_astp_opt rparen_exp sname_c_opt  */
#line 3701 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "explain_command",
                  "EXPLAIN '(' type_c_ast cast_c_astp_opt ')' sname_c_opt" );
      DUMP_AST( "type_c_ast", (yyvsp[-4].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-2].ast_pair) );
      DUMP_SNAME( "sname_c_opt", (yyvsp[0].sname) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[0].sname) );
      cast_ast->cast.kind = C_CAST_C;
      cast_ast->cast.to_ast =
        c_ast_patch_placeholder( (yyvsp[-4].ast), (yyvsp[-2].ast_pair).ast );

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_english( cast_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7815 "parser.c"
    break;

  case 288: /* c_style_cast_expr_c: '(' pc99_pointer_decl_list_c rparen_exp  */
#line 3734 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[-1].ast_list) ) );
      c_ast_list_english( &(yyvsp[-1].ast_list), stdout );
    }
#line 7824 "parser.c"
    break;

  case 289: /* $@5: %empty  */
#line 3744 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 7832 "parser.c"
    break;

  case 290: /* new_style_cast_expr_c: new_style_cast_c lt_exp type_c_ast $@5 cast_c_astp_opt gt_exp lparen_exp sname_c_exp rparen_exp  */
#line 3748 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "explain_command",
                  "EXPLAIN new_style_cast_c"
                  "'<' type_c_ast cast_c_astp_opt '>' '(' sname ')'" );
      DUMP_STR( "new_style_cast_c", c_cast_english( (yyvsp[-8].cast_kind) ) );
      DUMP_AST( "type_c_ast", (yyvsp[-6].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-4].ast_pair) );
      DUMP_SNAME( "sname_c_exp", (yyvsp[-1].sname) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-1].sname) );
      cast_ast->cast.kind = (yyvsp[-8].cast_kind);
      cast_ast->cast.to_ast =
        c_ast_patch_placeholder( (yyvsp[-6].ast), (yyvsp[-4].ast_pair).ast );

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_english( cast_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7861 "parser.c"
    break;

  case 291: /* new_style_cast_c: Y_const_cast  */
#line 3775 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_CONST;        }
#line 7867 "parser.c"
    break;

  case 292: /* new_style_cast_c: Y_dynamic_cast  */
#line 3776 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_DYNAMIC;      }
#line 7873 "parser.c"
    break;

  case 293: /* new_style_cast_c: Y_reinterpret_cast  */
#line 3777 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_REINTERPRET;  }
#line 7879 "parser.c"
    break;

  case 294: /* new_style_cast_c: Y_static_cast  */
#line 3778 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_STATIC;       }
#line 7885 "parser.c"
    break;

  case 295: /* $@6: %empty  */
#line 3788 "parser.y"
                                  { in_attr.align = (yyvsp[0].align); }
#line 7891 "parser.c"
    break;

  case 296: /* $@7: %empty  */
#line 3789 "parser.y"
                                  { in_attr.is_typename = (yyvsp[0].flag); }
#line 7897 "parser.c"
    break;

  case 298: /* alignas_specifier_c: alignas lparen_exp uint_lit rparen_exp  */
#line 3795 "parser.y"
    {
      DUMP_START( "alignas_specifier_c", "ALIGNAS '(' uint_lit ')'" );
      DUMP_INT( "uint_lit", (yyvsp[-1].uint_val) );

      (yyval.align).kind = C_ALIGNAS_BYTES;
      (yyval.align).loc = (yyloc);
      (yyval.align).bytes = (yyvsp[-1].uint_val);

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7913 "parser.c"
    break;

  case 299: /* alignas_specifier_c: alignas lparen_exp sname_c rparen_exp  */
#line 3808 "parser.y"
    {
      DUMP_START( "alignas_specifier_c", "ALIGNAS '(' sname_c ')'" );
      DUMP_SNAME( "sname", (yyvsp[-1].sname) );

      (yyval.align).kind = C_ALIGNAS_SNAME;
      (yyval.align).loc = (yyloc);
      (yyval.align).sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7929 "parser.c"
    break;

  case 300: /* $@8: %empty  */
#line 3820 "parser.y"
                                            { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 7935 "parser.c"
    break;

  case 301: /* alignas_specifier_c: alignas lparen_exp type_c_ast $@8 cast_c_astp_opt rparen_exp  */
#line 3822 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "alignas_specifier_c",
                  "ALIGNAS '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.align).kind = C_ALIGNAS_TYPE;
      (yyval.align).loc = (yyloc);
      (yyval.align).type_ast = c_ast_patch_placeholder( (yyvsp[-3].ast), (yyvsp[-1].ast_pair).ast );

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7955 "parser.c"
    break;

  case 302: /* alignas_specifier_c: alignas lparen_exp error ')'  */
#line 3839 "parser.y"
    {
      elaborate_error( "integer or type expected" );
    }
#line 7963 "parser.c"
    break;

  case 305: /* asm_declaration_c: Y_asm lparen_exp str_lit_exp rparen_exp  */
#line 3853 "parser.y"
    {
      free( (yyvsp[-1].str_val) );
      UNSUPPORTED( &(yylsp[-3]), "asm declarations" );
    }
#line 7972 "parser.c"
    break;

  case 309: /* $@9: %empty  */
#line 3872 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[0]) ) );
      gibberish_to_english();           // see the comment in "explain"
    }
#line 7981 "parser.c"
    break;

  case 310: /* $@10: %empty  */
#line 3877 "parser.y"
    {
      c_type_t const *const cur_type =
        c_sname_local_type( &in_attr.scope_sname );
      if ( c_tid_is_any( cur_type->btids, TB_ANY_CLASS ) ) {
        char const *const cur_name = c_sname_local_name( &in_attr.scope_sname );
        char const *const mbr_name = c_sname_local_name( &(yyvsp[0].sname) );
        if ( strcmp( mbr_name, cur_name ) == 0 ) {
          print_error( &(yylsp[0]),
            "\"%s\": member has the same name as its enclosing %s\n",
            mbr_name, c_type_gibberish( cur_type )
          );
          c_sname_cleanup( &(yyvsp[0].sname) );
          PARSE_ABORT();
        }
      }

      DUMP_START( "class_struct_union_declaration_c",
                  "class_struct_union_btid any_sname_c_exp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      c_sname_append_sname( &in_attr.scope_sname, &(yyvsp[0].sname) );

      c_sname_local_data( &in_attr.scope_sname )->type =
        C_TYPE_LIT_B( (yyvsp[-2].tid) );
      c_sname_set_all_types( &in_attr.scope_sname );

      c_sname_t csu_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_sname( &csu_sname, &(yyvsp[0].sname) );

      c_ast_t *const csu_ast = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yylsp[0]) );
      csu_ast->sname = csu_sname;
      csu_ast->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      c_sname_init_name(
        &csu_ast->csu.csu_sname,
        check_strdup( c_sname_local_name( &csu_ast->sname ) )
      );

      DUMP_AST( "$$_ast", csu_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( csu_ast, C_GIB_TYPEDEF ) );
    }
#line 8030 "parser.c"
    break;

  case 312: /* $@11: %empty  */
#line 3929 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[0]) ) );
      gibberish_to_english();           // see the comment in "explain"
    }
#line 8039 "parser.c"
    break;

  case 313: /* enum_declaration_c: enum_btids $@11 any_sname_c_exp enum_fixed_type_c_ast_opt  */
#line 3934 "parser.y"
    {
      DUMP_START( "enum_declaration_c",
                  "enum_btids any_sname_c_exp enum_fixed_type_c_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-3].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_c_ast_opt", (yyvsp[0].ast) );

      c_sname_t enum_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_sname( &enum_sname, &(yyvsp[-1].sname) );

      c_sname_local_data( &enum_sname )->type = C_TYPE_LIT_B( (yyvsp[-3].tid) );
      c_sname_set_all_types( &enum_sname );

      c_ast_t *const enum_ast = c_ast_new_gc( K_ENUM, &(yylsp[-1]) );
      enum_ast->sname = enum_sname;
      enum_ast->type.btids = c_tid_check( (yyvsp[-3].tid), C_TPID_BASE );
      c_ast_set_parent( (yyvsp[0].ast), enum_ast );
      c_sname_init_name(
        &enum_ast->enum_.enum_sname,
        check_strdup( c_sname_local_name( &enum_ast->sname ) )
      );

      DUMP_AST( "$$_ast", enum_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( enum_ast, C_GIB_TYPEDEF ) );
    }
#line 8071 "parser.c"
    break;

  case 314: /* $@12: %empty  */
#line 3968 "parser.y"
    {
      gibberish_to_english();           // see the comment in "explain"
    }
#line 8079 "parser.c"
    break;

  case 315: /* $@13: %empty  */
#line 3972 "parser.y"
    {
      DUMP_START( "namespace_declaration_c",
                  "namespace_type namespace_sname_c_exp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_TYPE( "namespace_type", (yyvsp[-2].type) );
      DUMP_SNAME( "namespace_sname_c_exp", (yyvsp[0].sname) );

      //
      // Nested namespace declarations are supported only in C++17 and later.
      // (However, we always allow them in configuration files.)
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the AST has no "memory" of how a namespace was
      // constructed.
      //
      if ( c_sname_count( &(yyvsp[0].sname) ) > 1 && !OPT_LANG_IS( NESTED_namespace ) ) {
        print_error( &(yylsp[0]),
          "nested namespace declarations not supported%s\n",
          C_LANG_WHICH( NESTED_namespace )
        );
        c_sname_cleanup( &(yyvsp[0].sname) );
        PARSE_ABORT();
      }

      //
      // The namespace type (plain namespace or inline namespace) has to be
      // split across the namespace sname: only the storage classes (for
      // TS_inline) has to be or'd with the first scope-type of the sname ...
      //
      c_type_t *const sname_global_type = &c_sname_global_data( &(yyvsp[0].sname) )->type;
      *sname_global_type =
        C_TYPE_LIT(
          sname_global_type->btids,
          sname_global_type->stids | (yyvsp[-2].type).stids,
          sname_global_type->atids
        );
      //
      // ... and only the base types (for TB_namespace) has to be or'd with the
      // local scope type of the sname.
      //
      c_type_t *const sname_local_type = &c_sname_local_data( &(yyvsp[0].sname) )->type;
      *sname_local_type =
        C_TYPE_LIT(
          sname_local_type->btids | (yyvsp[-2].type).btids,
          sname_local_type->stids,
          sname_local_type->atids
        );

      c_sname_append_sname( &in_attr.scope_sname, &(yyvsp[0].sname) );
      c_sname_set_all_types( &in_attr.scope_sname );

      DUMP_SNAME( "$$_sname", (yyvsp[0].sname) );
      DUMP_END();

      //
      // These checks are better to do now in the parser rather than later in
      // the AST because they give a better error location.
      //
      if ( c_sname_is_inline_nested_namespace( &in_attr.scope_sname ) ) {
        print_error( &(yylsp[0]),
          "nested namespace can not be %s\n",
          c_tid_error( TS_inline )
        );
        PARSE_ABORT();
      }
      PARSE_ASSERT( c_sname_check( &in_attr.scope_sname, &(yylsp[0]) ) );
    }
#line 8151 "parser.c"
    break;

  case 319: /* namespace_sname_c_exp: error  */
#line 4046 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 8160 "parser.c"
    break;

  case 320: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON Y_NAME  */
#line 4059 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "sname_c '::' NAME" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-2].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_namespace );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8177 "parser.c"
    break;

  case 321: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON any_typedef_tdef  */
#line 4073 "parser.y"
    {
      DUMP_START( "namespace_sname_c",
                  "namespace_sname_c '::' any_typedef_tdef" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_namespace );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8196 "parser.c"
    break;

  case 322: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON Y_inline name_exp  */
#line 4089 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "sname_c '::' NAME INLINE NAME" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-3].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-3].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_local_data( &(yyval.sname) )->type =
        C_TYPE_LIT( TB_namespace, (yyvsp[-1].tid), TA_NONE );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8214 "parser.c"
    break;

  case 323: /* namespace_sname_c: Y_NAME  */
#line 4104 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      c_sname_init_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_namespace );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8229 "parser.c"
    break;

  case 324: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON sname_c  */
#line 4123 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' sname_c" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_append_sname( &(yyval.sname), &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8246 "parser.c"
    break;

  case 325: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON any_typedef_tdef  */
#line 4137 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' any_typedef_tdef" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_local_data( &(yyval.sname) )->type =
        *c_sname_local_type( &(yyvsp[0].tdef)->ast->sname );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8266 "parser.c"
    break;

  case 326: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON Y_inline name_exp  */
#line 4155 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' INLINE NAME" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-3].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-3].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_local_data( &(yyval.sname) )->type =
        C_TYPE_LIT( TB_namespace, (yyvsp[-1].tid), TA_NONE );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8285 "parser.c"
    break;

  case 327: /* namespace_typedef_sname_c: any_typedef_tdef  */
#line 4170 "parser.y"
                                  { (yyval.sname) = c_sname_dup( &(yyvsp[0].tdef)->ast->sname ); }
#line 8291 "parser.c"
    break;

  case 329: /* brace_in_scope_declaration_c_exp: error  */
#line 4176 "parser.y"
    {
      punct_expected( '{' );
    }
#line 8299 "parser.c"
    break;

  case 337: /* in_scope_declaration_c_exp: error  */
#line 4196 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 8307 "parser.c"
    break;

  case 338: /* lambda_declaration_c: '[' capture_decl_list_c_opt ']' paren_param_c_ast_list_opt storage_class_subset_english_type_opt lambda_return_type_c_ast_opt  */
#line 4208 "parser.y"
    {
      DUMP_START( "lambda_declaration_c",
                  "'[' capture_decl_list_c_opt ']' "
                  "paren_param_c_ast_list_opt "
                  "lambda_return_type_c_ast_opt" );
      DUMP_AST_LIST( "capture_decl_list_c_opt", (yyvsp[-4].ast_list) );
      DUMP_AST_LIST( "paren_param_c_ast_list_opt", (yyvsp[-2].ast_list) );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "lambda_return_type_c_ast_opt", (yyvsp[0].ast) );

      c_ast_t *const lambda_ast = c_ast_new_gc( K_LAMBDA, &(yyloc) );
      lambda_ast->type = (yyvsp[-1].type);
      c_ast_list_set_param_of( &(yyvsp[-4].ast_list), lambda_ast );
      lambda_ast->lambda.capture_ast_list = slist_move( &(yyvsp[-4].ast_list) );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), lambda_ast );
      lambda_ast->lambda.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), lambda_ast );

      DUMP_AST( "$$_ast", lambda_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( lambda_ast ) );
      c_ast_english( lambda_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8337 "parser.c"
    break;

  case 339: /* capture_decl_list_c_opt: %empty  */
#line 4236 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 8343 "parser.c"
    break;

  case 341: /* capture_decl_list_c: capture_decl_list_c comma_exp capture_decl_c_ast  */
#line 4243 "parser.y"
    {
      DUMP_START( "capture_decl_list_c",
                  "capture_decl_list_c ',' "
                  "capture_decl_c_ast" );
      DUMP_AST_LIST( "capture_decl_list_c", (yyvsp[-2].ast_list) );
      DUMP_AST( "capture_decl_c_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 8361 "parser.c"
    break;

  case 342: /* capture_decl_list_c: capture_decl_c_ast  */
#line 4258 "parser.y"
    {
      DUMP_START( "capture_decl_list_c",
                  "capture_decl_c_ast" );
      DUMP_AST( "capture_decl_c_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 8377 "parser.c"
    break;

  case 343: /* capture_decl_c_ast: '&'  */
#line 4273 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 8386 "parser.c"
    break;

  case 344: /* capture_decl_c_ast: '&' Y_NAME  */
#line 4278 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_init_name( &(yyval.ast)->sname, (yyvsp[0].name) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 8396 "parser.c"
    break;

  case 345: /* capture_decl_c_ast: '='  */
#line 4284 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_COPY;
    }
#line 8405 "parser.c"
    break;

  case 346: /* capture_decl_c_ast: Y_NAME  */
#line 4289 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_init_name( &(yyval.ast)->sname, (yyvsp[0].name) );
    }
#line 8414 "parser.c"
    break;

  case 347: /* capture_decl_c_ast: Y_this  */
#line 4294 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_THIS;
    }
#line 8423 "parser.c"
    break;

  case 348: /* capture_decl_c_ast: '*' this_exp  */
#line 4299 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_STAR_THIS;
    }
#line 8432 "parser.c"
    break;

  case 349: /* lambda_return_type_c_ast_opt: %empty  */
#line 4306 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 8438 "parser.c"
    break;

  case 350: /* $@14: %empty  */
#line 4307 "parser.y"
                                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 8444 "parser.c"
    break;

  case 351: /* lambda_return_type_c_ast_opt: Y_MINUS_GREATER type_c_ast $@14 cast_c_astp_opt  */
#line 4309 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "lambda_return_type_c_ast_opt",
                  "'->' type_c_ast cast_c_astp_opt" );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = IF_ELSE_EXPR( (yyvsp[0].ast_pair).ast, (yyvsp[-2].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8462 "parser.c"
    break;

  case 352: /* template_declaration_c: Y_template  */
#line 4328 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "template declarations" );
    }
#line 8470 "parser.c"
    break;

  case 353: /* $@15: %empty  */
#line 4336 "parser.y"
                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 8476 "parser.c"
    break;

  case 354: /* typed_declaration_c: type_c_ast $@15 decl_list_c_opt  */
#line 4337 "parser.y"
    {
      ia_type_ast_pop();
    }
#line 8484 "parser.c"
    break;

  case 355: /* $@16: %empty  */
#line 4346 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[-1]) ) );
      in_attr.is_typename = (yyvsp[0].flag);
      gibberish_to_english();           // see the comment in "explain"
    }
#line 8494 "parser.c"
    break;

  case 356: /* $@17: %empty  */
#line 4352 "parser.y"
    {
      PARSE_ASSERT( !in_attr.is_typename || c_ast_is_typename_ok( (yyvsp[0].ast) ) );
      // see the comment in "define_command" about TS_typedef
      PARSE_ASSERT(
        c_type_add_tid( &(yyvsp[0].ast)->type, TS_typedef, &(yylsp[0]) )
      );
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 8507 "parser.c"
    break;

  case 357: /* typedef_declaration_c: Y_typedef typename_flag_opt $@16 type_c_ast $@17 typedef_decl_list_c  */
#line 4361 "parser.y"
    {
      ia_type_ast_pop();
    }
#line 8515 "parser.c"
    break;

  case 360: /* typedef_decl_c: decl_c_astp  */
#line 4374 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "typedef_decl_c", "decl_c_astp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      c_ast_t *const decl_ast = (yyvsp[0].ast_pair).ast;
      c_ast_t *typedef_ast;
      c_sname_t temp_sname;

      if ( decl_ast->kind == K_TYPEDEF && c_sname_empty( &decl_ast->sname ) ) {
        //
        // This is for either of the following cases:
        //
        //      typedef int int32_t;
        //      typedef int32_t int_least32_t;
        //
        // that is: any type name followed by an existing typedef name.
        //
        typedef_ast = type_ast;
        if ( c_sname_empty( &typedef_ast->sname ) )
          typedef_ast->sname = c_sname_dup( &decl_ast->tdef.for_ast->sname );
      }
      else {
        //
        // This is for either of the following cases:
        //
        //      typedef int foo;
        //      typedef int32_t foo;
        //
        // that is: any type name followed by a new name.
        //
        typedef_ast = c_ast_patch_placeholder( type_ast, decl_ast );
        temp_sname = c_ast_move_sname( decl_ast );
        c_sname_set( &typedef_ast->sname, &temp_sname );
      }

      PARSE_ASSERT( c_ast_check( typedef_ast ) );
      // see the comment in "define_command" about TS_typedef
      PJL_DISCARD_RV( c_ast_take_type_any( typedef_ast, &T_TS_typedef ) );

      if ( c_sname_count( &typedef_ast->sname ) > 1 ) {
        print_error( &(yylsp[0]),
          "typedef names can not be scoped; "
          "use: namespace %s { typedef ... }\n",
          c_sname_scope_gibberish( &typedef_ast->sname )
        );
        PARSE_ABORT();
      }

      temp_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_prepend_sname( &typedef_ast->sname, &temp_sname );

      DUMP_AST( "$$_ast", typedef_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( typedef_ast, C_GIB_TYPEDEF  ) );
    }
#line 8580 "parser.c"
    break;

  case 362: /* typedef_decl_c_exp: error  */
#line 4439 "parser.y"
    {
      elaborate_error( "type expected" );
    }
#line 8588 "parser.c"
    break;

  case 363: /* user_defined_conversion_declaration_c: user_defined_conversion_decl_c_astp  */
#line 4448 "parser.y"
    {
      DUMP_START( "user_defined_conversion_declaration_c",
                  "user_defined_conversion_decl_c_astp" );
      DUMP_AST_PAIR( "user_defined_conversion_declaration_c", (yyvsp[0].ast_pair) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast_pair).ast ) );
      c_ast_english( (yyvsp[0].ast_pair).ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8603 "parser.c"
    break;

  case 364: /* using_declaration_c: using_decl_c_ast  */
#line 4464 "parser.y"
    {
      // see the comment in "define_command" about TS_typedef
      PJL_DISCARD_RV( c_ast_take_type_any( (yyvsp[0].ast), &T_TS_typedef ) );

      PARSE_ASSERT( define_type( (yyvsp[0].ast), C_GIB_USING ) );
    }
#line 8614 "parser.c"
    break;

  case 365: /* $@18: %empty  */
#line 4474 "parser.y"
    { //
      // Using declarations are supported only in C++11 and later.  (However,
      // we always allow them in configuration files.)
      //
      // This check has to be done now in the parser rather than later in the
      // AST because using declarations are treated like typedef declarations
      // and the AST has no "memory" that such a declaration was a using
      // declaration.
      //
      if ( !OPT_LANG_IS( using_DECLS ) ) {
        print_error( &(yylsp[0]),
          "\"using\" not supported%s\n",
          C_LANG_WHICH( using_DECLS )
        );
        PARSE_ABORT();
      }

      gibberish_to_english();           // see the comment in "explain"
    }
#line 8638 "parser.c"
    break;

  case 366: /* $@19: %empty  */
#line 4495 "parser.y"
    {
      // see the comment in "define_command" about TS_typedef
      if ( !c_type_add_tid( &(yyvsp[0].ast)->type, TS_typedef, &(yylsp[0]) ) ) {
        free( (yyvsp[-3].name) );
        PARSE_ABORT();
      }
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 8651 "parser.c"
    break;

  case 367: /* using_decl_c_ast: Y_using $@18 any_name_exp attribute_specifier_list_c_atid_opt equals_exp type_c_ast $@19 cast_c_astp_opt  */
#line 4504 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "using_decl_c_ast",
                  "USING any_name_exp attribute_specifier_list_c_atid_opt '=' "
                  "type_c_ast cast_c_astp_opt" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_STR( "any_name_exp", (yyvsp[-5].name) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-4].tid) );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      c_ast_t *const cast_ast = (yyvsp[0].ast_pair).ast;

      //
      // Ensure the type on the right-hand side doesn't have a name, e.g.:
      //
      //      using U = void (*F)();    // error
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the patched AST loses the name.
      //
      c_sname_t const *const sname = c_ast_find_name( cast_ast, C_VISIT_DOWN );
      if ( sname != NULL ) {
        print_error( &cast_ast->loc, "\"using\" type can not have a name\n" );
        free( (yyvsp[-5].name) );
        PARSE_ABORT();
      }

      c_sname_t temp_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_name( &temp_sname, (yyvsp[-5].name) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), cast_ast );
      c_sname_set( &(yyval.ast)->sname, &temp_sname );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-4].tid), C_TPID_ATTR );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyval.ast) ) );
    }
#line 8697 "parser.c"
    break;

  case 368: /* decl_list_c_opt: %empty  */
#line 4565 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "decl_list_c_opt", "<empty>" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );

      if ( in_attr.align.kind != C_ALIGNAS_NONE ) {
        print_error( &in_attr.align.loc,
          "\"%s\" invalid here\n",
          alignas_name()
        );
        PARSE_ABORT();
      }

      bool const is_structured_binding =
        c_ast_unreference_any( type_ast )->kind == K_STRUCTURED_BINDING;

      if ( is_structured_binding ) {
        // do nothing
      }
      else if ( (type_ast->kind & K_ANY_ECSU) == 0 ) {
        //
        // The declaration is a non-ECSU type, e.g.:
        //
        //      int
        //
        c_loc_t const loc = lexer_loc();
        print_error( &loc, "declaration expected" );
        print_error_token_is_a( printable_yytext() );
        EPUTC( '\n' );
        PARSE_ABORT();
      }
      else {
        c_sname_t const *const ecsu_sname = &type_ast->csu.csu_sname;
        assert( !c_sname_empty( ecsu_sname ) );

        if ( c_sname_count( ecsu_sname ) > 1 ) {
          print_error( &type_ast->loc,
            "forward declaration can not have a scoped name\n"
          );
          PARSE_ABORT();
        }

        c_sname_t temp_sname = c_sname_dup( ecsu_sname );
        c_sname_set( &type_ast->sname, &temp_sname );
      }

      DUMP_AST( "$$_ast", type_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( type_ast ) );
      if ( is_structured_binding )
        c_ast_english( type_ast, C_ENG_DECL, stdout );
      else
        c_typedef_english( &C_TYPEDEF_LIT( type_ast, C_ENG_DECL ), stdout );
      PUTC( '\n' );
    }
#line 8759 "parser.c"
    break;

  case 369: /* decl_list_c_opt: decl_list_c  */
#line 4624 "parser.y"
    {
      DUMP_START( "decl_list_c_opt", "decl_list_c" );
      DUMP_AST_LIST( "decl_list_c", (yyvsp[0].ast_list) );
      DUMP_END();

      PARSE_ASSERT( c_ast_list_check( &(yyvsp[0].ast_list) ) );
      c_ast_list_english( &(yyvsp[0].ast_list), stdout );
    }
#line 8772 "parser.c"
    break;

  case 370: /* decl_list_c: decl_list_c ',' decl_c_exp  */
#line 4636 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 8781 "parser.c"
    break;

  case 371: /* decl_list_c: decl_c  */
#line 4641 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 8790 "parser.c"
    break;

  case 372: /* decl_c: decl_c_astp  */
#line 4650 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "decl_c", "decl_c_astp" );
      switch ( in_attr.align.kind ) {
        case C_ALIGNAS_NONE:
          break;
        case C_ALIGNAS_BYTES:
          DUMP_INT( "in_attr__alignas_bytes", in_attr.align.bytes );
          break;
        case C_ALIGNAS_SNAME:
          DUMP_SNAME( "in_attr__alignas_sname", in_attr.align.sname );
          break;
        case C_ALIGNAS_TYPE:
          DUMP_AST( "in_attr__alignas_type_ast", in_attr.align.type_ast );
          break;
      } // switch
      DUMP_BOOL( "in_attr__typename_flag_opt", in_attr.is_typename );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast) = join_type_decl( type_ast, (yyvsp[0].ast_pair).ast );
      PARSE_ASSERT( (yyval.ast) != NULL );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8822 "parser.c"
    break;

  case 374: /* decl_c_exp: error  */
#line 4682 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 8830 "parser.c"
    break;

  case 379: /* decl_c_astp: msc_calling_convention_atid msc_calling_convention_c_astp  */
#line 4693 "parser.y"
    {
      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);
      (yyval.ast_pair).ast->type.atids |= (yyvsp[-1].tid);
    }
#line 8840 "parser.c"
    break;

  case 387: /* decl2_c_astp: param_pack_decl_c_ast  */
#line 4711 "parser.y"
                                   { (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), NULL }; }
#line 8846 "parser.c"
    break;

  case 388: /* decl2_c_astp: sname_c_ast gnu_attribute_specifier_list_c_opt  */
#line 4713 "parser.y"
    {
      (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[-1].ast), .target_ast = NULL };
    }
#line 8854 "parser.c"
    break;

  case 389: /* decl2_c_astp: typedef_type_decl_c_ast  */
#line 4717 "parser.y"
    {
      (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), .target_ast = NULL };
    }
#line 8862 "parser.c"
    break;

  case 392: /* param_pack_decl_c_ast: "..." sname_c_ast  */
#line 4726 "parser.y"
    {
      DUMP_START( "param_pack_decl_c_ast", "... sname_c_ast" );\
      DUMP_AST( "sname_c_ast", (yyvsp[0].ast) );

      c_ast_set_parameter_pack( (yyvsp[0].ast) );
      (yyval.ast) = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8877 "parser.c"
    break;

  case 393: /* param_pack_decl_c_ast: "..." error  */
#line 4737 "parser.y"
    {
      (yyval.ast) = NULL;
      elaborate_error( "name expected" );
    }
#line 8886 "parser.c"
    break;

  case 394: /* array_decl_c_astp: decl2_c_astp array_size_c_ast gnu_attribute_specifier_list_c_opt  */
#line 4749 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "array_decl_c_astp", "decl2_c_astp array_size_c_ast" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl2_c_astp", (yyvsp[-2].ast_pair) );
      DUMP_AST( "array_size_c_ast", (yyvsp[-1].ast) );

      c_ast_set_parent(
        c_ast_new_gc( K_PLACEHOLDER, &(yylsp[-2]) ), (yyvsp[-1].ast)
      );

      c_ast_t *const of_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-2].ast_pair).target_ast != NULL ) {
        // array-of or function-like-ret type
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-2].ast_pair).ast,
          c_ast_add_array( (yyvsp[-2].ast_pair).target_ast, (yyvsp[-1].ast), of_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_array( (yyvsp[-2].ast_pair).ast, (yyvsp[-1].ast), of_ast ),
          .target_ast = NULL
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 8921 "parser.c"
    break;

  case 395: /* array_size_c_ast: '[' rbracket_exp  */
#line 4783 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NONE;
    }
#line 8930 "parser.c"
    break;

  case 396: /* array_size_c_ast: '[' uint_lit rbracket_exp  */
#line 4788 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_INT;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8940 "parser.c"
    break;

  case 397: /* array_size_c_ast: '[' Y_NAME rbracket_exp  */
#line 4794 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NAME;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8950 "parser.c"
    break;

  case 398: /* array_size_c_ast: '[' type_qualifier_list_c_stid rbracket_exp  */
#line 4800 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-1].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NONE;
    }
#line 8960 "parser.c"
    break;

  case 399: /* array_size_c_ast: '[' type_qualifier_list_c_stid static_stid_opt uint_lit rbracket_exp  */
#line 4807 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-3].tid) | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_INT;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8971 "parser.c"
    break;

  case 400: /* array_size_c_ast: '[' type_qualifier_list_c_stid static_stid_opt Y_NAME rbracket_exp  */
#line 4815 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-3].tid) | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NAME;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8982 "parser.c"
    break;

  case 401: /* array_size_c_ast: '[' type_qualifier_list_c_stid_opt '*' rbracket_exp  */
#line 4822 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_VLA;
    }
#line 8992 "parser.c"
    break;

  case 402: /* array_size_c_ast: '[' Y_static type_qualifier_list_c_stid_opt uint_lit rbracket_exp  */
#line 4829 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids =
        c_tid_check( TS_NON_EMPTY_ARRAY | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_INT;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 9004 "parser.c"
    break;

  case 403: /* array_size_c_ast: '[' Y_static type_qualifier_list_c_stid_opt Y_NAME rbracket_exp  */
#line 4838 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids =
        c_tid_check( TS_NON_EMPTY_ARRAY | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NAME;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 9016 "parser.c"
    break;

  case 404: /* array_size_c_ast: '[' error ']'  */
#line 4846 "parser.y"
    {
      elaborate_error( "array size expected" );
    }
#line 9024 "parser.c"
    break;

  case 405: /* $@20: %empty  */
#line 4856 "parser.y"
    { //
      // A block AST has to be the type inherited attribute for decl_c_astp so
      // we have to create it here.
      //
      ia_type_ast_push( c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) ) );
    }
#line 9035 "parser.c"
    break;

  case 406: /* block_decl_c_astp: '(' '^' $@20 type_qualifier_list_c_stid_opt decl_c_astp rparen_exp lparen_exp param_c_ast_list_opt ')' gnu_attribute_specifier_list_c_opt  */
#line 4865 "parser.y"
    {
      c_ast_t *const block_ast = ia_type_ast_pop();
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "block_decl_c_astp",
                  "'(' '^' type_qualifier_list_c_stid_opt decl_c_astp ')' "
                  "'(' param_c_ast_list_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-6].tid) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[-5].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-2].ast_list) );

      PARSE_ASSERT(
        c_type_add_tid( &block_ast->type, (yyvsp[-6].tid), &(yylsp[-6]) )
      );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), block_ast );
      block_ast->block.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );

      c_ast_t *const ret_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-5].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-5].ast_pair).ast,
          c_ast_add_func( (yyvsp[-5].ast_pair).target_ast, block_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( (yyvsp[-5].ast_pair).ast, block_ast, ret_ast ),
          block_ast->block.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9075 "parser.c"
    break;

  case 407: /* destructor_declaration_c: virtual_stid_opt '~' any_name_exp lparen_exp no_destructor_params param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt func_equals_c_stid_opt  */
#line 4913 "parser.y"
    {
      DUMP_START( "destructor_declaration_c",
                  "virtual_stid_opt '~' any_name_exp '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "gnu_attribute_specifier_list_c_opt func_equals_c_stid_opt" );
      DUMP_TID( "virtual_stid_opt", (yyvsp[-8].tid) );
      DUMP_STR( "any_name_exp", (yyvsp[-6].name) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *const dtor_ast = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );
      c_sname_init_name( &dtor_ast->sname, (yyvsp[-6].name) );
      dtor_ast->type.stids = c_tid_check(
        (yyvsp[-8].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      DUMP_AST( "$$_ast", dtor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( dtor_ast ) );
      c_ast_english( dtor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 9105 "parser.c"
    break;

  case 409: /* no_destructor_params: error  */
#line 4960 "parser.y"
    { //
      // Ordinarily, we'd get an error message like:
      //
      //      c++decl> explain ~C(int)
      //                          ^
      //      12: syntax error: "int": destructors may not have parameters
      //      ("int" is a keyword)
      //
      // where the <<("int" is a keyword)>> part seems wrong since the user
      // didn't try using "int" as an ordinary identifier.  To suppress that
      // part, set yytext to the empty string so elaborate_error() won't print
      // it nor call print_error_token_is_a() and and we'll instead get an
      // error message like:
      //
      //      c++decl> explain ~C(int)
      //                          ^
      //      12: syntax error: destructors may not have parameters
      //
      set_yytext( "" );
      elaborate_error( "destructors may not have parameters" );
    }
#line 9131 "parser.c"
    break;

  case 410: /* file_scope_constructor_declaration_c: inline_stid_opt Y_CONSTRUCTOR_SNAME lparen_exp param_c_ast_list_opt param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt  */
#line 4990 "parser.y"
    {
      DUMP_START( "file_scope_constructor_declaration_c",
                  "inline_opt CONSTRUCTOR_SNAME '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt" );
      DUMP_TID( "inline_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "CONSTRUCTOR_SNAME", (yyvsp[-5].sname) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_sname_set_scope_type( &(yyvsp[-5].sname), &C_TYPE_LIT_B( TB_class ) );

      c_ast_t *const ctor_ast = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      ctor_ast->sname = c_sname_move( &(yyvsp[-5].sname) );
      ctor_ast->type.stids = c_tid_check(
        (yyvsp[-6].tid) | (yyvsp[-2].tid) | (yyvsp[-1].tid),
        C_TPID_STORE
      );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), ctor_ast );
      ctor_ast->ctor.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      DUMP_AST( "$$_ast", ctor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( ctor_ast ) );
      c_ast_english( ctor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 9164 "parser.c"
    break;

  case 411: /* file_scope_destructor_declaration_c: inline_stid_opt destructor_sname lparen_exp no_destructor_params param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt  */
#line 5027 "parser.y"
    {
      DUMP_START( "file_scope_destructor_declaration_c",
                  "inline_opt destructor_sname '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt" );
      DUMP_TID( "inline_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "destructor_sname", (yyvsp[-5].sname) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_sname_set_scope_type( &(yyvsp[-5].sname), &C_TYPE_LIT_B( TB_class ) );

      c_ast_t *const dtor_ast = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );
      dtor_ast->sname = c_sname_move( &(yyvsp[-5].sname) );
      dtor_ast->type.stids = c_tid_check(
        (yyvsp[-6].tid) | (yyvsp[-2].tid) | (yyvsp[-1].tid),
        C_TPID_STORE
      );

      DUMP_AST( "$$_ast", dtor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( dtor_ast ) );
      c_ast_english( dtor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 9194 "parser.c"
    break;

  case 412: /* func_decl_c_astp: decl2_c_astp param_list_c_lparen param_c_ast_list_opt param_list_rparen_func_qualifier_list_c_stid_opt ref_qualifier_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt func_equals_c_stid_opt  */
#line 5072 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "func_decl_c_astp",
                  "decl2_c_astp '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt "
                  "ref_qualifier_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl2_c_astp", (yyvsp[-7].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-5].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[-1].ast) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_tid_t const func_stids = c_tid_check(
        (yyvsp[-4].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      bool const assume_constructor = c_ast_is_likely_ctor( type_ast );

      c_ast_t *const func_ast =
        c_ast_new_gc( assume_constructor ? K_CONSTRUCTOR : K_FUNCTION, &(yyloc) );
      func_ast->type.stids = func_stids;
      c_ast_list_set_param_of( &(yyvsp[-5].ast_list), func_ast );
      func_ast->func.param_ast_list = slist_move( &(yyvsp[-5].ast_list) );

      c_ast_t *const decl_ast = (yyvsp[-7].ast_pair).ast;

      if ( assume_constructor ) {
        assert( (yyvsp[-1].ast) == NULL );
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( decl_ast, func_ast, /*ret_ast=*/NULL ),
          .target_ast = NULL
        };
      }
      else {
        c_ast_t *ret_ast;
        c_ast_t *target_ast = (yyvsp[-7].ast_pair).target_ast;

        if ( target_ast != NULL && target_ast->kind != K_POINTER ) {
          //
          // This is for a case like:
          //
          //      int f() ()
          //       |    |  |
          //       |    |  func
          //       |    |
          //       |    decl_ast (func)
          //       |
          //       ret_ast
          //
          // We replace ret_ast with decl_ast:
          //
          //      int f() ()
          //       |    |  |
          //       |    |  func
          //       X    |
          //       |    decl_ast (func)
          //       |
          //       ret_ast <- decl_ast (func)
          //
          // that is, a "function returning function" -- which is illegal
          // (since functions can't return functions) and will be caught by
          // c_ast_check_ret_type().
          //
          ret_ast = decl_ast;
          target_ast = NULL;
        }
        else {
          ret_ast = IF_ELSE_EXPR(
            (yyvsp[-1].ast), ia_type_spec_ast( type_ast )
          );
        }

        if ( target_ast != NULL ) {
          (yyval.ast_pair) = (c_ast_pair_t){
            decl_ast,
            c_ast_add_func( target_ast, func_ast, ret_ast )
          };
        }
        else {
          (yyval.ast_pair) = (c_ast_pair_t){
            c_ast_add_func( decl_ast, func_ast, ret_ast ),
            func_ast->func.ret_ast
          };
        }
      }

      c_tid_t const msc_call_atids = (yyval.ast_pair).ast->type.atids & TA_ANY_MSC_CALL;
      if ( msc_call_atids != TA_NONE ) {
        //
        // Microsoft calling conventions need to be moved from the pointer to
        // the function, e.g., change:
        //
        //      declare f as cdecl pointer to function returning void
        //
        // to:
        //
        //      declare f as pointer to cdecl function returning void
        //
        for ( c_ast_t *ast = (yyval.ast_pair).ast; (ast = c_ast_unpointer( ast )) != NULL; ) {
          if ( ast->kind == K_FUNCTION ) {
            (yyval.ast_pair).ast->type.atids &= c_tid_compl( TA_ANY_MSC_CALL );
            ast->type.atids |= msc_call_atids;
          }
        } // for
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9315 "parser.c"
    break;

  case 413: /* $@21: %empty  */
#line 5199 "parser.y"
    {
      if ( OPT_LANG_IS( CONSTRUCTORS ) ) {
        //
        // In C++, encountering a name followed by '(' declares an in-class
        // constructor.  That means NAME is the name of a class, so we have to
        // create a temporary class type for it so if it's used as the type of
        // a parameter, e.g.:
        //
        //      C(C const&)
        //
        // it'll be recognized as such.
        //
        c_ast_t *const csu_ast = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yylsp[-1]) );
        csu_ast->type.btids = TB_class;
        c_sname_init_name( &csu_ast->csu.csu_sname, check_strdup( (yyvsp[-1].name) ) );
        csu_ast->sname = c_sname_dup( &csu_ast->csu.csu_sname );

        in_attr.tdef_rb = c_typedef_add( csu_ast, C_GIB_TYPEDEF );
        MAYBE_UNUSED c_typedef_t const *const csu_tdef =
          (void*)in_attr.tdef_rb->data;
        assert( csu_tdef->ast == csu_ast );
      }
    }
#line 9343 "parser.c"
    break;

  case 414: /* pc99_func_or_constructor_declaration_c: Y_NAME param_list_c_lparen $@21 param_c_ast_list_opt param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt func_equals_c_stid_opt  */
#line 5225 "parser.y"
    {
      DUMP_START( "pc99_func_or_constructor_declaration_c",
                  "NAME '(' param_c_ast_list_opt ')' noexcept_c_stid_opt "
                  "func_equals_c_stid_opt" );
      DUMP_STR( "NAME", (yyvsp[-6].name) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *ast;

      if ( OPT_LANG_IS( CONSTRUCTORS ) ) {
        //
        // Remove the temporary typedef for the class.
        //
        c_typedef_remove( in_attr.tdef_rb );

        //
        // In C++, encountering a name followed by '(' declares an in-class
        // constructor.
        //
        ast = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      }
      else {
        if ( !OPT_LANG_IS( IMPLICIT_int ) ) {
          //
          // In C99 and later, implicit int is an error.  This check has to be
          // done now in the parser rather than later in the AST since the AST
          // would have no "memory" that the return type was implicitly int.
          //
          print_error( &(yylsp[-6]),
            "implicit \"%s\" functions are illegal%s",
            c_tid_error( TB_int ),
            C_LANG_WHICH( IMPLICIT_int )
          );
          print_error_token_is_a( (yyvsp[-6].name) );
          if ( strcmp( (yyvsp[-6].name), L_typeof ) == 0 ||
               strcmp( (yyvsp[-6].name), L_typeof_unqual ) == 0 ) {
            EPRINTF( "; use \"%s\" instead", L_GNU___typeof__ );
          }
          else {
            print_suggestions(
              DYM_C_KEYWORDS | DYM_C_MACROS | DYM_C_TYPES,
              (yyvsp[-6].name)
            );
          }
          EPUTC( '\n' );
          free( (yyvsp[-6].name) );
          PARSE_ABORT();
        }

        //
        // In C prior to C99, encountering a name followed by '(' declares a
        // function that implicitly returns int:
        //
        //      power(x, n)             /* raise x to n-th power; n > 0 */
        //
        c_ast_t *const ret_ast = c_ast_new_gc( K_BUILTIN, &(yylsp[-6]) );
        ret_ast->type.btids = TB_int;

        ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
        c_ast_set_parent( ret_ast, ast );
      }

      c_sname_init_name( &ast->sname, (yyvsp[-6].name) );
      ast->type.stids = c_tid_check(
        (yyvsp[-2].tid) | (yyvsp[-1].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), ast );
      ast->func.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      DUMP_AST( "$$_ast", ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( ast ) );
      c_ast_english( ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 9428 "parser.c"
    break;

  case 415: /* $@22: %empty  */
#line 5309 "parser.y"
    {
      if ( OPT_LANG_IS( MEMBER_FUNCTIONS ) ) {
        //
        // Both "final" and "override" are matched only within member function
        // declarations.  Now that ')' has been parsed, we're within one, so
        // set the keyword context to C_KW_CTX_MBR_FUNC.
        //
        lexer_keyword_ctx = C_KW_CTX_MBR_FUNC;
      }
    }
#line 9443 "parser.c"
    break;

  case 416: /* param_list_rparen_func_qualifier_list_c_stid_opt: param_list_rparen $@22 func_qualifier_list_c_stid_opt  */
#line 5320 "parser.y"
    {
      lexer_keyword_ctx = C_KW_CTX_DEFAULT;
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 9452 "parser.c"
    break;

  case 417: /* func_qualifier_list_c_stid_opt: %empty  */
#line 5327 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9458 "parser.c"
    break;

  case 418: /* func_qualifier_list_c_stid_opt: func_qualifier_list_c_stid_opt func_qualifier_c_stid  */
#line 5329 "parser.y"
    {
      DUMP_START( "func_qualifier_list_c_stid_opt",
                  "func_qualifier_list_c_stid_opt func_qualifier_c_stid" );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_qualifier_c_stid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 9475 "parser.c"
    break;

  case 423: /* noexcept_c_stid_opt: %empty  */
#line 5358 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9481 "parser.c"
    break;

  case 425: /* noexcept_c_stid_opt: Y_noexcept '(' noexcept_bool_stid_exp rparen_exp  */
#line 5361 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 9489 "parser.c"
    break;

  case 426: /* noexcept_c_stid_opt: Y_throw lparen_exp rparen_exp  */
#line 5365 "parser.y"
    {
      (yyval.tid) = (yyvsp[-2].tid);
    }
#line 9497 "parser.c"
    break;

  case 427: /* noexcept_c_stid_opt: Y_throw lparen_exp param_c_ast_list ')'  */
#line 5369 "parser.y"
    {
      c_ast_list_cleanup( &(yyvsp[-1].ast_list) );

      if ( OPT_LANG_IS( throw ) )
        UNSUPPORTED( &(yylsp[-1]), "dynamic exception specifications" );

      print_error( &(yylsp[-1]),
        "dynamic exception specifications not supported%s\n",
        C_LANG_WHICH( throw )
      );
      PARSE_ABORT();
    }
#line 9514 "parser.c"
    break;

  case 430: /* noexcept_bool_stid_exp: error  */
#line 5387 "parser.y"
    {
      elaborate_error( "\"true\" or \"false\" expected" );
    }
#line 9522 "parser.c"
    break;

  case 431: /* trailing_return_type_c_ast_opt: %empty  */
#line 5393 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 9528 "parser.c"
    break;

  case 432: /* $@23: %empty  */
#line 5395 "parser.y"
                                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9534 "parser.c"
    break;

  case 433: /* trailing_return_type_c_ast_opt: Y_MINUS_GREATER type_c_ast $@23 cast_c_astp_opt  */
#line 5397 "parser.y"
    { //
      // The function trailing return-type syntax is supported only in C++11
      // and later.  This check has to be done now in the parser rather than
      // later in the AST because the AST has no "memory" of where the return-
      // type came from.
      //
      if ( !OPT_LANG_IS( TRAILING_RETURN_TYPES ) ) {
        print_error( &(yylsp[-3]),
          "trailing return type not supported%s\n",
          C_LANG_WHICH( TRAILING_RETURN_TYPES )
        );
        PARSE_ABORT();
      }

      ia_type_ast_pop();
      c_ast_t const *const ret_ast = ia_type_ast_peek();

      DUMP_START( "trailing_return_type_c_ast_opt",
                  "'->' type_c_ast cast_c_astp_opt" );
      DUMP_AST( "in_attr__type_c_ast", ret_ast );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = IF_ELSE_EXPR( (yyvsp[0].ast_pair).ast, (yyvsp[-2].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      //
      // Ensure that a function using the C++11 trailing return type syntax
      // starts with "auto":
      //
      //      void f() -> int
      //      ^
      //      error: must be "auto"
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the "auto" is just a syntactic return-type placeholder in
      // C++11 and the AST node for the placeholder is discarded and never made
      // part of the AST.
      //
      if ( ret_ast->type.btids != TB_auto ) {
        print_error( &ret_ast->loc,
          "function with trailing return type must only specify \"%s\"\n",
          c_tid_error( TB_auto )
        );
        PARSE_ABORT();
      }
    }
#line 9588 "parser.c"
    break;

  case 434: /* trailing_return_type_c_ast_opt: gnu_attribute_specifier_list_c  */
#line 5448 "parser.y"
    {
      (yyval.ast) = NULL;
    }
#line 9596 "parser.c"
    break;

  case 435: /* func_equals_c_stid_opt: %empty  */
#line 5454 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9602 "parser.c"
    break;

  case 436: /* func_equals_c_stid_opt: '=' Y_default  */
#line 5455 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 9608 "parser.c"
    break;

  case 437: /* func_equals_c_stid_opt: '=' Y_delete delete_reason_opt  */
#line 5457 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 9616 "parser.c"
    break;

  case 438: /* func_equals_c_stid_opt: '=' uint_lit  */
#line 5461 "parser.y"
    {
      if ( (yyvsp[0].uint_val) != 0 ) {
        print_error( &(yylsp[0]), "'0' expected\n" );
        PARSE_ABORT();
      }
      (yyval.tid) = TS_PURE_virtual;
    }
#line 9628 "parser.c"
    break;

  case 439: /* func_equals_c_stid_opt: '=' error  */
#line 5469 "parser.y"
    {
      if ( OPT_LANG_IS( default_delete_FUNCS ) )
        elaborate_error( "'0', \"default\", or \"delete\" expected" );
      else
        elaborate_error( "'0' expected" );
    }
#line 9639 "parser.c"
    break;

  case 441: /* delete_reason_opt: '(' str_lit_exp rparen_exp  */
#line 5480 "parser.y"
    {
      FREE( (yyvsp[-1].str_val) );
      //
      // This check has to be done now in the parser rather than later in the
      // AST since we ignore the reason string.
      //
      if ( !OPT_LANG_IS( delete_REASON ) ) {
        print_error( &(yylsp[-1]),
          "\"delete\" with reason not supported%s\n",
          C_LANG_WHICH( delete_REASON )
        );
        PARSE_ABORT();
      }
    }
#line 9658 "parser.c"
    break;

  case 443: /* param_c_ast_list_exp: error  */
#line 5501 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      elaborate_error( "parameter list expected" );
    }
#line 9667 "parser.c"
    break;

  case 444: /* param_c_ast_list_opt: %empty  */
#line 5508 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 9673 "parser.c"
    break;

  case 446: /* param_c_ast_list: param_c_ast_list comma_exp param_c_ast_exp  */
#line 5514 "parser.y"
    {
      DUMP_START( "param_c_ast_list", "param_c_ast_list ',' param_c_ast" );
      DUMP_AST_LIST( "param_c_ast_list", (yyvsp[-2].ast_list) );
      DUMP_AST( "param_c_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 9689 "parser.c"
    break;

  case 447: /* param_c_ast_list: param_c_ast  */
#line 5527 "parser.y"
    {
      DUMP_START( "param_c_ast_list", "param_c_ast" );
      DUMP_AST( "param_c_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 9704 "parser.c"
    break;

  case 448: /* $@24: %empty  */
#line 5544 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 9712 "parser.c"
    break;

  case 449: /* param_c_ast: this_stid_opt type_c_ast $@24 cast_c_astp_opt  */
#line 5548 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "param_c_ast", "this_stid_opt type_c_ast cast_c_astp_opt" );
      DUMP_TID( "this_stid_opt", (yyvsp[-3].tid) );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast );

      if ( (yyval.ast)->kind == K_FUNCTION ) {
        //
        // From the C11 standard, section 6.3.2.1(4):
        //
        //    [A] function designator with type "function returning type" is
        //    converted to an expression that has type "pointer to function
        //    returning type."
        //
        (yyval.ast) = c_ast_pointer( (yyval.ast), &gc_ast_list );
      }

      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-3].tid), &(yylsp[-3]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9743 "parser.c"
    break;

  case 451: /* param_c_ast: "..."  */
#line 5584 "parser.y"
    {
      DUMP_START( "param_c_ast", "..." );

      (yyval.ast) = c_ast_new_gc( K_VARIADIC, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9756 "parser.c"
    break;

  case 453: /* param_c_ast_exp: error  */
#line 5597 "parser.y"
    {
      elaborate_error( "parameter declaration expected" );
    }
#line 9764 "parser.c"
    break;

  case 454: /* paren_param_c_ast_list_opt: %empty  */
#line 5603 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 9770 "parser.c"
    break;

  case 455: /* paren_param_c_ast_list_opt: param_list_c_lparen param_c_ast_list_opt param_list_rparen  */
#line 5605 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 9778 "parser.c"
    break;

  case 456: /* param_list_c_lparen: '('  */
#line 5611 "parser.y"
                                  { lexer_is_param_list_decl = true; }
#line 9784 "parser.c"
    break;

  case 457: /* param_list_rparen: ')'  */
#line 5615 "parser.y"
                                  { lexer_is_param_list_decl = false; }
#line 9790 "parser.c"
    break;

  case 458: /* $@25: %empty  */
#line 5622 "parser.y"
    {
      ia_type_ast_push( c_ast_new_gc( K_PLACEHOLDER, &(yyloc) ) );
      ++in_attr.ast_depth;
    }
#line 9799 "parser.c"
    break;

  case 459: /* nested_decl_c_astp: '(' $@25 decl_c_astp rparen_exp  */
#line 5627 "parser.y"
    {
      ia_type_ast_pop();
      --in_attr.ast_depth;

      DUMP_START( "nested_decl_c_astp", "'(' decl_c_astp ')'" );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[-1].ast_pair) );

      (yyval.ast_pair) = (yyvsp[-1].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9817 "parser.c"
    break;

  case 460: /* oper_decl_c_astp: oper_sname_c_opt Y_operator c_operator param_list_c_lparen param_c_ast_list_opt param_list_rparen_func_qualifier_list_c_stid_opt ref_qualifier_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt func_equals_c_stid_opt  */
#line 5653 "parser.y"
    {
      c_operator_t const *const operator = c_op_get( (yyvsp[-7].op_id) );
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "oper_decl_c_astp",
                  "oper_sname_c_opt OPERATOR c_operator "
                  "'(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt "
                  "ref_qualifier_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-9].sname) );
      DUMP_STR( "c_operator", operator->literal );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-5].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[-1].ast) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_tid_t const oper_stids = c_tid_check(
        (yyvsp[-4].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      c_ast_t *const oper_ast = c_ast_new_gc( K_OPERATOR, &(yyloc) );
      oper_ast->sname = c_sname_move( &(yyvsp[-9].sname) );
      oper_ast->type.stids = oper_stids;
      c_ast_list_set_param_of( &(yyvsp[-5].ast_list), oper_ast );
      oper_ast->oper.param_ast_list = slist_move( &(yyvsp[-5].ast_list) );
      oper_ast->oper.operator = operator;

      c_ast_t *const ret_ast =
        IF_ELSE_EXPR( (yyvsp[-1].ast), ia_type_spec_ast( type_ast ) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_add_func( type_ast, oper_ast, ret_ast ),
        oper_ast->oper.ret_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9866 "parser.c"
    break;

  case 461: /* $@26: %empty  */
#line 5702 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9872 "parser.c"
    break;

  case 462: /* pointer_decl_c_astp: pointer_type_c_ast $@26 decl_c_astp  */
#line 5704 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_decl_c_astp", "pointer_type_c_ast decl_c_astp" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      PJL_DISCARD_RV( c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ) );
      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9891 "parser.c"
    break;

  case 463: /* pointer_type_c_ast: '*' type_qualifier_list_c_stid_opt  */
#line 5723 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "pointer_type_c_ast", "'*' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_POINTER, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9910 "parser.c"
    break;

  case 464: /* pc99_pointer_decl_list_c: pc99_pointer_decl_c ',' decl_list_c  */
#line 5743 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[0].ast_list);
      slist_push_front( &(yyval.ast_list), (yyvsp[-2].ast) );
    }
#line 9919 "parser.c"
    break;

  case 465: /* pc99_pointer_decl_list_c: pc99_pointer_decl_c  */
#line 5748 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 9928 "parser.c"
    break;

  case 466: /* $@27: %empty  */
#line 5755 "parser.y"
                                      { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9934 "parser.c"
    break;

  case 467: /* pc99_pointer_decl_c: pc99_pointer_type_c_ast $@27 decl_c_astp  */
#line 5757 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pc99_pointer_decl_c",
                  "pc99_pointer_type_c_ast decl_c_astp" );
      DUMP_AST( "pc99_pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast );
      (yyval.ast)->loc = (yyloc);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9953 "parser.c"
    break;

  case 468: /* pc99_pointer_type_c_ast: '*' type_qualifier_list_c_stid_opt  */
#line 5776 "parser.y"
    {
      if ( !OPT_LANG_IS( IMPLICIT_int ) ) {
        //
        // In C99 and later, implicit int is an error.  This check has to be
        // done now in the parser rather than later in the AST since the AST
        // would have no "memory" that the return type was implicitly int.
        //
        print_error( &(yylsp[-1]),
          "implicit \"%s\" is illegal%s\n",
          c_tid_error( TB_int ),
          C_LANG_WHICH( IMPLICIT_int )
        );
        PARSE_ABORT();
      }

      c_ast_t *type_ast = ia_type_ast_peek();

      DUMP_START( "pc99_pointer_type_c_ast",
                  "'*' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      if ( type_ast == NULL ) {
        type_ast = c_ast_new_gc( K_BUILTIN, &(yyloc) );
        type_ast->type.btids = TB_int;
        ia_type_ast_push( type_ast );
      }

      (yyval.ast) = c_ast_pointer( ia_type_spec_ast( type_ast ), &gc_ast_list );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9992 "parser.c"
    break;

  case 469: /* $@28: %empty  */
#line 5815 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9998 "parser.c"
    break;

  case 470: /* pointer_to_member_decl_c_astp: pointer_to_member_type_c_ast $@28 decl_c_astp  */
#line 5817 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_decl_c_astp",
                  "pointer_to_member_type_c_ast decl_c_astp" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10017 "parser.c"
    break;

  case 471: /* pointer_to_member_type_c_ast: any_sname_c Y_COLON_COLON_STAR '*' cv_qualifier_list_stid_opt  */
#line 5837 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "pointer_to_member_type_c_ast",
                  "any_sname_c '::*' cv_qualifier_list_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "any_sname_c", (yyvsp[-3].sname) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_POINTER_TO_MEMBER, &(yyloc) );

      c_type_t scope_type = *c_sname_local_type( &(yyvsp[-3].sname) );
      if ( !c_tid_is_any( scope_type.btids, TB_ANY_SCOPE ) ) {
        //
        // The sname has no scope-type, but we now know there's a pointer-to-
        // member of it, so it must be a class.  (It could alternatively be a
        // struct, but we have no context to know, so just pick class because
        // it's more C++-like.)
        //
        scope_type.btids = TB_class;
        c_sname_local_data( &(yyvsp[-3].sname) )->type = scope_type;
      }

      // adopt sname's scope-type for the AST
      (yyval.ast)->type = c_type_or( &C_TYPE_LIT_S( (yyvsp[0].tid) ), &scope_type );

      (yyval.ast)->ptr_mbr.class_sname = c_sname_move( &(yyvsp[-3].sname) );
      c_ast_set_parent( c_ast_dup_gc( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10054 "parser.c"
    break;

  case 472: /* $@29: %empty  */
#line 5875 "parser.y"
    {
      (yyvsp[-1].ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      ia_type_ast_push( (yyvsp[-1].ast) );
    }
#line 10063 "parser.c"
    break;

  case 473: /* reference_decl_c_astp: reference_type_c_ast type_qualifier_list_c_stid_opt $@29 decl_c_astp  */
#line 5880 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_decl_c_astp", "reference_type_c_ast decl_c_astp" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-3].ast) );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      PJL_DISCARD_RV( c_ast_patch_placeholder( (yyvsp[-3].ast), (yyvsp[0].ast_pair).ast ) );
      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10083 "parser.c"
    break;

  case 474: /* reference_type_c_ast: '&'  */
#line 5900 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "reference_type_c_ast", "'&'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );

      (yyval.ast) = c_ast_new_gc( K_REFERENCE, &(yyloc) );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10100 "parser.c"
    break;

  case 475: /* reference_type_c_ast: Y_AMPER_AMPER  */
#line 5915 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "reference_type_c_ast", "'&&'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );

      (yyval.ast) = c_ast_new_gc( K_RVALUE_REFERENCE, &(yyloc) );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10117 "parser.c"
    break;

  case 476: /* typedef_type_decl_c_ast: typedef_type_c_ast bit_field_c_uint_opt  */
#line 5934 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "typedef_type_decl_c_ast",
                  "typedef_type_c_ast bit_field_c_uint_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST( "typedef_type_c_ast", (yyvsp[-1].ast) );
      DUMP_INT( "bit_field_c_uint_opt", (yyvsp[0].uint_val) );

      if ( c_tid_is_any( type_ast->type.stids, TS_typedef ) ) {
        //
        // If we're defining a type, return the type as-is.
        //
        (yyval.ast) = (yyvsp[-1].ast);
      }
      else {
        //
        // Otherwise, return the type that it's typedef'd as.
        //
        c_ast_t const *const raw_tdef_ast = c_ast_untypedef( (yyvsp[-1].ast) );

        //
        // But first ensure the name isn't of a previously declared type:
        //
        //      cdecl> struct S
        //      cdecl> explain int S    // error: "S": previously declared
        //
        // Note that typedef_type_c_ast is like:
        //
        //      typedef_type_c_ast: {
        //        sname: { string: "" },
        //        kind: { value: 0x20, string: "typedef" },
        //        ...
        //        type: { btid: 0x10000001, ..., string: "none" },
        //        tdef: {
        //          for_ast: {
        //            sname: { string: "S", scopes: "struct" },
        //            kind: { value: 0x8, string: "struct or union" },
        //            ...
        //            type: { btid: 0x800001, ..., string: "struct" },
        //            csu: {
        //              csu_sname: { string: "S", scopes: "none" }
        //            }
        //          }
        //        },
        //        ...
        //      }
        //
        // That is, typedef_type_c_ast has no name itself (at this point), but
        // the raw type, of course, does, so it's that name we have to check.
        //
        // This check has to be done now in the parser rather than later in the
        // AST since if this declaration were joined with a type (like `int`
        // above), the type information would be lost and we'd get this from
        // above:
        //
        //      declare S as structure S          // wrong
        //
        // Additionally, we also get here when the typedef name is used as part
        // of longer name, e.g., `S::x`:
        //
        //      c++decl> explain int S::x
        //      declare x of structure S as int   // correct
        //
        // but that name isn't of a previously declared type, so it's OK.
        //
        PARSE_ASSERT(
          !c_sname_is_type( &raw_tdef_ast->sname, &(yyvsp[-1].ast)->loc )
        );

        //
        // We have to duplicate the type to set the current location.
        //
        (yyval.ast) = c_ast_dup_gc( raw_tdef_ast );
        (yyval.ast)->loc = (yyvsp[-1].ast)->loc;
      }

      PARSE_ASSERT( c_ast_set_bit_field_width( (yyval.ast), (yyvsp[0].uint_val) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10204 "parser.c"
    break;

  case 477: /* $@30: %empty  */
#line 6023 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 10212 "parser.c"
    break;

  case 478: /* user_defined_conversion_decl_c_astp: oper_sname_c_opt Y_operator type_c_ast $@30 udc_decl_c_ast_opt lparen_exp param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt func_equals_c_stid_opt  */
#line 6029 "parser.y"
    {
      ia_type_ast_pop();

      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "user_defined_conversion_decl_c_astp",
                  "oper_sname_c_opt OPERATOR "
                  "type_c_ast udc_decl_c_ast_opt '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-8].sname) );
      DUMP_AST( "type_c_ast", (yyvsp[-6].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[-4].ast) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *const udc_ast = c_ast_new_gc( K_UDEF_CONV, &(yyloc) );
      udc_ast->sname = c_sname_move( &(yyvsp[-8].sname) );
      udc_ast->type.stids = c_tid_check(
        (yyvsp[-2].tid) | (yyvsp[-1].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );
      if ( type_ast != NULL )
        c_type_or_eq( &udc_ast->type, &type_ast->type );
      udc_ast->udef_conv.to_ast = IF_ELSE_EXPR( (yyvsp[-4].ast), (yyvsp[-6].ast) );

      (yyval.ast_pair) = (c_ast_pair_t){ udc_ast, udc_ast->udef_conv.to_ast };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10250 "parser.c"
    break;

  case 479: /* user_defined_literal_decl_c_astp: oper_sname_c_opt Y_operator empty_str_lit_exp name_exp lparen_exp param_c_ast_list_exp ')' noexcept_c_stid_opt trailing_return_type_c_ast_opt  */
#line 6072 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "user_defined_literal_decl_c_astp",
                  "oper_sname_c_opt OPERATOR '\"\"' "
                  "'(' param_c_ast_list_exp ')' noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-8].sname) );
      DUMP_STR( "name", (yyvsp[-5].name) );
      DUMP_AST_LIST( "param_c_ast_list_exp", (yyvsp[-3].ast_list) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[0].ast) );

      c_sname_set( &type_ast->sname, &(yyvsp[-8].sname) );
      c_sname_append_name( &type_ast->sname, (yyvsp[-5].name) );

      c_ast_t *const udl_ast = c_ast_new_gc( K_UDEF_LIT, &(yyloc) );
      udl_ast->type.stids = c_tid_check( (yyvsp[-1].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), udl_ast );
      udl_ast->udef_lit.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_add_func(
          type_ast,
          udl_ast,
          IF_ELSE_EXPR( (yyvsp[0].ast), type_ast )
        ),
        udl_ast->udef_lit.ret_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10289 "parser.c"
    break;

  case 480: /* cast_c_astp_opt: %empty  */
#line 6113 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ NULL, NULL }; }
#line 10295 "parser.c"
    break;

  case 490: /* cast2_c_astp: param_pack_cast_c_ast  */
#line 6130 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), NULL }; }
#line 10301 "parser.c"
    break;

  case 491: /* cast2_c_astp: sname_c_ast  */
#line 6131 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), NULL }; }
#line 10307 "parser.c"
    break;

  case 492: /* param_pack_cast_c_ast: "..."  */
#line 6140 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "param_pack_cast_c_ast", "..." );\
      DUMP_AST( "in_attr__type_c_ast", type_ast );

      c_ast_set_parameter_pack( type_ast );
      (yyval.ast) = NULL;

      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_END();
    }
#line 10324 "parser.c"
    break;

  case 493: /* param_pack_cast_c_ast: "..." sname_c_ast  */
#line 6153 "parser.y"
    {
      DUMP_START( "param_pack_cast_c_ast", "... sname_c_ast" );\
      DUMP_AST( "sname_c_ast", (yyvsp[0].ast) );

      c_ast_set_parameter_pack( (yyvsp[0].ast) );
      (yyval.ast) = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10339 "parser.c"
    break;

  case 494: /* array_cast_c_astp: cast_c_astp_opt array_size_c_ast  */
#line 6170 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "array_cast_c_astp", "cast_c_astp_opt array_size_c_ast" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );
      DUMP_AST( "array_size_c_ast", (yyvsp[0].ast) );

      c_ast_set_parent(
        c_ast_new_gc( K_PLACEHOLDER, &(yylsp[-1]) ), (yyvsp[0].ast)
      );

      c_ast_t *const of_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-1].ast_pair).target_ast != NULL ) {
        // array-of or function-like-ret type
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-1].ast_pair).ast,
          c_ast_add_array( (yyvsp[-1].ast_pair).target_ast, (yyvsp[0].ast), of_ast )
        };
      } else {
        c_ast_t *const ast = IF_ELSE_EXPR( (yyvsp[-1].ast_pair).ast, of_ast );
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_array( ast, (yyvsp[0].ast), of_ast ),
          .target_ast = NULL
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10374 "parser.c"
    break;

  case 495: /* $@31: %empty  */
#line 6207 "parser.y"
    { //
      // A block AST has to be the type inherited attribute for cast_c_astp_opt
      // so we have to create it here.
      //
      ia_type_ast_push( c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) ) );
    }
#line 10385 "parser.c"
    break;

  case 496: /* block_cast_c_astp: '(' '^' $@31 type_qualifier_list_c_stid_opt cast_c_astp_opt rparen_exp param_list_c_lparen param_c_ast_list_opt param_list_rparen  */
#line 6216 "parser.y"
    {
      c_ast_t *const block_ast = ia_type_ast_pop();
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "block_cast_c_astp",
                  "'(' '^' type_qualifier_list_c_stid_opt cast_c_astp_opt ')' "
                  "'(' param_c_ast_list_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-5].tid) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-4].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-1].ast_list) );

      PARSE_ASSERT(
        c_type_add_tid( &block_ast->type, (yyvsp[-5].tid), &(yylsp[-5]) )
      );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), block_ast );
      block_ast->block.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );

      c_ast_t *const ret_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-4].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-4].ast_pair).ast,
          c_ast_add_func( (yyvsp[-4].ast_pair).target_ast, block_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( (yyvsp[-4].ast_pair).ast, block_ast, ret_ast ),
          block_ast->block.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10425 "parser.c"
    break;

  case 497: /* func_cast_c_astp: cast2_c_astp param_list_c_lparen param_c_ast_list_opt param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt  */
#line 6262 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "func_cast_c_astp",
                  "cast2_c_astp '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast2_c_astp", (yyvsp[-5].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[0].ast) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_ast_t *const func_ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
      func_ast->type.stids =
        c_tid_check( (yyvsp[-2].tid) | (yyvsp[-1].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), func_ast );
      func_ast->func.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      c_ast_t *const cast_ast = (yyvsp[-5].ast_pair).ast;
      //
      // This is for a case similar to the one in func_decl_c_astp like:
      //
      //     void f( int () () )
      //              |   |  |
      //              |   |  func
      //              |   |
      //              |   cast_ast (func)
      //              |
      //              ret_ast
      //
      // We replace ret_ast with cast_ast:
      //
      //      void f( int() () )
      //              |  |  |
      //              |  |  func
      //              X  |
      //              |  cast_ast (func)
      //              |
      //              ret_ast <- cast_ast (func)
      //
      // that is, a "function returning function returning int" -- which is
      // illegal (since functions can't return functions) and will be caught by
      // c_ast_check_ret_type().
      //
      c_ast_t *const ret_ast = cast_ast->kind == K_FUNCTION ?
        cast_ast :
        IF_ELSE_EXPR( (yyvsp[0].ast), ia_type_spec_ast( type_ast ) );

      if ( (yyvsp[-5].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          cast_ast,
          c_ast_add_func( (yyvsp[-5].ast_pair).target_ast, func_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( cast_ast, func_ast, ret_ast ),
          func_ast->func.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10496 "parser.c"
    break;

  case 498: /* $@32: %empty  */
#line 6334 "parser.y"
    {
      ia_type_ast_push( c_ast_new_gc( K_PLACEHOLDER, &(yyloc) ) );
      ++in_attr.ast_depth;
    }
#line 10505 "parser.c"
    break;

  case 499: /* nested_cast_c_astp: '(' $@32 cast_c_astp_opt rparen_exp  */
#line 6339 "parser.y"
    {
      ia_type_ast_pop();
      --in_attr.ast_depth;

      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "nested_cast_c_astp", "'(' cast_c_astp_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.ast_pair) = (yyvsp[-1].ast_pair);

      if ( (yyval.ast_pair).ast == NULL ) {
        //
        // This is for a case like:
        //
        //      void f( int() )
        //                 ^^
        //
        // where the unnamed parameter is a "function returning int".  (In
        // param_c_ast, this will be converted into a "pointer to function
        // returning int".)
        //
        (yyval.ast_pair).ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
        c_ast_set_parent( type_ast, (yyval.ast_pair).ast );
      } else {
        (yyval.ast_pair).ast->loc = (yyloc);
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10542 "parser.c"
    break;

  case 500: /* $@33: %empty  */
#line 6376 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10548 "parser.c"
    break;

  case 501: /* pointer_cast_c_astp: pointer_type_c_ast $@33 cast_c_astp_opt  */
#line 6378 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_cast_c_astp", "pointer_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10568 "parser.c"
    break;

  case 502: /* $@34: %empty  */
#line 6398 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10574 "parser.c"
    break;

  case 503: /* pointer_to_member_cast_c_astp: pointer_to_member_type_c_ast $@34 cast_c_astp_opt  */
#line 6400 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_cast_c_astp",
                  "pointer_to_member_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10595 "parser.c"
    break;

  case 504: /* $@35: %empty  */
#line 6421 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10601 "parser.c"
    break;

  case 505: /* reference_cast_c_astp: reference_type_c_ast $@35 cast_c_astp_opt  */
#line 6423 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_cast_c_astp",
                  "reference_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10622 "parser.c"
    break;

  case 506: /* udc_decl_c_ast_opt: %empty  */
#line 6450 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 10628 "parser.c"
    break;

  case 512: /* $@36: %empty  */
#line 6462 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10634 "parser.c"
    break;

  case 513: /* pointer_udc_decl_c_ast: pointer_type_c_ast $@36 udc_decl_c_ast_opt  */
#line 6464 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_udc_decl_c_ast",
                  "pointer_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10652 "parser.c"
    break;

  case 514: /* $@37: %empty  */
#line 6480 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10658 "parser.c"
    break;

  case 515: /* pointer_to_member_udc_decl_c_ast: pointer_to_member_type_c_ast $@37 udc_decl_c_ast_opt  */
#line 6482 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_udc_decl_c_ast",
                  "pointer_to_member_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10676 "parser.c"
    break;

  case 516: /* $@38: %empty  */
#line 6498 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10682 "parser.c"
    break;

  case 517: /* reference_udc_decl_c_ast: reference_type_c_ast $@38 udc_decl_c_ast_opt  */
#line 6500 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_udc_decl_c_ast",
                  "reference_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10700 "parser.c"
    break;

  case 518: /* type_c_ast: type_modifier_list_c_type  */
#line 6526 "parser.y"
    {
      DUMP_START( "type_c_ast", "type_modifier_list_c_type" );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[0].type) );

      //
      // Prior to C99, typeless declarations are implicitly int, so we set it
      // here.  In C99 and later, however, implicit int is an error, so we
      // don't set it here and c_ast_check() will catch the error later.
      //
      // Note that type modifiers, e.g., unsigned, count as a type since that
      // means unsigned int; however, neither qualifiers, e.g., const, nor
      // storage classes, e.g., register, by themselves count as a type:
      //
      //      unsigned i;   // legal in C99
      //      const    j;   // illegal in C99
      //      register k;   // illegal in C99
      //
      c_type_t type = OPT_LANG_IS( IMPLICIT_int ) ?
        C_TYPE_LIT_B( TB_int ) : T_NONE;

      PARSE_ASSERT( c_type_add( &type, &(yyvsp[0].type), &(yylsp[0]) ) );

      if ( type.btids == TB_int ) {     // type is still the TB_int we added
        //
        // This check has to be done now in the parser rather than later in the
        // AST since the AST has no memory that the "int" is implicit.
        //
        // Alternatively, we could _not_ set TB_int here, but then we'd need a
        // new separate AST "fix-up" pass that would change TB_NONE to TB_int.
        // Objectively, that's probably the better solution, but it's a lot of
        // extra code that would currently only be needed to fix-up implicit
        // int.
        //
        print_warning( &(yylsp[0]),
          "missing type specifier; \"%s\" assumed\n",
          c_tid_error( TB_int )
        );
      }

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type = type;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10750 "parser.c"
    break;

  case 519: /* type_c_ast: type_modifier_list_c_type east_modified_type_c_ast  */
#line 6578 "parser.y"
    {
      DUMP_START( "type_c_ast",
                  "type_modifier_list_c_type east_modified_type_c_ast " );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[-1].type) );
      DUMP_AST( "east_modified_type_c_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10768 "parser.c"
    break;

  case 521: /* type_modifier_list_c_type_opt: %empty  */
#line 6596 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 10774 "parser.c"
    break;

  case 523: /* type_modifier_list_c_type: type_modifier_list_c_type type_modifier_c_type  */
#line 6602 "parser.y"
    {
      DUMP_START( "type_modifier_list_c_type",
                  "type_modifier_list_c_type type_modifier_c_type" );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_modifier_c_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 10791 "parser.c"
    break;

  case 525: /* type_modifier_c_type: type_modifier_base_type  */
#line 6620 "parser.y"
    {
      (yyval.type) = (yyvsp[0].type);
      //
      // This is for a case like:
      //
      //      explain typedef unsigned long size_t
      //
      // that is: explain a redefinition of a typedef'd type with the same type
      // that contains only one or more type_modifier_base_type.  The problem
      // is that, without an east_modified_type_c_ast (like int), the parser
      // would ordinarily take the typedef'd type (here, the size_t) as part of
      // the type_c_ast and then be out of tokens for the decl_c_astp -- at
      // which time it'll complain.
      //
      // Since type modifiers can't apply to a typedef'd type (e.g., "long
      // size_t" is illegal), we tell the lexer not to return either
      // Y_TYPEDEF_NAME_TDEF or Y_TYPEDEF_SNAME_TDEF if we encounter at least
      // one type modifier (except "register" since it's is really a storage
      // class -- see the comment in type_modifier_base_type about "register").
      //
      if ( (yyval.type).stids != TS_register )
        lexer_find &= ~LEXER_FIND_TYPES;
    }
#line 10819 "parser.c"
    break;

  case 526: /* type_modifier_c_type: type_qualifier_c_stid  */
#line 6643 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10825 "parser.c"
    break;

  case 528: /* type_modifier_c_type: attribute_specifier_list_c_atid  */
#line 6646 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 10833 "parser.c"
    break;

  case 529: /* type_modifier_base_type: Y__Complex  */
#line 6652 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10839 "parser.c"
    break;

  case 530: /* type_modifier_base_type: Y__Imaginary  */
#line 6653 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10845 "parser.c"
    break;

  case 531: /* type_modifier_base_type: Y_long  */
#line 6654 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10851 "parser.c"
    break;

  case 532: /* type_modifier_base_type: Y_short  */
#line 6655 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10857 "parser.c"
    break;

  case 533: /* type_modifier_base_type: Y_signed  */
#line 6656 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10863 "parser.c"
    break;

  case 534: /* type_modifier_base_type: Y_unsigned  */
#line 6657 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10869 "parser.c"
    break;

  case 535: /* type_modifier_base_type: Y_EMC__Sat  */
#line 6658 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10875 "parser.c"
    break;

  case 536: /* type_modifier_base_type: Y_register  */
#line 6664 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10881 "parser.c"
    break;

  case 537: /* east_modified_type_c_ast: east_modifiable_type_c_ast type_modifier_list_c_type_opt  */
#line 6670 "parser.y"
    {
      DUMP_START( "east_modified_type_c_ast",
                  "east_modifiable_type_c_ast type_modifier_list_c_type_opt" );
      DUMP_AST( "east_modifiable_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TYPE( "type_modifier_list_c_type_opt", (yyvsp[0].type) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10899 "parser.c"
    break;

  case 538: /* east_modified_type_c_ast: enum_class_struct_union_c_ast cv_qualifier_list_stid_opt  */
#line 6686 "parser.y"
    {
      DUMP_START( "east_modified_type_c_ast",
                  "enum_class_struct_union_c_ast cv_qualifier_list_stid_opt" );
      DUMP_AST( "enum_class_struct_union_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10917 "parser.c"
    break;

  case 545: /* $@39: %empty  */
#line 6714 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 10925 "parser.c"
    break;

  case 546: /* atomic_specifier_type_c_ast: Y__Atomic_SPEC lparen_exp type_c_ast $@39 cast_c_astp_opt rparen_exp  */
#line 6718 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "atomic_specifier_type_c_ast",
                  "ATOMIC '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.ast) = IF_ELSE_EXPR( (yyvsp[-1].ast_pair).ast, (yyvsp[-3].ast) );
      (yyval.ast)->loc = (yyloc);

      //
      // Ensure the _Atomic() specifier type doesn't have either a storage
      // class or attributes:
      //
      //      const _Atomic(int) x;     // OK
      //      _Atomic(const int) y;     // error
      //
      // This check has to be done now in the parser rather than later in the
      // AST since the type would be stored as "atomic const int" either way so
      // the AST has no "memory" of which it was.
      //
      if ( (yyval.ast)->type.stids != TS_NONE || (yyval.ast)->type.atids != TA_NONE ) {
        static c_type_t const TSA_ANY = { TB_NONE, TS_ANY, TA_ANY };
        c_type_t const error_type = c_type_and( &(yyval.ast)->type, &TSA_ANY );
        print_error( &(yylsp[-3]),
          "\"%s\" can not be of \"%s\"\n",
          c_tid_error( TS__Atomic ),
          c_type_gibberish( &error_type )
        );
        PARSE_ABORT();
      }

      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, TS__Atomic, &(yylsp[-5]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10968 "parser.c"
    break;

  case 547: /* builtin_type_c_ast: builtin_no_BitInt_c_btid  */
#line 6762 "parser.y"
    {
      DUMP_START( "builtin_type_c_ast", "builtin_no_BitInt_c_btid" );
      DUMP_TID( "builtin_no_BitInt_c_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10983 "parser.c"
    break;

  case 548: /* builtin_type_c_ast: Y__BitInt lparen_exp uint_lit_exp rparen_exp  */
#line 6773 "parser.y"
    {
      DUMP_START( "builtin_type_c_ast", "_BitInt '(' uint_lit_exp ')'" );
      DUMP_INT( "uint_lit_exp", (yyvsp[-1].uint_val) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = TB__BitInt;
      (yyval.ast)->builtin.BitInt.width = (yyvsp[-1].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10999 "parser.c"
    break;

  case 557: /* builtin_no_BitInt_c_btid: Y_decltype  */
#line 6796 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "decltype declarations" );
    }
#line 11007 "parser.c"
    break;

  case 564: /* concept_type_c_ast: Y_CONCEPT_SNAME auto_TYPE_exp  */
#line 6811 "parser.y"
    {
      DUMP_START( "concept_type_c_ast", "Y_CONCEPT_SNAME AUTO" );
      DUMP_SNAME( "Y_CONCEPT_SNAME", (yyvsp[-1].sname) );

      c_sname_set_all_types( &(yyvsp[-1].sname) );

      (yyval.ast) = c_ast_new_gc( K_CONCEPT, &(yylsp[-1]) );
      (yyval.ast)->concept.concept_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11024 "parser.c"
    break;

  case 565: /* structured_binding_type_c_ast: Y_auto_STRUCTURED_BINDING cv_qualifier_list_stid_opt ref_qualifier_c_stid_opt lbracket_exp sname_list_c rbracket_exp  */
#line 6831 "parser.y"
    {
      DUMP_START( "structured_binding_type_c_ast",
                  "AUTO cv_qualifier_list_stid_opt ref_qualifier_c_stid_opt "
                  "'[' sname_list_c ']'" );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );

      (yyval.ast) = c_ast_new_gc( K_STRUCTURED_BINDING, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-4].tid) | (yyvsp[-3].tid), C_TPID_STORE );
      (yyval.ast)->struct_bind.sname_list = slist_move( &(yyvsp[-1].sname_list) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11043 "parser.c"
    break;

  case 566: /* typedef_type_c_ast: any_typedef_tdef sub_scope_sname_c_opt  */
#line 6851 "parser.y"
    {
      c_ast_t *type_ast = ia_type_ast_peek();
      c_ast_t const *type_for_ast = (yyvsp[-1].tdef)->ast;

      DUMP_START( "typedef_type_c_ast",
                  "any_typedef_tdef sub_scope_sname_c_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST( "any_typedef__ast", type_for_ast );
      DUMP_SNAME( "sub_scope_sname_c_opt", (yyvsp[0].sname) );

      if ( c_sname_empty( &(yyvsp[0].sname) ) ) {
ttntd:  (yyval.ast) = c_ast_new_gc( K_TYPEDEF, &(yyloc) );
        (yyval.ast)->type.btids = TB_typedef;
        (yyval.ast)->tdef.for_ast = type_for_ast;
      }
      else {
        c_sname_t temp_sname = c_sname_dup( &(yyvsp[-1].tdef)->ast->sname );
        c_sname_append_sname( &temp_sname, &(yyvsp[0].sname) );

        if ( type_ast == NULL ) {
          //
          // This is for a case like:
          //
          //      define S as struct S
          //      explain S::T x
          //
          // that is: a typedef'd type followed by ::T where T is an unknown
          // name used as a type. Just assume the T is some type, say int, and
          // create a name for it.
          //
          type_ast = c_ast_new_gc( K_BUILTIN, &(yyloc) );
          type_ast->type.btids = TB_int;
          c_sname_set( &type_ast->sname, &temp_sname );
          type_for_ast = type_ast;
          goto ttntd;
        }

        //
        // Otherwise, this is for cases like:
        //
        //  1. A typedef'd type used for a scope:
        //
        //          define S as struct S
        //          explain int S::x
        //
        //  2. A typedef'd type used for an intermediate scope:
        //
        //          define S as struct S
        //          define T as struct T
        //          explain int S::T::x
        //
        (yyval.ast) = type_ast;
        c_sname_set( &(yyval.ast)->sname, &temp_sname );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11106 "parser.c"
    break;

  case 567: /* sub_scope_sname_c_opt: %empty  */
#line 6912 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 11112 "parser.c"
    break;

  case 568: /* sub_scope_sname_c_opt: Y_COLON_COLON any_sname_c  */
#line 6914 "parser.y"
    {
      (yyval.sname) = (yyvsp[0].sname);
    }
#line 11120 "parser.c"
    break;

  case 569: /* $@40: %empty  */
#line 6923 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 11128 "parser.c"
    break;

  case 570: /* typeof_type_c_ast: typeof lparen_exp type_c_ast $@40 cast_c_astp_opt rparen_exp  */
#line 6927 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "typeof_type_c_ast",
                  "TYPEOF '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_BOOL( "is_unqual", (yyvsp[-5].flag) );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      if ( (yyvsp[-5].flag) ) {
        c_ast_t const *const raw_ast = c_ast_untypedef( (yyvsp[-3].ast) );
        if ( raw_ast != (yyvsp[-3].ast) &&
             c_tid_is_any( raw_ast->type.stids, TS__Atomic | TS_CVR ) ) {
          //
          // The type is a typedef and the type that it's for is ACVR-qualified
          // so we need to dup _that_ type before un-ACVR-qualifying it because
          // we don't want to modify it.
          //
          c_loc_t const *const orig_loc = &(yyvsp[-3].ast)->loc;
          (yyvsp[-3].ast) = c_ast_dup_gc( raw_ast );
          (yyvsp[-3].ast)->loc = *orig_loc;
        }
        (yyvsp[-3].ast)->type.stids &= c_tid_compl( TS__Atomic | TS_CVR );
      }

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-3].ast), (yyvsp[-1].ast_pair).ast );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      //
      // Overwrite type_spec_ast to be the typeof type since _that_ is the base
      // type for one or more declarators, e.g.:
      //
      //      typeof(int*) p, a[2], f(char)
      //
      in_attr.type_spec_ast = (yyval.ast);
    }
#line 11171 "parser.c"
    break;

  case 571: /* typeof_type_c_ast: typeof lparen_exp error  */
#line 6967 "parser.y"
    {
      elaborate_error(
        "typeof(expression) declarations not supported by " CDECL
      );
    }
#line 11181 "parser.c"
    break;

  case 572: /* typeof: Y_typeof  */
#line 6975 "parser.y"
                                  { (yyval.flag) = /*is_unqual=*/false; }
#line 11187 "parser.c"
    break;

  case 573: /* typeof: Y_typeof_unqual  */
#line 6976 "parser.y"
                                  { (yyval.flag) = /*is_unqual=*/true;  }
#line 11193 "parser.c"
    break;

  case 576: /* class_struct_union_c_ast: class_struct_union_btid attribute_specifier_list_c_atid_opt any_sname_c_exp  */
#line 6989 "parser.y"
    {
      DUMP_START( "enum_class_struct_union_c_ast",
                  "class_struct_union_btid "
                  "attribute_specifier_list_c_atid_opt any_sname_c_exp" );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-2].tid) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-1].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-1].tid), C_TPID_ATTR );
      (yyval.ast)->csu.csu_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11214 "parser.c"
    break;

  case 577: /* class_struct_union_c_ast: class_struct_union_btid attribute_specifier_list_c_atid_opt any_sname_c_opt '{'  */
#line 7008 "parser.y"
    {
      c_sname_cleanup( &(yyvsp[-1].sname) );
      UNSUPPORTED( &(yylsp[0]),
        "explaining %s declarations", c_tid_gibberish( (yyvsp[-3].tid) )
      );
    }
#line 11225 "parser.c"
    break;

  case 578: /* enum_c_ast: enum_btids attribute_specifier_list_c_atid_opt any_sname_c_exp enum_fixed_type_c_ast_opt  */
#line 7019 "parser.y"
    {
      DUMP_START( "enum_c_ast",
                  "enum_btids attribute_specifier_list_c_atid_opt "
                  "any_sname_c_exp enum_fixed_type_c_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-3].tid) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ENUM, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-3].tid), C_TPID_BASE );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-2].tid), C_TPID_ATTR );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      (yyval.ast)->enum_.enum_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11248 "parser.c"
    break;

  case 579: /* enum_c_ast: enum_btids attribute_specifier_list_c_atid_opt any_sname_c_opt '{'  */
#line 7040 "parser.y"
    {
      c_sname_cleanup( &(yyvsp[-1].sname) );
      UNSUPPORTED( &(yylsp[0]),
        "explaining %s declarations", c_tid_gibberish( (yyvsp[-3].tid) )
      );
    }
#line 11259 "parser.c"
    break;

  case 580: /* enum_btids: Y_enum class_struct_btid_opt  */
#line 7051 "parser.y"
                                  { (yyval.tid) = (yyvsp[-1].tid) | (yyvsp[0].tid); }
#line 11265 "parser.c"
    break;

  case 581: /* enum_fixed_type_c_ast_opt: %empty  */
#line 7055 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 11271 "parser.c"
    break;

  case 582: /* enum_fixed_type_c_ast_opt: ':' enum_fixed_type_c_ast  */
#line 7056 "parser.y"
                                  { (yyval.ast) = (yyvsp[0].ast); }
#line 11277 "parser.c"
    break;

  case 583: /* enum_fixed_type_c_ast_opt: ':' error  */
#line 7058 "parser.y"
    {
      elaborate_error( "type name expected" );
    }
#line 11285 "parser.c"
    break;

  case 584: /* enum_fixed_type_c_ast: enum_fixed_type_modifier_list_btid  */
#line 7074 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_fixed_type_modifier_list_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11301 "parser.c"
    break;

  case 585: /* enum_fixed_type_c_ast: enum_fixed_type_modifier_list_btid enum_unmodified_fixed_type_c_ast enum_fixed_type_modifier_list_btid_opt  */
#line 7094 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_fixed_type_modifier_list_btid "
                  "enum_unmodified_fixed_type_c_ast "
                  "enum_fixed_type_modifier_list_btid_opt" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[-2].tid) );
      DUMP_AST( "enum_unmodified_fixed_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "enum_fixed_type_modifier_list_btid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-2].tid), &(yylsp[-2]) ) );
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11323 "parser.c"
    break;

  case 586: /* enum_fixed_type_c_ast: enum_unmodified_fixed_type_c_ast enum_fixed_type_modifier_list_btid_opt  */
#line 7119 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_unmodified_fixed_type_c_ast "
                  "enum_fixed_type_modifier_list_btid_opt" );
      DUMP_AST( "enum_unmodified_fixed_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "enum_fixed_type_modifier_list_btid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11342 "parser.c"
    break;

  case 587: /* enum_fixed_type_modifier_list_btid_opt: %empty  */
#line 7136 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 11348 "parser.c"
    break;

  case 589: /* enum_fixed_type_modifier_list_btid: enum_fixed_type_modifier_list_btid enum_fixed_type_modifier_btid  */
#line 7143 "parser.y"
    {
      DUMP_START( "enum_fixed_type_modifier_list_btid",
                  "enum_fixed_type_modifier_list_btid "
                  "enum_fixed_type_modifier_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[-1].tid) );
      DUMP_TID( "enum_fixed_type_modifier_btid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_btids", (yyval.tid) );
      DUMP_END();
    }
#line 11366 "parser.c"
    break;

  case 598: /* class_struct_btid_opt: %empty  */
#line 7176 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 11372 "parser.c"
    break;

  case 604: /* type_qualifier_list_c_stid_opt: %empty  */
#line 7193 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 11378 "parser.c"
    break;

  case 606: /* type_qualifier_list_c_stid: type_qualifier_list_c_stid type_qualifier_c_stid gnu_or_msc_attribute_specifier_list_c_opt  */
#line 7200 "parser.y"
    {
      DUMP_START( "type_qualifier_list_c_stid",
                  "type_qualifier_list_c_stid type_qualifier_c_stid" );
      DUMP_TID( "type_qualifier_list_c_stid", (yyvsp[-2].tid) );
      DUMP_TID( "type_qualifier_c_stid", (yyvsp[-1].tid) );

      (yyval.tid) = (yyvsp[-2].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[-1].tid), &(yylsp[-1]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 11395 "parser.c"
    break;

  case 607: /* type_qualifier_list_c_stid: gnu_or_msc_attribute_specifier_list_c type_qualifier_c_stid  */
#line 7214 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 11403 "parser.c"
    break;

  case 608: /* type_qualifier_list_c_stid: type_qualifier_c_stid gnu_or_msc_attribute_specifier_list_c_opt  */
#line 7219 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 11411 "parser.c"
    break;

  case 618: /* cv_qualifier_list_stid_opt: %empty  */
#line 7240 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 11417 "parser.c"
    break;

  case 619: /* cv_qualifier_list_stid_opt: cv_qualifier_list_stid_opt cv_qualifier_stid  */
#line 7242 "parser.y"
    {
      DUMP_START( "cv_qualifier_list_stid_opt",
                  "cv_qualifier_list_stid_opt cv_qualifier_stid" );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "cv_qualifier_stid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 11434 "parser.c"
    break;

  case 620: /* restrict_qualifier_c_stid: Y_restrict  */
#line 7258 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since both "restrict" and "__restrict" map to TS_restrict and the
      // AST has no "memory" of which it was.
      //
      if ( OPT_LANG_IS( CPP_ANY ) ) {
        print_error( &(yylsp[0]),
          "\"restrict\" not supported in C++; use \"%s\" instead\n",
          L_GNU___restrict
        );
        PARSE_ABORT();
      }
    }
#line 11452 "parser.c"
    break;

  case 625: /* upc_layout_qualifier_c: '[' error ']'  */
#line 7279 "parser.y"
    {
      elaborate_error( "one of nothing, integer, or '*' expected" );
    }
#line 11460 "parser.c"
    break;

  case 626: /* storage_class_c_type: Y_auto_STORAGE  */
#line 7287 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11466 "parser.c"
    break;

  case 627: /* storage_class_c_type: Y_Apple___block  */
#line 7288 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11472 "parser.c"
    break;

  case 628: /* storage_class_c_type: Y_consteval  */
#line 7289 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11478 "parser.c"
    break;

  case 629: /* storage_class_c_type: Y_constexpr  */
#line 7290 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11484 "parser.c"
    break;

  case 630: /* storage_class_c_type: Y_constinit  */
#line 7291 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11490 "parser.c"
    break;

  case 631: /* storage_class_c_type: Y_explicit  */
#line 7292 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11496 "parser.c"
    break;

  case 632: /* storage_class_c_type: Y_export  */
#line 7293 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11502 "parser.c"
    break;

  case 633: /* storage_class_c_type: Y_extern  */
#line 7294 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11508 "parser.c"
    break;

  case 634: /* storage_class_c_type: extern_linkage_c_stid  */
#line 7295 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11514 "parser.c"
    break;

  case 635: /* storage_class_c_type: Y_final  */
#line 7296 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11520 "parser.c"
    break;

  case 636: /* storage_class_c_type: Y_friend  */
#line 7297 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11526 "parser.c"
    break;

  case 637: /* storage_class_c_type: Y_inline  */
#line 7298 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11532 "parser.c"
    break;

  case 638: /* storage_class_c_type: Y_mutable  */
#line 7299 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11538 "parser.c"
    break;

  case 639: /* storage_class_c_type: _Noreturn_atid  */
#line 7301 "parser.y"
    {
      //
      // These checks have to be done now in the parser rather than later in
      // the AST because the _Noreturn keyword is mapped to the [[noreturn]]
      // attribute and the AST has no "memory" that it was _Noreturn.
      //
      if ( !OPT_LANG_IS( _Noreturn ) ) {
        print_error( &(yylsp[0]),
          "\"%s\" keyword not supported%s",
          yytext, C_LANG_WHICH( _Noreturn )
        );
        print_hint(
          "%snoreturn%s", other_token_c( "[[" ), other_token_c( "]]" )
        );
        PARSE_ABORT();
      }
      if ( !OPT_LANG_IS( _Noreturn_NOT_DEPRECATED ) ) {
        print_warning( &(yylsp[0]),
          "\"%s\" is deprecated%s",
          yytext, C_LANG_WHICH( _Noreturn_NOT_DEPRECATED )
        );
        print_hint(
          "%snoreturn%s", other_token_c( "[[" ), other_token_c( "]]" )
        );
      }

      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 11571 "parser.c"
    break;

  case 640: /* storage_class_c_type: Y_override  */
#line 7329 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11577 "parser.c"
    break;

  case 641: /* storage_class_c_type: Y_static  */
#line 7331 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11583 "parser.c"
    break;

  case 642: /* storage_class_c_type: Y_typedef  */
#line 7332 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11589 "parser.c"
    break;

  case 643: /* storage_class_c_type: Y__Thread_local  */
#line 7333 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11595 "parser.c"
    break;

  case 644: /* storage_class_c_type: Y_thread_local  */
#line 7334 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11601 "parser.c"
    break;

  case 645: /* storage_class_c_type: Y_virtual  */
#line 7335 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11607 "parser.c"
    break;

  case 648: /* attribute_specifier_list_c_atid_opt: %empty  */
#line 7346 "parser.y"
                                  { (yyval.tid) = TA_NONE; }
#line 11613 "parser.c"
    break;

  case 650: /* $@41: %empty  */
#line 7352 "parser.y"
    {
      if ( !OPT_LANG_IS( ATTRIBUTES ) ) {
        print_error( &(yylsp[-1]),
          "\"%s\" attribute syntax not supported%s\n",
          other_token_c( "[[" ),
          C_LANG_WHICH( ATTRIBUTES )
        );
        PARSE_ABORT();
      }
      lexer_keyword_ctx = C_KW_CTX_ATTRIBUTE;
    }
#line 11629 "parser.c"
    break;

  case 651: /* attribute_specifier_list_c_atid: Y_ATTR_BEGIN '[' $@41 using_opt attribute_list_c_atid_opt ']' rbracket_exp  */
#line 7364 "parser.y"
    {
      lexer_keyword_ctx = C_KW_CTX_DEFAULT;

      DUMP_START( "attribute_specifier_list_c_atid",
                  "'[[' using_opt attribute_list_c_atid_opt ']]'" );
      DUMP_TID( "attribute_list_c_atid_opt", (yyvsp[-2].tid) );

      (yyval.tid) = (yyvsp[-2].tid);

      DUMP_END();
    }
#line 11645 "parser.c"
    break;

  case 652: /* attribute_specifier_list_c_atid: gnu_or_msc_attribute_specifier_list_c  */
#line 7377 "parser.y"
    {
      (yyval.tid) = TA_NONE;
    }
#line 11653 "parser.c"
    break;

  case 654: /* using_opt: Y_using name_exp colon_exp  */
#line 7385 "parser.y"
    {
      IGNORING( &(yylsp[-2]), "\"using\" in attributes" );
      free( (yyvsp[-1].name) );
    }
#line 11662 "parser.c"
    break;

  case 655: /* attribute_list_c_atid_opt: %empty  */
#line 7392 "parser.y"
                                  { (yyval.tid) = TA_NONE; }
#line 11668 "parser.c"
    break;

  case 657: /* attribute_list_c_atid: attribute_list_c_atid comma_exp attribute_c_atid_exp  */
#line 7398 "parser.y"
    {
      DUMP_START( "attribute_list_c_atid",
                  "attribute_list_c_atid ',' attribute_c_atid" );
      DUMP_TID( "attribute_list_c_atid", (yyvsp[-2].tid) );
      DUMP_TID( "attribute_c_atid_exp", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-2].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_atids", (yyval.tid) );
      DUMP_END();
    }
#line 11685 "parser.c"
    break;

  case 668: /* attribute_c_atid_exp: sname_c  */
#line 7425 "parser.y"
    {
      if ( c_sname_count( &(yyvsp[0].sname) ) > 1 ) {
        IGNORING( &(yylsp[0]),
          "\"%s\": namespaced attributes", c_sname_gibberish( &(yyvsp[0].sname) )
        );
      }
      else {
        char const *adj = "unknown";
        c_lang_id_t lang_ids = LANG_NONE;

        char const *const name = c_sname_local_name( &(yyvsp[0].sname) );
        c_keyword_t const *const ck = c_keyword_find(
          name, c_lang_newer( opt_lang_id ), C_KW_CTX_ATTRIBUTE
        );
        if ( ck != NULL && c_tid_tpid( ck->tid ) == C_TPID_ATTR ) {
          adj = "unsupported";
          lang_ids = ck->lang_ids;
        }
        print_warning( &(yylsp[0]),
          "\"%s\": %s attribute%s",
          name, adj, c_lang_which( lang_ids )
        );

        print_suggestions( DYM_C_ATTRIBUTES, name );
        EPUTC( '\n' );
      }

      (yyval.tid) = TA_NONE;
      c_sname_cleanup( &(yyvsp[0].sname) );
    }
#line 11720 "parser.c"
    break;

  case 669: /* attribute_c_atid_exp: error  */
#line 7456 "parser.y"
    {
      elaborate_error_dym( DYM_C_ATTRIBUTES, "attribute name expected" );
    }
#line 11728 "parser.c"
    break;

  case 671: /* attribute_str_arg_c_opt: '(' str_lit_exp rparen_exp  */
#line 7464 "parser.y"
    {
      IGNORING( &(yylsp[-2]), "attribute arguments" );
      free( (yyvsp[-1].str_val) );
    }
#line 11737 "parser.c"
    break;

  case 680: /* $@42: %empty  */
#line 7492 "parser.y"
    {
      attr_syntax_not_supported( L_GNU___attribute__, &(yylsp[0]) );
      //
      // Temporariy disabling finding keywords allows GNU attributes that are C
      // keywords (e.g., const) to be found as ordinary string literals.
      //
      lexer_find &= ~LEXER_FIND_C_KEYWORDS;
    }
#line 11750 "parser.c"
    break;

  case 681: /* gnu_attribute_specifier_c: Y_GNU___attribute__ $@42 lparen_exp lparen_exp gnu_attribute_list_c_opt ')' rparen_exp  */
#line 7501 "parser.y"
    {
      lexer_find |= LEXER_FIND_C_KEYWORDS;
    }
#line 11758 "parser.c"
    break;

  case 686: /* gnu_attribute_c_exp: Y_NAME gnu_attribute_decl_arg_list_c_opt  */
#line 7518 "parser.y"
    {
      free( (yyvsp[-1].name) );
    }
#line 11766 "parser.c"
    break;

  case 687: /* gnu_attribute_c_exp: error  */
#line 7522 "parser.y"
    {
      elaborate_error( "attribute name expected" );
    }
#line 11774 "parser.c"
    break;

  case 694: /* gnu_attribute_arg_c: Y_NAME  */
#line 7543 "parser.y"
                                  { free( (yyvsp[0].name) ); }
#line 11780 "parser.c"
    break;

  case 695: /* gnu_attribute_arg_c: Y_CHAR_LIT  */
#line 7544 "parser.y"
                                  { free( (yyvsp[0].str_val) ); }
#line 11786 "parser.c"
    break;

  case 697: /* gnu_attribute_arg_c: Y_STR_LIT  */
#line 7546 "parser.y"
                                  { free( (yyvsp[0].str_val) ); }
#line 11792 "parser.c"
    break;

  case 699: /* gnu_attribute_arg_c: Y_LEXER_ERROR  */
#line 7549 "parser.y"
    {
      PARSE_ABORT();
    }
#line 11800 "parser.c"
    break;

  case 702: /* $@43: %empty  */
#line 7561 "parser.y"
    {
      attr_syntax_not_supported( L_MSC___declspec, &(yylsp[0]) );
      // See comment in gnu_attribute_specifier_c.
      lexer_find &= ~LEXER_FIND_C_KEYWORDS;
    }
#line 11810 "parser.c"
    break;

  case 703: /* msc_attribute_specifier_c: Y_MSC___declspec $@43 lparen_exp msc_attribute_list_c_opt ')'  */
#line 7567 "parser.y"
    {
      lexer_find |= LEXER_FIND_C_KEYWORDS;
    }
#line 11818 "parser.c"
    break;

  case 711: /* array_decl_english_ast: Y_array array_size_decl_ast of_exp decl_english_ast  */
#line 7603 "parser.y"
    {
      DUMP_START( "array_decl_english_ast",
                  "ARRAY array_size_num_opt OF decl_english_ast" );
      DUMP_AST( "array_size_decl_ast", (yyvsp[-2].ast) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[-2].ast);
      (yyval.ast)->loc = (yylsp[-3]);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11836 "parser.c"
    break;

  case 712: /* array_decl_english_ast: Y_variable length_opt array_exp name_opt of_exp decl_english_ast  */
#line 7619 "parser.y"
    {
      DUMP_START( "array_decl_english_ast",
                  "VARIABLE LENGTH ARRAY name_opt OF decl_english_ast" );
      DUMP_STR( "name_opt", (yyvsp[-2].name) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      if ( (yyvsp[-2].name) == NULL ) {
        (yyval.ast)->array.kind = C_ARRAY_SIZE_VLA;
      } else {
        (yyval.ast)->array.kind = C_ARRAY_SIZE_NAME;
        (yyval.ast)->array.size_name = (yyvsp[-2].name);
      }
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11859 "parser.c"
    break;

  case 713: /* array_size_decl_ast: %empty  */
#line 7641 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NONE;
    }
#line 11868 "parser.c"
    break;

  case 714: /* array_size_decl_ast: uint_lit  */
#line 7646 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_INT;
      (yyval.ast)->array.size_int = (yyvsp[0].uint_val);
    }
#line 11878 "parser.c"
    break;

  case 715: /* array_size_decl_ast: Y_NAME  */
#line 7652 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NAME;
      (yyval.ast)->array.size_name = (yyvsp[0].name);
    }
#line 11888 "parser.c"
    break;

  case 716: /* array_size_decl_ast: '*'  */
#line 7658 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_VLA;
    }
#line 11897 "parser.c"
    break;

  case 719: /* block_decl_english_ast: Y_Apple_block paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 7675 "parser.y"
    {
      DUMP_START( "block_decl_english_ast",
                  "BLOCK paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), (yyval.ast) );
      (yyval.ast)->block.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11917 "parser.c"
    break;

  case 720: /* constructor_decl_english_ast: Y_constructor paren_param_decl_list_english_opt  */
#line 7696 "parser.y"
    {
      DUMP_START( "constructor_decl_english_ast",
                  "CONSTRUCTOR paren_param_decl_list_english_opt" );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[0].ast_list) );

      (yyval.ast) = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[0].ast_list), (yyval.ast) );
      (yyval.ast)->ctor.param_ast_list = slist_move( &(yyvsp[0].ast_list) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11934 "parser.c"
    break;

  case 721: /* destructor_decl_english_ast: Y_destructor destructor_parens_opt  */
#line 7714 "parser.y"
    {
      DUMP_START( "destructor_decl_english_ast", "DESTRUCTOR ['(' ')']" );

      (yyval.ast) = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11947 "parser.c"
    break;

  case 724: /* func_decl_english_ast: func_qualifier_english_type_opt member_or_non_member_opt Y_function paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 7736 "parser.y"
    {
      DUMP_START( "func_decl_english_ast",
                  "ref_qualifier_english_stid_opt "
                  "member_or_non_member_opt "
                  "FUNCTION paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_TYPE( "func_qualifier_english_type_opt", (yyvsp[-4].type) );
      DUMP_INT( "member_or_non_member_opt", (yyvsp[-3].member) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_FUNCTION, &(yyloc) );
      (yyval.ast)->type = (yyvsp[-4].type);
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), (yyval.ast) );
      (yyval.ast)->func.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      (yyval.ast)->func.member = (yyvsp[-3].member);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11973 "parser.c"
    break;

  case 725: /* func_qualifier_english_type_opt: ref_qualifier_english_stid_opt  */
#line 7761 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) );
    }
#line 11981 "parser.c"
    break;

  case 726: /* func_qualifier_english_type_opt: msc_calling_convention_atid  */
#line 7765 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 11989 "parser.c"
    break;

  case 733: /* paren_param_decl_list_english_opt: %empty  */
#line 7782 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 11995 "parser.c"
    break;

  case 735: /* paren_param_decl_list_english: '(' param_decl_list_english_opt ')'  */
#line 7788 "parser.y"
    {
      DUMP_START( "paren_param_decl_list_english",
                  "'(' param_decl_list_english_opt ')'" );
      DUMP_AST_LIST( "param_decl_list_english_opt", (yyvsp[-1].ast_list) );

      (yyval.ast_list) = (yyvsp[-1].ast_list);

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 12010 "parser.c"
    break;

  case 736: /* param_decl_list_english_opt: %empty  */
#line 7801 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 12016 "parser.c"
    break;

  case 738: /* param_decl_list_english: param_decl_list_english comma_exp decl_english_ast_exp  */
#line 7808 "parser.y"
    {
      DUMP_START( "param_decl_list_english",
                  "param_decl_list_english ',' decl_english_ast" );
      DUMP_AST_LIST( "param_decl_list_english", (yyvsp[-2].ast_list) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 12033 "parser.c"
    break;

  case 739: /* param_decl_list_english: decl_english_ast  */
#line 7822 "parser.y"
    {
      DUMP_START( "param_decl_list_english", "decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      if ( (yyvsp[0].ast)->kind == K_FUNCTION ) // see the comment in param_c_ast
        (yyvsp[0].ast) = c_ast_pointer( (yyvsp[0].ast), &gc_ast_list );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 12051 "parser.c"
    break;

  case 741: /* decl_english_ast_exp: error  */
#line 7840 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 12059 "parser.c"
    break;

  case 742: /* ref_qualifier_english_stid_opt: %empty  */
#line 7848 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 12065 "parser.c"
    break;

  case 743: /* ref_qualifier_english_stid_opt: Y_reference  */
#line 7849 "parser.y"
                                  { (yyval.tid) = TS_REFERENCE; }
#line 12071 "parser.c"
    break;

  case 744: /* ref_qualifier_english_stid_opt: Y_rvalue reference_exp  */
#line 7850 "parser.y"
                                  { (yyval.tid) = TS_RVALUE_REFERENCE; }
#line 12077 "parser.c"
    break;

  case 745: /* returning_english_ast_opt: %empty  */
#line 7857 "parser.y"
    {
      DUMP_START( "returning_english_ast_opt", "<empty>" );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      // see the comment in "type_c_ast"
      (yyval.ast)->type.btids = OPT_LANG_IS( IMPLICIT_int ) ? TB_int : TB_void;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12092 "parser.c"
    break;

  case 747: /* returning_english_ast: returning decl_english_ast  */
#line 7873 "parser.y"
    {
      DUMP_START( "returning_english_ast", "RETURNING decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12106 "parser.c"
    break;

  case 748: /* returning_english_ast: returning error  */
#line 7884 "parser.y"
    {
      elaborate_error( "English expected after \"returning\"" );
    }
#line 12114 "parser.c"
    break;

  case 749: /* qualified_decl_english_ast: type_qualifier_list_english_type_opt qualifiable_decl_english_ast  */
#line 7894 "parser.y"
    {
      DUMP_START( "qualified_decl_english_ast",
                  "type_qualifier_list_english_type_opt "
                  "qualifiable_decl_english_ast" );
      DUMP_TYPE( "type_qualifier_list_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "qualifiable_decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( !c_type_is_none( &(yyvsp[-1].type) ) )
        (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12134 "parser.c"
    break;

  case 750: /* type_qualifier_list_english_type_opt: %empty  */
#line 7912 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 12140 "parser.c"
    break;

  case 752: /* type_qualifier_list_english_type: type_qualifier_list_english_type type_qualifier_english_type  */
#line 7919 "parser.y"
    {
      DUMP_START( "type_qualifier_list_english_type",
                  "type_qualifier_list_english_type "
                  "type_qualifier_english_type" );
      DUMP_TYPE( "type_qualifier_list_english_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_qualifier_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 12158 "parser.c"
    break;

  case 754: /* type_qualifier_english_type: attribute_english_atid  */
#line 7937 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) ); }
#line 12164 "parser.c"
    break;

  case 755: /* type_qualifier_english_type: storage_class_english_stid  */
#line 7938 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 12170 "parser.c"
    break;

  case 756: /* type_qualifier_english_type: type_qualifier_english_stid  */
#line 7939 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 12176 "parser.c"
    break;

  case 757: /* attribute_english_atid: Y_carries dependency_exp  */
#line 7943 "parser.y"
                                  { (yyval.tid) = TA_carries_dependency; }
#line 12182 "parser.c"
    break;

  case 761: /* attribute_english_atid: Y_maybe unused_exp  */
#line 7947 "parser.y"
                                  { (yyval.tid) = TA_maybe_unused; }
#line 12188 "parser.c"
    break;

  case 763: /* attribute_english_atid: Y_no Y_discard  */
#line 7949 "parser.y"
                                  { (yyval.tid) = TA_nodiscard; }
#line 12194 "parser.c"
    break;

  case 765: /* attribute_english_atid: Y_no Y_return  */
#line 7951 "parser.y"
                                  { (yyval.tid) = TA_noreturn; }
#line 12200 "parser.c"
    break;

  case 768: /* attribute_english_atid: Y_no Y_unique address_exp  */
#line 7954 "parser.y"
                                  { (yyval.tid) = TA_no_unique_address; }
#line 12206 "parser.c"
    break;

  case 774: /* storage_class_english_stid: Y_constant eval_expr_init_stid  */
#line 7964 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 12214 "parser.c"
    break;

  case 783: /* storage_class_english_stid: Y_extern linkage_stid linkage_opt  */
#line 7976 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 12222 "parser.c"
    break;

  case 788: /* storage_class_english_stid: Y_no Y_except  */
#line 7983 "parser.y"
                                  { (yyval.tid) = TS_noexcept; }
#line 12228 "parser.c"
    break;

  case 790: /* storage_class_english_stid: Y_non_empty  */
#line 7985 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 12234 "parser.c"
    break;

  case 794: /* storage_class_english_stid: Y_thread local_exp  */
#line 7990 "parser.y"
                                  { (yyval.tid) = TS_thread_local; }
#line 12240 "parser.c"
    break;

  case 800: /* storage_class_english_stid: Y_pure virtual_stid_exp  */
#line 7996 "parser.y"
                                  { (yyval.tid) = TS_PURE_virtual | (yyvsp[0].tid); }
#line 12246 "parser.c"
    break;

  case 801: /* eval_expr_init_stid: Y_evaluation  */
#line 8000 "parser.y"
                                  { (yyval.tid) = TS_consteval; }
#line 12252 "parser.c"
    break;

  case 802: /* eval_expr_init_stid: Y_expression  */
#line 8001 "parser.y"
                                  { (yyval.tid) = TS_constexpr; }
#line 12258 "parser.c"
    break;

  case 803: /* eval_expr_init_stid: Y_initialization  */
#line 8002 "parser.y"
                                  { (yyval.tid) = TS_constinit; }
#line 12264 "parser.c"
    break;

  case 804: /* linkage_stid: str_lit  */
#line 8014 "parser.y"
    {
      bool ok = true;

      if ( strcmp( (yyvsp[0].str_val), "C" ) == 0 )
        (yyval.tid) = TS_extern_C;
      else if ( strcmp( (yyvsp[0].str_val), "C++" ) == 0 )
        (yyval.tid) = TS_NONE;
      else {
        print_error( &(yylsp[0]), "\"%s\": unknown linkage language", (yyvsp[0].str_val) );
        print_hint( "\"C\" or \"C++\"" );
        ok = false;
      }

      free( (yyvsp[0].str_val) );
      PARSE_ASSERT( ok );
    }
#line 12285 "parser.c"
    break;

  case 825: /* pointer_decl_english_ast: Y_pointer to_exp decl_english_ast  */
#line 8072 "parser.y"
    {
      DUMP_START( "pointer_decl_english_ast", "POINTER TO decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      // see the comment in "declare_command"
      PARSE_ASSERT( !c_ast_is_name_error( (yyvsp[0].ast) ) );

      (yyval.ast) = c_ast_new_gc( K_POINTER, &(yyloc) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12303 "parser.c"
    break;

  case 826: /* pointer_decl_english_ast: Y_pointer to_exp Y_member of_exp class_struct_union_btid_exp sname_english_exp decl_english_ast  */
#line 8092 "parser.y"
    {
      DUMP_START( "pointer_to_member_decl_english",
                  "POINTER TO MEMBER OF "
                  "class_struct_union_btid_exp "
                  "sname_english decl_english_ast" );
      DUMP_TID( "class_struct_union_btid_exp", (yyvsp[-2].tid) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-1].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      // see the comment in "declare_command"
      if ( c_ast_is_name_error( (yyvsp[0].ast) ) ) {
        c_sname_cleanup( &(yyvsp[-1].sname) );
        PARSE_ABORT();
      }

      (yyval.ast) = c_ast_new_gc( K_POINTER_TO_MEMBER, &(yyloc) );
      (yyval.ast)->ptr_mbr.class_sname = c_sname_move( &(yyvsp[-1].sname) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-2].tid), &(yylsp[-2]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12331 "parser.c"
    break;

  case 827: /* pointer_decl_english_ast: Y_pointer to_exp error  */
#line 8117 "parser.y"
    {
      if ( OPT_LANG_IS( POINTERS_TO_MEMBER ) )
        elaborate_error( "type name or \"member\" expected" );
      else
        elaborate_error( "type name expected" );
    }
#line 12342 "parser.c"
    break;

  case 828: /* reference_decl_english_ast: reference_english_ast to_exp decl_english_ast  */
#line 8130 "parser.y"
    {
      DUMP_START( "reference_decl_english_ast",
                  "reference_english_ast TO decl_english_ast" );
      DUMP_AST( "reference_english_ast", (yyvsp[-2].ast) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      // see the comment in "declare_command"
      PARSE_ASSERT( !c_ast_is_name_error( (yyvsp[0].ast) ) );

      (yyval.ast) = (yyvsp[-2].ast);
      (yyval.ast)->loc = (yyloc);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12363 "parser.c"
    break;

  case 829: /* reference_english_ast: Y_reference  */
#line 8150 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_REFERENCE, &(yyloc) );
    }
#line 12371 "parser.c"
    break;

  case 830: /* reference_english_ast: Y_rvalue reference_exp  */
#line 8155 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_RVALUE_REFERENCE, &(yyloc) );
    }
#line 12379 "parser.c"
    break;

  case 831: /* structured_binding_decl_english_ast: Y_structured binding_exp  */
#line 8164 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_STRUCTURED_BINDING, &(yyloc) );
    }
#line 12387 "parser.c"
    break;

  case 832: /* user_defined_literal_decl_english_ast: user_defined literal_exp lparen_exp param_decl_list_english_opt ')' returning_english_ast_opt  */
#line 8175 "parser.y"
    { //
      // User-defined literals are supported only in C++11 and later.
      // (However, we always allow them in configuration files.)
      //
      // This check is better to do now in the parser rather than later in the
      // AST because it has to be done in fewer places in the code plus gives a
      // better error location.
      //
      if ( !OPT_LANG_IS( USER_DEF_LITS ) ) {
        print_error( &(yylsp[-5]),
          "user-defined literals not supported%s\n",
          C_LANG_WHICH( USER_DEF_LITS )
        );
        PARSE_ABORT();
      }

      DUMP_START( "user_defined_literal_decl_english_ast",
                  "USER-DEFINED LITERAL '(' param_decl_list_english_opt ')' "
                  "returning_english_ast_opt" );
      DUMP_AST_LIST( "param_decl_list_english_opt", (yyvsp[-2].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_UDEF_LIT, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), (yyval.ast) );
      (yyval.ast)->udef_lit.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12422 "parser.c"
    break;

  case 833: /* var_decl_english_ast: sname_c Y_as decl_english_ast  */
#line 8214 "parser.y"
    {
      DUMP_START( "var_decl_english_ast", "sname_c AS decl_english_ast" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      // see the comment in "declare_command"
      if ( c_ast_is_name_error( (yyvsp[0].ast) ) ) {
        c_sname_cleanup( &(yyvsp[-2].sname) );
        PARSE_ABORT();
      }

      (yyval.ast) = (yyvsp[0].ast);
      (yyval.ast)->loc = (yyloc);
      c_sname_set( &(yyval.ast)->sname, &(yyvsp[-2].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12445 "parser.c"
    break;

  case 835: /* var_decl_english_ast: "..."  */
#line 8242 "parser.y"
    {
      DUMP_START( "var_decl_english_ast", "..." );

      (yyval.ast) = c_ast_new_gc( K_VARIADIC, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12458 "parser.c"
    break;

  case 836: /* type_english_ast: type_modifier_list_english_type_opt unmodified_type_english_ast  */
#line 8259 "parser.y"
    {
      DUMP_START( "type_english_ast",
                  "type_modifier_list_english_type_opt "
                  "unmodified_type_english_ast" );
      DUMP_TYPE( "type_modifier_list_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "unmodified_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( !c_type_is_none( &(yyvsp[-1].type) ) ) {
        // Set the AST's location to the entire rule only if the leading
        // optional rule is actually present, otherwise @$ refers to a column
        // before $ast.
        (yyval.ast)->loc = (yyloc);
        PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12482 "parser.c"
    break;

  case 837: /* type_english_ast: type_modifier_list_english_type  */
#line 8281 "parser.y"
    {
      DUMP_START( "type_english_ast", "type_modifier_list_english_type" );
      DUMP_TYPE( "type_modifier_list_english_type", (yyvsp[0].type) );

      // see the comment in "type_c_ast"
      c_type_t new_type =
        C_TYPE_LIT_B( OPT_LANG_IS( IMPLICIT_int ) ? TB_int : TB_NONE );

      PARSE_ASSERT( c_type_add( &new_type, &(yyvsp[0].type), &(yylsp[0]) ) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type = new_type;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12503 "parser.c"
    break;

  case 838: /* type_modifier_list_english_type_opt: %empty  */
#line 8300 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 12509 "parser.c"
    break;

  case 840: /* type_modifier_list_english_type: type_modifier_list_english_type type_modifier_english_type  */
#line 8307 "parser.y"
    {
      DUMP_START( "type_modifier_list_english_type",
                  "type_modifier_list_english_type "
                  "type_modifier_english_type" );
      DUMP_TYPE( "type_modifier_list_english_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_modifier_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 12527 "parser.c"
    break;

  case 849: /* builtin_type_english_ast: builtin_no_BitInt_english_btid  */
#line 8339 "parser.y"
    {
      DUMP_START( "builtin_type_english_ast",
                  "builtin_no_BitInt_english_btid" );
      DUMP_TID( "builtin_no_BitInt_english_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12543 "parser.c"
    break;

  case 850: /* builtin_type_english_ast: BitInt_english_int  */
#line 8351 "parser.y"
    {
      DUMP_START( "builtin_type_english_ast", "BitInt_english_int" );
      DUMP_INT( "BitInt_english_int", (yyvsp[0].uint_val) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = TB__BitInt;
      (yyval.ast)->builtin.BitInt.width = (yyvsp[0].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12559 "parser.c"
    break;

  case 855: /* builtin_no_BitInt_english_btid: Y_char uint_lit_opt  */
#line 8370 "parser.y"
    {
      switch ( (yyvsp[0].uint_val) ) {
        case  0: (yyval.tid) = TB_char    ; break;
        case  8: (yyval.tid) = TB_char8_t ; break;
        case 16: (yyval.tid) = TB_char16_t; break;
        case 32: (yyval.tid) = TB_char32_t; break;
        default:
          print_error( &(yylsp[0]), "bits must be one of 8, 16, or 32\n" );
          PARSE_ABORT();
      } // switch
    }
#line 12575 "parser.c"
    break;

  case 859: /* builtin_no_BitInt_english_btid: Y_decltype  */
#line 8385 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "decltype() declarations" );
    }
#line 12583 "parser.c"
    break;

  case 861: /* builtin_no_BitInt_english_btid: Y_wide char_exp  */
#line 8389 "parser.y"
                                  { (yyval.tid) = TB_wchar_t; }
#line 12589 "parser.c"
    break;

  case 864: /* builtin_no_BitInt_english_btid: Y_floating point_exp  */
#line 8392 "parser.y"
                                  { (yyval.tid) = TB_float; }
#line 12595 "parser.c"
    break;

  case 865: /* builtin_no_BitInt_english_btid: Y_double precision_opt  */
#line 8393 "parser.y"
                                  { (yyval.tid) = TB_double; }
#line 12601 "parser.c"
    break;

  case 868: /* BitInt_english_int: BitInt_english uint_lit bits_opt  */
#line 8400 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12609 "parser.c"
    break;

  case 869: /* BitInt_english_int: BitInt_english '(' uint_lit_exp rparen_exp  */
#line 8404 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12617 "parser.c"
    break;

  case 870: /* BitInt_english_int: BitInt_english Y_width uint_lit_exp bits_opt  */
#line 8408 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12625 "parser.c"
    break;

  case 871: /* BitInt_english_int: BitInt_english error  */
#line 8412 "parser.y"
    {
      elaborate_error( "integer literal, '(', or \"width\" expected" );
    }
#line 12633 "parser.c"
    break;

  case 875: /* concept_type_english_ast: Y_concept sname_english_exp  */
#line 8425 "parser.y"
    {
      DUMP_START( "concept_type_english_ast", "CONCEPT sname_english_exp" );
      DUMP_SNAME( "sname_english_exp", (yyvsp[0].sname) );

      c_sname_set_all_types( &(yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CONCEPT, &(yyloc) );
      (yyval.ast)->concept.concept_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12650 "parser.c"
    break;

  case 876: /* concept_type_english_ast: Y_concept sname_english_exp Y_parameter pack_exp  */
#line 8439 "parser.y"
    {
      DUMP_START( "concept_type_english_ast",
                  "CONCEPT sname_english_exp PARAMTER PACK" );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );

      c_sname_set_all_types( &(yyvsp[-2].sname) );

      (yyval.ast) = c_ast_new_gc( K_CONCEPT, &(yyloc) );
      (yyval.ast)->is_param_pack = true;
      (yyval.ast)->concept.concept_sname = c_sname_move( &(yyvsp[-2].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12669 "parser.c"
    break;

  case 877: /* parameter_pack_english_ast: Y_parameter pack_exp  */
#line 8457 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->is_param_pack = true;
      (yyval.ast)->type.btids = TB_auto;         // for consistency with C++ case
    }
#line 12679 "parser.c"
    break;

  case 879: /* pack_exp: error  */
#line 8467 "parser.y"
    {
      keyword_expected( L_pack );
    }
#line 12687 "parser.c"
    break;

  case 882: /* class_struct_union_english_ast: class_struct_union_btid any_sname_c_exp  */
#line 8479 "parser.y"
    {
      DUMP_START( "class_struct_union_english_ast",
                  "class_struct_union_btid any_sname_c_exp" );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-1].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-1].tid), C_TPID_BASE );
      (yyval.ast)->csu.csu_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12705 "parser.c"
    break;

  case 883: /* enum_english_ast: enum_btids any_sname_c_exp of_type_enum_fixed_type_english_ast_opt  */
#line 8497 "parser.y"
    {
      DUMP_START( "enum_english_ast",
                  "enum_btids any_sname_c_exp "
                  "of_type_enum_fixed_type_english_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ENUM, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      (yyval.ast)->enum_.enum_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12726 "parser.c"
    break;

  case 884: /* of_type_enum_fixed_type_english_ast_opt: %empty  */
#line 8516 "parser.y"
                                        { (yyval.ast) = NULL; }
#line 12732 "parser.c"
    break;

  case 885: /* of_type_enum_fixed_type_english_ast_opt: Y_of type_opt enum_fixed_type_english_ast  */
#line 8518 "parser.y"
    {
      (yyval.ast) = (yyvsp[0].ast);
    }
#line 12740 "parser.c"
    break;

  case 886: /* enum_fixed_type_english_ast: enum_fixed_type_modifier_list_english_btid_opt enum_unmodified_fixed_type_english_ast  */
#line 8526 "parser.y"
    {
      DUMP_START( "enum_fixed_type_english_ast",
                  "enum_fixed_type_modifier_list_stid" );
      DUMP_TID( "enum_fixed_type_modifier_list_stid", (yyvsp[-1].tid) );
      DUMP_AST( "enum_unmodified_fixed_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( (yyvsp[-1].tid) != TB_NONE ) {        // See comment in type_english_ast.
        (yyval.ast)->loc = (yyloc);
        PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-1].tid), &(yylsp[-1]) ) );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12760 "parser.c"
    break;

  case 887: /* enum_fixed_type_english_ast: enum_fixed_type_modifier_list_english_btid  */
#line 8543 "parser.y"
    {
      DUMP_START( "enum_fixed_type_english_ast",
                  "enum_fixed_type_modifier_list_english_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_english_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12776 "parser.c"
    break;

  case 888: /* enum_fixed_type_modifier_list_english_btid_opt: %empty  */
#line 8557 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 12782 "parser.c"
    break;

  case 890: /* enum_fixed_type_modifier_list_english_btid: enum_fixed_type_modifier_list_english_btid enum_fixed_type_modifier_btid  */
#line 8564 "parser.y"
    {
      DUMP_START( "enum_fixed_type_modifier_list_english_btid",
                  "enum_fixed_type_modifier_list_english_btid "
                  "enum_fixed_type_modifier_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_english_btid", (yyvsp[-1].tid) );
      DUMP_TID( "enum_fixed_type_modifier_btid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_btids", (yyval.tid) );
      DUMP_END();
    }
#line 12800 "parser.c"
    break;

  case 895: /* any_name: Y_TYPEDEF_NAME_TDEF  */
#line 8593 "parser.y"
    {
      assert( c_sname_count( &(yyvsp[0].tdef)->ast->sname ) == 1 );
      (yyval.name) = check_strdup( c_sname_local_name( &(yyvsp[0].tdef)->ast->sname ) );
    }
#line 12809 "parser.c"
    break;

  case 897: /* any_name_exp: error  */
#line 8602 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "name expected" );
    }
#line 12818 "parser.c"
    break;

  case 901: /* any_sname_c_exp: error  */
#line 8616 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12827 "parser.c"
    break;

  case 902: /* any_sname_c_opt: %empty  */
#line 8623 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12833 "parser.c"
    break;

  case 906: /* name_ast: Y_NAME  */
#line 8634 "parser.y"
    {
      DUMP_START( "name_ast", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      (yyval.ast) = c_ast_new_gc( K_NAME, &(yyloc) );
      c_sname_init_name( &(yyval.ast)->sname, (yyvsp[0].name) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12848 "parser.c"
    break;

  case 908: /* name_exp: error  */
#line 8649 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "name expected" );
    }
#line 12857 "parser.c"
    break;

  case 909: /* name_cat: name_cat Y_NAME  */
#line 8657 "parser.y"
    {
      (yyval.name) = str_realloc_cat( (yyvsp[-1].name), " ", (yyvsp[0].name) );
      free( (yyvsp[0].name) );
    }
#line 12866 "parser.c"
    break;

  case 911: /* name_opt: %empty  */
#line 8665 "parser.y"
                                  { (yyval.name) = NULL; }
#line 12872 "parser.c"
    break;

  case 913: /* oper_sname_c_opt: %empty  */
#line 8670 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12878 "parser.c"
    break;

  case 914: /* oper_sname_c_opt: Y_OPERATOR_SNAME Y_COLON_COLON  */
#line 8673 "parser.y"
    {
      (yyval.sname) = (yyvsp[-1].sname);
      if ( c_type_is_none( c_sname_local_type( &(yyval.sname) ) ) )
        c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_SCOPE );
    }
#line 12888 "parser.c"
    break;

  case 915: /* sname_c: sname_c Y_COLON_COLON Y_NAME  */
#line 8682 "parser.y"
    {
      // see the comment in "of_scope_english"
      if ( !OPT_LANG_IS( SCOPED_NAMES ) ) {
        print_error( &(yylsp[-1]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        c_sname_cleanup( &(yyvsp[-2].sname) );
        free( (yyvsp[0].name) );
        PARSE_ABORT();
      }

      DUMP_START( "sname_c", "sname_c '::' NAME" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_SCOPE );
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12916 "parser.c"
    break;

  case 916: /* sname_c: sname_c Y_COLON_COLON any_typedef_tdef  */
#line 8707 "parser.y"
    { //
      // This is for a case like:
      //
      //      define S::int8_t as char
      //
      // that is: the type int8_t is an existing type in no scope being defined
      // as a distinct type in a new scope.
      //
      DUMP_START( "sname_c", "sname_c '::' any_typedef_tdef" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_SCOPE );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12941 "parser.c"
    break;

  case 917: /* sname_c: Y_NAME  */
#line 8729 "parser.y"
    {
      DUMP_START( "sname_c", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      c_sname_init_name( &(yyval.sname), (yyvsp[0].name) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12955 "parser.c"
    break;

  case 918: /* sname_c_ast: sname_c bit_field_c_uint_opt  */
#line 8743 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "sname_c_ast", "sname_c" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "sname_c", (yyvsp[-1].sname) );
      DUMP_INT( "bit_field_c_uint_opt", (yyvsp[0].uint_val) );

      (yyval.ast) = ia_type_spec_ast( type_ast );
      c_sname_set( &(yyval.ast)->sname, &(yyvsp[-1].sname) );
      PARSE_ASSERT( c_ast_set_bit_field_width( (yyval.ast), (yyvsp[0].uint_val) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12975 "parser.c"
    break;

  case 919: /* bit_field_c_uint_opt: %empty  */
#line 8761 "parser.y"
                                  { (yyval.uint_val) = 0; }
#line 12981 "parser.c"
    break;

  case 920: /* bit_field_c_uint_opt: ':' uint_lit_exp  */
#line 8763 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since we use 0 to mean "no bit-field."
      //
      if ( (yyvsp[0].uint_val) == 0 ) {
        print_error( &(yylsp[0]), "bit-field width must be > 0\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = (yyvsp[0].uint_val);
    }
#line 12996 "parser.c"
    break;

  case 922: /* sname_c_exp: error  */
#line 8778 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 13005 "parser.c"
    break;

  case 923: /* sname_c_opt: %empty  */
#line 8785 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 13011 "parser.c"
    break;

  case 925: /* sname_english: any_sname_c of_scope_list_english_opt  */
#line 8791 "parser.y"
    {
      DUMP_START( "sname_english", "any_sname_c of_scope_list_english_opt" );
      DUMP_SNAME( "any_sname_c", (yyvsp[-1].sname) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[0].sname) );

      c_type_t const *local_type = c_sname_local_type( &(yyvsp[0].sname) );
      if ( c_type_is_none( local_type ) )
        local_type = c_sname_local_type( &(yyvsp[-1].sname) );
      (yyval.sname) = (yyvsp[0].sname);
      c_sname_append_sname( &(yyval.sname), &(yyvsp[-1].sname) );
      c_sname_local_data( &(yyval.sname) )->type = *local_type;

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 13031 "parser.c"
    break;

  case 926: /* sname_english_ast: Y_NAME of_scope_list_english_opt  */
#line 8810 "parser.y"
    {
      DUMP_START( "sname_english_ast", "NAME of_scope_list_english_opt" );
      DUMP_STR( "NAME", (yyvsp[-1].name) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[0].sname) );

      c_sname_t sname = c_sname_move( &(yyvsp[0].sname) );
      c_sname_append_name( &sname, (yyvsp[-1].name) );

      c_typedef_t const *const tdef = c_typedef_find_sname( &sname );
      if ( tdef != NULL ) {
        //
        // The sname is the name of a typedef'd type: create a new K_TYPEDEF
        // node and point it at the typedef's AST.
        //
        (yyval.ast) = c_ast_new_gc( K_TYPEDEF, &(yyloc) );
        (yyval.ast)->type.btids = TB_typedef;
        (yyval.ast)->tdef.for_ast = tdef->ast;
        c_sname_cleanup( &sname );
      }
      else {
        (yyval.ast) = c_ast_new_gc( K_NAME, &(yyloc) );
        (yyval.ast)->sname = sname;
        //
        // Set the c_name_ast's sname also in case it's used as a type name.
        //
        c_sname_t temp_sname = c_sname_dup( &(yyval.ast)->sname );
        c_sname_set( &(yyval.ast)->name.sname, &temp_sname );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 13068 "parser.c"
    break;

  case 928: /* sname_english_exp: error  */
#line 8847 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 13077 "parser.c"
    break;

  case 929: /* sname_english_opt: %empty  */
#line 8854 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 13083 "parser.c"
    break;

  case 931: /* sname_list_c: sname_list_c ',' sname_c  */
#line 8860 "parser.y"
    {
      DUMP_START( "sname_list_c",
                  "sname_list_c ',' sname_c" );
      DUMP_SNAME_LIST( "sname_list_c", (yyvsp[-2].sname_list) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      (yyval.sname_list) = (yyvsp[-2].sname_list);
      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 13102 "parser.c"
    break;

  case 932: /* sname_list_c: sname_c  */
#line 8875 "parser.y"
    {
      DUMP_START( "sname_list_c", "sname_c" );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_init( &(yyval.sname_list) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 13119 "parser.c"
    break;

  case 933: /* sname_list_english: sname_list_english ',' sname_english_exp  */
#line 8891 "parser.y"
    {
      DUMP_START( "sname_list_english",
                  "sname_list_english ',' sname_english" );
      DUMP_SNAME_LIST( "sname_list_english", (yyvsp[-2].sname_list) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[0].sname) );

      (yyval.sname_list) = (yyvsp[-2].sname_list);
      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 13138 "parser.c"
    break;

  case 934: /* sname_list_english: sname_english  */
#line 8907 "parser.y"
    {
      DUMP_START( "sname_list_english", "sname_english" );
      DUMP_SNAME( "sname_english", (yyvsp[0].sname) );

      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_init( &(yyval.sname_list) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 13155 "parser.c"
    break;

  case 935: /* typedef_sname_c: typedef_sname_c Y_COLON_COLON sname_c  */
#line 8923 "parser.y"
    {
      DUMP_START( "typedef_sname_c", "typedef_sname_c '::' sname_c" );
      DUMP_SNAME( "typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      //
      // This is for a case like:
      //
      //      define S as struct S
      //      define S::T as struct T
      //
      (yyval.sname) = c_sname_move( &(yyvsp[-2].sname) );
      c_sname_append_sname( &(yyval.sname), &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 13177 "parser.c"
    break;

  case 936: /* typedef_sname_c: typedef_sname_c Y_COLON_COLON any_typedef_tdef  */
#line 8942 "parser.y"
    {
      DUMP_START( "typedef_sname_c", "typedef_sname_c '::' any_typedef_tdef" );
      DUMP_SNAME( "typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      //
      // This is for a case like:
      //
      //      define S as struct S
      //      define T as struct T
      //      define S::T as struct S_T
      //
      (yyval.sname) = c_sname_move( &(yyvsp[-2].sname) );
      c_sname_local_data( &(yyval.sname) )->type =
        *c_sname_local_type( &(yyvsp[0].tdef)->ast->sname );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 13203 "parser.c"
    break;

  case 937: /* typedef_sname_c: any_typedef_tdef  */
#line 8964 "parser.y"
                                  { (yyval.sname) = c_sname_dup( &(yyvsp[0].tdef)->ast->sname ); }
#line 13209 "parser.c"
    break;

  case 939: /* address_exp: error  */
#line 8974 "parser.y"
    {
      keyword_expected( L_address );
    }
#line 13217 "parser.c"
    break;

  case 941: /* array_exp: error  */
#line 8982 "parser.y"
    {
      keyword_expected( L_array );
    }
#line 13225 "parser.c"
    break;

  case 942: /* as_exp: Y_as  */
#line 8989 "parser.y"
    {
      if ( OPT_LANG_IS( MEMBER_FUNCTIONS ) ) {
        //
        // For either "declare" or "define", neither "override" nor "final"
        // must be matched initially to allow for cases like:
        //
        //      c++decl> declare final as int
        //      int final;
        //
        // (which is legal).  However, in C++, after parsing "as", the keyword
        // context has to be set to C_KW_CTX_MBR_FUNC to be able to match
        // "override" and "final", e.g.:
        //
        //      c++decl> declare f as final function
        //      void f() final;
        //
        lexer_keyword_ctx = C_KW_CTX_MBR_FUNC;
      }
    }
#line 13249 "parser.c"
    break;

  case 943: /* as_exp: error  */
#line 9009 "parser.y"
    {
      keyword_expected( L_as );
    }
#line 13257 "parser.c"
    break;

  case 947: /* as_into_to_exp: error  */
#line 9019 "parser.y"
    {
      elaborate_error( "\"as\", \"into\", or \"to\" expected" );
    }
#line 13265 "parser.c"
    break;

  case 952: /* auto_TYPE_exp: error  */
#line 9033 "parser.y"
    {
      keyword_expected( L_auto );
    }
#line 13273 "parser.c"
    break;

  case 954: /* binding_exp: error  */
#line 9041 "parser.y"
    {
      keyword_expected( L_binding );
    }
#line 13281 "parser.c"
    break;

  case 961: /* cast_exp: error  */
#line 9060 "parser.y"
    {
      keyword_expected( L_cast );
    }
#line 13289 "parser.c"
    break;

  case 963: /* char_exp: error  */
#line 9068 "parser.y"
    {
      keyword_expected( L_char );
    }
#line 13297 "parser.c"
    break;

  case 965: /* class_struct_union_btid_exp: error  */
#line 9076 "parser.y"
    {
      elaborate_error( "\"class\", \"struct\", or \"union\" expected" );
    }
#line 13305 "parser.c"
    break;

  case 967: /* colon_exp: error  */
#line 9084 "parser.y"
    {
      punct_expected( ':' );
    }
#line 13313 "parser.c"
    break;

  case 969: /* comma_exp: error  */
#line 9092 "parser.y"
    {
      punct_expected( ',' );
    }
#line 13321 "parser.c"
    break;

  case 971: /* conversion_exp: error  */
#line 9100 "parser.y"
    {
      keyword_expected( L_conversion );
    }
#line 13329 "parser.c"
    break;

  case 972: /* c_operator: Y_co_await  */
#line 9106 "parser.y"
                                  { (yyval.op_id) = C_OP_CO_AWAIT              ; }
#line 13335 "parser.c"
    break;

  case 973: /* c_operator: Y_new  */
#line 9107 "parser.y"
                                  { (yyval.op_id) = C_OP_NEW                   ; }
#line 13341 "parser.c"
    break;

  case 974: /* c_operator: Y_new '[' rbracket_exp  */
#line 9108 "parser.y"
                                  { (yyval.op_id) = C_OP_NEW_ARRAY             ; }
#line 13347 "parser.c"
    break;

  case 975: /* c_operator: Y_delete  */
#line 9109 "parser.y"
                                  { (yyval.op_id) = C_OP_DELETE                ; }
#line 13353 "parser.c"
    break;

  case 976: /* c_operator: Y_delete '[' rbracket_exp  */
#line 9110 "parser.y"
                                  { (yyval.op_id) = C_OP_DELETE_ARRAY          ; }
#line 13359 "parser.c"
    break;

  case 977: /* c_operator: '!'  */
#line 9111 "parser.y"
                                  { (yyval.op_id) = C_OP_EXCLAMATION           ; }
#line 13365 "parser.c"
    break;

  case 978: /* c_operator: Y_EXCLAM_EQUAL  */
#line 9112 "parser.y"
                                  { (yyval.op_id) = C_OP_EXCLAMATION_EQUAL     ; }
#line 13371 "parser.c"
    break;

  case 979: /* c_operator: '%'  */
#line 9113 "parser.y"
                                  { (yyval.op_id) = C_OP_PERCENT               ; }
#line 13377 "parser.c"
    break;

  case 980: /* c_operator: Y_PERCENT_EQUAL  */
#line 9114 "parser.y"
                                  { (yyval.op_id) = C_OP_PERCENT_EQUAL         ; }
#line 13383 "parser.c"
    break;

  case 981: /* c_operator: '&'  */
#line 9115 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPERSAND             ; }
#line 13389 "parser.c"
    break;

  case 982: /* c_operator: Y_AMPER_AMPER  */
#line 9116 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPERSAND_AMPERSAND   ; }
#line 13395 "parser.c"
    break;

  case 983: /* c_operator: Y_AMPER_EQUAL  */
#line 9117 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPER_EQUAL           ; }
#line 13401 "parser.c"
    break;

  case 984: /* c_operator: '(' rparen_exp  */
#line 9118 "parser.y"
                                  { (yyval.op_id) = C_OP_PARENTHESES           ; }
#line 13407 "parser.c"
    break;

  case 985: /* c_operator: '*'  */
#line 9119 "parser.y"
                                  { (yyval.op_id) = C_OP_STAR                  ; }
#line 13413 "parser.c"
    break;

  case 986: /* c_operator: Y_STAR_EQUAL  */
#line 9120 "parser.y"
                                  { (yyval.op_id) = C_OP_STAR_EQUAL            ; }
#line 13419 "parser.c"
    break;

  case 987: /* c_operator: '+'  */
#line 9121 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS                  ; }
#line 13425 "parser.c"
    break;

  case 988: /* c_operator: "++"  */
#line 9122 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS_PLUS             ; }
#line 13431 "parser.c"
    break;

  case 989: /* c_operator: Y_PLUS_EQUAL  */
#line 9123 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS_EQUAL            ; }
#line 13437 "parser.c"
    break;

  case 990: /* c_operator: ','  */
#line 9124 "parser.y"
                                  { (yyval.op_id) = C_OP_COMMA                 ; }
#line 13443 "parser.c"
    break;

  case 991: /* c_operator: '-'  */
#line 9125 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS                 ; }
#line 13449 "parser.c"
    break;

  case 992: /* c_operator: "--"  */
#line 9126 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_MINUS           ; }
#line 13455 "parser.c"
    break;

  case 993: /* c_operator: Y_MINUS_EQUAL  */
#line 9127 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_EQUAL           ; }
#line 13461 "parser.c"
    break;

  case 994: /* c_operator: Y_MINUS_GREATER  */
#line 9128 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_GREATER         ; }
#line 13467 "parser.c"
    break;

  case 995: /* c_operator: Y_MINUS_GREATER_STAR  */
#line 9129 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_GREATER_STAR    ; }
#line 13473 "parser.c"
    break;

  case 996: /* c_operator: '.'  */
#line 9130 "parser.y"
                                  { (yyval.op_id) = C_OP_DOT                   ; }
#line 13479 "parser.c"
    break;

  case 997: /* c_operator: Y_DOT_STAR  */
#line 9131 "parser.y"
                                  { (yyval.op_id) = C_OP_DOT_STAR              ; }
#line 13485 "parser.c"
    break;

  case 998: /* c_operator: '/'  */
#line 9132 "parser.y"
                                  { (yyval.op_id) = C_OP_SLASH                 ; }
#line 13491 "parser.c"
    break;

  case 999: /* c_operator: Y_SLASH_EQUAL  */
#line 9133 "parser.y"
                                  { (yyval.op_id) = C_OP_SLASH_EQUAL           ; }
#line 13497 "parser.c"
    break;

  case 1000: /* c_operator: Y_COLON_COLON  */
#line 9134 "parser.y"
                                  { (yyval.op_id) = C_OP_COLON_COLON           ; }
#line 13503 "parser.c"
    break;

  case 1001: /* c_operator: '<'  */
#line 9135 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS                  ; }
#line 13509 "parser.c"
    break;

  case 1002: /* c_operator: Y_LESS_LESS  */
#line 9136 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_LESS             ; }
#line 13515 "parser.c"
    break;

  case 1003: /* c_operator: Y_LESS_LESS_EQUAL  */
#line 9137 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_LESS_EQUAL       ; }
#line 13521 "parser.c"
    break;

  case 1004: /* c_operator: Y_LESS_EQUAL  */
#line 9138 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_EQUAL            ; }
#line 13527 "parser.c"
    break;

  case 1005: /* c_operator: Y_LESS_EQUAL_GREATER  */
#line 9139 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_EQUAL_GREATER    ; }
#line 13533 "parser.c"
    break;

  case 1006: /* c_operator: '='  */
#line 9140 "parser.y"
                                  { (yyval.op_id) = C_OP_EQUAL                 ; }
#line 13539 "parser.c"
    break;

  case 1007: /* c_operator: Y_EQUAL_EQUAL  */
#line 9141 "parser.y"
                                  { (yyval.op_id) = C_OP_EQUAL_EQUAL           ; }
#line 13545 "parser.c"
    break;

  case 1008: /* c_operator: '>'  */
#line 9142 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER               ; }
#line 13551 "parser.c"
    break;

  case 1009: /* c_operator: Y_GREATER_GREATER  */
#line 9143 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_GREATER       ; }
#line 13557 "parser.c"
    break;

  case 1010: /* c_operator: Y_GREATER_GREATER_EQUAL  */
#line 9144 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_GREATER_EQUAL ; }
#line 13563 "parser.c"
    break;

  case 1011: /* c_operator: Y_GREATER_EQUAL  */
#line 9145 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_EQUAL         ; }
#line 13569 "parser.c"
    break;

  case 1012: /* c_operator: Y_QMARK_COLON  */
#line 9146 "parser.y"
                                  { (yyval.op_id) = C_OP_QUESTION_MARK_COLON   ; }
#line 13575 "parser.c"
    break;

  case 1013: /* c_operator: '[' rbracket_exp  */
#line 9147 "parser.y"
                                  { (yyval.op_id) = C_OP_BRACKETS              ; }
#line 13581 "parser.c"
    break;

  case 1014: /* c_operator: '^'  */
#line 9148 "parser.y"
                                  { (yyval.op_id) = C_OP_CARET                 ; }
#line 13587 "parser.c"
    break;

  case 1015: /* c_operator: Y_CARET_EQUAL  */
#line 9149 "parser.y"
                                  { (yyval.op_id) = C_OP_CARET_EQUAL           ; }
#line 13593 "parser.c"
    break;

  case 1016: /* c_operator: '|'  */
#line 9150 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE                  ; }
#line 13599 "parser.c"
    break;

  case 1017: /* c_operator: Y_PIPE_PIPE  */
#line 9151 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE_PIPE             ; }
#line 13605 "parser.c"
    break;

  case 1018: /* c_operator: Y_PIPE_EQUAL  */
#line 9152 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE_EQUAL            ; }
#line 13611 "parser.c"
    break;

  case 1019: /* c_operator: '~'  */
#line 9153 "parser.y"
                                  { (yyval.op_id) = C_OP_TILDE                 ; }
#line 13617 "parser.c"
    break;

  case 1021: /* default_exp: error  */
#line 9159 "parser.y"
    {
      keyword_expected( L_default );
    }
#line 13625 "parser.c"
    break;

  case 1023: /* defined_exp: error  */
#line 9167 "parser.y"
    {
      keyword_expected( L_defined );
    }
#line 13633 "parser.c"
    break;

  case 1025: /* dependency_exp: error  */
#line 9175 "parser.y"
    {
      keyword_expected( L_dependency );
    }
#line 13641 "parser.c"
    break;

  case 1027: /* destructor_sname: Y_LEXER_ERROR  */
#line 9183 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      PARSE_ABORT();
    }
#line 13650 "parser.c"
    break;

  case 1028: /* empty_str_lit_exp: str_lit_exp  */
#line 9191 "parser.y"
    { //
      // This check is done now in the parser rather than later in the AST so
      // we don't have to keep the string literal around.
      //
      bool const is_empty = (yyvsp[0].str_val) == NULL || (yyvsp[0].str_val)[0] == '\0';
      free( (yyvsp[0].str_val) );
      if ( !is_empty ) {
        print_error( &(yylsp[0]), "empty string literal expected\n" );
        PARSE_ABORT();
      }
    }
#line 13666 "parser.c"
    break;

  case 1030: /* equals_exp: error  */
#line 9207 "parser.y"
    {
      punct_expected( '=' );
    }
#line 13674 "parser.c"
    break;

  case 1031: /* extern_linkage_c_stid: Y_extern linkage_stid  */
#line 9213 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 13680 "parser.c"
    break;

  case 1032: /* extern_linkage_c_stid: Y_extern linkage_stid '{'  */
#line 9215 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "scoped linkage declarations" );
    }
#line 13688 "parser.c"
    break;

  case 1033: /* extern_linkage_c_stid_opt: %empty  */
#line 9221 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13694 "parser.c"
    break;

  case 1035: /* glob: Y_GLOB  */
#line 9227 "parser.y"
    {
      if ( !OPT_LANG_IS( SCOPED_NAMES ) && strchr( (yyvsp[0].name), ':' ) != NULL ) {
        print_error( &(yylsp[0]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        free( (yyvsp[0].name) );
        PARSE_ABORT();
      }
      (yyval.name) = (yyvsp[0].name);
    }
#line 13710 "parser.c"
    break;

  case 1036: /* glob_opt: %empty  */
#line 9241 "parser.y"
                                  { (yyval.name) = NULL; }
#line 13716 "parser.c"
    break;

  case 1039: /* gt_exp: error  */
#line 9248 "parser.y"
    {
      punct_expected( '>' );
    }
#line 13724 "parser.c"
    break;

  case 1040: /* inline_stid_opt: %empty  */
#line 9254 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13730 "parser.c"
    break;

  case 1043: /* int_exp: error  */
#line 9261 "parser.y"
    {
      elaborate_error( "\"int[eger]\" expected" );
    }
#line 13738 "parser.c"
    break;

  case 1045: /* lbracket_exp: error  */
#line 9269 "parser.y"
    {
      punct_expected( '[' );
    }
#line 13746 "parser.c"
    break;

  case 1047: /* literal_exp: error  */
#line 9277 "parser.y"
    {
      keyword_expected( L_literal );
    }
#line 13754 "parser.c"
    break;

  case 1049: /* local_exp: error  */
#line 9285 "parser.y"
    {
      keyword_expected( L_local );
    }
#line 13762 "parser.c"
    break;

  case 1051: /* lparen_exp: error  */
#line 9293 "parser.y"
    {
      punct_expected( '(' );
    }
#line 13770 "parser.c"
    break;

  case 1053: /* lt_exp: error  */
#line 9301 "parser.y"
    {
      punct_expected( '<' );
    }
#line 13778 "parser.c"
    break;

  case 1054: /* member_or_non_member_opt: %empty  */
#line 9307 "parser.y"
                                  { (yyval.member) = C_FUNC_UNSPECIFIED; }
#line 13784 "parser.c"
    break;

  case 1055: /* member_or_non_member_opt: Y_member  */
#line 9308 "parser.y"
                                  { (yyval.member) = C_FUNC_MEMBER     ; }
#line 13790 "parser.c"
    break;

  case 1056: /* member_or_non_member_opt: Y_non_member  */
#line 9309 "parser.y"
                                  { (yyval.member) = C_FUNC_NON_MEMBER ; }
#line 13796 "parser.c"
    break;

  case 1058: /* namespace_btid_exp: error  */
#line 9315 "parser.y"
    {
      keyword_expected( L_namespace );
    }
#line 13804 "parser.c"
    break;

  case 1059: /* namespace_type: Y_namespace  */
#line 9321 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 13810 "parser.c"
    break;

  case 1060: /* namespace_type: Y_inline namespace_btid_exp  */
#line 9322 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT( (yyvsp[0].tid), (yyvsp[-1].tid), TA_NONE ); }
#line 13816 "parser.c"
    break;

  case 1062: /* of_exp: error  */
#line 9328 "parser.y"
    {
      keyword_expected( L_of );
    }
#line 13824 "parser.c"
    break;

  case 1063: /* of_scope_english: Y_of scope_english_type_exp any_sname_c_exp  */
#line 9335 "parser.y"
    { //
      // Scoped names are supported only in C++.  (However, we always allow
      // them in configuration files.)
      //
      // This check is better to do now in the parser rather than later in the
      // AST because it has to be done in fewer places in the code plus gives a
      // better error location.
      //
      if ( !OPT_LANG_IS( SCOPED_NAMES ) ) {
        print_error( &(yylsp[-1]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        c_sname_cleanup( &(yyvsp[0].sname) );
        PARSE_ABORT();
      }
      (yyval.sname) = c_sname_move( &(yyvsp[0].sname) );
      c_sname_local_data( &(yyval.sname) )->type = (yyvsp[-1].type);
    }
#line 13848 "parser.c"
    break;

  case 1064: /* of_scope_list_english: of_scope_list_english of_scope_english  */
#line 9358 "parser.y"
    {
      // "of scope X of scope Y" means Y::X
      (yyval.sname) = c_sname_move( &(yyvsp[0].sname) );
      c_sname_append_sname( &(yyval.sname), &(yyvsp[-1].sname) );
      c_sname_set_all_types( &(yyval.sname) );
      if ( !c_sname_check( &(yyval.sname), &(yylsp[-1]) ) ) {
        c_sname_cleanup( &(yyval.sname) );
        PARSE_ABORT();
      }
    }
#line 13863 "parser.c"
    break;

  case 1066: /* of_scope_list_english_opt: %empty  */
#line 9372 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 13869 "parser.c"
    break;

  case 1069: /* operator_exp: error  */
#line 9379 "parser.y"
    {
      keyword_expected( L_operator );
    }
#line 13877 "parser.c"
    break;

  case 1073: /* point_exp: error  */
#line 9392 "parser.y"
    {
      keyword_expected( L_point );
    }
#line 13885 "parser.c"
    break;

  case 1077: /* rbrace_exp: error  */
#line 9404 "parser.y"
    {
      punct_expected( '}' );
    }
#line 13893 "parser.c"
    break;

  case 1079: /* rbracket_exp: error  */
#line 9412 "parser.y"
    {
      punct_expected( ']' );
    }
#line 13901 "parser.c"
    break;

  case 1080: /* ref_qualifier_c_stid_opt: %empty  */
#line 9418 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13907 "parser.c"
    break;

  case 1081: /* ref_qualifier_c_stid_opt: '&'  */
#line 9419 "parser.y"
                                  { (yyval.tid) = TS_REFERENCE; }
#line 13913 "parser.c"
    break;

  case 1082: /* ref_qualifier_c_stid_opt: Y_AMPER_AMPER  */
#line 9420 "parser.y"
                                  { (yyval.tid) = TS_RVALUE_REFERENCE; }
#line 13919 "parser.c"
    break;

  case 1084: /* reference_exp: error  */
#line 9426 "parser.y"
    {
      keyword_expected( L_reference );
    }
#line 13927 "parser.c"
    break;

  case 1088: /* returning_exp: error  */
#line 9439 "parser.y"
    {
      keyword_expected( L_returning );
    }
#line 13935 "parser.c"
    break;

  case 1090: /* rparen_exp: error  */
#line 9447 "parser.y"
    {
      punct_expected( ')' );
    }
#line 13943 "parser.c"
    break;

  case 1091: /* scope_english_type: class_struct_union_btid  */
#line 9453 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 13949 "parser.c"
    break;

  case 1093: /* scope_english_type: Y_scope  */
#line 9455 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( TB_SCOPE ); }
#line 13955 "parser.c"
    break;

  case 1095: /* scope_english_type_exp: error  */
#line 9461 "parser.y"
    {
      elaborate_error(
        "\"class\", \"namespace\", \"scope\", \"struct\", or \"union\" expected"
      );
    }
#line 13965 "parser.c"
    break;

  case 1097: /* semi_exp: error  */
#line 9471 "parser.y"
    {
      punct_expected( ';' );
    }
#line 13973 "parser.c"
    break;

  case 1102: /* static_stid_opt: %empty  */
#line 9487 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13979 "parser.c"
    break;

  case 1103: /* static_stid_opt: Y_static  */
#line 9488 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 13985 "parser.c"
    break;

  case 1105: /* str_lit: Y_LEXER_ERROR  */
#line 9494 "parser.y"
    {
      (yyval.str_val) = NULL;
      PARSE_ABORT();
    }
#line 13994 "parser.c"
    break;

  case 1107: /* str_lit_exp: error  */
#line 9503 "parser.y"
    {
      (yyval.str_val) = NULL;
      elaborate_error( "string literal expected" );
    }
#line 14003 "parser.c"
    break;

  case 1109: /* this_exp: error  */
#line 9512 "parser.y"
    {
      keyword_expected( L_this );
    }
#line 14011 "parser.c"
    break;

  case 1110: /* this_stid_opt: %empty  */
#line 9518 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 14017 "parser.c"
    break;

  case 1113: /* to_exp: error  */
#line 9525 "parser.y"
    {
      keyword_expected( L_to );
    }
#line 14025 "parser.c"
    break;

  case 1116: /* typename_flag_opt: %empty  */
#line 9536 "parser.y"
                                  { (yyval.flag) = false; }
#line 14031 "parser.c"
    break;

  case 1117: /* typename_flag_opt: Y_typename  */
#line 9537 "parser.y"
                                  { (yyval.flag) = true; }
#line 14037 "parser.c"
    break;

  case 1118: /* uint_lit: Y_INT_LIT  */
#line 9542 "parser.y"
    {
      if ( (yyvsp[0].int_val) < 0 ) {
        //
        // This check is better to do now in the parser rather than later in
        // the AST because we can store the value as unsigned plus gives a
        // better error location.
        //
        print_error( &(yylsp[0]), "non-negative integer expected\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = STATIC_CAST( unsigned, (yyvsp[0].int_val) );
    }
#line 14054 "parser.c"
    break;

  case 1120: /* uint_lit_exp: error  */
#line 9559 "parser.y"
    {
      elaborate_error( "integer literal expected" );
    }
#line 14062 "parser.c"
    break;

  case 1121: /* uint_lit_opt: %empty  */
#line 9565 "parser.y"
                                  { (yyval.uint_val) = 0; }
#line 14068 "parser.c"
    break;

  case 1124: /* unused_exp: error  */
#line 9572 "parser.y"
    {
      keyword_expected( L_unused );
    }
#line 14076 "parser.c"
    break;

  case 1128: /* virtual_stid_exp: error  */
#line 9585 "parser.y"
    {
      keyword_expected( L_virtual );
    }
#line 14084 "parser.c"
    break;

  case 1129: /* virtual_stid_opt: %empty  */
#line 9591 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 14090 "parser.c"
    break;


#line 14094 "parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 9595 "parser.y"


/// @endcond

// Re-enable warnings.
#pragma GCC diagnostic pop

/**
 * @addtogroup parser-group
 * @{
 */

////////// local functions ////////////////////////////////////////////////////

/**
 * Prints an additional parsing error message including a newline to standard
 * error that continues from where yyerror() left off.  Additionally:
 *
 * + If the printable_yytext() isn't NULL:
 *     + Checks to see if it's a keyword: if it is, mentions that it's a
 *       keyword in the error message.
 *     + May print "did you mean ...?" \a dym_kinds suggestions.
 *
 * + In debug mode, also prints the file & line where the function was called
 *   from as well as the ID of the lookahead token, if any.
 *
 * @note A newline _is_ printed.
 * @note This function isn't normally called directly; use the
 * #elaborate_error() or #elaborate_error_dym() macros instead.
 *
 * @param line The line number within this file where this function was called
 * from.
 * @param dym_kinds The bitwise-or of the kind(s) of things possibly meant.
 * @param format A `printf()` style format string.  It _must not_ end in a
 * newline since this function prints its own newline.
 * @param ... Arguments to print.
 *
 * @sa #elaborate_error()
 * @sa #elaborate_error_dym()
 * @sa l_keyword_expected()
 * @sa l_punct_expected()
 * @sa yyerror()
 */
PJL_PRINTF_LIKE_FUNC(3)
static void l_elaborate_error( int line, dym_kind_t dym_kinds,
                               char const *format, ... ) {
  assert( format != NULL );

  EPUTS( ": " );
  print_debug_file_line( __FILE__, line );

  char const *const error_token = printable_yytext();
  if ( print_error_token( error_token ) )
    EPUTS( ": " );

  va_list args;
  va_start( args, format );
  vfprintf( stderr, format, args );
  va_end( args );

  if ( error_token != NULL ) {
    print_error_token_is_a( error_token );
    print_suggestions( dym_kinds, error_token );
  }

  EPUTC( '\n' );
}

/**
 * Cleans up all global parser data at program termination.
 *
 * @note This function is called only via **atexit**(3).
 *
 * @sa parser_init()
 */
static void parser_cleanup( void ) {
  c_ast_list_cleanup_gc( &typedef_ast_list );
}

/**
 * Prints \a token, quoted; if \ref opt_cdecl_debug `!=` #CDECL_DEBUG_NO, also
 * prints the look-ahead character within `[]`.
 *
 * @param token The error token to print, if any.
 * @return Returns `true` only if anything was printed.
 */
static bool print_error_token( char const *token ) {
  if ( token == NULL )
    return false;
  EPRINTF( "\"%s\"", token );
  if ( opt_cdecl_debug != CDECL_DEBUG_NO ) {
    // LCOV_EXCL_START
    switch ( yychar ) {
      case YYEMPTY:
        EPUTS( " [<EMPTY>]" );
        break;
      case YYEOF:
        EPUTS( " [<EOF>]" );
        break;
      case YYerror:
        EPUTS( " [<error>]" );
        break;
      case YYUNDEF:
        EPUTS( " [<UNDEF>]" );
        break;
      default:
        EPRINTF( isprint( yychar ) ? " ['%c']" : " [%d]", yychar );
    } // switch
    // LCOV_EXCL_STOP
  }
  return true;
}

////////// extern functions ///////////////////////////////////////////////////

void parser_init( void ) {
  ASSERT_RUN_ONCE();
  ATEXIT( &parser_cleanup );
}

bool yyparse_sn( char const *s, size_t s_len ) {
  assert( s != NULL );

  FILE *const s_file = fmemopen( CONST_CAST( void*, s ), s_len, "r" );
  PERROR_EXIT_IF( s_file == NULL, EX_IOERR );
  yyrestart( s_file );

  int const bison_rv = yyparse();
  fclose( s_file );
  if ( unlikely( bison_rv == 2 ) ) {
    //
    // Bison has already printed "memory exhausted" via yyerror() that doesn't
    // print a newline, so print one now.
    //
    // LCOV_EXCL_START
    EPUTC( '\n' );
    _Exit( EX_SOFTWARE );
    // LCOV_EXCL_STOP
  }

  return bison_rv == 0;
}

///////////////////////////////////////////////////////////////////////////////

/** @} */

/* vim:set et sw=2 ts=2: */
